;(--------------Constants and arrays Declarations-------------
(declare-const T_RF (Array Int Int))
(declare-const T_DM (Array Int Int))
(declare-const T_IM (Array Int Int))

(declare-const T_Cache_Tag (Array (_ BitVec 2) Int))
(declare-const T_Cache_Data (Array (_ BitVec 2) Int))
(declare-const T_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_PC (Int))

(declare-const T_IP (_ BitVec 3))
(declare-const T_CP (_ BitVec 3))

(declare-const T_ROB_busy (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_ROB_op_type (Array (_ BitVec 3) Int))
(declare-const T_ROB_destination (Array (_ BitVec 3) Int))
(declare-const T_ROB_result (Array (_ BitVec 3) Int))
(declare-const T_ROB_exception (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_ROB_done (Array (_ BitVec 3) (_ BitVec 1)))

(declare-const T_RS_op_type (Array (_ BitVec 2) Int))
(declare-const T_RS_op (Array (_ BitVec 2) Int))
(declare-const T_RS_ROB_dst (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_RS_vj (Array (_ BitVec 2) Int))
(declare-const T_RS_vk (Array (_ BitVec 2) Int))
(declare-const T_RS_qj (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_RS_qk (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_RS_imm (Array (_ BitVec 2) Int))
(declare-const T_RS_dis (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_RS_busy (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_LSQ_op_type (Array (_ BitVec 2) Int))
(declare-const T_LSQ_op (Array (_ BitVec 2) Int))
(declare-const T_LSQ_ROB_dst (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_LSQ_vj (Array (_ BitVec 2) Int))
(declare-const T_LSQ_vk (Array (_ BitVec 2) Int))
(declare-const T_LSQ_qj (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_LSQ_qk (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const T_LSQ_imm (Array (_ BitVec 2) Int))
(declare-const T_LSQ_dis (Array (_ BitVec 2) (_ BitVec 1)))
(declare-const T_LSQ_busy (Array (_ BitVec 2) (_ BitVec 1)))

(declare-const T_Evict_Tag (Array (_ BitVec 3) Int))
(declare-const T_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const T_Evict_Index (_ BitVec 3))

(declare-const T_MRB (_ BitVec 3))

(declare-const Rtype (Int))
(declare-const Branch (Int))
(declare-const Mul_div (Int))
(declare-const Load (Int))
(declare-const Store (Int))
(declare-const Jump (Int))

(declare-const U_path_stall (_ BitVec 1))
(declare-const W_path_stall (_ BitVec 1))
(declare-const SCS (_ BitVec 1))

(declare-const int_bit_index (Int))
(declare-const int_bit_index2 (Int))

(declare-const empty_ROB_1bit (Array (_ BitVec 3) (_ BitVec 1)))
(declare-const empty_ROB_int (Array (_ BitVec 3) Int))

(declare-const empty_RS_LSQ_int (Array (_ BitVec 2) Int))
(declare-const empty_RS_LSQ_3bit (Array (_ BitVec 2) (_ BitVec 3)))
(declare-const empty_RS_LSQ_1bit (Array (_ BitVec 2) (_ BitVec 1)))
;)

;(--------------Functions--------------------------
(declare-fun Inst_op (Int) Int)
(declare-fun Inst_op_type (Int) Int)
(declare-fun Inst_rs (Int) Int)
(declare-fun Inst_rt (Int) Int)
(declare-fun Inst_rd (Int) Int)
(declare-fun Inst_imm (Int) Int)

(declare-fun ALU1 (Int Int Int Int) Int)
;(declare-fun ALU2_BR (Int Int Int Int) Int)
(declare-fun MUL_DIV (Int Int Int Int) Int)
(declare-fun LOAD_Unit (Int Int Int) Int)
(declare-fun STORE_Unit (Int Int Int) Int)

(define-fun subtract ((input (_ BitVec 3)) ) (_ BitVec 3)
	(let
		(
			(sub_one (bvsub input (_ bv1 3)))
		)
	(let
		(
			(output 
				(ite (= sub_one #b000) (_ bv4 3)
					sub_one
				)
			)
		)
	))
)

(define-fun ALU2_BR ((rs Int) (rt Int) (imm Int) (op Int)) Int
	(let
		(
			(output (ite (= op 1) 1 0))
		)
	)
)
;)

;(--------------Cache Equivalance Property Function----------------------------------------------------------------------
(define-fun V_U_cache_equivalence ((U_Cache_Tag (Array (_ BitVec 2) Int)) (U_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (U_Evict_Tag (Array (_ BitVec 3) Int)) (U_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1))) (V_Cache_Tag (Array (_ BitVec 2) Int)) (V_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (V_Evict_Tag (Array (_ BitVec 3) Int)) (V_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1))) (S_Cache_Tag (Array (_ BitVec 2) Int)) (S_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (S_Evict_Tag (Array (_ BitVec 3) Int)) (S_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1)))) (_ BitVec 1) 

;---------U_cache is ISA cache------ State V is reached by Stepping the processor once and flushing it------------------
;---------State U is reached by Flushing the processor then projecting it to ISA and steping the ISA once ----------------
	(let
		(
			(U_Cache_entry0 (select U_Cache_Tag (_ bv0 2)))
			(U_Cache_entry1 (select U_Cache_Tag (_ bv1 2)))
			(U_Cache_entry2 (select U_Cache_Tag (_ bv2 2)))
			(U_Cache_entry3 (select U_Cache_Tag (_ bv3 2)))
			
			(U_evicttable_entry0 (select U_Evict_Tag (_ bv0 3)))
			(U_evicttable_entry1 (select U_Evict_Tag (_ bv1 3)))
			(U_evicttable_entry2 (select U_Evict_Tag (_ bv2 3)))
			(U_evicttable_entry3 (select U_Evict_Tag (_ bv3 3)))
			(U_evicttable_entry4 (select U_Evict_Tag (_ bv4 3)))
			(U_evicttable_entry5 (select U_Evict_Tag (_ bv5 3)))
			(U_evicttable_entry6 (select U_Evict_Tag (_ bv6 3)))
			(U_evicttable_entry7 (select U_Evict_Tag (_ bv7 3)))
			
			(V_Cache_entry0 (select V_Cache_Tag (_ bv0 2)))
			(V_Cache_entry1 (select V_Cache_Tag (_ bv1 2)))
			(V_Cache_entry2 (select V_Cache_Tag (_ bv2 2)))
			(V_Cache_entry3 (select V_Cache_Tag (_ bv3 2)))
			
			(V_evicttable_entry0 (select V_Evict_Tag (_ bv0 3)))
			(V_evicttable_entry1 (select V_Evict_Tag (_ bv1 3)))
			(V_evicttable_entry2 (select V_Evict_Tag (_ bv2 3)))
			(V_evicttable_entry3 (select V_Evict_Tag (_ bv3 3)))
			(V_evicttable_entry4 (select V_Evict_Tag (_ bv4 3)))
			(V_evicttable_entry5 (select V_Evict_Tag (_ bv5 3)))
			(V_evicttable_entry6 (select V_Evict_Tag (_ bv6 3)))
			(V_evicttable_entry7 (select V_Evict_Tag (_ bv7 3)))
			
			(S_Cache_entry0 (select S_Cache_Tag (_ bv0 2)))
			(S_Cache_entry1 (select S_Cache_Tag (_ bv1 2)))
			(S_Cache_entry2 (select S_Cache_Tag (_ bv2 2)))
			(S_Cache_entry3 (select S_Cache_Tag (_ bv3 2)))
			
			(S_evicttable_entry0 (select S_Evict_Tag (_ bv0 3)))
			(S_evicttable_entry1 (select S_Evict_Tag (_ bv1 3)))
			(S_evicttable_entry2 (select S_Evict_Tag (_ bv2 3)))
			(S_evicttable_entry3 (select S_Evict_Tag (_ bv3 3)))
			(S_evicttable_entry4 (select S_Evict_Tag (_ bv4 3)))
			(S_evicttable_entry5 (select S_Evict_Tag (_ bv5 3)))
			(S_evicttable_entry6 (select S_Evict_Tag (_ bv6 3)))
			(S_evicttable_entry7 (select S_Evict_Tag (_ bv7 3)))
		)
	(let
		(
			(U_cache0_valid (select U_Cache_Valid (_ bv0 2)))
			(U_cache1_valid (select U_Cache_Valid (_ bv1 2)))
			(U_cache2_valid (select U_Cache_Valid (_ bv2 2)))
			(U_cache3_valid (select U_Cache_Valid (_ bv3 2)))
			
			(U_evict0_valid (select U_Evict_Valid (_ bv0 3)))
			(U_evict1_valid (select U_Evict_Valid (_ bv1 3)))
			(U_evict2_valid (select U_Evict_Valid (_ bv2 3)))
			(U_evict3_valid (select U_Evict_Valid (_ bv3 3)))
			(U_evict4_valid (select U_Evict_Valid (_ bv4 3)))
			(U_evict5_valid (select U_Evict_Valid (_ bv5 3)))
			(U_evict6_valid (select U_Evict_Valid (_ bv6 3)))
			(U_evict7_valid (select U_Evict_Valid (_ bv7 3)))
			
			
			(V_cache0_valid (select V_Cache_Valid (_ bv0 2)))
			(V_cache1_valid (select V_Cache_Valid (_ bv1 2)))
			(V_cache2_valid (select V_Cache_Valid (_ bv2 2)))
			(V_cache3_valid (select V_Cache_Valid (_ bv3 2)))
			
			(V_evict0_valid (select V_Evict_Valid (_ bv0 3)))
			(V_evict1_valid (select V_Evict_Valid (_ bv1 3)))
			(V_evict2_valid (select V_Evict_Valid (_ bv2 3)))
			(V_evict3_valid (select V_Evict_Valid (_ bv3 3)))
			(V_evict4_valid (select V_Evict_Valid (_ bv4 3)))
			(V_evict5_valid (select V_Evict_Valid (_ bv5 3)))
			(V_evict6_valid (select V_Evict_Valid (_ bv6 3)))
			(V_evict7_valid (select V_Evict_Valid (_ bv7 3)))
			
			
			(S_cache0_valid (select S_Cache_Valid (_ bv0 2)))
			(S_cache1_valid (select S_Cache_Valid (_ bv1 2)))
			(S_cache2_valid (select S_Cache_Valid (_ bv2 2)))
			(S_cache3_valid (select S_Cache_Valid (_ bv3 2)))
			
			(S_evict0_valid (select S_Evict_Valid (_ bv0 3)))
			(S_evict1_valid (select S_Evict_Valid (_ bv1 3)))
			(S_evict2_valid (select S_Evict_Valid (_ bv2 3)))
			(S_evict3_valid (select S_Evict_Valid (_ bv3 3)))
			(S_evict4_valid (select S_Evict_Valid (_ bv4 3)))
			(S_evict5_valid (select S_Evict_Valid (_ bv5 3)))
			(S_evict6_valid (select S_Evict_Valid (_ bv6 3)))
			(S_evict7_valid (select S_Evict_Valid (_ bv7 3)))
			
			
		)
	(let
		(
			(U_cache0_check
				(ite 
					(=> (= U_cache0_valid #b1) 
						(or (= U_Cache_entry0 V_Cache_entry0)
							(= U_Cache_entry0 V_Cache_entry1)
							(= U_Cache_entry0 V_Cache_entry2)
							(= U_Cache_entry0 V_Cache_entry3)
							(= U_Cache_entry0 V_evicttable_entry0)
							(= U_Cache_entry0 V_evicttable_entry1)
							(= U_Cache_entry0 V_evicttable_entry2)
							(= U_Cache_entry0 V_evicttable_entry3)
							(= U_Cache_entry0 V_evicttable_entry4)
							(= U_Cache_entry0 V_evicttable_entry5)
							(= U_Cache_entry0 V_evicttable_entry6)
							(= U_Cache_entry0 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_cache1_check
				(ite 
					(=> (= U_cache1_valid #b1) 
						(or (= U_Cache_entry1 V_Cache_entry0)
							(= U_Cache_entry1 V_Cache_entry1)
							(= U_Cache_entry1 V_Cache_entry2)
							(= U_Cache_entry1 V_Cache_entry3)
							(= U_Cache_entry1 V_evicttable_entry0)
							(= U_Cache_entry1 V_evicttable_entry1)
							(= U_Cache_entry1 V_evicttable_entry2)
							(= U_Cache_entry1 V_evicttable_entry3)
							(= U_Cache_entry1 V_evicttable_entry4)
							(= U_Cache_entry1 V_evicttable_entry5)
							(= U_Cache_entry1 V_evicttable_entry6)
							(= U_Cache_entry1 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_cache2_check
				(ite 
					(=> (= U_cache2_valid #b1) 
						(or (= U_Cache_entry2 V_Cache_entry0)
							(= U_Cache_entry2 V_Cache_entry1)
							(= U_Cache_entry2 V_Cache_entry2)
							(= U_Cache_entry2 V_Cache_entry3)
							(= U_Cache_entry2 V_evicttable_entry0)
							(= U_Cache_entry2 V_evicttable_entry1)
							(= U_Cache_entry2 V_evicttable_entry2)
							(= U_Cache_entry2 V_evicttable_entry3)
							(= U_Cache_entry2 V_evicttable_entry4)
							(= U_Cache_entry2 V_evicttable_entry5)
							(= U_Cache_entry2 V_evicttable_entry6)
							(= U_Cache_entry2 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_cache3_check
				(ite 
					(=> (= U_cache3_valid #b1) 
						(or (= U_Cache_entry3 V_Cache_entry0)
							(= U_Cache_entry3 V_Cache_entry1)
							(= U_Cache_entry3 V_Cache_entry2)
							(= U_Cache_entry3 V_Cache_entry3)
							(= U_Cache_entry3 V_evicttable_entry0)
							(= U_Cache_entry3 V_evicttable_entry1)
							(= U_Cache_entry3 V_evicttable_entry2)
							(= U_Cache_entry3 V_evicttable_entry3)
							(= U_Cache_entry3 V_evicttable_entry4)
							(= U_Cache_entry3 V_evicttable_entry5)
							(= U_Cache_entry3 V_evicttable_entry6)
							(= U_Cache_entry3 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict0_check
				(ite 
					(=> (= U_evict0_valid #b1) 
						(or (= U_evicttable_entry0 V_Cache_entry0)
							(= U_evicttable_entry0 V_Cache_entry1)
							(= U_evicttable_entry0 V_Cache_entry2)
							(= U_evicttable_entry0 V_Cache_entry3)
							(= U_evicttable_entry0 V_evicttable_entry0)
							(= U_evicttable_entry0 V_evicttable_entry1)
							(= U_evicttable_entry0 V_evicttable_entry2)
							(= U_evicttable_entry0 V_evicttable_entry3)
							(= U_evicttable_entry0 V_evicttable_entry4)
							(= U_evicttable_entry0 V_evicttable_entry5)
							(= U_evicttable_entry0 V_evicttable_entry6)
							(= U_evicttable_entry0 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict1_check
				(ite 
					(=> (= U_evict1_valid #b1) 
						(or (= U_evicttable_entry1 V_Cache_entry0)
							(= U_evicttable_entry1 V_Cache_entry1)
							(= U_evicttable_entry1 V_Cache_entry2)
							(= U_evicttable_entry1 V_Cache_entry3)
							(= U_evicttable_entry1 V_evicttable_entry0)
							(= U_evicttable_entry1 V_evicttable_entry1)
							(= U_evicttable_entry1 V_evicttable_entry2)
							(= U_evicttable_entry1 V_evicttable_entry3)
							(= U_evicttable_entry1 V_evicttable_entry4)
							(= U_evicttable_entry1 V_evicttable_entry5)
							(= U_evicttable_entry1 V_evicttable_entry6)
							(= U_evicttable_entry1 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict2_check
				(ite 
					(=> (= U_evict2_valid #b1) 
						(or (= U_evicttable_entry2 V_Cache_entry0)
							(= U_evicttable_entry2 V_Cache_entry1)
							(= U_evicttable_entry2 V_Cache_entry2)
							(= U_evicttable_entry2 V_Cache_entry3)
							(= U_evicttable_entry2 V_evicttable_entry0)
							(= U_evicttable_entry2 V_evicttable_entry1)
							(= U_evicttable_entry2 V_evicttable_entry2)
							(= U_evicttable_entry2 V_evicttable_entry3)
							(= U_evicttable_entry2 V_evicttable_entry4)
							(= U_evicttable_entry2 V_evicttable_entry5)
							(= U_evicttable_entry2 V_evicttable_entry6)
							(= U_evicttable_entry2 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict3_check
				(ite 
					(=> (= U_evict3_valid #b1) 
						(or (= U_evicttable_entry3 V_Cache_entry0)
							(= U_evicttable_entry3 V_Cache_entry1)
							(= U_evicttable_entry3 V_Cache_entry2)
							(= U_evicttable_entry3 V_Cache_entry3)
							(= U_evicttable_entry3 V_evicttable_entry0)
							(= U_evicttable_entry3 V_evicttable_entry1)
							(= U_evicttable_entry3 V_evicttable_entry2)
							(= U_evicttable_entry3 V_evicttable_entry3)
							(= U_evicttable_entry3 V_evicttable_entry4)
							(= U_evicttable_entry3 V_evicttable_entry5)
							(= U_evicttable_entry3 V_evicttable_entry6)
							(= U_evicttable_entry3 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict4_check
				(ite 
					(=> (= U_evict4_valid #b1) 
						(or (= U_evicttable_entry4 V_Cache_entry0)
							(= U_evicttable_entry4 V_Cache_entry1)
							(= U_evicttable_entry4 V_Cache_entry2)
							(= U_evicttable_entry4 V_Cache_entry3)
							(= U_evicttable_entry4 V_evicttable_entry0)
							(= U_evicttable_entry4 V_evicttable_entry1)
							(= U_evicttable_entry4 V_evicttable_entry2)
							(= U_evicttable_entry4 V_evicttable_entry3)
							(= U_evicttable_entry4 V_evicttable_entry4)
							(= U_evicttable_entry4 V_evicttable_entry5)
							(= U_evicttable_entry4 V_evicttable_entry6)
							(= U_evicttable_entry4 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict5_check
				(ite 
					(=> (= U_evict5_valid #b1) 
						(or (= U_evicttable_entry5 V_Cache_entry0)
							(= U_evicttable_entry5 V_Cache_entry1)
							(= U_evicttable_entry5 V_Cache_entry2)
							(= U_evicttable_entry5 V_Cache_entry3)
							(= U_evicttable_entry5 V_evicttable_entry0)
							(= U_evicttable_entry5 V_evicttable_entry1)
							(= U_evicttable_entry5 V_evicttable_entry2)
							(= U_evicttable_entry5 V_evicttable_entry3)
							(= U_evicttable_entry5 V_evicttable_entry4)
							(= U_evicttable_entry5 V_evicttable_entry5)
							(= U_evicttable_entry5 V_evicttable_entry6)
							(= U_evicttable_entry5 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict6_check
				(ite 
					(=> (= U_evict6_valid #b1) 
						(or (= U_evicttable_entry6 V_Cache_entry0)
							(= U_evicttable_entry6 V_Cache_entry1)
							(= U_evicttable_entry6 V_Cache_entry2)
							(= U_evicttable_entry6 V_Cache_entry3)
							(= U_evicttable_entry6 V_evicttable_entry0)
							(= U_evicttable_entry6 V_evicttable_entry1)
							(= U_evicttable_entry6 V_evicttable_entry2)
							(= U_evicttable_entry6 V_evicttable_entry3)
							(= U_evicttable_entry6 V_evicttable_entry4)
							(= U_evicttable_entry6 V_evicttable_entry5)
							(= U_evicttable_entry6 V_evicttable_entry6)
							(= U_evicttable_entry6 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(U_evict7_check
				(ite 
					(=> (= U_evict7_valid #b1) 
						(or (= U_evicttable_entry7 V_Cache_entry0)
							(= U_evicttable_entry7 V_Cache_entry1)
							(= U_evicttable_entry7 V_Cache_entry2)
							(= U_evicttable_entry7 V_Cache_entry3)
							(= U_evicttable_entry7 V_evicttable_entry0)
							(= U_evicttable_entry7 V_evicttable_entry1)
							(= U_evicttable_entry7 V_evicttable_entry2)
							(= U_evicttable_entry7 V_evicttable_entry3)
							(= U_evicttable_entry7 V_evicttable_entry4)
							(= U_evicttable_entry7 V_evicttable_entry5)
							(= U_evicttable_entry7 V_evicttable_entry6)
							(= U_evicttable_entry7 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			
		)
	(let
		(
			(U_issubset_of_V (bvand U_cache0_check U_cache1_check U_cache2_check U_cache3_check U_evict0_check U_evict1_check U_evict2_check U_evict3_check U_evict4_check U_evict5_check U_evict6_check U_evict7_check))
		)
	(let
		(
			(V_cache0_check
				(ite 
					(=> (= V_cache0_valid #b1) 
						(or (= V_Cache_entry0 U_Cache_entry0)
							(= V_Cache_entry0 U_Cache_entry1)
							(= V_Cache_entry0 U_Cache_entry2)
							(= V_Cache_entry0 U_Cache_entry3)
							(= V_Cache_entry0 U_evicttable_entry0)
							(= V_Cache_entry0 U_evicttable_entry1)
							(= V_Cache_entry0 U_evicttable_entry2)
							(= V_Cache_entry0 U_evicttable_entry3)
							(= V_Cache_entry0 U_evicttable_entry4)
							(= V_Cache_entry0 U_evicttable_entry5)
							(= V_Cache_entry0 U_evicttable_entry6)
							(= V_Cache_entry0 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache1_check
				(ite 
					(=> (= V_cache1_valid #b1) 
						(or (= V_Cache_entry1 U_Cache_entry0)
							(= V_Cache_entry1 U_Cache_entry1)
							(= V_Cache_entry1 U_Cache_entry2)
							(= V_Cache_entry1 U_Cache_entry3)
							(= V_Cache_entry1 U_evicttable_entry0)
							(= V_Cache_entry1 U_evicttable_entry1)
							(= V_Cache_entry1 U_evicttable_entry2)
							(= V_Cache_entry1 U_evicttable_entry3)
							(= V_Cache_entry1 U_evicttable_entry4)
							(= V_Cache_entry1 U_evicttable_entry5)
							(= V_Cache_entry1 U_evicttable_entry6)
							(= V_Cache_entry1 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache2_check
				(ite 
					(=> (= V_cache2_valid #b1) 
						(or (= V_Cache_entry2 U_Cache_entry0)
							(= V_Cache_entry2 U_Cache_entry1)
							(= V_Cache_entry2 U_Cache_entry2)
							(= V_Cache_entry2 U_Cache_entry3)
							(= V_Cache_entry2 U_evicttable_entry0)
							(= V_Cache_entry2 U_evicttable_entry1)
							(= V_Cache_entry2 U_evicttable_entry2)
							(= V_Cache_entry2 U_evicttable_entry3)
							(= V_Cache_entry2 U_evicttable_entry4)
							(= V_Cache_entry2 U_evicttable_entry5)
							(= V_Cache_entry2 U_evicttable_entry6)
							(= V_Cache_entry2 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache3_check
				(ite 
					(=> (= V_cache3_valid #b1) 
						(or (= V_Cache_entry3 U_Cache_entry0)
							(= V_Cache_entry3 U_Cache_entry1)
							(= V_Cache_entry3 U_Cache_entry2)
							(= V_Cache_entry3 U_Cache_entry3)
							(= V_Cache_entry3 U_evicttable_entry0)
							(= V_Cache_entry3 U_evicttable_entry1)
							(= V_Cache_entry3 U_evicttable_entry2)
							(= V_Cache_entry3 U_evicttable_entry3)
							(= V_Cache_entry3 U_evicttable_entry4)
							(= V_Cache_entry3 U_evicttable_entry5)
							(= V_Cache_entry3 U_evicttable_entry6)
							(= V_Cache_entry3 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict0_check
				(ite 
					(=> (= V_evict0_valid #b1) 
						(or (= V_evicttable_entry0 U_Cache_entry0)
							(= V_evicttable_entry0 U_Cache_entry1)
							(= V_evicttable_entry0 U_Cache_entry2)
							(= V_evicttable_entry0 U_Cache_entry3)
							(= V_evicttable_entry0 U_evicttable_entry0)
							(= V_evicttable_entry0 U_evicttable_entry1)
							(= V_evicttable_entry0 U_evicttable_entry2)
							(= V_evicttable_entry0 U_evicttable_entry3)
							(= V_evicttable_entry0 U_evicttable_entry4)
							(= V_evicttable_entry0 U_evicttable_entry5)
							(= V_evicttable_entry0 U_evicttable_entry6)
							(= V_evicttable_entry0 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict1_check
				(ite 
					(=> (= V_evict1_valid #b1) 
						(or (= V_evicttable_entry1 U_Cache_entry0)
							(= V_evicttable_entry1 U_Cache_entry1)
							(= V_evicttable_entry1 U_Cache_entry2)
							(= V_evicttable_entry1 U_Cache_entry3)
							(= V_evicttable_entry1 U_evicttable_entry0)
							(= V_evicttable_entry1 U_evicttable_entry1)
							(= V_evicttable_entry1 U_evicttable_entry2)
							(= V_evicttable_entry1 U_evicttable_entry3)
							(= V_evicttable_entry1 U_evicttable_entry4)
							(= V_evicttable_entry1 U_evicttable_entry5)
							(= V_evicttable_entry1 U_evicttable_entry6)
							(= V_evicttable_entry1 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict2_check
				(ite 
					(=> (= V_evict2_valid #b1) 
						(or (= V_evicttable_entry2 U_Cache_entry0)
							(= V_evicttable_entry2 U_Cache_entry1)
							(= V_evicttable_entry2 U_Cache_entry2)
							(= V_evicttable_entry2 U_Cache_entry3)
							(= V_evicttable_entry2 U_evicttable_entry0)
							(= V_evicttable_entry2 U_evicttable_entry1)
							(= V_evicttable_entry2 U_evicttable_entry2)
							(= V_evicttable_entry2 U_evicttable_entry3)
							(= V_evicttable_entry2 U_evicttable_entry4)
							(= V_evicttable_entry2 U_evicttable_entry5)
							(= V_evicttable_entry2 U_evicttable_entry6)
							(= V_evicttable_entry2 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict3_check
				(ite 
					(=> (= V_evict3_valid #b1) 
						(or (= V_evicttable_entry3 U_Cache_entry0)
							(= V_evicttable_entry3 U_Cache_entry1)
							(= V_evicttable_entry3 U_Cache_entry2)
							(= V_evicttable_entry3 U_Cache_entry3)
							(= V_evicttable_entry3 U_evicttable_entry0)
							(= V_evicttable_entry3 U_evicttable_entry1)
							(= V_evicttable_entry3 U_evicttable_entry2)
							(= V_evicttable_entry3 U_evicttable_entry3)
							(= V_evicttable_entry3 U_evicttable_entry4)
							(= V_evicttable_entry3 U_evicttable_entry5)
							(= V_evicttable_entry3 U_evicttable_entry6)
							(= V_evicttable_entry3 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict4_check
				(ite 
					(=> (= V_evict4_valid #b1) 
						(or (= V_evicttable_entry4 U_Cache_entry0)
							(= V_evicttable_entry4 U_Cache_entry1)
							(= V_evicttable_entry4 U_Cache_entry2)
							(= V_evicttable_entry4 U_Cache_entry3)
							(= V_evicttable_entry4 U_evicttable_entry0)
							(= V_evicttable_entry4 U_evicttable_entry1)
							(= V_evicttable_entry4 U_evicttable_entry2)
							(= V_evicttable_entry4 U_evicttable_entry3)
							(= V_evicttable_entry4 U_evicttable_entry4)
							(= V_evicttable_entry4 U_evicttable_entry5)
							(= V_evicttable_entry4 U_evicttable_entry6)
							(= V_evicttable_entry4 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict5_check
				(ite 
					(=> (= V_evict5_valid #b1) 
						(or (= V_evicttable_entry5 U_Cache_entry0)
							(= V_evicttable_entry5 U_Cache_entry1)
							(= V_evicttable_entry5 U_Cache_entry2)
							(= V_evicttable_entry5 U_Cache_entry3)
							(= V_evicttable_entry5 U_evicttable_entry0)
							(= V_evicttable_entry5 U_evicttable_entry1)
							(= V_evicttable_entry5 U_evicttable_entry2)
							(= V_evicttable_entry5 U_evicttable_entry3)
							(= V_evicttable_entry5 U_evicttable_entry4)
							(= V_evicttable_entry5 U_evicttable_entry5)
							(= V_evicttable_entry5 U_evicttable_entry6)
							(= V_evicttable_entry5 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict6_check
				(ite 
					(=> (= V_evict6_valid #b1) 
						(or (= V_evicttable_entry6 U_Cache_entry0)
							(= V_evicttable_entry6 U_Cache_entry1)
							(= V_evicttable_entry6 U_Cache_entry2)
							(= V_evicttable_entry6 U_Cache_entry3)
							(= V_evicttable_entry6 U_evicttable_entry0)
							(= V_evicttable_entry6 U_evicttable_entry1)
							(= V_evicttable_entry6 U_evicttable_entry2)
							(= V_evicttable_entry6 U_evicttable_entry3)
							(= V_evicttable_entry6 U_evicttable_entry4)
							(= V_evicttable_entry6 U_evicttable_entry5)
							(= V_evicttable_entry6 U_evicttable_entry6)
							(= V_evicttable_entry6 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict7_check
				(ite 
					(=> (= V_evict7_valid #b1) 
						(or (= V_evicttable_entry7 U_Cache_entry0)
							(= V_evicttable_entry7 U_Cache_entry1)
							(= V_evicttable_entry7 U_Cache_entry2)
							(= V_evicttable_entry7 U_Cache_entry3)
							(= V_evicttable_entry7 U_evicttable_entry0)
							(= V_evicttable_entry7 U_evicttable_entry1)
							(= V_evicttable_entry7 U_evicttable_entry2)
							(= V_evicttable_entry7 U_evicttable_entry3)
							(= V_evicttable_entry7 U_evicttable_entry4)
							(= V_evicttable_entry7 U_evicttable_entry5)
							(= V_evicttable_entry7 U_evicttable_entry6)
							(= V_evicttable_entry7 U_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			
		)
	(let
		(
			(V_issubset_of_U (bvand V_cache0_check V_cache1_check V_cache2_check V_cache3_check V_evict0_check V_evict1_check V_evict2_check V_evict3_check V_evict4_check V_evict5_check V_evict6_check V_evict7_check))
		)
	(let
		(
			(cache_are_eqvi (bvand U_issubset_of_V V_issubset_of_U))
		)
	)))))))
)
(define-fun V_S_cache_equivalence ((U_Cache_Tag (Array (_ BitVec 2) Int)) (U_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (U_Evict_Tag (Array (_ BitVec 3) Int)) (U_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1))) (V_Cache_Tag (Array (_ BitVec 2) Int)) (V_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (V_Evict_Tag (Array (_ BitVec 3) Int)) (V_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1))) (S_Cache_Tag (Array (_ BitVec 2) Int)) (S_Cache_Valid (Array (_ BitVec 2) (_ BitVec 1))) (S_Evict_Tag (Array (_ BitVec 3) Int)) (S_Evict_Valid (Array (_ BitVec 3) (_ BitVec 1)))) (_ BitVec 1) 

;---------U_cache is ISA cache------ State V is reached by Stepping the processor once and flushing it------------------
;---------State U is reached by Flushing the processor then projecting it to ISA and steping the ISA once ----------------
	(let
		(
			(U_Cache_entry0 (select U_Cache_Tag (_ bv0 2)))
			(U_Cache_entry1 (select U_Cache_Tag (_ bv1 2)))
			(U_Cache_entry2 (select U_Cache_Tag (_ bv2 2)))
			(U_Cache_entry3 (select U_Cache_Tag (_ bv3 2)))
			
			(U_evicttable_entry0 (select U_Evict_Tag (_ bv0 3)))
			(U_evicttable_entry1 (select U_Evict_Tag (_ bv1 3)))
			(U_evicttable_entry2 (select U_Evict_Tag (_ bv2 3)))
			(U_evicttable_entry3 (select U_Evict_Tag (_ bv3 3)))
			(U_evicttable_entry4 (select U_Evict_Tag (_ bv4 3)))
			(U_evicttable_entry5 (select U_Evict_Tag (_ bv5 3)))
			(U_evicttable_entry6 (select U_Evict_Tag (_ bv6 3)))
			(U_evicttable_entry7 (select U_Evict_Tag (_ bv7 3)))
			
			(V_Cache_entry0 (select V_Cache_Tag (_ bv0 2)))
			(V_Cache_entry1 (select V_Cache_Tag (_ bv1 2)))
			(V_Cache_entry2 (select V_Cache_Tag (_ bv2 2)))
			(V_Cache_entry3 (select V_Cache_Tag (_ bv3 2)))
			
			(V_evicttable_entry0 (select V_Evict_Tag (_ bv0 3)))
			(V_evicttable_entry1 (select V_Evict_Tag (_ bv1 3)))
			(V_evicttable_entry2 (select V_Evict_Tag (_ bv2 3)))
			(V_evicttable_entry3 (select V_Evict_Tag (_ bv3 3)))
			(V_evicttable_entry4 (select V_Evict_Tag (_ bv4 3)))
			(V_evicttable_entry5 (select V_Evict_Tag (_ bv5 3)))
			(V_evicttable_entry6 (select V_Evict_Tag (_ bv6 3)))
			(V_evicttable_entry7 (select V_Evict_Tag (_ bv7 3)))
			
			(S_Cache_entry0 (select S_Cache_Tag (_ bv0 2)))
			(S_Cache_entry1 (select S_Cache_Tag (_ bv1 2)))
			(S_Cache_entry2 (select S_Cache_Tag (_ bv2 2)))
			(S_Cache_entry3 (select S_Cache_Tag (_ bv3 2)))
			
			(S_evicttable_entry0 (select S_Evict_Tag (_ bv0 3)))
			(S_evicttable_entry1 (select S_Evict_Tag (_ bv1 3)))
			(S_evicttable_entry2 (select S_Evict_Tag (_ bv2 3)))
			(S_evicttable_entry3 (select S_Evict_Tag (_ bv3 3)))
			(S_evicttable_entry4 (select S_Evict_Tag (_ bv4 3)))
			(S_evicttable_entry5 (select S_Evict_Tag (_ bv5 3)))
			(S_evicttable_entry6 (select S_Evict_Tag (_ bv6 3)))
			(S_evicttable_entry7 (select S_Evict_Tag (_ bv7 3)))
		)
	(let
		(
			(U_cache0_valid (select U_Cache_Valid (_ bv0 2)))
			(U_cache1_valid (select U_Cache_Valid (_ bv1 2)))
			(U_cache2_valid (select U_Cache_Valid (_ bv2 2)))
			(U_cache3_valid (select U_Cache_Valid (_ bv3 2)))
			
			(U_evict0_valid (select U_Evict_Valid (_ bv0 3)))
			(U_evict1_valid (select U_Evict_Valid (_ bv1 3)))
			(U_evict2_valid (select U_Evict_Valid (_ bv2 3)))
			(U_evict3_valid (select U_Evict_Valid (_ bv3 3)))
			(U_evict4_valid (select U_Evict_Valid (_ bv4 3)))
			(U_evict5_valid (select U_Evict_Valid (_ bv5 3)))
			(U_evict6_valid (select U_Evict_Valid (_ bv6 3)))
			(U_evict7_valid (select U_Evict_Valid (_ bv7 3)))
			
			
			(V_cache0_valid (select V_Cache_Valid (_ bv0 2)))
			(V_cache1_valid (select V_Cache_Valid (_ bv1 2)))
			(V_cache2_valid (select V_Cache_Valid (_ bv2 2)))
			(V_cache3_valid (select V_Cache_Valid (_ bv3 2)))
			
			(V_evict0_valid (select V_Evict_Valid (_ bv0 3)))
			(V_evict1_valid (select V_Evict_Valid (_ bv1 3)))
			(V_evict2_valid (select V_Evict_Valid (_ bv2 3)))
			(V_evict3_valid (select V_Evict_Valid (_ bv3 3)))
			(V_evict4_valid (select V_Evict_Valid (_ bv4 3)))
			(V_evict5_valid (select V_Evict_Valid (_ bv5 3)))
			(V_evict6_valid (select V_Evict_Valid (_ bv6 3)))
			(V_evict7_valid (select V_Evict_Valid (_ bv7 3)))
			
			
			(S_cache0_valid (select S_Cache_Valid (_ bv0 2)))
			(S_cache1_valid (select S_Cache_Valid (_ bv1 2)))
			(S_cache2_valid (select S_Cache_Valid (_ bv2 2)))
			(S_cache3_valid (select S_Cache_Valid (_ bv3 2)))
			
			(S_evict0_valid (select S_Evict_Valid (_ bv0 3)))
			(S_evict1_valid (select S_Evict_Valid (_ bv1 3)))
			(S_evict2_valid (select S_Evict_Valid (_ bv2 3)))
			(S_evict3_valid (select S_Evict_Valid (_ bv3 3)))
			(S_evict4_valid (select S_Evict_Valid (_ bv4 3)))
			(S_evict5_valid (select S_Evict_Valid (_ bv5 3)))
			(S_evict6_valid (select S_Evict_Valid (_ bv6 3)))
			(S_evict7_valid (select S_Evict_Valid (_ bv7 3)))
			
			
		)
	(let
		(
			(S_cache0_check
				(ite 
					(=> (= S_cache0_valid #b1) 
						(or (= S_Cache_entry0 V_Cache_entry0)
							(= S_Cache_entry0 V_Cache_entry1)
							(= S_Cache_entry0 V_Cache_entry2)
							(= S_Cache_entry0 V_Cache_entry3)
							(= S_Cache_entry0 V_evicttable_entry0)
							(= S_Cache_entry0 V_evicttable_entry1)
							(= S_Cache_entry0 V_evicttable_entry2)
							(= S_Cache_entry0 V_evicttable_entry3)
							(= S_Cache_entry0 V_evicttable_entry4)
							(= S_Cache_entry0 V_evicttable_entry5)
							(= S_Cache_entry0 V_evicttable_entry6)
							(= S_Cache_entry0 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_cache1_check
				(ite 
					(=> (= S_cache1_valid #b1) 
						(or (= S_Cache_entry1 V_Cache_entry0)
							(= S_Cache_entry1 V_Cache_entry1)
							(= S_Cache_entry1 V_Cache_entry2)
							(= S_Cache_entry1 V_Cache_entry3)
							(= S_Cache_entry1 V_evicttable_entry0)
							(= S_Cache_entry1 V_evicttable_entry1)
							(= S_Cache_entry1 V_evicttable_entry2)
							(= S_Cache_entry1 V_evicttable_entry3)
							(= S_Cache_entry1 V_evicttable_entry4)
							(= S_Cache_entry1 V_evicttable_entry5)
							(= S_Cache_entry1 V_evicttable_entry6)
							(= S_Cache_entry1 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_cache2_check
				(ite 
					(=> (= S_cache2_valid #b1) 
						(or (= S_Cache_entry2 V_Cache_entry0)
							(= S_Cache_entry2 V_Cache_entry1)
							(= S_Cache_entry2 V_Cache_entry2)
							(= S_Cache_entry2 V_Cache_entry3)
							(= S_Cache_entry2 V_evicttable_entry0)
							(= S_Cache_entry2 V_evicttable_entry1)
							(= S_Cache_entry2 V_evicttable_entry2)
							(= S_Cache_entry2 V_evicttable_entry3)
							(= S_Cache_entry2 V_evicttable_entry4)
							(= S_Cache_entry2 V_evicttable_entry5)
							(= S_Cache_entry2 V_evicttable_entry6)
							(= S_Cache_entry2 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_cache3_check
				(ite 
					(=> (= S_cache3_valid #b1) 
						(or (= S_Cache_entry3 V_Cache_entry0)
							(= S_Cache_entry3 V_Cache_entry1)
							(= S_Cache_entry3 V_Cache_entry2)
							(= S_Cache_entry3 V_Cache_entry3)
							(= S_Cache_entry3 V_evicttable_entry0)
							(= S_Cache_entry3 V_evicttable_entry1)
							(= S_Cache_entry3 V_evicttable_entry2)
							(= S_Cache_entry3 V_evicttable_entry3)
							(= S_Cache_entry3 V_evicttable_entry4)
							(= S_Cache_entry3 V_evicttable_entry5)
							(= S_Cache_entry3 V_evicttable_entry6)
							(= S_Cache_entry3 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict0_check
				(ite 
					(=> (= S_evict0_valid #b1) 
						(or (= S_evicttable_entry0 V_Cache_entry0)
							(= S_evicttable_entry0 V_Cache_entry1)
							(= S_evicttable_entry0 V_Cache_entry2)
							(= S_evicttable_entry0 V_Cache_entry3)
							(= S_evicttable_entry0 V_evicttable_entry0)
							(= S_evicttable_entry0 V_evicttable_entry1)
							(= S_evicttable_entry0 V_evicttable_entry2)
							(= S_evicttable_entry0 V_evicttable_entry3)
							(= S_evicttable_entry0 V_evicttable_entry4)
							(= S_evicttable_entry0 V_evicttable_entry5)
							(= S_evicttable_entry0 V_evicttable_entry6)
							(= S_evicttable_entry0 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict1_check
				(ite 
					(=> (= S_evict1_valid #b1) 
						(or (= S_evicttable_entry1 V_Cache_entry0)
							(= S_evicttable_entry1 V_Cache_entry1)
							(= S_evicttable_entry1 V_Cache_entry2)
							(= S_evicttable_entry1 V_Cache_entry3)
							(= S_evicttable_entry1 V_evicttable_entry0)
							(= S_evicttable_entry1 V_evicttable_entry1)
							(= S_evicttable_entry1 V_evicttable_entry2)
							(= S_evicttable_entry1 V_evicttable_entry3)
							(= S_evicttable_entry1 V_evicttable_entry4)
							(= S_evicttable_entry1 V_evicttable_entry5)
							(= S_evicttable_entry1 V_evicttable_entry6)
							(= S_evicttable_entry1 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict2_check
				(ite 
					(=> (= S_evict2_valid #b1) 
						(or (= S_evicttable_entry2 V_Cache_entry0)
							(= S_evicttable_entry2 V_Cache_entry1)
							(= S_evicttable_entry2 V_Cache_entry2)
							(= S_evicttable_entry2 V_Cache_entry3)
							(= S_evicttable_entry2 V_evicttable_entry0)
							(= S_evicttable_entry2 V_evicttable_entry1)
							(= S_evicttable_entry2 V_evicttable_entry2)
							(= S_evicttable_entry2 V_evicttable_entry3)
							(= S_evicttable_entry2 V_evicttable_entry4)
							(= S_evicttable_entry2 V_evicttable_entry5)
							(= S_evicttable_entry2 V_evicttable_entry6)
							(= S_evicttable_entry2 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict3_check
				(ite 
					(=> (= S_evict3_valid #b1) 
						(or (= S_evicttable_entry3 V_Cache_entry0)
							(= S_evicttable_entry3 V_Cache_entry1)
							(= S_evicttable_entry3 V_Cache_entry2)
							(= S_evicttable_entry3 V_Cache_entry3)
							(= S_evicttable_entry3 V_evicttable_entry0)
							(= S_evicttable_entry3 V_evicttable_entry1)
							(= S_evicttable_entry3 V_evicttable_entry2)
							(= S_evicttable_entry3 V_evicttable_entry3)
							(= S_evicttable_entry3 V_evicttable_entry4)
							(= S_evicttable_entry3 V_evicttable_entry5)
							(= S_evicttable_entry3 V_evicttable_entry6)
							(= S_evicttable_entry3 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict4_check
				(ite 
					(=> (= S_evict4_valid #b1) 
						(or (= S_evicttable_entry4 V_Cache_entry0)
							(= S_evicttable_entry4 V_Cache_entry1)
							(= S_evicttable_entry4 V_Cache_entry2)
							(= S_evicttable_entry4 V_Cache_entry3)
							(= S_evicttable_entry4 V_evicttable_entry0)
							(= S_evicttable_entry4 V_evicttable_entry1)
							(= S_evicttable_entry4 V_evicttable_entry2)
							(= S_evicttable_entry4 V_evicttable_entry3)
							(= S_evicttable_entry4 V_evicttable_entry4)
							(= S_evicttable_entry4 V_evicttable_entry5)
							(= S_evicttable_entry4 V_evicttable_entry6)
							(= S_evicttable_entry4 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict5_check
				(ite 
					(=> (= S_evict5_valid #b1) 
						(or (= S_evicttable_entry5 V_Cache_entry0)
							(= S_evicttable_entry5 V_Cache_entry1)
							(= S_evicttable_entry5 V_Cache_entry2)
							(= S_evicttable_entry5 V_Cache_entry3)
							(= S_evicttable_entry5 V_evicttable_entry0)
							(= S_evicttable_entry5 V_evicttable_entry1)
							(= S_evicttable_entry5 V_evicttable_entry2)
							(= S_evicttable_entry5 V_evicttable_entry3)
							(= S_evicttable_entry5 V_evicttable_entry4)
							(= S_evicttable_entry5 V_evicttable_entry5)
							(= S_evicttable_entry5 V_evicttable_entry6)
							(= S_evicttable_entry5 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict6_check
				(ite 
					(=> (= S_evict6_valid #b1) 
						(or (= S_evicttable_entry6 V_Cache_entry0)
							(= S_evicttable_entry6 V_Cache_entry1)
							(= S_evicttable_entry6 V_Cache_entry2)
							(= S_evicttable_entry6 V_Cache_entry3)
							(= S_evicttable_entry6 V_evicttable_entry0)
							(= S_evicttable_entry6 V_evicttable_entry1)
							(= S_evicttable_entry6 V_evicttable_entry2)
							(= S_evicttable_entry6 V_evicttable_entry3)
							(= S_evicttable_entry6 V_evicttable_entry4)
							(= S_evicttable_entry6 V_evicttable_entry5)
							(= S_evicttable_entry6 V_evicttable_entry6)
							(= S_evicttable_entry6 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(S_evict7_check
				(ite 
					(=> (= S_evict7_valid #b1) 
						(or (= S_evicttable_entry7 V_Cache_entry0)
							(= S_evicttable_entry7 V_Cache_entry1)
							(= S_evicttable_entry7 V_Cache_entry2)
							(= S_evicttable_entry7 V_Cache_entry3)
							(= S_evicttable_entry7 V_evicttable_entry0)
							(= S_evicttable_entry7 V_evicttable_entry1)
							(= S_evicttable_entry7 V_evicttable_entry2)
							(= S_evicttable_entry7 V_evicttable_entry3)
							(= S_evicttable_entry7 V_evicttable_entry4)
							(= S_evicttable_entry7 V_evicttable_entry5)
							(= S_evicttable_entry7 V_evicttable_entry6)
							(= S_evicttable_entry7 V_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			
		)
	(let
		(
			(S_issubset_of_V (bvand S_cache0_check S_cache1_check S_cache2_check S_cache3_check S_evict0_check S_evict1_check S_evict2_check S_evict3_check S_evict4_check S_evict5_check S_evict6_check S_evict7_check))
		)
	(let
		(
			(V_cache0_check
				(ite 
					(=> (= V_cache0_valid #b1) 
						(or (= V_Cache_entry0 S_Cache_entry0)
							(= V_Cache_entry0 S_Cache_entry1)
							(= V_Cache_entry0 S_Cache_entry2)
							(= V_Cache_entry0 S_Cache_entry3)
							(= V_Cache_entry0 S_evicttable_entry0)
							(= V_Cache_entry0 S_evicttable_entry1)
							(= V_Cache_entry0 S_evicttable_entry2)
							(= V_Cache_entry0 S_evicttable_entry3)
							(= V_Cache_entry0 S_evicttable_entry4)
							(= V_Cache_entry0 S_evicttable_entry5)
							(= V_Cache_entry0 S_evicttable_entry6)
							(= V_Cache_entry0 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache1_check
				(ite 
					(=> (= V_cache1_valid #b1) 
						(or (= V_Cache_entry1 S_Cache_entry0)
							(= V_Cache_entry1 S_Cache_entry1)
							(= V_Cache_entry1 S_Cache_entry2)
							(= V_Cache_entry1 S_Cache_entry3)
							(= V_Cache_entry1 S_evicttable_entry0)
							(= V_Cache_entry1 S_evicttable_entry1)
							(= V_Cache_entry1 S_evicttable_entry2)
							(= V_Cache_entry1 S_evicttable_entry3)
							(= V_Cache_entry1 S_evicttable_entry4)
							(= V_Cache_entry1 S_evicttable_entry5)
							(= V_Cache_entry1 S_evicttable_entry6)
							(= V_Cache_entry1 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache2_check
				(ite 
					(=> (= V_cache2_valid #b1) 
						(or (= V_Cache_entry2 S_Cache_entry0)
							(= V_Cache_entry2 S_Cache_entry1)
							(= V_Cache_entry2 S_Cache_entry2)
							(= V_Cache_entry2 S_Cache_entry3)
							(= V_Cache_entry2 S_evicttable_entry0)
							(= V_Cache_entry2 S_evicttable_entry1)
							(= V_Cache_entry2 S_evicttable_entry2)
							(= V_Cache_entry2 S_evicttable_entry3)
							(= V_Cache_entry2 S_evicttable_entry4)
							(= V_Cache_entry2 S_evicttable_entry5)
							(= V_Cache_entry2 S_evicttable_entry6)
							(= V_Cache_entry2 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_cache3_check
				(ite 
					(=> (= V_cache3_valid #b1) 
						(or (= V_Cache_entry3 S_Cache_entry0)
							(= V_Cache_entry3 S_Cache_entry1)
							(= V_Cache_entry3 S_Cache_entry2)
							(= V_Cache_entry3 S_Cache_entry3)
							(= V_Cache_entry3 S_evicttable_entry0)
							(= V_Cache_entry3 S_evicttable_entry1)
							(= V_Cache_entry3 S_evicttable_entry2)
							(= V_Cache_entry3 S_evicttable_entry3)
							(= V_Cache_entry3 S_evicttable_entry4)
							(= V_Cache_entry3 S_evicttable_entry5)
							(= V_Cache_entry3 S_evicttable_entry6)
							(= V_Cache_entry3 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict0_check
				(ite 
					(=> (= V_evict0_valid #b1) 
						(or (= V_evicttable_entry0 S_Cache_entry0)
							(= V_evicttable_entry0 S_Cache_entry1)
							(= V_evicttable_entry0 S_Cache_entry2)
							(= V_evicttable_entry0 S_Cache_entry3)
							(= V_evicttable_entry0 S_evicttable_entry0)
							(= V_evicttable_entry0 S_evicttable_entry1)
							(= V_evicttable_entry0 S_evicttable_entry2)
							(= V_evicttable_entry0 S_evicttable_entry3)
							(= V_evicttable_entry0 S_evicttable_entry4)
							(= V_evicttable_entry0 S_evicttable_entry5)
							(= V_evicttable_entry0 S_evicttable_entry6)
							(= V_evicttable_entry0 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict1_check
				(ite 
					(=> (= V_evict1_valid #b1) 
						(or (= V_evicttable_entry1 S_Cache_entry0)
							(= V_evicttable_entry1 S_Cache_entry1)
							(= V_evicttable_entry1 S_Cache_entry2)
							(= V_evicttable_entry1 S_Cache_entry3)
							(= V_evicttable_entry1 S_evicttable_entry0)
							(= V_evicttable_entry1 S_evicttable_entry1)
							(= V_evicttable_entry1 S_evicttable_entry2)
							(= V_evicttable_entry1 S_evicttable_entry3)
							(= V_evicttable_entry1 S_evicttable_entry4)
							(= V_evicttable_entry1 S_evicttable_entry5)
							(= V_evicttable_entry1 S_evicttable_entry6)
							(= V_evicttable_entry1 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict2_check
				(ite 
					(=> (= V_evict2_valid #b1) 
						(or (= V_evicttable_entry2 S_Cache_entry0)
							(= V_evicttable_entry2 S_Cache_entry1)
							(= V_evicttable_entry2 S_Cache_entry2)
							(= V_evicttable_entry2 S_Cache_entry3)
							(= V_evicttable_entry2 S_evicttable_entry0)
							(= V_evicttable_entry2 S_evicttable_entry1)
							(= V_evicttable_entry2 S_evicttable_entry2)
							(= V_evicttable_entry2 S_evicttable_entry3)
							(= V_evicttable_entry2 S_evicttable_entry4)
							(= V_evicttable_entry2 S_evicttable_entry5)
							(= V_evicttable_entry2 S_evicttable_entry6)
							(= V_evicttable_entry2 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict3_check
				(ite 
					(=> (= V_evict3_valid #b1) 
						(or (= V_evicttable_entry3 S_Cache_entry0)
							(= V_evicttable_entry3 S_Cache_entry1)
							(= V_evicttable_entry3 S_Cache_entry2)
							(= V_evicttable_entry3 S_Cache_entry3)
							(= V_evicttable_entry3 S_evicttable_entry0)
							(= V_evicttable_entry3 S_evicttable_entry1)
							(= V_evicttable_entry3 S_evicttable_entry2)
							(= V_evicttable_entry3 S_evicttable_entry3)
							(= V_evicttable_entry3 S_evicttable_entry4)
							(= V_evicttable_entry3 S_evicttable_entry5)
							(= V_evicttable_entry3 S_evicttable_entry6)
							(= V_evicttable_entry3 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict4_check
				(ite 
					(=> (= V_evict4_valid #b1) 
						(or (= V_evicttable_entry4 S_Cache_entry0)
							(= V_evicttable_entry4 S_Cache_entry1)
							(= V_evicttable_entry4 S_Cache_entry2)
							(= V_evicttable_entry4 S_Cache_entry3)
							(= V_evicttable_entry4 S_evicttable_entry0)
							(= V_evicttable_entry4 S_evicttable_entry1)
							(= V_evicttable_entry4 S_evicttable_entry2)
							(= V_evicttable_entry4 S_evicttable_entry3)
							(= V_evicttable_entry4 S_evicttable_entry4)
							(= V_evicttable_entry4 S_evicttable_entry5)
							(= V_evicttable_entry4 S_evicttable_entry6)
							(= V_evicttable_entry4 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict5_check
				(ite 
					(=> (= V_evict5_valid #b1) 
						(or (= V_evicttable_entry5 S_Cache_entry0)
							(= V_evicttable_entry5 S_Cache_entry1)
							(= V_evicttable_entry5 S_Cache_entry2)
							(= V_evicttable_entry5 S_Cache_entry3)
							(= V_evicttable_entry5 S_evicttable_entry0)
							(= V_evicttable_entry5 S_evicttable_entry1)
							(= V_evicttable_entry5 S_evicttable_entry2)
							(= V_evicttable_entry5 S_evicttable_entry3)
							(= V_evicttable_entry5 S_evicttable_entry4)
							(= V_evicttable_entry5 S_evicttable_entry5)
							(= V_evicttable_entry5 S_evicttable_entry6)
							(= V_evicttable_entry5 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict6_check
				(ite 
					(=> (= V_evict6_valid #b1) 
						(or (= V_evicttable_entry6 S_Cache_entry0)
							(= V_evicttable_entry6 S_Cache_entry1)
							(= V_evicttable_entry6 S_Cache_entry2)
							(= V_evicttable_entry6 S_Cache_entry3)
							(= V_evicttable_entry6 S_evicttable_entry0)
							(= V_evicttable_entry6 S_evicttable_entry1)
							(= V_evicttable_entry6 S_evicttable_entry2)
							(= V_evicttable_entry6 S_evicttable_entry3)
							(= V_evicttable_entry6 S_evicttable_entry4)
							(= V_evicttable_entry6 S_evicttable_entry5)
							(= V_evicttable_entry6 S_evicttable_entry6)
							(= V_evicttable_entry6 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			(V_evict7_check
				(ite 
					(=> (= V_evict7_valid #b1) 
						(or (= V_evicttable_entry7 S_Cache_entry0)
							(= V_evicttable_entry7 S_Cache_entry1)
							(= V_evicttable_entry7 S_Cache_entry2)
							(= V_evicttable_entry7 S_Cache_entry3)
							(= V_evicttable_entry7 S_evicttable_entry0)
							(= V_evicttable_entry7 S_evicttable_entry1)
							(= V_evicttable_entry7 S_evicttable_entry2)
							(= V_evicttable_entry7 S_evicttable_entry3)
							(= V_evicttable_entry7 S_evicttable_entry4)
							(= V_evicttable_entry7 S_evicttable_entry5)
							(= V_evicttable_entry7 S_evicttable_entry6)
							(= V_evicttable_entry7 S_evicttable_entry7)
						)
					)
					(_ bv1 1)
					(_ bv0 1)
				)
			)
			
		)
	(let
		(
			(V_issubset_of_U (bvand V_cache0_check V_cache1_check V_cache2_check V_cache3_check V_evict0_check V_evict1_check V_evict2_check V_evict3_check V_evict4_check V_evict5_check V_evict6_check V_evict7_check))
		)
	(let
		(
			(cache_are_eqvi (bvand S_issubset_of_V V_issubset_of_U))
		)
	)))))))
)


;)

;(--------------Visual Declarations-------------
(declare-const T_state_Cache0_Tag (Int))
(declare-const T_state_Cache1_Tag (Int))
(declare-const T_state_Cache2_Tag (Int))
(declare-const T_state_Cache3_Tag (Int))
(declare-const T_state_Cache0_Data (Int))
(declare-const T_state_Cache1_Data (Int))
(declare-const T_state_Cache2_Data (Int))
(declare-const T_state_Cache3_Data (Int))
(declare-const T_state_Cache0_Valid (_ BitVec 1))
(declare-const T_state_Cache1_Valid (_ BitVec 1))
(declare-const T_state_Cache2_Valid (_ BitVec 1))
(declare-const T_state_Cache3_Valid (_ BitVec 1))


(declare-const T_state_Evict0_Valid (_ BitVec 1))
(declare-const T_state_Evict1_Valid (_ BitVec 1))
(declare-const T_state_Evict2_Valid (_ BitVec 1))
(declare-const T_state_Evict3_Valid (_ BitVec 1))
(declare-const T_state_Evict4_Valid (_ BitVec 1))
(declare-const T_state_Evict5_Valid (_ BitVec 1))
(declare-const T_state_Evict6_Valid (_ BitVec 1))
(declare-const T_state_Evict7_Valid (_ BitVec 1))
(declare-const T_state_Evict0_Tag (Int))
(declare-const T_state_Evict1_Tag (Int))
(declare-const T_state_Evict2_Tag (Int))
(declare-const T_state_Evict3_Tag (Int))
(declare-const T_state_Evict4_Tag (Int))
(declare-const T_state_Evict5_Tag (Int))
(declare-const T_state_Evict6_Tag (Int))
(declare-const T_state_Evict7_Tag (Int))

(declare-const T_state_IP (_ BitVec 3))
(declare-const T_state_CP (_ BitVec 3))
(declare-const T_state_PC (Int))

(declare-const T_state_ROB0_busy (_ BitVec 1))
(declare-const T_state_ROB0_op_type (Int))
(declare-const T_state_ROB0_destination (Int))
(declare-const T_state_ROB0_result (Int))
(declare-const T_state_ROB0_exception (_ BitVec 1))
(declare-const T_state_ROB0_done (_ BitVec 1))

(declare-const T_state_ROB1_busy (_ BitVec 1))
(declare-const T_state_ROB1_op_type (Int))
(declare-const T_state_ROB1_destination (Int))
(declare-const T_state_ROB1_result (Int))
(declare-const T_state_ROB1_exception (_ BitVec 1))
(declare-const T_state_ROB1_done (_ BitVec 1))

(declare-const T_state_ROB2_busy (_ BitVec 1))
(declare-const T_state_ROB2_op_type (Int))
(declare-const T_state_ROB2_destination (Int))
(declare-const T_state_ROB2_result (Int))
(declare-const T_state_ROB2_exception (_ BitVec 1))
(declare-const T_state_ROB2_done (_ BitVec 1))

(declare-const T_state_ROB3_busy (_ BitVec 1))
(declare-const T_state_ROB3_op_type (Int))
(declare-const T_state_ROB3_destination (Int))
(declare-const T_state_ROB3_result (Int))
(declare-const T_state_ROB3_exception (_ BitVec 1))
(declare-const T_state_ROB3_done (_ BitVec 1))

(declare-const T_state_ROB4_busy (_ BitVec 1))
(declare-const T_state_ROB4_op_type (Int))
(declare-const T_state_ROB4_destination (Int))
(declare-const T_state_ROB4_result (Int))
(declare-const T_state_ROB4_exception (_ BitVec 1))
(declare-const T_state_ROB4_done (_ BitVec 1))

(declare-const T_state_ROB5_busy (_ BitVec 1))
(declare-const T_state_ROB5_op_type (Int))
(declare-const T_state_ROB5_destination (Int))
(declare-const T_state_ROB5_result (Int))
(declare-const T_state_ROB5_exception (_ BitVec 1))
(declare-const T_state_ROB5_done (_ BitVec 1))

(declare-const T_state_ROB6_busy (_ BitVec 1))
(declare-const T_state_ROB6_op_type (Int))
(declare-const T_state_ROB6_destination (Int))
(declare-const T_state_ROB6_result (Int))
(declare-const T_state_ROB6_exception (_ BitVec 1))
(declare-const T_state_ROB6_done (_ BitVec 1))

(declare-const T_state_ROB7_busy (_ BitVec 1))
(declare-const T_state_ROB7_op_type (Int))
(declare-const T_state_ROB7_destination (Int))
(declare-const T_state_ROB7_result (Int))
(declare-const T_state_ROB7_exception (_ BitVec 1))
(declare-const T_state_ROB7_done (_ BitVec 1))

(declare-const T_state_RS0_op_type (Int))
(declare-const T_state_RS0_op (Int))
(declare-const T_state_RS0_ROB_dst (_ BitVec 3))
(declare-const T_state_RS0_vj (Int))
(declare-const T_state_RS0_vk (Int))
(declare-const T_state_RS0_qj (_ BitVec 3))
(declare-const T_state_RS0_qk (_ BitVec 3))
(declare-const T_state_RS0_imm (Int))
(declare-const T_state_RS0_dis (_ BitVec 1))
(declare-const T_state_RS0_busy (_ BitVec 1))

(declare-const T_state_RS1_op_type (Int))
(declare-const T_state_RS1_op (Int))
(declare-const T_state_RS1_ROB_dst (_ BitVec 3))
(declare-const T_state_RS1_vj (Int))
(declare-const T_state_RS1_vk (Int))
(declare-const T_state_RS1_qj (_ BitVec 3))
(declare-const T_state_RS1_qk (_ BitVec 3))
(declare-const T_state_RS1_imm (Int))
(declare-const T_state_RS1_dis (_ BitVec 1))
(declare-const T_state_RS1_busy (_ BitVec 1))

(declare-const T_state_RS2_op_type (Int))
(declare-const T_state_RS2_op (Int))
(declare-const T_state_RS2_ROB_dst (_ BitVec 3))
(declare-const T_state_RS2_vj (Int))
(declare-const T_state_RS2_vk (Int))
(declare-const T_state_RS2_qj (_ BitVec 3))
(declare-const T_state_RS2_qk (_ BitVec 3))
(declare-const T_state_RS2_imm (Int))
(declare-const T_state_RS2_dis (_ BitVec 1))
(declare-const T_state_RS2_busy (_ BitVec 1))

(declare-const T_state_RS3_op_type (Int))
(declare-const T_state_RS3_op (Int))
(declare-const T_state_RS3_ROB_dst (_ BitVec 3))
(declare-const T_state_RS3_vj (Int))
(declare-const T_state_RS3_vk (Int))
(declare-const T_state_RS3_qj (_ BitVec 3))
(declare-const T_state_RS3_qk (_ BitVec 3))
(declare-const T_state_RS3_imm (Int))
(declare-const T_state_RS3_dis (_ BitVec 1))
(declare-const T_state_RS3_busy (_ BitVec 1))

(declare-const T_state_LSQ0_op_type (Int))
(declare-const T_state_LSQ0_op (Int))
(declare-const T_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const T_state_LSQ0_vj (Int))
(declare-const T_state_LSQ0_vk (Int))
(declare-const T_state_LSQ0_qj (_ BitVec 3))
(declare-const T_state_LSQ0_qk (_ BitVec 3))
(declare-const T_state_LSQ0_imm (Int))
(declare-const T_state_LSQ0_dis (_ BitVec 1))
(declare-const T_state_LSQ0_busy (_ BitVec 1))

(declare-const T_state_LSQ1_op_type (Int))
(declare-const T_state_LSQ1_op (Int))
(declare-const T_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const T_state_LSQ1_vj (Int))
(declare-const T_state_LSQ1_vk (Int))
(declare-const T_state_LSQ1_qj (_ BitVec 3))
(declare-const T_state_LSQ1_qk (_ BitVec 3))
(declare-const T_state_LSQ1_imm (Int))
(declare-const T_state_LSQ1_dis (_ BitVec 1))
(declare-const T_state_LSQ1_busy (_ BitVec 1))

(declare-const T_state_LSQ2_op_type (Int))
(declare-const T_state_LSQ2_op (Int))
(declare-const T_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const T_state_LSQ2_vj (Int))
(declare-const T_state_LSQ2_vk (Int))
(declare-const T_state_LSQ2_qj (_ BitVec 3))
(declare-const T_state_LSQ2_qk (_ BitVec 3))
(declare-const T_state_LSQ2_imm (Int))
(declare-const T_state_LSQ2_dis (_ BitVec 1))
(declare-const T_state_LSQ2_busy (_ BitVec 1))

(declare-const T_state_LSQ3_op_type (Int))
(declare-const T_state_LSQ3_op (Int))
(declare-const T_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const T_state_LSQ3_vj (Int))
(declare-const T_state_LSQ3_vk (Int))
(declare-const T_state_LSQ3_qj (_ BitVec 3))
(declare-const T_state_LSQ3_qk (_ BitVec 3))
(declare-const T_state_LSQ3_imm (Int))
(declare-const T_state_LSQ3_dis (_ BitVec 1))
(declare-const T_state_LSQ3_busy (_ BitVec 1))

(declare-const U1_state_Cache0_Tag (Int))
(declare-const U1_state_Cache1_Tag (Int))
(declare-const U1_state_Cache2_Tag (Int))
(declare-const U1_state_Cache3_Tag (Int))
(declare-const U1_state_Cache0_Data (Int))
(declare-const U1_state_Cache1_Data (Int))
(declare-const U1_state_Cache2_Data (Int))
(declare-const U1_state_Cache3_Data (Int))
(declare-const U1_state_Cache0_Valid (_ BitVec 1))
(declare-const U1_state_Cache1_Valid (_ BitVec 1))
(declare-const U1_state_Cache2_Valid (_ BitVec 1))
(declare-const U1_state_Cache3_Valid (_ BitVec 1))

(declare-const U1_state_IP (_ BitVec 3))
(declare-const U1_state_CP (_ BitVec 3))
(declare-const U1_state_PC (Int))

(declare-const U1_state_ROB0_busy (_ BitVec 1))
(declare-const U1_state_ROB0_op_type (Int))
(declare-const U1_state_ROB0_destination (Int))
(declare-const U1_state_ROB0_result (Int))
(declare-const U1_state_ROB0_exception (_ BitVec 1))
(declare-const U1_state_ROB0_done (_ BitVec 1))

(declare-const U1_state_ROB1_busy (_ BitVec 1))
(declare-const U1_state_ROB1_op_type (Int))
(declare-const U1_state_ROB1_destination (Int))
(declare-const U1_state_ROB1_result (Int))
(declare-const U1_state_ROB1_exception (_ BitVec 1))
(declare-const U1_state_ROB1_done (_ BitVec 1))

(declare-const U1_state_ROB2_busy (_ BitVec 1))
(declare-const U1_state_ROB2_op_type (Int))
(declare-const U1_state_ROB2_destination (Int))
(declare-const U1_state_ROB2_result (Int))
(declare-const U1_state_ROB2_exception (_ BitVec 1))
(declare-const U1_state_ROB2_done (_ BitVec 1))

(declare-const U1_state_ROB3_busy (_ BitVec 1))
(declare-const U1_state_ROB3_op_type (Int))
(declare-const U1_state_ROB3_destination (Int))
(declare-const U1_state_ROB3_result (Int))
(declare-const U1_state_ROB3_exception (_ BitVec 1))
(declare-const U1_state_ROB3_done (_ BitVec 1))

(declare-const U1_state_ROB4_busy (_ BitVec 1))
(declare-const U1_state_ROB4_op_type (Int))
(declare-const U1_state_ROB4_destination (Int))
(declare-const U1_state_ROB4_result (Int))
(declare-const U1_state_ROB4_exception (_ BitVec 1))
(declare-const U1_state_ROB4_done (_ BitVec 1))

(declare-const U1_state_ROB5_busy (_ BitVec 1))
(declare-const U1_state_ROB5_op_type (Int))
(declare-const U1_state_ROB5_destination (Int))
(declare-const U1_state_ROB5_result (Int))
(declare-const U1_state_ROB5_exception (_ BitVec 1))
(declare-const U1_state_ROB5_done (_ BitVec 1))

(declare-const U1_state_ROB6_busy (_ BitVec 1))
(declare-const U1_state_ROB6_op_type (Int))
(declare-const U1_state_ROB6_destination (Int))
(declare-const U1_state_ROB6_result (Int))
(declare-const U1_state_ROB6_exception (_ BitVec 1))
(declare-const U1_state_ROB6_done (_ BitVec 1))

(declare-const U1_state_ROB7_busy (_ BitVec 1))
(declare-const U1_state_ROB7_op_type (Int))
(declare-const U1_state_ROB7_destination (Int))
(declare-const U1_state_ROB7_result (Int))
(declare-const U1_state_ROB7_exception (_ BitVec 1))
(declare-const U1_state_ROB7_done (_ BitVec 1))

(declare-const U1_state_RS0_op_type (Int))
(declare-const U1_state_RS0_op (Int))
(declare-const U1_state_RS0_ROB_dst (_ BitVec 3))
(declare-const U1_state_RS0_vj (Int))
(declare-const U1_state_RS0_vk (Int))
(declare-const U1_state_RS0_qj (_ BitVec 3))
(declare-const U1_state_RS0_qk (_ BitVec 3))
(declare-const U1_state_RS0_imm (Int))
(declare-const U1_state_RS0_dis (_ BitVec 1))
(declare-const U1_state_RS0_busy (_ BitVec 1))

(declare-const U1_state_RS1_op_type (Int))
(declare-const U1_state_RS1_op (Int))
(declare-const U1_state_RS1_ROB_dst (_ BitVec 3))
(declare-const U1_state_RS1_vj (Int))
(declare-const U1_state_RS1_vk (Int))
(declare-const U1_state_RS1_qj (_ BitVec 3))
(declare-const U1_state_RS1_qk (_ BitVec 3))
(declare-const U1_state_RS1_imm (Int))
(declare-const U1_state_RS1_dis (_ BitVec 1))
(declare-const U1_state_RS1_busy (_ BitVec 1))

(declare-const U1_state_RS2_op_type (Int))
(declare-const U1_state_RS2_op (Int))
(declare-const U1_state_RS2_ROB_dst (_ BitVec 3))
(declare-const U1_state_RS2_vj (Int))
(declare-const U1_state_RS2_vk (Int))
(declare-const U1_state_RS2_qj (_ BitVec 3))
(declare-const U1_state_RS2_qk (_ BitVec 3))
(declare-const U1_state_RS2_imm (Int))
(declare-const U1_state_RS2_dis (_ BitVec 1))
(declare-const U1_state_RS2_busy (_ BitVec 1))

(declare-const U1_state_RS3_op_type (Int))
(declare-const U1_state_RS3_op (Int))
(declare-const U1_state_RS3_ROB_dst (_ BitVec 3))
(declare-const U1_state_RS3_vj (Int))
(declare-const U1_state_RS3_vk (Int))
(declare-const U1_state_RS3_qj (_ BitVec 3))
(declare-const U1_state_RS3_qk (_ BitVec 3))
(declare-const U1_state_RS3_imm (Int))
(declare-const U1_state_RS3_dis (_ BitVec 1))
(declare-const U1_state_RS3_busy (_ BitVec 1))

(declare-const U1_state_LSQ0_op_type (Int))
(declare-const U1_state_LSQ0_op (Int))
(declare-const U1_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const U1_state_LSQ0_vj (Int))
(declare-const U1_state_LSQ0_vk (Int))
(declare-const U1_state_LSQ0_qj (_ BitVec 3))
(declare-const U1_state_LSQ0_qk (_ BitVec 3))
(declare-const U1_state_LSQ0_imm (Int))
(declare-const U1_state_LSQ0_dis (_ BitVec 1))
(declare-const U1_state_LSQ0_busy (_ BitVec 1))

(declare-const U1_state_LSQ1_op_type (Int))
(declare-const U1_state_LSQ1_op (Int))
(declare-const U1_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const U1_state_LSQ1_vj (Int))
(declare-const U1_state_LSQ1_vk (Int))
(declare-const U1_state_LSQ1_qj (_ BitVec 3))
(declare-const U1_state_LSQ1_qk (_ BitVec 3))
(declare-const U1_state_LSQ1_imm (Int))
(declare-const U1_state_LSQ1_dis (_ BitVec 1))
(declare-const U1_state_LSQ1_busy (_ BitVec 1))

(declare-const U1_state_LSQ2_op_type (Int))
(declare-const U1_state_LSQ2_op (Int))
(declare-const U1_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const U1_state_LSQ2_vj (Int))
(declare-const U1_state_LSQ2_vk (Int))
(declare-const U1_state_LSQ2_qj (_ BitVec 3))
(declare-const U1_state_LSQ2_qk (_ BitVec 3))
(declare-const U1_state_LSQ2_imm (Int))
(declare-const U1_state_LSQ2_dis (_ BitVec 1))
(declare-const U1_state_LSQ2_busy (_ BitVec 1))

(declare-const U1_state_LSQ3_op_type (Int))
(declare-const U1_state_LSQ3_op (Int))
(declare-const U1_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const U1_state_LSQ3_vj (Int))
(declare-const U1_state_LSQ3_vk (Int))
(declare-const U1_state_LSQ3_qj (_ BitVec 3))
(declare-const U1_state_LSQ3_qk (_ BitVec 3))
(declare-const U1_state_LSQ3_imm (Int))
(declare-const U1_state_LSQ3_dis (_ BitVec 1))
(declare-const U1_state_LSQ3_busy (_ BitVec 1))

(declare-const U1_state_Evict0_Valid (_ BitVec 1))
(declare-const U1_state_Evict1_Valid (_ BitVec 1))
(declare-const U1_state_Evict2_Valid (_ BitVec 1))
(declare-const U1_state_Evict3_Valid (_ BitVec 1))
(declare-const U1_state_Evict4_Valid (_ BitVec 1))
(declare-const U1_state_Evict5_Valid (_ BitVec 1))
(declare-const U1_state_Evict6_Valid (_ BitVec 1))
(declare-const U1_state_Evict7_Valid (_ BitVec 1))
(declare-const U1_state_Evict0_Tag (Int))
(declare-const U1_state_Evict1_Tag (Int))
(declare-const U1_state_Evict2_Tag (Int))
(declare-const U1_state_Evict3_Tag (Int))
(declare-const U1_state_Evict4_Tag (Int))
(declare-const U1_state_Evict5_Tag (Int))
(declare-const U1_state_Evict6_Tag (Int))
(declare-const U1_state_Evict7_Tag (Int))

(declare-const U2_state_Cache0_Tag (Int))
(declare-const U2_state_Cache1_Tag (Int))
(declare-const U2_state_Cache2_Tag (Int))
(declare-const U2_state_Cache3_Tag (Int))
(declare-const U2_state_Cache0_Data (Int))
(declare-const U2_state_Cache1_Data (Int))
(declare-const U2_state_Cache2_Data (Int))
(declare-const U2_state_Cache3_Data (Int))
(declare-const U2_state_Cache0_Valid (_ BitVec 1))
(declare-const U2_state_Cache1_Valid (_ BitVec 1))
(declare-const U2_state_Cache2_Valid (_ BitVec 1))
(declare-const U2_state_Cache3_Valid (_ BitVec 1))

(declare-const U2_state_IP (_ BitVec 3))
(declare-const U2_state_CP (_ BitVec 3))
(declare-const U2_state_PC (Int))

(declare-const U2_state_ROB0_busy (_ BitVec 1))
(declare-const U2_state_ROB0_op_type (Int))
(declare-const U2_state_ROB0_destination (Int))
(declare-const U2_state_ROB0_result (Int))
(declare-const U2_state_ROB0_exception (_ BitVec 1))
(declare-const U2_state_ROB0_done (_ BitVec 1))

(declare-const U2_state_ROB1_busy (_ BitVec 1))
(declare-const U2_state_ROB1_op_type (Int))
(declare-const U2_state_ROB1_destination (Int))
(declare-const U2_state_ROB1_result (Int))
(declare-const U2_state_ROB1_exception (_ BitVec 1))
(declare-const U2_state_ROB1_done (_ BitVec 1))

(declare-const U2_state_ROB2_busy (_ BitVec 1))
(declare-const U2_state_ROB2_op_type (Int))
(declare-const U2_state_ROB2_destination (Int))
(declare-const U2_state_ROB2_result (Int))
(declare-const U2_state_ROB2_exception (_ BitVec 1))
(declare-const U2_state_ROB2_done (_ BitVec 1))

(declare-const U2_state_ROB3_busy (_ BitVec 1))
(declare-const U2_state_ROB3_op_type (Int))
(declare-const U2_state_ROB3_destination (Int))
(declare-const U2_state_ROB3_result (Int))
(declare-const U2_state_ROB3_exception (_ BitVec 1))
(declare-const U2_state_ROB3_done (_ BitVec 1))

(declare-const U2_state_ROB4_busy (_ BitVec 1))
(declare-const U2_state_ROB4_op_type (Int))
(declare-const U2_state_ROB4_destination (Int))
(declare-const U2_state_ROB4_result (Int))
(declare-const U2_state_ROB4_exception (_ BitVec 1))
(declare-const U2_state_ROB4_done (_ BitVec 1))

(declare-const U2_state_ROB5_busy (_ BitVec 1))
(declare-const U2_state_ROB5_op_type (Int))
(declare-const U2_state_ROB5_destination (Int))
(declare-const U2_state_ROB5_result (Int))
(declare-const U2_state_ROB5_exception (_ BitVec 1))
(declare-const U2_state_ROB5_done (_ BitVec 1))

(declare-const U2_state_ROB6_busy (_ BitVec 1))
(declare-const U2_state_ROB6_op_type (Int))
(declare-const U2_state_ROB6_destination (Int))
(declare-const U2_state_ROB6_result (Int))
(declare-const U2_state_ROB6_exception (_ BitVec 1))
(declare-const U2_state_ROB6_done (_ BitVec 1))

(declare-const U2_state_ROB7_busy (_ BitVec 1))
(declare-const U2_state_ROB7_op_type (Int))
(declare-const U2_state_ROB7_destination (Int))
(declare-const U2_state_ROB7_result (Int))
(declare-const U2_state_ROB7_exception (_ BitVec 1))
(declare-const U2_state_ROB7_done (_ BitVec 1))

(declare-const U2_state_RS0_op_type (Int))
(declare-const U2_state_RS0_op (Int))
(declare-const U2_state_RS0_ROB_dst (_ BitVec 3))
(declare-const U2_state_RS0_vj (Int))
(declare-const U2_state_RS0_vk (Int))
(declare-const U2_state_RS0_qj (_ BitVec 3))
(declare-const U2_state_RS0_qk (_ BitVec 3))
(declare-const U2_state_RS0_imm (Int))
(declare-const U2_state_RS0_dis (_ BitVec 1))
(declare-const U2_state_RS0_busy (_ BitVec 1))

(declare-const U2_state_RS1_op_type (Int))
(declare-const U2_state_RS1_op (Int))
(declare-const U2_state_RS1_ROB_dst (_ BitVec 3))
(declare-const U2_state_RS1_vj (Int))
(declare-const U2_state_RS1_vk (Int))
(declare-const U2_state_RS1_qj (_ BitVec 3))
(declare-const U2_state_RS1_qk (_ BitVec 3))
(declare-const U2_state_RS1_imm (Int))
(declare-const U2_state_RS1_dis (_ BitVec 1))
(declare-const U2_state_RS1_busy (_ BitVec 1))

(declare-const U2_state_RS2_op_type (Int))
(declare-const U2_state_RS2_op (Int))
(declare-const U2_state_RS2_ROB_dst (_ BitVec 3))
(declare-const U2_state_RS2_vj (Int))
(declare-const U2_state_RS2_vk (Int))
(declare-const U2_state_RS2_qj (_ BitVec 3))
(declare-const U2_state_RS2_qk (_ BitVec 3))
(declare-const U2_state_RS2_imm (Int))
(declare-const U2_state_RS2_dis (_ BitVec 1))
(declare-const U2_state_RS2_busy (_ BitVec 1))

(declare-const U2_state_RS3_op_type (Int))
(declare-const U2_state_RS3_op (Int))
(declare-const U2_state_RS3_ROB_dst (_ BitVec 3))
(declare-const U2_state_RS3_vj (Int))
(declare-const U2_state_RS3_vk (Int))
(declare-const U2_state_RS3_qj (_ BitVec 3))
(declare-const U2_state_RS3_qk (_ BitVec 3))
(declare-const U2_state_RS3_imm (Int))
(declare-const U2_state_RS3_dis (_ BitVec 1))
(declare-const U2_state_RS3_busy (_ BitVec 1))

(declare-const U2_state_LSQ0_op_type (Int))
(declare-const U2_state_LSQ0_op (Int))
(declare-const U2_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const U2_state_LSQ0_vj (Int))
(declare-const U2_state_LSQ0_vk (Int))
(declare-const U2_state_LSQ0_qj (_ BitVec 3))
(declare-const U2_state_LSQ0_qk (_ BitVec 3))
(declare-const U2_state_LSQ0_imm (Int))
(declare-const U2_state_LSQ0_dis (_ BitVec 1))
(declare-const U2_state_LSQ0_busy (_ BitVec 1))

(declare-const U2_state_LSQ1_op_type (Int))
(declare-const U2_state_LSQ1_op (Int))
(declare-const U2_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const U2_state_LSQ1_vj (Int))
(declare-const U2_state_LSQ1_vk (Int))
(declare-const U2_state_LSQ1_qj (_ BitVec 3))
(declare-const U2_state_LSQ1_qk (_ BitVec 3))
(declare-const U2_state_LSQ1_imm (Int))
(declare-const U2_state_LSQ1_dis (_ BitVec 1))
(declare-const U2_state_LSQ1_busy (_ BitVec 1))

(declare-const U2_state_LSQ2_op_type (Int))
(declare-const U2_state_LSQ2_op (Int))
(declare-const U2_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const U2_state_LSQ2_vj (Int))
(declare-const U2_state_LSQ2_vk (Int))
(declare-const U2_state_LSQ2_qj (_ BitVec 3))
(declare-const U2_state_LSQ2_qk (_ BitVec 3))
(declare-const U2_state_LSQ2_imm (Int))
(declare-const U2_state_LSQ2_dis (_ BitVec 1))
(declare-const U2_state_LSQ2_busy (_ BitVec 1))

(declare-const U2_state_LSQ3_op_type (Int))
(declare-const U2_state_LSQ3_op (Int))
(declare-const U2_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const U2_state_LSQ3_vj (Int))
(declare-const U2_state_LSQ3_vk (Int))
(declare-const U2_state_LSQ3_qj (_ BitVec 3))
(declare-const U2_state_LSQ3_qk (_ BitVec 3))
(declare-const U2_state_LSQ3_imm (Int))
(declare-const U2_state_LSQ3_dis (_ BitVec 1))
(declare-const U2_state_LSQ3_busy (_ BitVec 1))

(declare-const U2_state_Evict0_Valid (_ BitVec 1))
(declare-const U2_state_Evict1_Valid (_ BitVec 1))
(declare-const U2_state_Evict2_Valid (_ BitVec 1))
(declare-const U2_state_Evict3_Valid (_ BitVec 1))
(declare-const U2_state_Evict4_Valid (_ BitVec 1))
(declare-const U2_state_Evict5_Valid (_ BitVec 1))
(declare-const U2_state_Evict6_Valid (_ BitVec 1))
(declare-const U2_state_Evict7_Valid (_ BitVec 1))
(declare-const U2_state_Evict0_Tag (Int))
(declare-const U2_state_Evict1_Tag (Int))
(declare-const U2_state_Evict2_Tag (Int))
(declare-const U2_state_Evict3_Tag (Int))
(declare-const U2_state_Evict4_Tag (Int))
(declare-const U2_state_Evict5_Tag (Int))
(declare-const U2_state_Evict6_Tag (Int))
(declare-const U2_state_Evict7_Tag (Int))

(declare-const U3_state_Cache0_Tag (Int))
(declare-const U3_state_Cache1_Tag (Int))
(declare-const U3_state_Cache2_Tag (Int))
(declare-const U3_state_Cache3_Tag (Int))
(declare-const U3_state_Cache0_Data (Int))
(declare-const U3_state_Cache1_Data (Int))
(declare-const U3_state_Cache2_Data (Int))
(declare-const U3_state_Cache3_Data (Int))
(declare-const U3_state_Cache0_Valid (_ BitVec 1))
(declare-const U3_state_Cache1_Valid (_ BitVec 1))
(declare-const U3_state_Cache2_Valid (_ BitVec 1))
(declare-const U3_state_Cache3_Valid (_ BitVec 1))

(declare-const U3_state_IP (_ BitVec 3))
(declare-const U3_state_CP (_ BitVec 3))
(declare-const U3_state_PC (Int))

(declare-const U3_state_ROB0_busy (_ BitVec 1))
(declare-const U3_state_ROB0_op_type (Int))
(declare-const U3_state_ROB0_destination (Int))
(declare-const U3_state_ROB0_result (Int))
(declare-const U3_state_ROB0_exception (_ BitVec 1))
(declare-const U3_state_ROB0_done (_ BitVec 1))

(declare-const U3_state_ROB1_busy (_ BitVec 1))
(declare-const U3_state_ROB1_op_type (Int))
(declare-const U3_state_ROB1_destination (Int))
(declare-const U3_state_ROB1_result (Int))
(declare-const U3_state_ROB1_exception (_ BitVec 1))
(declare-const U3_state_ROB1_done (_ BitVec 1))

(declare-const U3_state_ROB2_busy (_ BitVec 1))
(declare-const U3_state_ROB2_op_type (Int))
(declare-const U3_state_ROB2_destination (Int))
(declare-const U3_state_ROB2_result (Int))
(declare-const U3_state_ROB2_exception (_ BitVec 1))
(declare-const U3_state_ROB2_done (_ BitVec 1))

(declare-const U3_state_ROB3_busy (_ BitVec 1))
(declare-const U3_state_ROB3_op_type (Int))
(declare-const U3_state_ROB3_destination (Int))
(declare-const U3_state_ROB3_result (Int))
(declare-const U3_state_ROB3_exception (_ BitVec 1))
(declare-const U3_state_ROB3_done (_ BitVec 1))

(declare-const U3_state_ROB4_busy (_ BitVec 1))
(declare-const U3_state_ROB4_op_type (Int))
(declare-const U3_state_ROB4_destination (Int))
(declare-const U3_state_ROB4_result (Int))
(declare-const U3_state_ROB4_exception (_ BitVec 1))
(declare-const U3_state_ROB4_done (_ BitVec 1))

(declare-const U3_state_ROB5_busy (_ BitVec 1))
(declare-const U3_state_ROB5_op_type (Int))
(declare-const U3_state_ROB5_destination (Int))
(declare-const U3_state_ROB5_result (Int))
(declare-const U3_state_ROB5_exception (_ BitVec 1))
(declare-const U3_state_ROB5_done (_ BitVec 1))

(declare-const U3_state_ROB6_busy (_ BitVec 1))
(declare-const U3_state_ROB6_op_type (Int))
(declare-const U3_state_ROB6_destination (Int))
(declare-const U3_state_ROB6_result (Int))
(declare-const U3_state_ROB6_exception (_ BitVec 1))
(declare-const U3_state_ROB6_done (_ BitVec 1))

(declare-const U3_state_ROB7_busy (_ BitVec 1))
(declare-const U3_state_ROB7_op_type (Int))
(declare-const U3_state_ROB7_destination (Int))
(declare-const U3_state_ROB7_result (Int))
(declare-const U3_state_ROB7_exception (_ BitVec 1))
(declare-const U3_state_ROB7_done (_ BitVec 1))

(declare-const U3_state_RS0_op_type (Int))
(declare-const U3_state_RS0_op (Int))
(declare-const U3_state_RS0_ROB_dst (_ BitVec 3))
(declare-const U3_state_RS0_vj (Int))
(declare-const U3_state_RS0_vk (Int))
(declare-const U3_state_RS0_qj (_ BitVec 3))
(declare-const U3_state_RS0_qk (_ BitVec 3))
(declare-const U3_state_RS0_imm (Int))
(declare-const U3_state_RS0_dis (_ BitVec 1))
(declare-const U3_state_RS0_busy (_ BitVec 1))

(declare-const U3_state_RS1_op_type (Int))
(declare-const U3_state_RS1_op (Int))
(declare-const U3_state_RS1_ROB_dst (_ BitVec 3))
(declare-const U3_state_RS1_vj (Int))
(declare-const U3_state_RS1_vk (Int))
(declare-const U3_state_RS1_qj (_ BitVec 3))
(declare-const U3_state_RS1_qk (_ BitVec 3))
(declare-const U3_state_RS1_imm (Int))
(declare-const U3_state_RS1_dis (_ BitVec 1))
(declare-const U3_state_RS1_busy (_ BitVec 1))

(declare-const U3_state_RS2_op_type (Int))
(declare-const U3_state_RS2_op (Int))
(declare-const U3_state_RS2_ROB_dst (_ BitVec 3))
(declare-const U3_state_RS2_vj (Int))
(declare-const U3_state_RS2_vk (Int))
(declare-const U3_state_RS2_qj (_ BitVec 3))
(declare-const U3_state_RS2_qk (_ BitVec 3))
(declare-const U3_state_RS2_imm (Int))
(declare-const U3_state_RS2_dis (_ BitVec 1))
(declare-const U3_state_RS2_busy (_ BitVec 1))

(declare-const U3_state_RS3_op_type (Int))
(declare-const U3_state_RS3_op (Int))
(declare-const U3_state_RS3_ROB_dst (_ BitVec 3))
(declare-const U3_state_RS3_vj (Int))
(declare-const U3_state_RS3_vk (Int))
(declare-const U3_state_RS3_qj (_ BitVec 3))
(declare-const U3_state_RS3_qk (_ BitVec 3))
(declare-const U3_state_RS3_imm (Int))
(declare-const U3_state_RS3_dis (_ BitVec 1))
(declare-const U3_state_RS3_busy (_ BitVec 1))

(declare-const U3_state_LSQ0_op_type (Int))
(declare-const U3_state_LSQ0_op (Int))
(declare-const U3_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const U3_state_LSQ0_vj (Int))
(declare-const U3_state_LSQ0_vk (Int))
(declare-const U3_state_LSQ0_qj (_ BitVec 3))
(declare-const U3_state_LSQ0_qk (_ BitVec 3))
(declare-const U3_state_LSQ0_imm (Int))
(declare-const U3_state_LSQ0_dis (_ BitVec 1))
(declare-const U3_state_LSQ0_busy (_ BitVec 1))

(declare-const U3_state_LSQ1_op_type (Int))
(declare-const U3_state_LSQ1_op (Int))
(declare-const U3_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const U3_state_LSQ1_vj (Int))
(declare-const U3_state_LSQ1_vk (Int))
(declare-const U3_state_LSQ1_qj (_ BitVec 3))
(declare-const U3_state_LSQ1_qk (_ BitVec 3))
(declare-const U3_state_LSQ1_imm (Int))
(declare-const U3_state_LSQ1_dis (_ BitVec 1))
(declare-const U3_state_LSQ1_busy (_ BitVec 1))

(declare-const U3_state_LSQ2_op_type (Int))
(declare-const U3_state_LSQ2_op (Int))
(declare-const U3_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const U3_state_LSQ2_vj (Int))
(declare-const U3_state_LSQ2_vk (Int))
(declare-const U3_state_LSQ2_qj (_ BitVec 3))
(declare-const U3_state_LSQ2_qk (_ BitVec 3))
(declare-const U3_state_LSQ2_imm (Int))
(declare-const U3_state_LSQ2_dis (_ BitVec 1))
(declare-const U3_state_LSQ2_busy (_ BitVec 1))

(declare-const U3_state_LSQ3_op_type (Int))
(declare-const U3_state_LSQ3_op (Int))
(declare-const U3_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const U3_state_LSQ3_vj (Int))
(declare-const U3_state_LSQ3_vk (Int))
(declare-const U3_state_LSQ3_qj (_ BitVec 3))
(declare-const U3_state_LSQ3_qk (_ BitVec 3))
(declare-const U3_state_LSQ3_imm (Int))
(declare-const U3_state_LSQ3_dis (_ BitVec 1))
(declare-const U3_state_LSQ3_busy (_ BitVec 1))

(declare-const U3_state_Evict0_Valid (_ BitVec 1))
(declare-const U3_state_Evict1_Valid (_ BitVec 1))
(declare-const U3_state_Evict2_Valid (_ BitVec 1))
(declare-const U3_state_Evict3_Valid (_ BitVec 1))
(declare-const U3_state_Evict4_Valid (_ BitVec 1))
(declare-const U3_state_Evict5_Valid (_ BitVec 1))
(declare-const U3_state_Evict6_Valid (_ BitVec 1))
(declare-const U3_state_Evict7_Valid (_ BitVec 1))
(declare-const U3_state_Evict0_Tag (Int))
(declare-const U3_state_Evict1_Tag (Int))
(declare-const U3_state_Evict2_Tag (Int))
(declare-const U3_state_Evict3_Tag (Int))
(declare-const U3_state_Evict4_Tag (Int))
(declare-const U3_state_Evict5_Tag (Int))
(declare-const U3_state_Evict6_Tag (Int))
(declare-const U3_state_Evict7_Tag (Int))

(declare-const U4_state_Cache0_Tag (Int))
(declare-const U4_state_Cache1_Tag (Int))
(declare-const U4_state_Cache2_Tag (Int))
(declare-const U4_state_Cache3_Tag (Int))
(declare-const U4_state_Cache0_Data (Int))
(declare-const U4_state_Cache1_Data (Int))
(declare-const U4_state_Cache2_Data (Int))
(declare-const U4_state_Cache3_Data (Int))
(declare-const U4_state_Cache0_Valid (_ BitVec 1))
(declare-const U4_state_Cache1_Valid (_ BitVec 1))
(declare-const U4_state_Cache2_Valid (_ BitVec 1))
(declare-const U4_state_Cache3_Valid (_ BitVec 1))

(declare-const U4_state_IP (_ BitVec 3))
(declare-const U4_state_CP (_ BitVec 3))
(declare-const U4_state_PC (Int))

(declare-const U4_state_ROB0_busy (_ BitVec 1))
(declare-const U4_state_ROB0_op_type (Int))
(declare-const U4_state_ROB0_destination (Int))
(declare-const U4_state_ROB0_result (Int))
(declare-const U4_state_ROB0_exception (_ BitVec 1))
(declare-const U4_state_ROB0_done (_ BitVec 1))

(declare-const U4_state_ROB1_busy (_ BitVec 1))
(declare-const U4_state_ROB1_op_type (Int))
(declare-const U4_state_ROB1_destination (Int))
(declare-const U4_state_ROB1_result (Int))
(declare-const U4_state_ROB1_exception (_ BitVec 1))
(declare-const U4_state_ROB1_done (_ BitVec 1))

(declare-const U4_state_ROB2_busy (_ BitVec 1))
(declare-const U4_state_ROB2_op_type (Int))
(declare-const U4_state_ROB2_destination (Int))
(declare-const U4_state_ROB2_result (Int))
(declare-const U4_state_ROB2_exception (_ BitVec 1))
(declare-const U4_state_ROB2_done (_ BitVec 1))

(declare-const U4_state_ROB3_busy (_ BitVec 1))
(declare-const U4_state_ROB3_op_type (Int))
(declare-const U4_state_ROB3_destination (Int))
(declare-const U4_state_ROB3_result (Int))
(declare-const U4_state_ROB3_exception (_ BitVec 1))
(declare-const U4_state_ROB3_done (_ BitVec 1))

(declare-const U4_state_ROB4_busy (_ BitVec 1))
(declare-const U4_state_ROB4_op_type (Int))
(declare-const U4_state_ROB4_destination (Int))
(declare-const U4_state_ROB4_result (Int))
(declare-const U4_state_ROB4_exception (_ BitVec 1))
(declare-const U4_state_ROB4_done (_ BitVec 1))

(declare-const U4_state_ROB5_busy (_ BitVec 1))
(declare-const U4_state_ROB5_op_type (Int))
(declare-const U4_state_ROB5_destination (Int))
(declare-const U4_state_ROB5_result (Int))
(declare-const U4_state_ROB5_exception (_ BitVec 1))
(declare-const U4_state_ROB5_done (_ BitVec 1))

(declare-const U4_state_ROB6_busy (_ BitVec 1))
(declare-const U4_state_ROB6_op_type (Int))
(declare-const U4_state_ROB6_destination (Int))
(declare-const U4_state_ROB6_result (Int))
(declare-const U4_state_ROB6_exception (_ BitVec 1))
(declare-const U4_state_ROB6_done (_ BitVec 1))

(declare-const U4_state_ROB7_busy (_ BitVec 1))
(declare-const U4_state_ROB7_op_type (Int))
(declare-const U4_state_ROB7_destination (Int))
(declare-const U4_state_ROB7_result (Int))
(declare-const U4_state_ROB7_exception (_ BitVec 1))
(declare-const U4_state_ROB7_done (_ BitVec 1))

(declare-const U4_state_RS0_op_type (Int))
(declare-const U4_state_RS0_op (Int))
(declare-const U4_state_RS0_ROB_dst (_ BitVec 3))
(declare-const U4_state_RS0_vj (Int))
(declare-const U4_state_RS0_vk (Int))
(declare-const U4_state_RS0_qj (_ BitVec 3))
(declare-const U4_state_RS0_qk (_ BitVec 3))
(declare-const U4_state_RS0_imm (Int))
(declare-const U4_state_RS0_dis (_ BitVec 1))
(declare-const U4_state_RS0_busy (_ BitVec 1))

(declare-const U4_state_RS1_op_type (Int))
(declare-const U4_state_RS1_op (Int))
(declare-const U4_state_RS1_ROB_dst (_ BitVec 3))
(declare-const U4_state_RS1_vj (Int))
(declare-const U4_state_RS1_vk (Int))
(declare-const U4_state_RS1_qj (_ BitVec 3))
(declare-const U4_state_RS1_qk (_ BitVec 3))
(declare-const U4_state_RS1_imm (Int))
(declare-const U4_state_RS1_dis (_ BitVec 1))
(declare-const U4_state_RS1_busy (_ BitVec 1))

(declare-const U4_state_RS2_op_type (Int))
(declare-const U4_state_RS2_op (Int))
(declare-const U4_state_RS2_ROB_dst (_ BitVec 3))
(declare-const U4_state_RS2_vj (Int))
(declare-const U4_state_RS2_vk (Int))
(declare-const U4_state_RS2_qj (_ BitVec 3))
(declare-const U4_state_RS2_qk (_ BitVec 3))
(declare-const U4_state_RS2_imm (Int))
(declare-const U4_state_RS2_dis (_ BitVec 1))
(declare-const U4_state_RS2_busy (_ BitVec 1))

(declare-const U4_state_RS3_op_type (Int))
(declare-const U4_state_RS3_op (Int))
(declare-const U4_state_RS3_ROB_dst (_ BitVec 3))
(declare-const U4_state_RS3_vj (Int))
(declare-const U4_state_RS3_vk (Int))
(declare-const U4_state_RS3_qj (_ BitVec 3))
(declare-const U4_state_RS3_qk (_ BitVec 3))
(declare-const U4_state_RS3_imm (Int))
(declare-const U4_state_RS3_dis (_ BitVec 1))
(declare-const U4_state_RS3_busy (_ BitVec 1))

(declare-const U4_state_LSQ0_op_type (Int))
(declare-const U4_state_LSQ0_op (Int))
(declare-const U4_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const U4_state_LSQ0_vj (Int))
(declare-const U4_state_LSQ0_vk (Int))
(declare-const U4_state_LSQ0_qj (_ BitVec 3))
(declare-const U4_state_LSQ0_qk (_ BitVec 3))
(declare-const U4_state_LSQ0_imm (Int))
(declare-const U4_state_LSQ0_dis (_ BitVec 1))
(declare-const U4_state_LSQ0_busy (_ BitVec 1))

(declare-const U4_state_LSQ1_op_type (Int))
(declare-const U4_state_LSQ1_op (Int))
(declare-const U4_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const U4_state_LSQ1_vj (Int))
(declare-const U4_state_LSQ1_vk (Int))
(declare-const U4_state_LSQ1_qj (_ BitVec 3))
(declare-const U4_state_LSQ1_qk (_ BitVec 3))
(declare-const U4_state_LSQ1_imm (Int))
(declare-const U4_state_LSQ1_dis (_ BitVec 1))
(declare-const U4_state_LSQ1_busy (_ BitVec 1))

(declare-const U4_state_LSQ2_op_type (Int))
(declare-const U4_state_LSQ2_op (Int))
(declare-const U4_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const U4_state_LSQ2_vj (Int))
(declare-const U4_state_LSQ2_vk (Int))
(declare-const U4_state_LSQ2_qj (_ BitVec 3))
(declare-const U4_state_LSQ2_qk (_ BitVec 3))
(declare-const U4_state_LSQ2_imm (Int))
(declare-const U4_state_LSQ2_dis (_ BitVec 1))
(declare-const U4_state_LSQ2_busy (_ BitVec 1))

(declare-const U4_state_LSQ3_op_type (Int))
(declare-const U4_state_LSQ3_op (Int))
(declare-const U4_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const U4_state_LSQ3_vj (Int))
(declare-const U4_state_LSQ3_vk (Int))
(declare-const U4_state_LSQ3_qj (_ BitVec 3))
(declare-const U4_state_LSQ3_qk (_ BitVec 3))
(declare-const U4_state_LSQ3_imm (Int))
(declare-const U4_state_LSQ3_dis (_ BitVec 1))
(declare-const U4_state_LSQ3_busy (_ BitVec 1))

(declare-const U4_state_Evict0_Valid (_ BitVec 1))
(declare-const U4_state_Evict1_Valid (_ BitVec 1))
(declare-const U4_state_Evict2_Valid (_ BitVec 1))
(declare-const U4_state_Evict3_Valid (_ BitVec 1))
(declare-const U4_state_Evict4_Valid (_ BitVec 1))
(declare-const U4_state_Evict5_Valid (_ BitVec 1))
(declare-const U4_state_Evict6_Valid (_ BitVec 1))
(declare-const U4_state_Evict7_Valid (_ BitVec 1))
(declare-const U4_state_Evict0_Tag (Int))
(declare-const U4_state_Evict1_Tag (Int))
(declare-const U4_state_Evict2_Tag (Int))
(declare-const U4_state_Evict3_Tag (Int))
(declare-const U4_state_Evict4_Tag (Int))
(declare-const U4_state_Evict5_Tag (Int))
(declare-const U4_state_Evict6_Tag (Int))
(declare-const U4_state_Evict7_Tag (Int))



(declare-const W1_state_Cache0_Tag (Int))
(declare-const W1_state_Cache1_Tag (Int))
(declare-const W1_state_Cache2_Tag (Int))
(declare-const W1_state_Cache3_Tag (Int))
(declare-const W1_state_Cache0_Data (Int))
(declare-const W1_state_Cache1_Data (Int))
(declare-const W1_state_Cache2_Data (Int))
(declare-const W1_state_Cache3_Data (Int))
(declare-const W1_state_Cache0_Valid (_ BitVec 1))
(declare-const W1_state_Cache1_Valid (_ BitVec 1))
(declare-const W1_state_Cache2_Valid (_ BitVec 1))
(declare-const W1_state_Cache3_Valid (_ BitVec 1))

(declare-const W1_state_IP (_ BitVec 3))
(declare-const W1_state_CP (_ BitVec 3))
(declare-const W1_state_PC (Int))

(declare-const W1_state_ROB0_busy (_ BitVec 1))
(declare-const W1_state_ROB0_op_type (Int))
(declare-const W1_state_ROB0_destination (Int))
(declare-const W1_state_ROB0_result (Int))
(declare-const W1_state_ROB0_exception (_ BitVec 1))
(declare-const W1_state_ROB0_done (_ BitVec 1))

(declare-const W1_state_ROB1_busy (_ BitVec 1))
(declare-const W1_state_ROB1_op_type (Int))
(declare-const W1_state_ROB1_destination (Int))
(declare-const W1_state_ROB1_result (Int))
(declare-const W1_state_ROB1_exception (_ BitVec 1))
(declare-const W1_state_ROB1_done (_ BitVec 1))

(declare-const W1_state_ROB2_busy (_ BitVec 1))
(declare-const W1_state_ROB2_op_type (Int))
(declare-const W1_state_ROB2_destination (Int))
(declare-const W1_state_ROB2_result (Int))
(declare-const W1_state_ROB2_exception (_ BitVec 1))
(declare-const W1_state_ROB2_done (_ BitVec 1))

(declare-const W1_state_ROB3_busy (_ BitVec 1))
(declare-const W1_state_ROB3_op_type (Int))
(declare-const W1_state_ROB3_destination (Int))
(declare-const W1_state_ROB3_result (Int))
(declare-const W1_state_ROB3_exception (_ BitVec 1))
(declare-const W1_state_ROB3_done (_ BitVec 1))

(declare-const W1_state_ROB4_busy (_ BitVec 1))
(declare-const W1_state_ROB4_op_type (Int))
(declare-const W1_state_ROB4_destination (Int))
(declare-const W1_state_ROB4_result (Int))
(declare-const W1_state_ROB4_exception (_ BitVec 1))
(declare-const W1_state_ROB4_done (_ BitVec 1))

(declare-const W1_state_ROB5_busy (_ BitVec 1))
(declare-const W1_state_ROB5_op_type (Int))
(declare-const W1_state_ROB5_destination (Int))
(declare-const W1_state_ROB5_result (Int))
(declare-const W1_state_ROB5_exception (_ BitVec 1))
(declare-const W1_state_ROB5_done (_ BitVec 1))

(declare-const W1_state_ROB6_busy (_ BitVec 1))
(declare-const W1_state_ROB6_op_type (Int))
(declare-const W1_state_ROB6_destination (Int))
(declare-const W1_state_ROB6_result (Int))
(declare-const W1_state_ROB6_exception (_ BitVec 1))
(declare-const W1_state_ROB6_done (_ BitVec 1))

(declare-const W1_state_ROB7_busy (_ BitVec 1))
(declare-const W1_state_ROB7_op_type (Int))
(declare-const W1_state_ROB7_destination (Int))
(declare-const W1_state_ROB7_result (Int))
(declare-const W1_state_ROB7_exception (_ BitVec 1))
(declare-const W1_state_ROB7_done (_ BitVec 1))

(declare-const W1_state_RS0_op_type (Int))
(declare-const W1_state_RS0_op (Int))
(declare-const W1_state_RS0_ROB_dst (_ BitVec 3))
(declare-const W1_state_RS0_vj (Int))
(declare-const W1_state_RS0_vk (Int))
(declare-const W1_state_RS0_qj (_ BitVec 3))
(declare-const W1_state_RS0_qk (_ BitVec 3))
(declare-const W1_state_RS0_imm (Int))
(declare-const W1_state_RS0_dis (_ BitVec 1))
(declare-const W1_state_RS0_busy (_ BitVec 1))

(declare-const W1_state_RS1_op_type (Int))
(declare-const W1_state_RS1_op (Int))
(declare-const W1_state_RS1_ROB_dst (_ BitVec 3))
(declare-const W1_state_RS1_vj (Int))
(declare-const W1_state_RS1_vk (Int))
(declare-const W1_state_RS1_qj (_ BitVec 3))
(declare-const W1_state_RS1_qk (_ BitVec 3))
(declare-const W1_state_RS1_imm (Int))
(declare-const W1_state_RS1_dis (_ BitVec 1))
(declare-const W1_state_RS1_busy (_ BitVec 1))

(declare-const W1_state_RS2_op_type (Int))
(declare-const W1_state_RS2_op (Int))
(declare-const W1_state_RS2_ROB_dst (_ BitVec 3))
(declare-const W1_state_RS2_vj (Int))
(declare-const W1_state_RS2_vk (Int))
(declare-const W1_state_RS2_qj (_ BitVec 3))
(declare-const W1_state_RS2_qk (_ BitVec 3))
(declare-const W1_state_RS2_imm (Int))
(declare-const W1_state_RS2_dis (_ BitVec 1))
(declare-const W1_state_RS2_busy (_ BitVec 1))

(declare-const W1_state_RS3_op_type (Int))
(declare-const W1_state_RS3_op (Int))
(declare-const W1_state_RS3_ROB_dst (_ BitVec 3))
(declare-const W1_state_RS3_vj (Int))
(declare-const W1_state_RS3_vk (Int))
(declare-const W1_state_RS3_qj (_ BitVec 3))
(declare-const W1_state_RS3_qk (_ BitVec 3))
(declare-const W1_state_RS3_imm (Int))
(declare-const W1_state_RS3_dis (_ BitVec 1))
(declare-const W1_state_RS3_busy (_ BitVec 1))

(declare-const W1_state_LSQ0_op_type (Int))
(declare-const W1_state_LSQ0_op (Int))
(declare-const W1_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const W1_state_LSQ0_vj (Int))
(declare-const W1_state_LSQ0_vk (Int))
(declare-const W1_state_LSQ0_qj (_ BitVec 3))
(declare-const W1_state_LSQ0_qk (_ BitVec 3))
(declare-const W1_state_LSQ0_imm (Int))
(declare-const W1_state_LSQ0_dis (_ BitVec 1))
(declare-const W1_state_LSQ0_busy (_ BitVec 1))

(declare-const W1_state_LSQ1_op_type (Int))
(declare-const W1_state_LSQ1_op (Int))
(declare-const W1_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const W1_state_LSQ1_vj (Int))
(declare-const W1_state_LSQ1_vk (Int))
(declare-const W1_state_LSQ1_qj (_ BitVec 3))
(declare-const W1_state_LSQ1_qk (_ BitVec 3))
(declare-const W1_state_LSQ1_imm (Int))
(declare-const W1_state_LSQ1_dis (_ BitVec 1))
(declare-const W1_state_LSQ1_busy (_ BitVec 1))

(declare-const W1_state_LSQ2_op_type (Int))
(declare-const W1_state_LSQ2_op (Int))
(declare-const W1_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const W1_state_LSQ2_vj (Int))
(declare-const W1_state_LSQ2_vk (Int))
(declare-const W1_state_LSQ2_qj (_ BitVec 3))
(declare-const W1_state_LSQ2_qk (_ BitVec 3))
(declare-const W1_state_LSQ2_imm (Int))
(declare-const W1_state_LSQ2_dis (_ BitVec 1))
(declare-const W1_state_LSQ2_busy (_ BitVec 1))

(declare-const W1_state_LSQ3_op_type (Int))
(declare-const W1_state_LSQ3_op (Int))
(declare-const W1_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const W1_state_LSQ3_vj (Int))
(declare-const W1_state_LSQ3_vk (Int))
(declare-const W1_state_LSQ3_qj (_ BitVec 3))
(declare-const W1_state_LSQ3_qk (_ BitVec 3))
(declare-const W1_state_LSQ3_imm (Int))
(declare-const W1_state_LSQ3_dis (_ BitVec 1))
(declare-const W1_state_LSQ3_busy (_ BitVec 1))

(declare-const W1_state_Evict0_Valid (_ BitVec 1))
(declare-const W1_state_Evict1_Valid (_ BitVec 1))
(declare-const W1_state_Evict2_Valid (_ BitVec 1))
(declare-const W1_state_Evict3_Valid (_ BitVec 1))
(declare-const W1_state_Evict4_Valid (_ BitVec 1))
(declare-const W1_state_Evict5_Valid (_ BitVec 1))
(declare-const W1_state_Evict6_Valid (_ BitVec 1))
(declare-const W1_state_Evict7_Valid (_ BitVec 1))
(declare-const W1_state_Evict0_Tag (Int))
(declare-const W1_state_Evict1_Tag (Int))
(declare-const W1_state_Evict2_Tag (Int))
(declare-const W1_state_Evict3_Tag (Int))
(declare-const W1_state_Evict4_Tag (Int))
(declare-const W1_state_Evict5_Tag (Int))
(declare-const W1_state_Evict6_Tag (Int))
(declare-const W1_state_Evict7_Tag (Int))

(declare-const W2_state_Cache0_Tag (Int))
(declare-const W2_state_Cache1_Tag (Int))
(declare-const W2_state_Cache2_Tag (Int))
(declare-const W2_state_Cache3_Tag (Int))
(declare-const W2_state_Cache0_Data (Int))
(declare-const W2_state_Cache1_Data (Int))
(declare-const W2_state_Cache2_Data (Int))
(declare-const W2_state_Cache3_Data (Int))
(declare-const W2_state_Cache0_Valid (_ BitVec 1))
(declare-const W2_state_Cache1_Valid (_ BitVec 1))
(declare-const W2_state_Cache2_Valid (_ BitVec 1))
(declare-const W2_state_Cache3_Valid (_ BitVec 1))

(declare-const W2_state_IP (_ BitVec 3))
(declare-const W2_state_CP (_ BitVec 3))
(declare-const W2_state_PC (Int))

(declare-const W2_state_ROB0_busy (_ BitVec 1))
(declare-const W2_state_ROB0_op_type (Int))
(declare-const W2_state_ROB0_destination (Int))
(declare-const W2_state_ROB0_result (Int))
(declare-const W2_state_ROB0_exception (_ BitVec 1))
(declare-const W2_state_ROB0_done (_ BitVec 1))

(declare-const W2_state_ROB1_busy (_ BitVec 1))
(declare-const W2_state_ROB1_op_type (Int))
(declare-const W2_state_ROB1_destination (Int))
(declare-const W2_state_ROB1_result (Int))
(declare-const W2_state_ROB1_exception (_ BitVec 1))
(declare-const W2_state_ROB1_done (_ BitVec 1))

(declare-const W2_state_ROB2_busy (_ BitVec 1))
(declare-const W2_state_ROB2_op_type (Int))
(declare-const W2_state_ROB2_destination (Int))
(declare-const W2_state_ROB2_result (Int))
(declare-const W2_state_ROB2_exception (_ BitVec 1))
(declare-const W2_state_ROB2_done (_ BitVec 1))

(declare-const W2_state_ROB3_busy (_ BitVec 1))
(declare-const W2_state_ROB3_op_type (Int))
(declare-const W2_state_ROB3_destination (Int))
(declare-const W2_state_ROB3_result (Int))
(declare-const W2_state_ROB3_exception (_ BitVec 1))
(declare-const W2_state_ROB3_done (_ BitVec 1))

(declare-const W2_state_ROB4_busy (_ BitVec 1))
(declare-const W2_state_ROB4_op_type (Int))
(declare-const W2_state_ROB4_destination (Int))
(declare-const W2_state_ROB4_result (Int))
(declare-const W2_state_ROB4_exception (_ BitVec 1))
(declare-const W2_state_ROB4_done (_ BitVec 1))

(declare-const W2_state_ROB5_busy (_ BitVec 1))
(declare-const W2_state_ROB5_op_type (Int))
(declare-const W2_state_ROB5_destination (Int))
(declare-const W2_state_ROB5_result (Int))
(declare-const W2_state_ROB5_exception (_ BitVec 1))
(declare-const W2_state_ROB5_done (_ BitVec 1))

(declare-const W2_state_ROB6_busy (_ BitVec 1))
(declare-const W2_state_ROB6_op_type (Int))
(declare-const W2_state_ROB6_destination (Int))
(declare-const W2_state_ROB6_result (Int))
(declare-const W2_state_ROB6_exception (_ BitVec 1))
(declare-const W2_state_ROB6_done (_ BitVec 1))

(declare-const W2_state_ROB7_busy (_ BitVec 1))
(declare-const W2_state_ROB7_op_type (Int))
(declare-const W2_state_ROB7_destination (Int))
(declare-const W2_state_ROB7_result (Int))
(declare-const W2_state_ROB7_exception (_ BitVec 1))
(declare-const W2_state_ROB7_done (_ BitVec 1))

(declare-const W2_state_RS0_op_type (Int))
(declare-const W2_state_RS0_op (Int))
(declare-const W2_state_RS0_ROB_dst (_ BitVec 3))
(declare-const W2_state_RS0_vj (Int))
(declare-const W2_state_RS0_vk (Int))
(declare-const W2_state_RS0_qj (_ BitVec 3))
(declare-const W2_state_RS0_qk (_ BitVec 3))
(declare-const W2_state_RS0_imm (Int))
(declare-const W2_state_RS0_dis (_ BitVec 1))
(declare-const W2_state_RS0_busy (_ BitVec 1))

(declare-const W2_state_RS1_op_type (Int))
(declare-const W2_state_RS1_op (Int))
(declare-const W2_state_RS1_ROB_dst (_ BitVec 3))
(declare-const W2_state_RS1_vj (Int))
(declare-const W2_state_RS1_vk (Int))
(declare-const W2_state_RS1_qj (_ BitVec 3))
(declare-const W2_state_RS1_qk (_ BitVec 3))
(declare-const W2_state_RS1_imm (Int))
(declare-const W2_state_RS1_dis (_ BitVec 1))
(declare-const W2_state_RS1_busy (_ BitVec 1))

(declare-const W2_state_RS2_op_type (Int))
(declare-const W2_state_RS2_op (Int))
(declare-const W2_state_RS2_ROB_dst (_ BitVec 3))
(declare-const W2_state_RS2_vj (Int))
(declare-const W2_state_RS2_vk (Int))
(declare-const W2_state_RS2_qj (_ BitVec 3))
(declare-const W2_state_RS2_qk (_ BitVec 3))
(declare-const W2_state_RS2_imm (Int))
(declare-const W2_state_RS2_dis (_ BitVec 1))
(declare-const W2_state_RS2_busy (_ BitVec 1))

(declare-const W2_state_RS3_op_type (Int))
(declare-const W2_state_RS3_op (Int))
(declare-const W2_state_RS3_ROB_dst (_ BitVec 3))
(declare-const W2_state_RS3_vj (Int))
(declare-const W2_state_RS3_vk (Int))
(declare-const W2_state_RS3_qj (_ BitVec 3))
(declare-const W2_state_RS3_qk (_ BitVec 3))
(declare-const W2_state_RS3_imm (Int))
(declare-const W2_state_RS3_dis (_ BitVec 1))
(declare-const W2_state_RS3_busy (_ BitVec 1))

(declare-const W2_state_LSQ0_op_type (Int))
(declare-const W2_state_LSQ0_op (Int))
(declare-const W2_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const W2_state_LSQ0_vj (Int))
(declare-const W2_state_LSQ0_vk (Int))
(declare-const W2_state_LSQ0_qj (_ BitVec 3))
(declare-const W2_state_LSQ0_qk (_ BitVec 3))
(declare-const W2_state_LSQ0_imm (Int))
(declare-const W2_state_LSQ0_dis (_ BitVec 1))
(declare-const W2_state_LSQ0_busy (_ BitVec 1))

(declare-const W2_state_LSQ1_op_type (Int))
(declare-const W2_state_LSQ1_op (Int))
(declare-const W2_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const W2_state_LSQ1_vj (Int))
(declare-const W2_state_LSQ1_vk (Int))
(declare-const W2_state_LSQ1_qj (_ BitVec 3))
(declare-const W2_state_LSQ1_qk (_ BitVec 3))
(declare-const W2_state_LSQ1_imm (Int))
(declare-const W2_state_LSQ1_dis (_ BitVec 1))
(declare-const W2_state_LSQ1_busy (_ BitVec 1))

(declare-const W2_state_LSQ2_op_type (Int))
(declare-const W2_state_LSQ2_op (Int))
(declare-const W2_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const W2_state_LSQ2_vj (Int))
(declare-const W2_state_LSQ2_vk (Int))
(declare-const W2_state_LSQ2_qj (_ BitVec 3))
(declare-const W2_state_LSQ2_qk (_ BitVec 3))
(declare-const W2_state_LSQ2_imm (Int))
(declare-const W2_state_LSQ2_dis (_ BitVec 1))
(declare-const W2_state_LSQ2_busy (_ BitVec 1))

(declare-const W2_state_LSQ3_op_type (Int))
(declare-const W2_state_LSQ3_op (Int))
(declare-const W2_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const W2_state_LSQ3_vj (Int))
(declare-const W2_state_LSQ3_vk (Int))
(declare-const W2_state_LSQ3_qj (_ BitVec 3))
(declare-const W2_state_LSQ3_qk (_ BitVec 3))
(declare-const W2_state_LSQ3_imm (Int))
(declare-const W2_state_LSQ3_dis (_ BitVec 1))
(declare-const W2_state_LSQ3_busy (_ BitVec 1))

(declare-const W2_state_Evict0_Valid (_ BitVec 1))
(declare-const W2_state_Evict1_Valid (_ BitVec 1))
(declare-const W2_state_Evict2_Valid (_ BitVec 1))
(declare-const W2_state_Evict3_Valid (_ BitVec 1))
(declare-const W2_state_Evict4_Valid (_ BitVec 1))
(declare-const W2_state_Evict5_Valid (_ BitVec 1))
(declare-const W2_state_Evict6_Valid (_ BitVec 1))
(declare-const W2_state_Evict7_Valid (_ BitVec 1))
(declare-const W2_state_Evict0_Tag (Int))
(declare-const W2_state_Evict1_Tag (Int))
(declare-const W2_state_Evict2_Tag (Int))
(declare-const W2_state_Evict3_Tag (Int))
(declare-const W2_state_Evict4_Tag (Int))
(declare-const W2_state_Evict5_Tag (Int))
(declare-const W2_state_Evict6_Tag (Int))
(declare-const W2_state_Evict7_Tag (Int))

(declare-const W3_state_Cache0_Tag (Int))
(declare-const W3_state_Cache1_Tag (Int))
(declare-const W3_state_Cache2_Tag (Int))
(declare-const W3_state_Cache3_Tag (Int))
(declare-const W3_state_Cache0_Data (Int))
(declare-const W3_state_Cache1_Data (Int))
(declare-const W3_state_Cache2_Data (Int))
(declare-const W3_state_Cache3_Data (Int))
(declare-const W3_state_Cache0_Valid (_ BitVec 1))
(declare-const W3_state_Cache1_Valid (_ BitVec 1))
(declare-const W3_state_Cache2_Valid (_ BitVec 1))
(declare-const W3_state_Cache3_Valid (_ BitVec 1))

(declare-const W3_state_IP (_ BitVec 3))
(declare-const W3_state_CP (_ BitVec 3))
(declare-const W3_state_PC (Int))

(declare-const W3_state_ROB0_busy (_ BitVec 1))
(declare-const W3_state_ROB0_op_type (Int))
(declare-const W3_state_ROB0_destination (Int))
(declare-const W3_state_ROB0_result (Int))
(declare-const W3_state_ROB0_exception (_ BitVec 1))
(declare-const W3_state_ROB0_done (_ BitVec 1))

(declare-const W3_state_ROB1_busy (_ BitVec 1))
(declare-const W3_state_ROB1_op_type (Int))
(declare-const W3_state_ROB1_destination (Int))
(declare-const W3_state_ROB1_result (Int))
(declare-const W3_state_ROB1_exception (_ BitVec 1))
(declare-const W3_state_ROB1_done (_ BitVec 1))

(declare-const W3_state_ROB2_busy (_ BitVec 1))
(declare-const W3_state_ROB2_op_type (Int))
(declare-const W3_state_ROB2_destination (Int))
(declare-const W3_state_ROB2_result (Int))
(declare-const W3_state_ROB2_exception (_ BitVec 1))
(declare-const W3_state_ROB2_done (_ BitVec 1))

(declare-const W3_state_ROB3_busy (_ BitVec 1))
(declare-const W3_state_ROB3_op_type (Int))
(declare-const W3_state_ROB3_destination (Int))
(declare-const W3_state_ROB3_result (Int))
(declare-const W3_state_ROB3_exception (_ BitVec 1))
(declare-const W3_state_ROB3_done (_ BitVec 1))

(declare-const W3_state_ROB4_busy (_ BitVec 1))
(declare-const W3_state_ROB4_op_type (Int))
(declare-const W3_state_ROB4_destination (Int))
(declare-const W3_state_ROB4_result (Int))
(declare-const W3_state_ROB4_exception (_ BitVec 1))
(declare-const W3_state_ROB4_done (_ BitVec 1))

(declare-const W3_state_ROB5_busy (_ BitVec 1))
(declare-const W3_state_ROB5_op_type (Int))
(declare-const W3_state_ROB5_destination (Int))
(declare-const W3_state_ROB5_result (Int))
(declare-const W3_state_ROB5_exception (_ BitVec 1))
(declare-const W3_state_ROB5_done (_ BitVec 1))

(declare-const W3_state_ROB6_busy (_ BitVec 1))
(declare-const W3_state_ROB6_op_type (Int))
(declare-const W3_state_ROB6_destination (Int))
(declare-const W3_state_ROB6_result (Int))
(declare-const W3_state_ROB6_exception (_ BitVec 1))
(declare-const W3_state_ROB6_done (_ BitVec 1))

(declare-const W3_state_ROB7_busy (_ BitVec 1))
(declare-const W3_state_ROB7_op_type (Int))
(declare-const W3_state_ROB7_destination (Int))
(declare-const W3_state_ROB7_result (Int))
(declare-const W3_state_ROB7_exception (_ BitVec 1))
(declare-const W3_state_ROB7_done (_ BitVec 1))

(declare-const W3_state_RS0_op_type (Int))
(declare-const W3_state_RS0_op (Int))
(declare-const W3_state_RS0_ROB_dst (_ BitVec 3))
(declare-const W3_state_RS0_vj (Int))
(declare-const W3_state_RS0_vk (Int))
(declare-const W3_state_RS0_qj (_ BitVec 3))
(declare-const W3_state_RS0_qk (_ BitVec 3))
(declare-const W3_state_RS0_imm (Int))
(declare-const W3_state_RS0_dis (_ BitVec 1))
(declare-const W3_state_RS0_busy (_ BitVec 1))

(declare-const W3_state_RS1_op_type (Int))
(declare-const W3_state_RS1_op (Int))
(declare-const W3_state_RS1_ROB_dst (_ BitVec 3))
(declare-const W3_state_RS1_vj (Int))
(declare-const W3_state_RS1_vk (Int))
(declare-const W3_state_RS1_qj (_ BitVec 3))
(declare-const W3_state_RS1_qk (_ BitVec 3))
(declare-const W3_state_RS1_imm (Int))
(declare-const W3_state_RS1_dis (_ BitVec 1))
(declare-const W3_state_RS1_busy (_ BitVec 1))

(declare-const W3_state_RS2_op_type (Int))
(declare-const W3_state_RS2_op (Int))
(declare-const W3_state_RS2_ROB_dst (_ BitVec 3))
(declare-const W3_state_RS2_vj (Int))
(declare-const W3_state_RS2_vk (Int))
(declare-const W3_state_RS2_qj (_ BitVec 3))
(declare-const W3_state_RS2_qk (_ BitVec 3))
(declare-const W3_state_RS2_imm (Int))
(declare-const W3_state_RS2_dis (_ BitVec 1))
(declare-const W3_state_RS2_busy (_ BitVec 1))

(declare-const W3_state_RS3_op_type (Int))
(declare-const W3_state_RS3_op (Int))
(declare-const W3_state_RS3_ROB_dst (_ BitVec 3))
(declare-const W3_state_RS3_vj (Int))
(declare-const W3_state_RS3_vk (Int))
(declare-const W3_state_RS3_qj (_ BitVec 3))
(declare-const W3_state_RS3_qk (_ BitVec 3))
(declare-const W3_state_RS3_imm (Int))
(declare-const W3_state_RS3_dis (_ BitVec 1))
(declare-const W3_state_RS3_busy (_ BitVec 1))

(declare-const W3_state_LSQ0_op_type (Int))
(declare-const W3_state_LSQ0_op (Int))
(declare-const W3_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const W3_state_LSQ0_vj (Int))
(declare-const W3_state_LSQ0_vk (Int))
(declare-const W3_state_LSQ0_qj (_ BitVec 3))
(declare-const W3_state_LSQ0_qk (_ BitVec 3))
(declare-const W3_state_LSQ0_imm (Int))
(declare-const W3_state_LSQ0_dis (_ BitVec 1))
(declare-const W3_state_LSQ0_busy (_ BitVec 1))

(declare-const W3_state_LSQ1_op_type (Int))
(declare-const W3_state_LSQ1_op (Int))
(declare-const W3_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const W3_state_LSQ1_vj (Int))
(declare-const W3_state_LSQ1_vk (Int))
(declare-const W3_state_LSQ1_qj (_ BitVec 3))
(declare-const W3_state_LSQ1_qk (_ BitVec 3))
(declare-const W3_state_LSQ1_imm (Int))
(declare-const W3_state_LSQ1_dis (_ BitVec 1))
(declare-const W3_state_LSQ1_busy (_ BitVec 1))

(declare-const W3_state_LSQ2_op_type (Int))
(declare-const W3_state_LSQ2_op (Int))
(declare-const W3_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const W3_state_LSQ2_vj (Int))
(declare-const W3_state_LSQ2_vk (Int))
(declare-const W3_state_LSQ2_qj (_ BitVec 3))
(declare-const W3_state_LSQ2_qk (_ BitVec 3))
(declare-const W3_state_LSQ2_imm (Int))
(declare-const W3_state_LSQ2_dis (_ BitVec 1))
(declare-const W3_state_LSQ2_busy (_ BitVec 1))

(declare-const W3_state_LSQ3_op_type (Int))
(declare-const W3_state_LSQ3_op (Int))
(declare-const W3_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const W3_state_LSQ3_vj (Int))
(declare-const W3_state_LSQ3_vk (Int))
(declare-const W3_state_LSQ3_qj (_ BitVec 3))
(declare-const W3_state_LSQ3_qk (_ BitVec 3))
(declare-const W3_state_LSQ3_imm (Int))
(declare-const W3_state_LSQ3_dis (_ BitVec 1))
(declare-const W3_state_LSQ3_busy (_ BitVec 1))

(declare-const W3_state_Evict0_Valid (_ BitVec 1))
(declare-const W3_state_Evict1_Valid (_ BitVec 1))
(declare-const W3_state_Evict2_Valid (_ BitVec 1))
(declare-const W3_state_Evict3_Valid (_ BitVec 1))
(declare-const W3_state_Evict4_Valid (_ BitVec 1))
(declare-const W3_state_Evict5_Valid (_ BitVec 1))
(declare-const W3_state_Evict6_Valid (_ BitVec 1))
(declare-const W3_state_Evict7_Valid (_ BitVec 1))
(declare-const W3_state_Evict0_Tag (Int))
(declare-const W3_state_Evict1_Tag (Int))
(declare-const W3_state_Evict2_Tag (Int))
(declare-const W3_state_Evict3_Tag (Int))
(declare-const W3_state_Evict4_Tag (Int))
(declare-const W3_state_Evict5_Tag (Int))
(declare-const W3_state_Evict6_Tag (Int))
(declare-const W3_state_Evict7_Tag (Int))

(declare-const W4_state_Cache0_Tag (Int))
(declare-const W4_state_Cache1_Tag (Int))
(declare-const W4_state_Cache2_Tag (Int))
(declare-const W4_state_Cache3_Tag (Int))
(declare-const W4_state_Cache0_Data (Int))
(declare-const W4_state_Cache1_Data (Int))
(declare-const W4_state_Cache2_Data (Int))
(declare-const W4_state_Cache3_Data (Int))
(declare-const W4_state_Cache0_Valid (_ BitVec 1))
(declare-const W4_state_Cache1_Valid (_ BitVec 1))
(declare-const W4_state_Cache2_Valid (_ BitVec 1))
(declare-const W4_state_Cache3_Valid (_ BitVec 1))

(declare-const W4_state_IP (_ BitVec 3))
(declare-const W4_state_CP (_ BitVec 3))
(declare-const W4_state_PC (Int))

(declare-const W4_state_ROB0_busy (_ BitVec 1))
(declare-const W4_state_ROB0_op_type (Int))
(declare-const W4_state_ROB0_destination (Int))
(declare-const W4_state_ROB0_result (Int))
(declare-const W4_state_ROB0_exception (_ BitVec 1))
(declare-const W4_state_ROB0_done (_ BitVec 1))

(declare-const W4_state_ROB1_busy (_ BitVec 1))
(declare-const W4_state_ROB1_op_type (Int))
(declare-const W4_state_ROB1_destination (Int))
(declare-const W4_state_ROB1_result (Int))
(declare-const W4_state_ROB1_exception (_ BitVec 1))
(declare-const W4_state_ROB1_done (_ BitVec 1))

(declare-const W4_state_ROB2_busy (_ BitVec 1))
(declare-const W4_state_ROB2_op_type (Int))
(declare-const W4_state_ROB2_destination (Int))
(declare-const W4_state_ROB2_result (Int))
(declare-const W4_state_ROB2_exception (_ BitVec 1))
(declare-const W4_state_ROB2_done (_ BitVec 1))

(declare-const W4_state_ROB3_busy (_ BitVec 1))
(declare-const W4_state_ROB3_op_type (Int))
(declare-const W4_state_ROB3_destination (Int))
(declare-const W4_state_ROB3_result (Int))
(declare-const W4_state_ROB3_exception (_ BitVec 1))
(declare-const W4_state_ROB3_done (_ BitVec 1))

(declare-const W4_state_ROB4_busy (_ BitVec 1))
(declare-const W4_state_ROB4_op_type (Int))
(declare-const W4_state_ROB4_destination (Int))
(declare-const W4_state_ROB4_result (Int))
(declare-const W4_state_ROB4_exception (_ BitVec 1))
(declare-const W4_state_ROB4_done (_ BitVec 1))

(declare-const W4_state_ROB5_busy (_ BitVec 1))
(declare-const W4_state_ROB5_op_type (Int))
(declare-const W4_state_ROB5_destination (Int))
(declare-const W4_state_ROB5_result (Int))
(declare-const W4_state_ROB5_exception (_ BitVec 1))
(declare-const W4_state_ROB5_done (_ BitVec 1))

(declare-const W4_state_ROB6_busy (_ BitVec 1))
(declare-const W4_state_ROB6_op_type (Int))
(declare-const W4_state_ROB6_destination (Int))
(declare-const W4_state_ROB6_result (Int))
(declare-const W4_state_ROB6_exception (_ BitVec 1))
(declare-const W4_state_ROB6_done (_ BitVec 1))

(declare-const W4_state_ROB7_busy (_ BitVec 1))
(declare-const W4_state_ROB7_op_type (Int))
(declare-const W4_state_ROB7_destination (Int))
(declare-const W4_state_ROB7_result (Int))
(declare-const W4_state_ROB7_exception (_ BitVec 1))
(declare-const W4_state_ROB7_done (_ BitVec 1))

(declare-const W4_state_RS0_op_type (Int))
(declare-const W4_state_RS0_op (Int))
(declare-const W4_state_RS0_ROB_dst (_ BitVec 3))
(declare-const W4_state_RS0_vj (Int))
(declare-const W4_state_RS0_vk (Int))
(declare-const W4_state_RS0_qj (_ BitVec 3))
(declare-const W4_state_RS0_qk (_ BitVec 3))
(declare-const W4_state_RS0_imm (Int))
(declare-const W4_state_RS0_dis (_ BitVec 1))
(declare-const W4_state_RS0_busy (_ BitVec 1))

(declare-const W4_state_RS1_op_type (Int))
(declare-const W4_state_RS1_op (Int))
(declare-const W4_state_RS1_ROB_dst (_ BitVec 3))
(declare-const W4_state_RS1_vj (Int))
(declare-const W4_state_RS1_vk (Int))
(declare-const W4_state_RS1_qj (_ BitVec 3))
(declare-const W4_state_RS1_qk (_ BitVec 3))
(declare-const W4_state_RS1_imm (Int))
(declare-const W4_state_RS1_dis (_ BitVec 1))
(declare-const W4_state_RS1_busy (_ BitVec 1))

(declare-const W4_state_RS2_op_type (Int))
(declare-const W4_state_RS2_op (Int))
(declare-const W4_state_RS2_ROB_dst (_ BitVec 3))
(declare-const W4_state_RS2_vj (Int))
(declare-const W4_state_RS2_vk (Int))
(declare-const W4_state_RS2_qj (_ BitVec 3))
(declare-const W4_state_RS2_qk (_ BitVec 3))
(declare-const W4_state_RS2_imm (Int))
(declare-const W4_state_RS2_dis (_ BitVec 1))
(declare-const W4_state_RS2_busy (_ BitVec 1))

(declare-const W4_state_RS3_op_type (Int))
(declare-const W4_state_RS3_op (Int))
(declare-const W4_state_RS3_ROB_dst (_ BitVec 3))
(declare-const W4_state_RS3_vj (Int))
(declare-const W4_state_RS3_vk (Int))
(declare-const W4_state_RS3_qj (_ BitVec 3))
(declare-const W4_state_RS3_qk (_ BitVec 3))
(declare-const W4_state_RS3_imm (Int))
(declare-const W4_state_RS3_dis (_ BitVec 1))
(declare-const W4_state_RS3_busy (_ BitVec 1))

(declare-const W4_state_LSQ0_op_type (Int))
(declare-const W4_state_LSQ0_op (Int))
(declare-const W4_state_LSQ0_ROB_dst (_ BitVec 3))
(declare-const W4_state_LSQ0_vj (Int))
(declare-const W4_state_LSQ0_vk (Int))
(declare-const W4_state_LSQ0_qj (_ BitVec 3))
(declare-const W4_state_LSQ0_qk (_ BitVec 3))
(declare-const W4_state_LSQ0_imm (Int))
(declare-const W4_state_LSQ0_dis (_ BitVec 1))
(declare-const W4_state_LSQ0_busy (_ BitVec 1))

(declare-const W4_state_LSQ1_op_type (Int))
(declare-const W4_state_LSQ1_op (Int))
(declare-const W4_state_LSQ1_ROB_dst (_ BitVec 3))
(declare-const W4_state_LSQ1_vj (Int))
(declare-const W4_state_LSQ1_vk (Int))
(declare-const W4_state_LSQ1_qj (_ BitVec 3))
(declare-const W4_state_LSQ1_qk (_ BitVec 3))
(declare-const W4_state_LSQ1_imm (Int))
(declare-const W4_state_LSQ1_dis (_ BitVec 1))
(declare-const W4_state_LSQ1_busy (_ BitVec 1))

(declare-const W4_state_LSQ2_op_type (Int))
(declare-const W4_state_LSQ2_op (Int))
(declare-const W4_state_LSQ2_ROB_dst (_ BitVec 3))
(declare-const W4_state_LSQ2_vj (Int))
(declare-const W4_state_LSQ2_vk (Int))
(declare-const W4_state_LSQ2_qj (_ BitVec 3))
(declare-const W4_state_LSQ2_qk (_ BitVec 3))
(declare-const W4_state_LSQ2_imm (Int))
(declare-const W4_state_LSQ2_dis (_ BitVec 1))
(declare-const W4_state_LSQ2_busy (_ BitVec 1))

(declare-const W4_state_LSQ3_op_type (Int))
(declare-const W4_state_LSQ3_op (Int))
(declare-const W4_state_LSQ3_ROB_dst (_ BitVec 3))
(declare-const W4_state_LSQ3_vj (Int))
(declare-const W4_state_LSQ3_vk (Int))
(declare-const W4_state_LSQ3_qj (_ BitVec 3))
(declare-const W4_state_LSQ3_qk (_ BitVec 3))
(declare-const W4_state_LSQ3_imm (Int))
(declare-const W4_state_LSQ3_dis (_ BitVec 1))
(declare-const W4_state_LSQ3_busy (_ BitVec 1))

(declare-const W4_state_Evict0_Valid (_ BitVec 1))
(declare-const W4_state_Evict1_Valid (_ BitVec 1))
(declare-const W4_state_Evict2_Valid (_ BitVec 1))
(declare-const W4_state_Evict3_Valid (_ BitVec 1))
(declare-const W4_state_Evict4_Valid (_ BitVec 1))
(declare-const W4_state_Evict5_Valid (_ BitVec 1))
(declare-const W4_state_Evict6_Valid (_ BitVec 1))
(declare-const W4_state_Evict7_Valid (_ BitVec 1))
(declare-const W4_state_Evict0_Tag (Int))
(declare-const W4_state_Evict1_Tag (Int))
(declare-const W4_state_Evict2_Tag (Int))
(declare-const W4_state_Evict3_Tag (Int))
(declare-const W4_state_Evict4_Tag (Int))
(declare-const W4_state_Evict5_Tag (Int))
(declare-const W4_state_Evict6_Tag (Int))
(declare-const W4_state_Evict7_Tag (Int))

(declare-const I_state_Cache0_Tag (Int))
(declare-const I_state_Cache1_Tag (Int))
(declare-const I_state_Cache2_Tag (Int))
(declare-const I_state_Cache3_Tag (Int))
(declare-const I_state_Cache0_Data (Int))
(declare-const I_state_Cache1_Data (Int))
(declare-const I_state_Cache2_Data (Int))
(declare-const I_state_Cache3_Data (Int))
(declare-const I_state_Cache0_Valid (_ BitVec 1))
(declare-const I_state_Cache1_Valid (_ BitVec 1))
(declare-const I_state_Cache2_Valid (_ BitVec 1))
(declare-const I_state_Cache3_Valid (_ BitVec 1))

(declare-const I_state_Evict0_Valid (_ BitVec 1))
(declare-const I_state_Evict1_Valid (_ BitVec 1))
(declare-const I_state_Evict2_Valid (_ BitVec 1))
(declare-const I_state_Evict3_Valid (_ BitVec 1))
(declare-const I_state_Evict4_Valid (_ BitVec 1))
(declare-const I_state_Evict5_Valid (_ BitVec 1))
(declare-const I_state_Evict6_Valid (_ BitVec 1))
(declare-const I_state_Evict7_Valid (_ BitVec 1))
(declare-const I_state_Evict0_Tag (Int))
(declare-const I_state_Evict1_Tag (Int))
(declare-const I_state_Evict2_Tag (Int))
(declare-const I_state_Evict3_Tag (Int))
(declare-const I_state_Evict4_Tag (Int))
(declare-const I_state_Evict5_Tag (Int))
(declare-const I_state_Evict6_Tag (Int))
(declare-const I_state_Evict7_Tag (Int))


(declare-const U4_state_ROB1_RF_dst_value (Int))
(declare-const U4_state_ROB2_RF_dst_value (Int))
(declare-const U4_state_ROB3_RF_dst_value (Int))
(declare-const U4_state_ROB4_RF_dst_value (Int))

(declare-const U4_state_ROB1_DM_dst_value (Int))
(declare-const U4_state_ROB2_DM_dst_value (Int))
(declare-const U4_state_ROB3_DM_dst_value (Int))
(declare-const U4_state_ROB4_DM_dst_value (Int))

(declare-const W4_state_ROB1_RF_dst_value (Int))
(declare-const W4_state_ROB2_RF_dst_value (Int))
(declare-const W4_state_ROB3_RF_dst_value (Int))
(declare-const W4_state_ROB4_RF_dst_value (Int))

(declare-const W4_state_ROB1_DM_dst_value (Int))
(declare-const W4_state_ROB2_DM_dst_value (Int))
(declare-const W4_state_ROB3_DM_dst_value (Int))
(declare-const W4_state_ROB4_DM_dst_value (Int))

(declare-const I_state_ROB1_RF_dst_value (Int))
(declare-const I_state_ROB2_RF_dst_value (Int))
(declare-const I_state_ROB3_RF_dst_value (Int))
(declare-const I_state_ROB4_RF_dst_value (Int))

(declare-const I_state_ROB1_DM_dst_value (Int))
(declare-const I_state_ROB2_DM_dst_value (Int))
(declare-const I_state_ROB3_DM_dst_value (Int))
(declare-const I_state_ROB4_DM_dst_value (Int))
;)


(assert
	(not
;---------------------------Issue--------------------------------------------------------------		
		(let
			(
				(Instruction (select T_IM T_PC))
			)
		(let
			(
				(op (Inst_op Instruction))
				(op_type (Inst_op_type Instruction))
				(rs (Inst_rs Instruction))
				(rt (Inst_rt Instruction))
				(rd (Inst_rd Instruction))
				(imm (Inst_imm Instruction))
				(PC_plus_one (+ T_PC 4))
				
				(ROB1_busy (select T_ROB_busy (_ bv1 3)))
				(ROB2_busy (select T_ROB_busy (_ bv2 3)))
				(ROB3_busy (select T_ROB_busy (_ bv3 3)))
				(ROB4_busy (select T_ROB_busy (_ bv4 3)))
				
				(RS0_busy (select T_RS_busy (_ bv0 2)))
				(RS1_busy (select T_RS_busy (_ bv1 2)))
				(RS2_busy (select T_RS_busy (_ bv2 2)))
				(RS3_busy (select T_RS_busy (_ bv3 2)))
				
				(LSQ0_busy (select T_LSQ_busy (_ bv0 2)))
				(LSQ1_busy (select T_LSQ_busy (_ bv1 2)))
				(LSQ2_busy (select T_LSQ_busy (_ bv2 2)))
				(LSQ3_busy (select T_LSQ_busy (_ bv3 2)))
			)
		(let
			(
				(RF_rs (select T_RF rs))
				(RF_rt (select T_RF rt))
			)
		(let((IP_m1 (subtract T_IP)))
		(let((IP_m2 (subtract IP_m1)))
		(let((IP_m3 (subtract IP_m2)))
		(let((IP_m4 (subtract IP_m3)))
		(let
			(	
				(RAT_rs
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rs (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rs (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rs (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rs (select T_ROB_destination IP_m4))) IP_m4
					(_ bv0 3)
					))))
				)
				(RAT_rt
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rt (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rt (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rt (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rt (select T_ROB_destination IP_m4))) IP_m4
					(_ bv0 3)
					))))
				)
				(T_MRB
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (= Branch (select T_ROB_op_type IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (= Branch (select T_ROB_op_type IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (= Branch (select T_ROB_op_type IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (= Branch (select T_ROB_op_type IP_m4))) IP_m4
					(_ bv0 3)
					))))
				)
				(SCS_input (ite (= 78 (select T_RF 3)) (_ bv0 1) SCS))
			)
		(let
			(
				(scs_stall (ite (and (= SCS_input #b1) (not (= #b000 T_MRB)) (= op_type Load)) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(stall
					(ite (= #b1 scs_stall) (_ bv1 1)
					(ite (= #b1 U_path_stall) (_ bv1 1)
					(ite (= #b1 (select T_ROB_busy T_IP)) (_ bv1 1)
					(ite (= #b1 (bvand ROB1_busy ROB2_busy ROB3_busy ROB4_busy)) (_ bv1 1)
					(_ bv0 1)
					))))
				)
				(RF_destination 
					(ite (= op_type Load) rt
					(ite (= op_type Rtype) rd
					(ite (= op_type Branch) imm
					0
					)))
				)
				(IP_update (bvadd T_IP (_ bv1 3)))
			)
		(let
			(
				(issue_to_rs0 (ite (and (= RS0_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq3 (ite (and (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs1 (ite (and (= issue_to_rs0 #b0) (= RS1_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq2 (ite (and (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs2 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= RS2_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq1 (ite (and (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs3 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= RS3_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq0 (ite (and (= issue_to_lsq1 #b0) (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(RS_Issue_index 
					(ite (= issue_to_rs0 #b1) (_ bv0 2)
					(ite (= issue_to_rs1 #b1) (_ bv1 2)
					(ite (= issue_to_rs2 #b1) (_ bv2 2)
					(ite (= issue_to_rs3 #b1) (_ bv3 2) (_ bv0 2)))))
				)
				(LSQ_Issue_index 
					(ite (= issue_to_lsq3 #b1) (_ bv3 2)
					(ite (= issue_to_lsq2 #b1) (_ bv2 2)
					(ite (= issue_to_lsq1 #b1) (_ bv1 2)
					(ite (= issue_to_lsq0 #b1) (_ bv0 2) (_ bv0 2)))))
				)
				(RS_issued (bvor issue_to_rs0 issue_to_rs1 issue_to_rs2 issue_to_rs3))
				(LSQ_issued (bvor issue_to_lsq3 issue_to_lsq2 issue_to_lsq1 issue_to_lsq0))
			)
		(let
			(
				(ROB_busy_update (store T_ROB_busy T_IP (_ bv1 1)))
				(ROB_op_type_update (store T_ROB_op_type T_IP op_type))
				(ROB_destination_update (store T_ROB_destination T_IP RF_destination))
				(ROB_result_update (store T_ROB_result T_IP 0))
				(ROB_exception_update (store T_ROB_exception T_IP (_ bv0 1)))
				(ROB_done_update (store T_ROB_done T_IP (_ bv0 1)))
				
				(IP_update (ite (= IP_update #b101) (_ bv1 3) IP_update))	;if IP+1= 5 then Loop back to 1
				
				(RS_op_type_update (store T_RS_op_type RS_Issue_index op_type))
				(RS_op_update (store T_RS_op RS_Issue_index op))
				(RS_ROB_dst_update (store T_RS_ROB_dst RS_Issue_index T_IP))
				(RS_vj_update (store T_RS_vj RS_Issue_index RF_rs))
				(RS_vk_update (store T_RS_vk RS_Issue_index RF_rt))
				(RS_qj_update (store T_RS_qj RS_Issue_index RAT_rs))
				(RS_qk_update (store T_RS_qk RS_Issue_index RAT_rt))
				(RS_imm_update (store T_RS_imm RS_Issue_index imm))
				(RS_dis_update (store T_RS_dis RS_Issue_index (_ bv0 1)))
				(RS_busy_update (store T_RS_busy RS_Issue_index (_ bv1 1)))
				
				(LSQ_op_type_update (store T_LSQ_op_type LSQ_Issue_index op_type))
				(LSQ_op_update (store T_LSQ_op LSQ_Issue_index op))
				(LSQ_ROB_dst_update (store T_LSQ_ROB_dst LSQ_Issue_index T_IP))
				(LSQ_vj_update (store T_LSQ_vj LSQ_Issue_index RF_rs))
				(LSQ_vk_update (store T_LSQ_vk LSQ_Issue_index RF_rt))
				(LSQ_qj_update (store T_LSQ_qj LSQ_Issue_index RAT_rs))
				(LSQ_qk_update (store T_LSQ_qk LSQ_Issue_index RAT_rt))
				(LSQ_imm_update (store T_LSQ_imm LSQ_Issue_index imm))
				(LSQ_dis_update (store T_LSQ_dis LSQ_Issue_index (_ bv0 1)))
				(LSQ_busy_update (store T_LSQ_busy LSQ_Issue_index (_ bv1 1)))
			)
		(let
			(
				
				(U1_RF (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_RF T_RF))
				(U1_DM (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_DM T_DM))
				
				(U1_Cache_Tag (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Tag T_Cache_Tag))
				(U1_Cache_Data (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Data T_Cache_Data))
				(U1_Cache_Valid (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Valid T_Cache_Valid))
				
				(U1_PC
					(ite (= op_type Jump) imm
					(ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) PC_plus_one 
					T_PC))
				)
				
				(U1_IP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) IP_update T_IP))
				(U1_CP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_CP T_CP))
				
				(U1_ROB_busy (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_busy_update T_ROB_busy))
				(U1_ROB_op_type (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_op_type_update T_ROB_op_type))
				(U1_ROB_destination (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_destination_update T_ROB_destination))
				(U1_ROB_result (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_result_update T_ROB_result))
				(U1_ROB_exception (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_exception_update T_ROB_exception))
				(U1_ROB_done (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_done_update T_ROB_done))
				
				(U1_RS_op_type (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_type_update T_RS_op_type))
				(U1_RS_op (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_update T_RS_op))
				(U1_RS_ROB_dst (ite (and (= stall #b0) (= RS_issued #b1)) RS_ROB_dst_update T_RS_ROB_dst))
				(U1_RS_vj (ite (and (= stall #b0) (= RS_issued #b1)) RS_vj_update T_RS_vj))
				(U1_RS_vk (ite (and (= stall #b0) (= RS_issued #b1)) RS_vk_update T_RS_vk))
				(U1_RS_qj (ite (and (= stall #b0) (= RS_issued #b1)) RS_qj_update T_RS_qj))
				(U1_RS_qk (ite (and (= stall #b0) (= RS_issued #b1)) RS_qk_update T_RS_qk))
				(U1_RS_imm (ite (and (= stall #b0) (= RS_issued #b1)) RS_imm_update T_RS_imm))
				(U1_RS_dis (ite (and (= stall #b0) (= RS_issued #b1)) RS_dis_update T_RS_dis))
				(U1_RS_busy (ite (and (= stall #b0) (= RS_issued #b1)) RS_busy_update T_RS_busy))
				
				(U1_LSQ_op_type (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_type_update T_LSQ_op_type))
				(U1_LSQ_op (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_update T_LSQ_op))
				(U1_LSQ_ROB_dst (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_ROB_dst_update T_LSQ_ROB_dst))
				(U1_LSQ_vj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vj_update T_LSQ_vj))
				(U1_LSQ_vk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vk_update T_LSQ_vk))
				(U1_LSQ_qj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qj_update T_LSQ_qj))
				(U1_LSQ_qk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qk_update T_LSQ_qk))
				(U1_LSQ_imm (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_imm_update T_LSQ_imm))
				(U1_LSQ_dis (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_dis_update T_LSQ_dis))
				(U1_LSQ_busy (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_busy_update T_LSQ_busy))
			
				(U1_Evict_Tag (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Tag T_Evict_Tag))
				(U1_Evict_Valid (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Valid T_Evict_Valid))
				(U1_Evict_Index (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Index T_Evict_Index))
			)
;---------------------------Update--------------------------------------------------------------	
		(let
			(
				(U1_RS0_busy (select U1_RS_busy (_ bv0 2)))
				(U1_RS0_qj (select U1_RS_qj (_ bv0 2)))
				(U1_RS0_qk (select U1_RS_qk (_ bv0 2)))
				(U1_RS1_busy (select U1_RS_busy (_ bv1 2)))
				(U1_RS1_qj (select U1_RS_qj (_ bv1 2)))
				(U1_RS1_qk (select U1_RS_qk (_ bv1 2)))
				(U1_RS2_busy (select U1_RS_busy (_ bv2 2)))
				(U1_RS2_qj (select U1_RS_qj (_ bv2 2)))
				(U1_RS2_qk (select U1_RS_qk (_ bv2 2)))
				(U1_RS3_busy (select U1_RS_busy (_ bv3 2)))
				(U1_RS3_qj (select U1_RS_qj (_ bv3 2)))
				(U1_RS3_qk (select U1_RS_qk (_ bv3 2)))
				
				(U1_LSQ0_busy (select U1_LSQ_busy (_ bv0 2)))
				(U1_LSQ0_qj (select U1_LSQ_qj (_ bv0 2)))
				(U1_LSQ0_qk (select U1_LSQ_qk (_ bv0 2)))
				(U1_LSQ1_busy (select U1_LSQ_busy (_ bv1 2)))
				(U1_LSQ1_qj (select U1_LSQ_qj (_ bv1 2)))
				(U1_LSQ1_qk (select U1_LSQ_qk (_ bv1 2)))
				(U1_LSQ2_busy (select U1_LSQ_busy (_ bv2 2)))
				(U1_LSQ2_qj (select U1_LSQ_qj (_ bv2 2)))
				(U1_LSQ2_qk (select U1_LSQ_qk (_ bv2 2)))
				(U1_LSQ3_busy (select U1_LSQ_busy (_ bv3 2)))
				(U1_LSQ3_qj (select U1_LSQ_qj (_ bv3 2)))
				(U1_LSQ3_qk (select U1_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U1_RS0_qj_ROB_done (select U1_ROB_done U1_RS0_qj))
				(U1_RS0_qj_ROB_result (select U1_ROB_result U1_RS0_qj))
				(U1_RS0_qk_ROB_done (select U1_ROB_done U1_RS0_qk))
				(U1_RS0_qk_ROB_result (select U1_ROB_result U1_RS0_qk))
				(U1_RS1_qj_ROB_done (select U1_ROB_done U1_RS1_qj))
				(U1_RS1_qj_ROB_result (select U1_ROB_result U1_RS1_qj))
				(U1_RS1_qk_ROB_done (select U1_ROB_done U1_RS1_qk))
				(U1_RS1_qk_ROB_result (select U1_ROB_result U1_RS1_qk))
				(U1_RS2_qj_ROB_done (select U1_ROB_done U1_RS2_qj))
				(U1_RS2_qj_ROB_result (select U1_ROB_result U1_RS2_qj))
				(U1_RS2_qk_ROB_done (select U1_ROB_done U1_RS2_qk))
				(U1_RS2_qk_ROB_result (select U1_ROB_result U1_RS2_qk))
				(U1_RS3_qj_ROB_done (select U1_ROB_done U1_RS3_qj))
				(U1_RS3_qj_ROB_result (select U1_ROB_result U1_RS3_qj))
				(U1_RS3_qk_ROB_done (select U1_ROB_done U1_RS3_qk))
				(U1_RS3_qk_ROB_result (select U1_ROB_result U1_RS3_qk))
				
				(U1_LSQ0_qj_ROB_done (select U1_ROB_done U1_LSQ0_qj))
				(U1_LSQ0_qj_ROB_result (select U1_ROB_result U1_LSQ0_qj))
				(U1_LSQ0_qk_ROB_done (select U1_ROB_done U1_LSQ0_qk))
				(U1_LSQ0_qk_ROB_result (select U1_ROB_result U1_LSQ0_qk))
				(U1_LSQ1_qj_ROB_done (select U1_ROB_done U1_LSQ1_qj))
				(U1_LSQ1_qj_ROB_result (select U1_ROB_result U1_LSQ1_qj))
				(U1_LSQ1_qk_ROB_done (select U1_ROB_done U1_LSQ1_qk))
				(U1_LSQ1_qk_ROB_result (select U1_ROB_result U1_LSQ1_qk))
				(U1_LSQ2_qj_ROB_done (select U1_ROB_done U1_LSQ2_qj))
				(U1_LSQ2_qj_ROB_result (select U1_ROB_result U1_LSQ2_qj))
				(U1_LSQ2_qk_ROB_done (select U1_ROB_done U1_LSQ2_qk))
				(U1_LSQ2_qk_ROB_result (select U1_ROB_result U1_LSQ2_qk))
				(U1_LSQ3_qj_ROB_done (select U1_ROB_done U1_LSQ3_qj))
				(U1_LSQ3_qj_ROB_result (select U1_ROB_result U1_LSQ3_qj))
				(U1_LSQ3_qk_ROB_done (select U1_ROB_done U1_LSQ3_qk))
				(U1_LSQ3_qk_ROB_result (select U1_ROB_result U1_LSQ3_qk))
			)
		(let
			(
				(U1_RS0_vj_update (store U1_RS_vj (_ bv0 2) U1_RS0_qj_ROB_result))
				(U1_RS0_vk_update (store U1_RS_vk (_ bv0 2) U1_RS0_qk_ROB_result))					
				(U1_RS0_qj_update (store U1_RS_qj (_ bv0 2) (_ bv0 3)))	
				(U1_RS0_qk_update (store U1_RS_qk (_ bv0 2) (_ bv0 3)))	
				(U1_LSQ0_vj_update (store U1_LSQ_vj (_ bv0 2) U1_LSQ0_qj_ROB_result))	
				(U1_LSQ0_vk_update (store U1_LSQ_vk (_ bv0 2) U1_LSQ0_qk_ROB_result))	
				(U1_LSQ0_qj_update (store U1_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(U1_LSQ0_qk_update (store U1_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS0_busy) (not (= #b000 U1_RS0_qj)) (= #b1 U1_RS0_qj_ROB_done)) U1_RS0_vj_update U1_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS0_busy) (not (= #b000 U1_RS0_qk)) (= #b1 U1_RS0_qk_ROB_done)) U1_RS0_vk_update U1_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS0_busy) (not (= #b000 U1_RS0_qj)) (= #b1 U1_RS0_qj_ROB_done)) U1_RS0_qj_update U1_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS0_busy) (not (= #b000 U1_RS0_qk)) (= #b1 U1_RS0_qk_ROB_done)) U1_RS0_qk_update U1_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000 U1_LSQ0_qj)) (= #b1 U1_LSQ0_qj_ROB_done)) U1_LSQ0_vj_update U1_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000 U1_LSQ0_qk)) (= #b1 U1_LSQ0_qk_ROB_done)) U1_LSQ0_vk_update U1_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000 U1_LSQ0_qj)) (= #b1 U1_LSQ0_qj_ROB_done)) U1_LSQ0_qj_update U1_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ0_busy) (not (= #b000 U1_LSQ0_qk)) (= #b1 U1_LSQ0_qk_ROB_done)) U1_LSQ0_qk_update U1_LSQ_qk))
			)
		(let
			(
				(U1_RS1_vj_update (store U2_RS_vj (_ bv1 2) U1_RS1_qj_ROB_result))	
				(U1_RS1_vk_update (store U2_RS_vk (_ bv1 2) U1_RS1_qk_ROB_result))	
				(U1_RS1_qj_update (store U2_RS_qj (_ bv1 2) (_ bv0 3)))	
				(U1_RS1_qk_update (store U2_RS_qk (_ bv1 2) (_ bv0 3)))	
				(U1_LSQ1_vj_update (store U2_LSQ_vj (_ bv1 2) U1_LSQ1_qj_ROB_result))	
				(U1_LSQ1_vk_update (store U2_LSQ_vk (_ bv1 2) U1_LSQ1_qk_ROB_result))	
				(U1_LSQ1_qj_update (store U2_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(U1_LSQ1_qk_update (store U2_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS1_busy) (not (= #b000 U1_RS1_qj)) (= #b1 U1_RS1_qj_ROB_done)) U1_RS1_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS1_busy) (not (= #b000 U1_RS1_qk)) (= #b1 U1_RS1_qk_ROB_done)) U1_RS1_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS1_busy) (not (= #b000 U1_RS1_qj)) (= #b1 U1_RS1_qj_ROB_done)) U1_RS1_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS1_busy) (not (= #b000 U1_RS1_qk)) (= #b1 U1_RS1_qk_ROB_done)) U1_RS1_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000 U1_LSQ1_qj)) (= #b1 U1_LSQ1_qj_ROB_done)) U1_LSQ1_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000 U1_LSQ1_qk)) (= #b1 U1_LSQ1_qk_ROB_done)) U1_LSQ1_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000 U1_LSQ1_qj)) (= #b1 U1_LSQ1_qj_ROB_done)) U1_LSQ1_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ1_busy) (not (= #b000 U1_LSQ1_qk)) (= #b1 U1_LSQ1_qk_ROB_done)) U1_LSQ1_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS2_vj_update (store U2_RS_vj (_ bv2 2) U1_RS2_qj_ROB_result))	
				(U1_RS2_vk_update (store U2_RS_vk (_ bv2 2) U1_RS2_qk_ROB_result))	
				(U1_RS2_qj_update (store U2_RS_qj (_ bv2 2) (_ bv0 3)))	
				(U1_RS2_qk_update (store U2_RS_qk (_ bv2 2) (_ bv0 3)))	
				(U1_LSQ2_vj_update (store U2_LSQ_vj (_ bv2 2) U1_LSQ2_qj_ROB_result))	
				(U1_LSQ2_vk_update (store U2_LSQ_vk (_ bv2 2) U1_LSQ2_qk_ROB_result))	
				(U1_LSQ2_qj_update (store U2_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(U1_LSQ2_qk_update (store U2_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS2_busy) (not (= #b000 U1_RS2_qj)) (= #b1 U1_RS2_qj_ROB_done)) U1_RS2_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS2_busy) (not (= #b000 U1_RS2_qk)) (= #b1 U1_RS2_qk_ROB_done)) U1_RS2_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS2_busy) (not (= #b000 U1_RS2_qj)) (= #b1 U1_RS2_qj_ROB_done)) U1_RS2_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS2_busy) (not (= #b000 U1_RS2_qk)) (= #b1 U1_RS2_qk_ROB_done)) U1_RS2_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000 U1_LSQ2_qj)) (= #b1 U1_LSQ2_qj_ROB_done)) U1_LSQ2_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000 U1_LSQ2_qk)) (= #b1 U1_LSQ2_qk_ROB_done)) U1_LSQ2_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000 U1_LSQ2_qj)) (= #b1 U1_LSQ2_qj_ROB_done)) U1_LSQ2_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ2_busy) (not (= #b000 U1_LSQ2_qk)) (= #b1 U1_LSQ2_qk_ROB_done)) U1_LSQ2_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U1_RS3_vj_update (store U2_RS_vj (_ bv3 2) U1_RS3_qj_ROB_result))	
				(U1_RS3_vk_update (store U2_RS_vk (_ bv3 2) U1_RS3_qk_ROB_result))	
				(U1_RS3_qj_update (store U2_RS_qj (_ bv3 2) (_ bv0 3)))	
				(U1_RS3_qk_update (store U2_RS_qk (_ bv3 2) (_ bv0 3)))	
				(U1_LSQ3_vj_update (store U2_LSQ_vj (_ bv3 2) U1_LSQ3_qj_ROB_result))	
				(U1_LSQ3_vk_update (store U2_LSQ_vk (_ bv3 2) U1_LSQ3_qk_ROB_result))	
				(U1_LSQ3_qj_update (store U2_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(U1_LSQ3_qk_update (store U2_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(U2_RS_vj (ite (and (= #b1 U1_RS3_busy) (not (= #b000 U1_RS3_qj)) (= #b1 U1_RS3_qj_ROB_done)) U1_RS3_vj_update U2_RS_vj))
				(U2_RS_vk (ite (and (= #b1 U1_RS3_busy) (not (= #b000 U1_RS3_qk)) (= #b1 U1_RS3_qk_ROB_done)) U1_RS3_vk_update U2_RS_vk))
				(U2_RS_qj (ite (and (= #b1 U1_RS3_busy) (not (= #b000 U1_RS3_qj)) (= #b1 U1_RS3_qj_ROB_done)) U1_RS3_qj_update U2_RS_qj))
				(U2_RS_qk (ite (and (= #b1 U1_RS3_busy) (not (= #b000 U1_RS3_qk)) (= #b1 U1_RS3_qk_ROB_done)) U1_RS3_qk_update U2_RS_qk))
				(U2_LSQ_vj (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000 U1_LSQ3_qj)) (= #b1 U1_LSQ3_qj_ROB_done)) U1_LSQ3_vj_update U2_LSQ_vj))
				(U2_LSQ_vk (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000 U1_LSQ3_qk)) (= #b1 U1_LSQ3_qk_ROB_done)) U1_LSQ3_vk_update U2_LSQ_vk))
				(U2_LSQ_qj (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000 U1_LSQ3_qj)) (= #b1 U1_LSQ3_qj_ROB_done)) U1_LSQ3_qj_update U2_LSQ_qj))
				(U2_LSQ_qk (ite (and (= #b1 U1_LSQ3_busy) (not (= #b000 U1_LSQ3_qk)) (= #b1 U1_LSQ3_qk_ROB_done)) U1_LSQ3_qk_update U2_LSQ_qk))
			)
		(let
			(
				(U2_RS0_busy (select U1_RS_busy (_ bv0 2)))
				(U2_RS0_qj (select U2_RS_qj (_ bv0 2)))
				(U2_RS0_qk (select U2_RS_qk (_ bv0 2)))
				(U2_RS1_busy (select U1_RS_busy (_ bv1 2)))
				(U2_RS1_qj (select U2_RS_qj (_ bv1 2)))
				(U2_RS1_qk (select U2_RS_qk (_ bv1 2)))
				(U2_RS2_busy (select U1_RS_busy (_ bv2 2)))
				(U2_RS2_qj (select U2_RS_qj (_ bv2 2)))
				(U2_RS2_qk (select U2_RS_qk (_ bv2 2)))
				(U2_RS3_busy (select U1_RS_busy (_ bv3 2)))
				(U2_RS3_qj (select U2_RS_qj (_ bv3 2)))
				(U2_RS3_qk (select U2_RS_qk (_ bv3 2)))
				(U2_LSQ0_busy (select U1_LSQ_busy (_ bv0 2)))
				(U2_LSQ0_qj (select U2_LSQ_qj (_ bv0 2)))
				(U2_LSQ0_qk (select U2_LSQ_qk (_ bv0 2)))
				(U2_LSQ1_busy (select U1_LSQ_busy (_ bv1 2)))
				(U2_LSQ1_qj (select U2_LSQ_qj (_ bv1 2)))
				(U2_LSQ1_qk (select U2_LSQ_qk (_ bv1 2)))
				(U2_LSQ2_busy (select U1_LSQ_busy (_ bv2 2)))
				(U2_LSQ2_qj (select U2_LSQ_qj (_ bv2 2)))
				(U2_LSQ2_qk (select U2_LSQ_qk (_ bv2 2)))
				(U2_LSQ3_busy (select U1_LSQ_busy (_ bv3 2)))
				(U2_LSQ3_qj (select U2_LSQ_qj (_ bv3 2)))
				(U2_LSQ3_qk (select U2_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U2_RS0_dis (ite (and (= #b1 U2_RS0_busy) (= #b000 U2_RS0_qj) (= #b000 U2_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS1_dis (ite (and (= #b1 U2_RS1_busy) (= #b000 U2_RS1_qj) (= #b000 U2_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS2_dis (ite (and (= #b1 U2_RS2_busy) (= #b000 U2_RS2_qj) (= #b000 U2_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_RS3_dis (ite (and (= #b1 U2_RS3_busy) (= #b000 U2_RS3_qj) (= #b000 U2_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U2_LSQ0_dis (ite (and (= #b1 U2_LSQ0_busy) (= #b000 U2_LSQ0_qj) (= #b000 U2_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ1_dis (ite (and (= #b1 U2_LSQ1_busy) (= #b000 U2_LSQ1_qj) (= #b000 U2_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ2_dis (ite (and (= #b1 U2_LSQ2_busy) (= #b000 U2_LSQ2_qj) (= #b000 U2_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U2_LSQ3_dis (ite (and (= #b1 U2_LSQ3_busy) (= #b000 U2_LSQ3_qj) (= #b000 U2_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U2_RS_dis (store U1_RS_dis (_ bv0 2) U2_RS0_dis))
				(U2_LSQ_dis (store U1_LSQ_dis (_ bv0 2) U2_LSQ0_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv1 2) U2_RS1_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv1 2) U2_LSQ1_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv2 2) U2_RS2_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv2 2) U2_LSQ2_dis))
			)
		(let
			(
				(U2_RS_dis (store U2_RS_dis (_ bv3 2) U2_RS3_dis))
				(U2_LSQ_dis (store U2_LSQ_dis (_ bv3 2) U2_LSQ3_dis))
			)
		(let
			(
				(U2_RF (ite (= 0 0) U1_RF U1_RF))
				(U2_DM (ite (= 0 0) U1_DM U1_DM))
				
				(U2_Cache_Tag (ite (= 0 0) U1_Cache_Tag U1_Cache_Tag))
				(U2_Cache_Data (ite (= 0 0) U1_Cache_Data U1_Cache_Data))
				(U2_Cache_Valid (ite (= 0 0) U1_Cache_Valid U1_Cache_Valid))
				
				(U2_PC (ite (= 0 0) U1_PC U1_PC))
				
				(U2_IP (ite (= 0 0) U1_IP U1_IP))
				(U2_CP (ite (= 0 0) U1_CP U1_CP))
				
				(U2_ROB_busy (ite (= 0 0) U1_ROB_busy U1_ROB_busy))
				(U2_ROB_op_type (ite (= 0 0) U1_ROB_op_type U1_ROB_op_type))
				(U2_ROB_destination (ite (= 0 0) U1_ROB_destination U1_ROB_destination))
				(U2_ROB_result (ite (= 0 0) U1_ROB_result U1_ROB_result))
				(U2_ROB_exception (ite (= 0 0) U1_ROB_exception U1_ROB_exception))
				(U2_ROB_done (ite (= 0 0) U1_ROB_done U1_ROB_done))
				
				(U2_RS_op_type (ite (= 0 0) U1_RS_op_type U1_RS_op_type))
				(U2_RS_op (ite (= 0 0) U1_RS_op U1_RS_op))
				(U2_RS_ROB_dst (ite (= 0 0) U1_RS_ROB_dst U1_RS_ROB_dst))
				(U2_RS_vj (ite (= 0 0) U2_RS_vj U2_RS_vj))
				(U2_RS_vk (ite (= 0 0) U2_RS_vk U2_RS_vk))
				(U2_RS_qj (ite (= 0 0) U2_RS_qj U2_RS_qj))
				(U2_RS_qk (ite (= 0 0) U2_RS_qk U2_RS_qk))
				(U2_RS_imm (ite (= 0 0) U1_RS_imm U1_RS_imm))
				(U2_RS_dis (ite (= 0 0) U2_RS_dis U2_RS_dis))
				(U2_RS_busy (ite (= 0 0) U1_RS_busy U1_RS_busy))
				
				(U2_LSQ_op_type (ite (= 0 0) U1_LSQ_op_type U1_LSQ_op_type))
				(U2_LSQ_op (ite (= 0 0) U1_LSQ_op U1_LSQ_op))
				(U2_LSQ_ROB_dst (ite (= 0 0) U1_LSQ_ROB_dst U1_LSQ_ROB_dst))
				(U2_LSQ_vj (ite (= 0 0) U2_LSQ_vj U2_LSQ_vj))
				(U2_LSQ_vk (ite (= 0 0) U2_LSQ_vk U2_LSQ_vk))
				(U2_LSQ_qj (ite (= 0 0) U2_LSQ_qj U2_LSQ_qj))
				(U2_LSQ_qk (ite (= 0 0) U2_LSQ_qk U2_LSQ_qk))
				(U2_LSQ_imm (ite (= 0 0) U1_LSQ_imm U1_LSQ_imm))
				(U2_LSQ_dis (ite (= 0 0) U2_LSQ_dis U2_LSQ_dis))
				(U2_LSQ_busy (ite (= 0 0) U1_LSQ_busy U1_LSQ_busy))
				
				(U2_Evict_Tag (ite (= 0 0) U1_Evict_Tag U1_Evict_Tag))
				(U2_Evict_Valid (ite (= 0 0) U1_Evict_Valid U1_Evict_Valid))
				(U2_Evict_Index (ite (= 0 0) U1_Evict_Index U1_Evict_Index))
			)
			
;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(U2_RS0_dis (select U2_RS_dis (_ bv0 2)))
				(U2_RS1_dis (select U2_RS_dis (_ bv1 2)))
				(U2_RS2_dis (select U2_RS_dis (_ bv2 2)))
				(U2_RS3_dis (select U2_RS_dis (_ bv3 2)))
			)
		(let
			(
				(U2_RS_dis_index
					(ite (= U2_RS0_dis #b1) (_ bv0 2)
					(ite (= U2_RS1_dis #b1) (_ bv1 2)
					(ite (= U2_RS2_dis #b1) (_ bv2 2)
					(ite (= U2_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U2_RS_entry_dispatched (bvor U2_RS0_dis U2_RS1_dis U2_RS2_dis U2_RS3_dis))
			)	
		(let
			(
				(U2_RS_dis_vj (select U2_RS_vj U2_RS_dis_index))
				(U2_RS_dis_vk (select U2_RS_vk U2_RS_dis_index))
				(U2_RS_dis_qj (select U2_RS_qj U2_RS_dis_index))
				(U2_RS_dis_qk (select U2_RS_qk U2_RS_dis_index))
				(U2_RS_dis_op (select U2_RS_op U2_RS_dis_index))
				(U2_RS_dis_op_type (select U2_RS_op_type U2_RS_dis_index))
				(U2_RS_dis_imm (select U2_RS_imm U2_RS_dis_index))
				(U2_RS_dis_ROB_dst (select U2_RS_ROB_dst U2_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
				(ALU1_result (ALU1 U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
				(MUL_DIV_result (MUL_DIV U2_RS_dis_vj U2_RS_dis_vk U2_RS_dis_imm U2_RS_dis_op))
			)
		(let
			(
				(U2_RS_result
					(ite (= U2_RS_dis_op_type Rtype) ALU1_result
					(ite (= U2_RS_dis_op_type Branch) Branch_result
					(ite (= U2_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(U2_ROB_result_update (store U2_ROB_result U2_RS_dis_ROB_dst U2_RS_result))
				(U2_ROB_done_update (store U2_ROB_done U2_RS_dis_ROB_dst (_ bv1 1)))
				(U2_ROB_exception_update (store U2_ROB_exception U2_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(U3_ROB_result (ite (= U2_RS_entry_dispatched #b1) U2_ROB_result_update U2_ROB_result))
				(U3_ROB_done (ite (= U2_RS_entry_dispatched #b1) U2_ROB_done_update U2_ROB_done))
				(U3_ROB_exception (ite (and (= U2_RS_dis_op_type Branch) (= U2_RS_result 1) (= U2_RS_entry_dispatched #b1)) U2_ROB_exception_update U2_ROB_exception))
			)
		(let
			(
				(U2_RS_op_type_update (store U2_RS_op_type U2_RS_dis_index 0))
				(U2_RS_op_update (store U2_RS_op U2_RS_dis_index 0))
				(U2_RS_ROB_dst_update (store U2_RS_ROB_dst U2_RS_dis_index (_ bv0 3)))
				(U2_RS_vj_update (store U2_RS_vj U2_RS_dis_index 0))
				(U2_RS_vk_update (store U2_RS_vk U2_RS_dis_index 0))
				(U2_RS_qj_update (store U2_RS_qj U2_RS_dis_index (_ bv0 3)))
				(U2_RS_qk_update (store U2_RS_qk U2_RS_dis_index (_ bv0 3)))
				(U2_RS_imm_update (store U2_RS_imm U2_RS_dis_index 0))
				(U2_RS_dis_update (store U2_RS_dis U2_RS_dis_index (_ bv0 1)))
				(U2_RS_busy_update (store U2_RS_busy U2_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(U3_RS_op_type (ite (= U2_RS_entry_dispatched #b1) U2_RS_op_type_update U2_RS_op_type))
				(U3_RS_op (ite (= U2_RS_entry_dispatched #b1) U2_RS_op_update U2_RS_op))
				(U3_RS_ROB_dst (ite (= U2_RS_entry_dispatched #b1) U2_RS_ROB_dst_update U2_RS_ROB_dst))
				(U3_RS_vj (ite (= U2_RS_entry_dispatched #b1) U2_RS_vj_update U2_RS_vj))
				(U3_RS_vk (ite (= U2_RS_entry_dispatched #b1) U2_RS_vk_update U2_RS_vk))
				(U3_RS_qj (ite (= U2_RS_entry_dispatched #b1) U2_RS_qj_update U2_RS_qj))
				(U3_RS_qk (ite (= U2_RS_entry_dispatched #b1) U2_RS_qk_update U2_RS_qk))
				(U3_RS_imm (ite (= U2_RS_entry_dispatched #b1) U2_RS_imm_update U2_RS_imm))
				(U3_RS_dis (ite (= U2_RS_entry_dispatched #b1) U2_RS_dis_update U2_RS_dis))
				(U3_RS_busy (ite (= U2_RS_entry_dispatched #b1) U2_RS_busy_update U2_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(U2_LSQ0_dis (select U2_LSQ_dis (_ bv0 2)))
				(U2_LSQ1_dis (select U2_LSQ_dis (_ bv1 2)))
				(U2_LSQ2_dis (select U2_LSQ_dis (_ bv2 2)))
				(U2_LSQ3_dis (select U2_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(U2_LSQ_dis_index
					(ite (= U2_LSQ0_dis #b1) (_ bv0 2)
					(ite (= U2_LSQ1_dis #b1) (_ bv1 2)
					(ite (= U2_LSQ2_dis #b1) (_ bv2 2)
					(ite (= U2_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U2_LSQ_entry_dispatched (bvor U2_LSQ0_dis U2_LSQ1_dis U2_LSQ2_dis U2_LSQ3_dis))
			)	
		(let
			(
				(U2_LSQ_dis_vj (select U2_LSQ_vj U2_LSQ_dis_index))
				(U2_LSQ_dis_vk (select U2_LSQ_vk U2_LSQ_dis_index))
				(U2_LSQ_dis_qj (select U2_LSQ_qj U2_LSQ_dis_index))
				(U2_LSQ_dis_qk (select U2_LSQ_qk U2_LSQ_dis_index))
				(U2_LSQ_dis_op (select U2_LSQ_op U2_LSQ_dis_index))
				(U2_LSQ_dis_op_type (select U2_LSQ_op_type U2_LSQ_dis_index))
				(U2_LSQ_dis_imm (select U2_LSQ_imm U2_LSQ_dis_index))
				(U2_LSQ_dis_ROB_dst (select U2_LSQ_ROB_dst U2_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit U2_LSQ_dis_vj U2_LSQ_dis_imm U2_LSQ_dis_op))
				(Store_address (STORE_Unit U2_LSQ_dis_vj U2_LSQ_dis_imm U2_LSQ_dis_op))
			)
		(let
			(
				(U2_Cache0_Tag (select U2_Cache_Tag (_ bv0 2)))
				(U2_Cache0_Data (select U2_Cache_Data (_ bv0 2)))
				(U2_Cache0_Valid (select U2_Cache_Valid (_ bv0 2)))
				(U2_Cache1_Tag (select U2_Cache_Tag (_ bv1 2)))
				(U2_Cache1_Data (select U2_Cache_Data (_ bv1 2)))
				(U2_Cache1_Valid (select U2_Cache_Valid (_ bv1 2)))
				(U2_Cache2_Tag (select U2_Cache_Tag (_ bv2 2)))
				(U2_Cache2_Data (select U2_Cache_Data (_ bv2 2)))
				(U2_Cache2_Valid (select U2_Cache_Valid (_ bv2 2)))
				(U2_Cache3_Tag (select U2_Cache_Tag (_ bv3 2)))
				(U2_Cache3_Data (select U2_Cache_Data (_ bv3 2)))
				(U2_Cache3_Valid (select U2_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select U2_DM LOAD_addr))
				(U2_Cache0_Hit_Load (ite (and (= U2_Cache0_Valid #b1) (= U2_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache1_Hit_Load (ite (and (= U2_Cache1_Valid #b1) (= U2_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache2_Hit_Load (ite (and (= U2_Cache2_Valid #b1) (= U2_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U2_Cache3_Hit_Load (ite (and (= U2_Cache3_Valid #b1) (= U2_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_U2_Cache_Line 
					(ite (= U2_Cache0_Valid #b0) (_ bv0 2)	;check if U2_Cache line 0 is free
					(ite (= U2_Cache1_Valid #b0) (_ bv1 2)	;check if U2_Cache line 1 is free
					(ite (= U2_Cache2_Valid #b0) (_ bv2 2)	;check if U2_Cache line 2 is free
					(ite (= U2_Cache3_Valid #b0) (_ bv3 2)	;check if U2_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U2_Cache line 0 
					))))
				)
			)
		(let
			(
				(U2_Cache_Hit_load (bvor U2_Cache0_Hit_Load U2_Cache1_Hit_Load U2_Cache2_Hit_Load U2_Cache3_Hit_Load))
			)
		(let
			(
				(U2_LSQ_result
					(ite (= U2_LSQ_dis_op_type Load) LOAD_Value
					(ite (= U2_LSQ_dis_op_type Store) U2_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(U2_ROB_destination_update (store U2_ROB_destination U2_LSQ_dis_ROB_dst Store_address))
				(U2_ROB_result_load (store U3_ROB_result U2_LSQ_dis_ROB_dst LOAD_Value))
				(U2_ROB_result_store (store U3_ROB_result U2_LSQ_dis_ROB_dst U2_LSQ_dis_vk))
				(U2_ROB_done_update (store U3_ROB_done U2_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(U2_Cache_tag_Update_Load (store U2_Cache_Tag Available_U2_Cache_Line LOAD_addr))
				
				(U2_Cache_data_Update_Load (store U2_Cache_Data Available_U2_Cache_Line LOAD_Value))
				
				(U2_Cache_valid_Update_Load (store U2_Cache_Valid Available_U2_Cache_Line (_ bv1 1)))
				
				(U2_Evict_Tag_update (store U2_Evict_Tag U2_Evict_Index U2_Cache0_Tag ))
				(U2_Evict_Valid_update (store U2_Evict_Valid U2_Evict_Index U2_Cache0_Valid ))
				(U2_Evict_Index_update (bvadd (_ bv1 3) U2_Evict_Index))
				
			)
		(let
			(
				(U3_Evict_Tag (ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load) (= #b00 Available_U2_Cache_Line) (= U2_Cache0_Valid #b1)) U2_Evict_Tag_update U2_Evict_Tag))
				(U3_Evict_Valid (ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load) (= #b00 Available_U2_Cache_Line) (= U2_Cache0_Valid #b1)) U2_Evict_Valid_update U2_Evict_Valid))
				(U3_Evict_Index (ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load) (= #b00 Available_U2_Cache_Line) (= U2_Cache0_Valid #b1)) U2_Evict_Index_update U2_Evict_Index))
			)
		(let
			(
				(U3_ROB_destination (ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Store)) U2_ROB_destination_update U2_ROB_destination))
				(U3_ROB_result
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Load)) U2_ROB_result_load
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_LSQ_dis_op_type Store)) U2_ROB_result_store
					U3_ROB_result
					))
				)
				(U3_ROB_done (ite (= U2_LSQ_entry_dispatched #b1) U2_ROB_done_update U3_ROB_done))
				
				(U3_Cache_Tag
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_tag_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Tag
					)
				)
				(U3_Cache_Data
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_data_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Data
					)
				)
				(U3_Cache_Valid
					(ite (and (= U2_LSQ_entry_dispatched #b1) (= U2_Cache_Hit_load #b0) (= U2_LSQ_dis_op_type Load)) U2_Cache_valid_Update_Load			;If load and U2_Cache miss, update the U2_Cache
					U2_Cache_Valid
					)
				)
			)
		(let
			(
				(U2_LSQ_op_type_update (store U2_LSQ_op_type U2_LSQ_dis_index 0))
				(U2_LSQ_op_update (store U2_LSQ_op U2_LSQ_dis_index 0))
				(U2_LSQ_ROB_dst_update (store U2_LSQ_ROB_dst U2_LSQ_dis_index (_ bv0 3)))
				(U2_LSQ_vj_update (store U2_LSQ_vj U2_LSQ_dis_index 0))
				(U2_LSQ_vk_update (store U2_LSQ_vk U2_LSQ_dis_index 0))
				(U2_LSQ_qj_update (store U2_LSQ_qj U2_LSQ_dis_index (_ bv0 3)))
				(U2_LSQ_qk_update (store U2_LSQ_qk U2_LSQ_dis_index (_ bv0 3)))
				(U2_LSQ_imm_update (store U2_LSQ_imm U2_LSQ_dis_index 0))
				(U2_LSQ_dis_update (store U2_LSQ_dis U2_LSQ_dis_index (_ bv0 1)))
				(U2_LSQ_busy_update (store U2_LSQ_busy U2_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(U3_LSQ_op_type (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_op_type_update U2_LSQ_op_type))
				(U3_LSQ_op (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_op_update U2_LSQ_op))
				(U3_LSQ_ROB_dst (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_ROB_dst_update U2_LSQ_ROB_dst))
				(U3_LSQ_vj (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_vj_update U2_LSQ_vj))
				(U3_LSQ_vk (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_vk_update U2_LSQ_vk))
				(U3_LSQ_qj (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_qj_update U2_LSQ_qj))
				(U3_LSQ_qk (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_qk_update U2_LSQ_qk))
				(U3_LSQ_imm (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_imm_update U2_LSQ_imm))
				(U3_LSQ_dis (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_dis_update U2_LSQ_dis))
				(U3_LSQ_busy (ite (= U2_LSQ_entry_dispatched #b1) U2_LSQ_busy_update U2_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(U3_RS0_busy (select U3_RS_busy (_ bv0 2)))
				(U3_RS0_qj (select U3_RS_qj (_ bv0 2)))
				(U3_RS0_qk (select U3_RS_qk (_ bv0 2)))
				(U3_RS1_busy (select U3_RS_busy (_ bv1 2)))
				(U3_RS1_qj (select U3_RS_qj (_ bv1 2)))
				(U3_RS1_qk (select U3_RS_qk (_ bv1 2)))
				(U3_RS2_busy (select U3_RS_busy (_ bv2 2)))
				(U3_RS2_qj (select U3_RS_qj (_ bv2 2)))
				(U3_RS2_qk (select U3_RS_qk (_ bv2 2)))
				(U3_RS3_busy (select U3_RS_busy (_ bv3 2)))
				(U3_RS3_qj (select U3_RS_qj (_ bv3 2)))
				(U3_RS3_qk (select U3_RS_qk (_ bv3 2)))
				
				(U3_LSQ0_busy (select U3_LSQ_busy (_ bv0 2)))
				(U3_LSQ0_qj (select U3_LSQ_qj (_ bv0 2)))
				(U3_LSQ0_qk (select U3_LSQ_qk (_ bv0 2)))
				(U3_LSQ1_busy (select U3_LSQ_busy (_ bv1 2)))
				(U3_LSQ1_qj (select U3_LSQ_qj (_ bv1 2)))
				(U3_LSQ1_qk (select U3_LSQ_qk (_ bv1 2)))
				(U3_LSQ2_busy (select U3_LSQ_busy (_ bv2 2)))
				(U3_LSQ2_qj (select U3_LSQ_qj (_ bv2 2)))
				(U3_LSQ2_qk (select U3_LSQ_qk (_ bv2 2)))
				(U3_LSQ3_busy (select U3_LSQ_busy (_ bv3 2)))
				(U3_LSQ3_qj (select U3_LSQ_qj (_ bv3 2)))
				(U3_LSQ3_qk (select U3_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U3_RS0_qj_ROB_done (select U3_ROB_done U3_RS0_qj))
				(U3_RS0_qj_ROB_result (select U3_ROB_result U3_RS0_qj))
				(U3_RS0_qk_ROB_done (select U3_ROB_done U3_RS0_qk))
				(U3_RS0_qk_ROB_result (select U3_ROB_result U3_RS0_qk))
				(U3_RS1_qj_ROB_done (select U3_ROB_done U3_RS1_qj))
				(U3_RS1_qj_ROB_result (select U3_ROB_result U3_RS1_qj))
				(U3_RS1_qk_ROB_done (select U3_ROB_done U3_RS1_qk))
				(U3_RS1_qk_ROB_result (select U3_ROB_result U3_RS1_qk))
				(U3_RS2_qj_ROB_done (select U3_ROB_done U3_RS2_qj))
				(U3_RS2_qj_ROB_result (select U3_ROB_result U3_RS2_qj))
				(U3_RS2_qk_ROB_done (select U3_ROB_done U3_RS2_qk))
				(U3_RS2_qk_ROB_result (select U3_ROB_result U3_RS2_qk))
				(U3_RS3_qj_ROB_done (select U3_ROB_done U3_RS3_qj))
				(U3_RS3_qj_ROB_result (select U3_ROB_result U3_RS3_qj))
				(U3_RS3_qk_ROB_done (select U3_ROB_done U3_RS3_qk))
				(U3_RS3_qk_ROB_result (select U3_ROB_result U3_RS3_qk))
				
				(U3_LSQ0_qj_ROB_done (select U3_ROB_done U3_LSQ0_qj))
				(U3_LSQ0_qj_ROB_result (select U3_ROB_result U3_LSQ0_qj))
				(U3_LSQ0_qk_ROB_done (select U3_ROB_done U3_LSQ0_qk))
				(U3_LSQ0_qk_ROB_result (select U3_ROB_result U3_LSQ0_qk))
				(U3_LSQ1_qj_ROB_done (select U3_ROB_done U3_LSQ1_qj))
				(U3_LSQ1_qj_ROB_result (select U3_ROB_result U3_LSQ1_qj))
				(U3_LSQ1_qk_ROB_done (select U3_ROB_done U3_LSQ1_qk))
				(U3_LSQ1_qk_ROB_result (select U3_ROB_result U3_LSQ1_qk))
				(U3_LSQ2_qj_ROB_done (select U3_ROB_done U3_LSQ2_qj))
				(U3_LSQ2_qj_ROB_result (select U3_ROB_result U3_LSQ2_qj))
				(U3_LSQ2_qk_ROB_done (select U3_ROB_done U3_LSQ2_qk))
				(U3_LSQ2_qk_ROB_result (select U3_ROB_result U3_LSQ2_qk))
				(U3_LSQ3_qj_ROB_done (select U3_ROB_done U3_LSQ3_qj))
				(U3_LSQ3_qj_ROB_result (select U3_ROB_result U3_LSQ3_qj))
				(U3_LSQ3_qk_ROB_done (select U3_ROB_done U3_LSQ3_qk))
				(U3_LSQ3_qk_ROB_result (select U3_ROB_result U3_LSQ3_qk))
			)
		(let
			(
				(U3_RS0_vj_update (store U3_RS_vj (_ bv0 2) U3_RS0_qj_ROB_result))
				(U3_RS0_vk_update (store U3_RS_vk (_ bv0 2) U3_RS0_qk_ROB_result))					
				(U3_RS0_qj_update (store U3_RS_qj (_ bv0 2) (_ bv0 3)))	
				(U3_RS0_qk_update (store U3_RS_qk (_ bv0 2) (_ bv0 3)))	
				(U3_LSQ0_vj_update (store U3_LSQ_vj (_ bv0 2) U3_LSQ0_qj_ROB_result))	
				(U3_LSQ0_vk_update (store U3_LSQ_vk (_ bv0 2) U3_LSQ0_qk_ROB_result))	
				(U3_LSQ0_qj_update (store U3_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(U3_LSQ0_qk_update (store U3_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS0_busy) (not (= #b000 U3_RS0_qj)) (= #b1 U3_RS0_qj_ROB_done)) U3_RS0_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS0_busy) (not (= #b000 U3_RS0_qk)) (= #b1 U3_RS0_qk_ROB_done)) U3_RS0_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS0_busy) (not (= #b000 U3_RS0_qj)) (= #b1 U3_RS0_qj_ROB_done)) U3_RS0_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS0_busy) (not (= #b000 U3_RS0_qk)) (= #b1 U3_RS0_qk_ROB_done)) U3_RS0_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000 U3_LSQ0_qj)) (= #b1 U3_LSQ0_qj_ROB_done)) U3_LSQ0_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000 U3_LSQ0_qk)) (= #b1 U3_LSQ0_qk_ROB_done)) U3_LSQ0_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000 U3_LSQ0_qj)) (= #b1 U3_LSQ0_qj_ROB_done)) U3_LSQ0_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ0_busy) (not (= #b000 U3_LSQ0_qk)) (= #b1 U3_LSQ0_qk_ROB_done)) U3_LSQ0_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS1_vj_update (store U3_RS_vj (_ bv1 2) U3_RS1_qj_ROB_result))	
				(U3_RS1_vk_update (store U3_RS_vk (_ bv1 2) U3_RS1_qk_ROB_result))	
				(U3_RS1_qj_update (store U3_RS_qj (_ bv1 2) (_ bv0 3)))	
				(U3_RS1_qk_update (store U3_RS_qk (_ bv1 2) (_ bv0 3)))	
				(U3_LSQ1_vj_update (store U3_LSQ_vj (_ bv1 2) U3_LSQ1_qj_ROB_result))	
				(U3_LSQ1_vk_update (store U3_LSQ_vk (_ bv1 2) U3_LSQ1_qk_ROB_result))	
				(U3_LSQ1_qj_update (store U3_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(U3_LSQ1_qk_update (store U3_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS1_busy) (not (= #b000 U3_RS1_qj)) (= #b1 U3_RS1_qj_ROB_done)) U3_RS1_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS1_busy) (not (= #b000 U3_RS1_qk)) (= #b1 U3_RS1_qk_ROB_done)) U3_RS1_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS1_busy) (not (= #b000 U3_RS1_qj)) (= #b1 U3_RS1_qj_ROB_done)) U3_RS1_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS1_busy) (not (= #b000 U3_RS1_qk)) (= #b1 U3_RS1_qk_ROB_done)) U3_RS1_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000 U3_LSQ1_qj)) (= #b1 U3_LSQ1_qj_ROB_done)) U3_LSQ1_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000 U3_LSQ1_qk)) (= #b1 U3_LSQ1_qk_ROB_done)) U3_LSQ1_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000 U3_LSQ1_qj)) (= #b1 U3_LSQ1_qj_ROB_done)) U3_LSQ1_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ1_busy) (not (= #b000 U3_LSQ1_qk)) (= #b1 U3_LSQ1_qk_ROB_done)) U3_LSQ1_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS2_vj_update (store U3_RS_vj (_ bv2 2) U3_RS2_qj_ROB_result))	
				(U3_RS2_vk_update (store U3_RS_vk (_ bv2 2) U3_RS2_qk_ROB_result))	
				(U3_RS2_qj_update (store U3_RS_qj (_ bv2 2) (_ bv0 3)))	
				(U3_RS2_qk_update (store U3_RS_qk (_ bv2 2) (_ bv0 3)))	
				(U3_LSQ2_vj_update (store U3_LSQ_vj (_ bv2 2) U3_LSQ2_qj_ROB_result))	
				(U3_LSQ2_vk_update (store U3_LSQ_vk (_ bv2 2) U3_LSQ2_qk_ROB_result))	
				(U3_LSQ2_qj_update (store U3_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(U3_LSQ2_qk_update (store U3_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS2_busy) (not (= #b000 U3_RS2_qj)) (= #b1 U3_RS2_qj_ROB_done)) U3_RS2_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS2_busy) (not (= #b000 U3_RS2_qk)) (= #b1 U3_RS2_qk_ROB_done)) U3_RS2_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS2_busy) (not (= #b000 U3_RS2_qj)) (= #b1 U3_RS2_qj_ROB_done)) U3_RS2_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS2_busy) (not (= #b000 U3_RS2_qk)) (= #b1 U3_RS2_qk_ROB_done)) U3_RS2_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000 U3_LSQ2_qj)) (= #b1 U3_LSQ2_qj_ROB_done)) U3_LSQ2_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000 U3_LSQ2_qk)) (= #b1 U3_LSQ2_qk_ROB_done)) U3_LSQ2_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000 U3_LSQ2_qj)) (= #b1 U3_LSQ2_qj_ROB_done)) U3_LSQ2_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ2_busy) (not (= #b000 U3_LSQ2_qk)) (= #b1 U3_LSQ2_qk_ROB_done)) U3_LSQ2_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS3_vj_update (store U3_RS_vj (_ bv3 2) U3_RS3_qj_ROB_result))	
				(U3_RS3_vk_update (store U3_RS_vk (_ bv3 2) U3_RS3_qk_ROB_result))	
				(U3_RS3_qj_update (store U3_RS_qj (_ bv3 2) (_ bv0 3)))	
				(U3_RS3_qk_update (store U3_RS_qk (_ bv3 2) (_ bv0 3)))	
				(U3_LSQ3_vj_update (store U3_LSQ_vj (_ bv3 2) U3_LSQ3_qj_ROB_result))	
				(U3_LSQ3_vk_update (store U3_LSQ_vk (_ bv3 2) U3_LSQ3_qk_ROB_result))	
				(U3_LSQ3_qj_update (store U3_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(U3_LSQ3_qk_update (store U3_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(U3_RS_vj (ite (and (= #b1 U3_RS3_busy) (not (= #b000 U3_RS3_qj)) (= #b1 U3_RS3_qj_ROB_done)) U3_RS3_vj_update U3_RS_vj))
				(U3_RS_vk (ite (and (= #b1 U3_RS3_busy) (not (= #b000 U3_RS3_qk)) (= #b1 U3_RS3_qk_ROB_done)) U3_RS3_vk_update U3_RS_vk))
				(U3_RS_qj (ite (and (= #b1 U3_RS3_busy) (not (= #b000 U3_RS3_qj)) (= #b1 U3_RS3_qj_ROB_done)) U3_RS3_qj_update U3_RS_qj))
				(U3_RS_qk (ite (and (= #b1 U3_RS3_busy) (not (= #b000 U3_RS3_qk)) (= #b1 U3_RS3_qk_ROB_done)) U3_RS3_qk_update U3_RS_qk))
				(U3_LSQ_vj (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000 U3_LSQ3_qj)) (= #b1 U3_LSQ3_qj_ROB_done)) U3_LSQ3_vj_update U3_LSQ_vj))
				(U3_LSQ_vk (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000 U3_LSQ3_qk)) (= #b1 U3_LSQ3_qk_ROB_done)) U3_LSQ3_vk_update U3_LSQ_vk))
				(U3_LSQ_qj (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000 U3_LSQ3_qj)) (= #b1 U3_LSQ3_qj_ROB_done)) U3_LSQ3_qj_update U3_LSQ_qj))
				(U3_LSQ_qk (ite (and (= #b1 U3_LSQ3_busy) (not (= #b000 U3_LSQ3_qk)) (= #b1 U3_LSQ3_qk_ROB_done)) U3_LSQ3_qk_update U3_LSQ_qk))
			)
		(let
			(
				(U3_RS0_busy (select U3_RS_busy (_ bv0 2)))
				(U3_RS0_qj (select U3_RS_qj (_ bv0 2)))
				(U3_RS0_qk (select U3_RS_qk (_ bv0 2)))
				(U3_RS1_busy (select U3_RS_busy (_ bv1 2)))
				(U3_RS1_qj (select U3_RS_qj (_ bv1 2)))
				(U3_RS1_qk (select U3_RS_qk (_ bv1 2)))
				(U3_RS2_busy (select U3_RS_busy (_ bv2 2)))
				(U3_RS2_qj (select U3_RS_qj (_ bv2 2)))
				(U3_RS2_qk (select U3_RS_qk (_ bv2 2)))
				(U3_RS3_busy (select U3_RS_busy (_ bv3 2)))
				(U3_RS3_qj (select U3_RS_qj (_ bv3 2)))
				(U3_RS3_qk (select U3_RS_qk (_ bv3 2)))
				(U3_LSQ0_busy (select U3_LSQ_busy (_ bv0 2)))
				(U3_LSQ0_qj (select U3_LSQ_qj (_ bv0 2)))
				(U3_LSQ0_qk (select U3_LSQ_qk (_ bv0 2)))
				(U3_LSQ1_busy (select U3_LSQ_busy (_ bv1 2)))
				(U3_LSQ1_qj (select U3_LSQ_qj (_ bv1 2)))
				(U3_LSQ1_qk (select U3_LSQ_qk (_ bv1 2)))
				(U3_LSQ2_busy (select U3_LSQ_busy (_ bv2 2)))
				(U3_LSQ2_qj (select U3_LSQ_qj (_ bv2 2)))
				(U3_LSQ2_qk (select U3_LSQ_qk (_ bv2 2)))
				(U3_LSQ3_busy (select U3_LSQ_busy (_ bv3 2)))
				(U3_LSQ3_qj (select U3_LSQ_qj (_ bv3 2)))
				(U3_LSQ3_qk (select U3_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U3_RS0_dis (ite (and (= #b1 U3_RS0_busy) (= #b000 U3_RS0_qj) (= #b000 U3_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS1_dis (ite (and (= #b1 U3_RS1_busy) (= #b000 U3_RS1_qj) (= #b000 U3_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS2_dis (ite (and (= #b1 U3_RS2_busy) (= #b000 U3_RS2_qj) (= #b000 U3_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_RS3_dis (ite (and (= #b1 U3_RS3_busy) (= #b000 U3_RS3_qj) (= #b000 U3_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U3_LSQ0_dis (ite (and (= #b1 U3_LSQ0_busy) (= #b000 U3_LSQ0_qj) (= #b000 U3_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ1_dis (ite (and (= #b1 U3_LSQ1_busy) (= #b000 U3_LSQ1_qj) (= #b000 U3_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ2_dis (ite (and (= #b1 U3_LSQ2_busy) (= #b000 U3_LSQ2_qj) (= #b000 U3_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U3_LSQ3_dis (ite (and (= #b1 U3_LSQ3_busy) (= #b000 U3_LSQ3_qj) (= #b000 U3_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv0 2) U3_RS0_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv0 2) U3_LSQ0_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv1 2) U3_RS1_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv1 2) U3_LSQ1_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv2 2) U3_RS2_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv2 2) U3_LSQ2_dis))
			)
		(let
			(
				(U3_RS_dis (store U3_RS_dis (_ bv3 2) U3_RS3_dis))
				(U3_LSQ_dis (store U3_LSQ_dis (_ bv3 2) U3_LSQ3_dis))
			)
		(let
			(
				(U3_RF (ite (= 0 0) U2_RF U2_RF))
				(U3_DM (ite (= 0 0) U2_DM U2_DM))
				
				(U3_Cache_Tag (ite (= 0 0) U3_Cache_Tag U3_Cache_Tag))
				(U3_Cache_Data (ite (= 0 0) U3_Cache_Data U3_Cache_Data))
				(U3_Cache_Valid (ite (= 0 0) U3_Cache_Valid U3_Cache_Valid))
				
				(U3_PC (ite (= 0 0) U2_PC U2_PC))
				
				(U3_IP (ite (= 0 0) U2_IP U2_IP))
				(U3_CP (ite (= 0 0) U2_CP U2_CP))
				
				(U3_ROB_busy (ite (= 0 0) U2_ROB_busy U2_ROB_busy))
				(U3_ROB_op_type (ite (= 0 0) U2_ROB_op_type U2_ROB_op_type))
				(U3_ROB_destination (ite (= 0 0) U3_ROB_destination U3_ROB_destination))
				(U3_ROB_result (ite (= 0 0) U3_ROB_result U3_ROB_result))
				(U3_ROB_exception (ite (= 0 0) U3_ROB_exception U3_ROB_exception))
				(U3_ROB_done (ite (= 0 0) U3_ROB_done U3_ROB_done))
				
				(U3_RS_op_type (ite (= 0 0) U3_RS_op_type U3_RS_op_type))
				(U3_RS_op (ite (= 0 0) U3_RS_op U3_RS_op))
				(U3_RS_ROB_dst (ite (= 0 0) U3_RS_ROB_dst U3_RS_ROB_dst))
				(U3_RS_vj (ite (= 0 0) U3_RS_vj U3_RS_vj))
				(U3_RS_vk (ite (= 0 0) U3_RS_vk U3_RS_vk))
				(U3_RS_qj (ite (= 0 0) U3_RS_qj U3_RS_qj))
				(U3_RS_qk (ite (= 0 0) U3_RS_qk U3_RS_qk))
				(U3_RS_imm (ite (= 0 0) U3_RS_imm U3_RS_imm))
				(U3_RS_dis (ite (= 0 0) U3_RS_dis U3_RS_dis))
				(U3_RS_busy (ite (= 0 0) U3_RS_busy U3_RS_busy))
				
				(U3_LSQ_op_type (ite (= 0 0) U3_LSQ_op_type U3_LSQ_op_type))
				(U3_LSQ_op (ite (= 0 0) U3_LSQ_op U3_LSQ_op))
				(U3_LSQ_ROB_dst (ite (= 0 0) U3_LSQ_ROB_dst U3_LSQ_ROB_dst))
				(U3_LSQ_vj (ite (= 0 0) U3_LSQ_vj U3_LSQ_vj))
				(U3_LSQ_vk (ite (= 0 0) U3_LSQ_vk U3_LSQ_vk))
				(U3_LSQ_qj (ite (= 0 0) U3_LSQ_qj U3_LSQ_qj))
				(U3_LSQ_qk (ite (= 0 0) U3_LSQ_qk U3_LSQ_qk))
				(U3_LSQ_imm (ite (= 0 0) U3_LSQ_imm U3_LSQ_imm))
				(U3_LSQ_dis (ite (= 0 0) U3_LSQ_dis U3_LSQ_dis))
				(U3_LSQ_busy (ite (= 0 0) U3_LSQ_busy U3_LSQ_busy))
				
				(U3_Evict_Tag (ite (= 0 0) U3_Evict_Tag U3_Evict_Tag))
				(U3_Evict_Valid (ite (= 0 0) U3_Evict_Valid U3_Evict_Valid))
				(U3_Evict_Index (ite (= 0 0) U3_Evict_Index U3_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U3_ROB_busy (select U3_ROB_busy U3_CP))
				(CP_U3_ROB_op_type (select U3_ROB_op_type U3_CP))
				(CP_U3_ROB_destination (select U3_ROB_destination U3_CP))
				(CP_U3_ROB_result (select U3_ROB_result U3_CP))
				(CP_U3_ROB_exception (select U3_ROB_exception U3_CP))
				(CP_U3_ROB_done (select U3_ROB_done U3_CP))
			)
		(let
			(
				(CP_update (bvadd U3_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U3_RF CP_U3_ROB_destination CP_U3_ROB_result))
				(DM_update (store U3_DM CP_U3_ROB_destination CP_U3_ROB_result))
				
				(U3_ROB_busy_update (store U3_ROB_busy U3_CP (_ bv0 1)))
				(U3_ROB_op_type_update (store U3_ROB_op_type U3_CP 0))
				(U3_ROB_destination_update (store U3_ROB_destination U3_CP 0))
				(U3_ROB_resulU3_update (store U3_ROB_result U3_CP 0))
				(U3_ROB_exception_update (store U3_ROB_exception U3_CP (_ bv0 1)))
				(U3_ROB_done_update (store U3_ROB_done U3_CP (_ bv0 1)))
			)
		(let
			(
				(U3_Cache0_Tag (select U3_Cache_Tag (_ bv0 2)))
				(U3_Cache0_Data (select U3_Cache_Data (_ bv0 2)))
				(U3_Cache0_Valid (select U3_Cache_Valid (_ bv0 2)))
				(U3_Cache1_Tag (select U3_Cache_Tag (_ bv1 2)))
				(U3_Cache1_Data (select U3_Cache_Data (_ bv1 2)))
				(U3_Cache1_Valid (select U3_Cache_Valid (_ bv1 2)))
				(U3_Cache2_Tag (select U3_Cache_Tag (_ bv2 2)))
				(U3_Cache2_Data (select U3_Cache_Data (_ bv2 2)))
				(U3_Cache2_Valid (select U3_Cache_Valid (_ bv2 2)))
				(U3_Cache3_Tag (select U3_Cache_Tag (_ bv3 2)))
				(U3_Cache3_Data (select U3_Cache_Data (_ bv3 2)))
				(U3_Cache3_Valid (select U3_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U3_Cache0_Hit_Store (ite (and (= U3_Cache0_Valid #b1) (= U3_Cache0_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache1_Hit_Store (ite (and (= U3_Cache1_Valid #b1) (= U3_Cache1_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache2_Hit_Store (ite (and (= U3_Cache2_Valid #b1) (= U3_Cache2_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U3_Cache3_Hit_Store (ite (and (= U3_Cache3_Valid #b1) (= U3_Cache3_Tag CP_U3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U3_Cache_Line 
					(ite (= U3_Cache0_Valid #b0) (_ bv0 2)	;check if U3_Cache line 0 is free
					(ite (= U3_Cache1_Valid #b0) (_ bv1 2)	;check if U3_Cache line 1 is free
					(ite (= U3_Cache2_Valid #b0) (_ bv2 2)	;check if U3_Cache line 2 is free
					(ite (= U3_Cache3_Valid #b0) (_ bv3 2)	;check if U3_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U3_Cache line 0 
					))))
				)
				(U3_Cache_Store_Hit_Index
					(ite (= U3_Cache0_Hit_Store #b1) (_ bv0 2)		;If U3_Cache has a hit for store, then whats the line index
					(ite (= U3_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U3_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U3_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U3_Cache_Hit_Store (bvor U3_Cache0_Hit_Store U3_Cache1_Hit_Store U3_Cache2_Hit_Store U3_Cache3_Hit_Store))
			)
		(let
			(
				(U3_Cache_tag_Update_Store_Hit (store U3_Cache_Tag U3_Cache_Store_Hit_Index CP_U3_ROB_destination))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_tag_Update_Store_Miss (store U3_Cache_Tag Available_U3_Cache_Line CP_U3_ROB_destination))	
				
				(U3_Cache_data_Update_Store_Hit (store U3_Cache_Data U3_Cache_Store_Hit_Index CP_U3_ROB_result))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_data_Update_Store_Miss (store U3_Cache_Data Available_U3_Cache_Line CP_U3_ROB_result))	;if U3_Cache is a miss, update the available entry with data
				
				(U3_Cache_valid_Update_Store_Hit (store U3_Cache_Valid U3_Cache_Store_Hit_Index (_ bv1 1)))	;if U3_Cache is a hit, update the line with new data
				(U3_Cache_valid_Update_Store_Miss (store U3_Cache_Valid Available_U3_Cache_Line (_ bv1 1)))	;if U3_Cache is a miss, update the available entry with data
				
				(CP_U3_ROB_exception (ite (and (= CP_U3_ROB_op_type Branch) (= 1 CP_U3_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U3_Evict_Tag_update (store U3_Evict_Tag U3_Evict_Index U3_Cache0_Tag))
				(U3_Evict_Valid_update (store U3_Evict_Valid U3_Evict_Index U3_Cache0_Valid))
				(U3_Evict_Index_update (bvadd (_ bv1 3) U3_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U3_ROB_done #b1) (or (= CP_U3_ROB_op_type Rtype) (= CP_U3_ROB_op_type Mul_div) (= CP_U3_ROB_op_type Load))) RF_update U3_RF))
				(U4_DM (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Store)) DM_update U3_DM))
				
				(U4_PC (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) CP_U3_ROB_destination U3_PC))
				(U4_IP (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) (_ bv1 3) U3_IP))
				(U4_CP 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U3_ROB_done #b1) CP_update
					U3_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_busy_update
					U3_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_op_type_update
					U3_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_destination_update
					U3_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U3_ROB_done #b1) U3_ROB_resulU3_update
					U3_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_exception_update
					U3_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U3_ROB_done #b1) U3_ROB_done_update
					U3_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_op_type))
				(U4_RS_op (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_vj))
				(U4_RS_vk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_vk))
				(U4_RS_qj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_qj))
				(U4_RS_qk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_RS_qk))
				(U4_RS_imm (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_RS_imm))
				(U4_RS_dis (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_RS_dis))
				(U4_RS_busy (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_3bit U3_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_int U3_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Branch) (= CP_U3_ROB_exception #b1)) empty_RS_LSQ_1bit U3_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_tag_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_tag_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_data_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_data_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b0) (= CP_U3_ROB_op_type Store)) U3_Cache_valid_Update_Store_Miss	;If Store and U3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U3_ROB_done #b1) (= U3_Cache_Hit_Store #b1) (= CP_U3_ROB_op_type Store)) U3_Cache_valid_Update_Store_Hit		;If Store and U3_Cache hit, update the line with new data
					U3_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Store)) U3_Evict_Tag_update U3_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Store)) U3_Evict_Valid_update U3_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U3_ROB_done #b1) (= CP_U3_ROB_op_type Store)) U3_Evict_Index_update U3_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(U4_RS0_dis (select U4_RS_dis (_ bv0 2)))
				(U4_RS1_dis (select U4_RS_dis (_ bv1 2)))
				(U4_RS2_dis (select U4_RS_dis (_ bv2 2)))
				(U4_RS3_dis (select U4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(U4_RS_dis_index
					(ite (= U4_RS0_dis #b1) (_ bv0 2)
					(ite (= U4_RS1_dis #b1) (_ bv1 2)
					(ite (= U4_RS2_dis #b1) (_ bv2 2)
					(ite (= U4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_RS_entry_dispatched (bvor U4_RS0_dis U4_RS1_dis U4_RS2_dis U4_RS3_dis))
			)	
		(let
			(
				(U4_RS_dis_vj (select U4_RS_vj U4_RS_dis_index))
				(U4_RS_dis_vk (select U4_RS_vk U4_RS_dis_index))
				(U4_RS_dis_qj (select U4_RS_qj U4_RS_dis_index))
				(U4_RS_dis_qk (select U4_RS_qk U4_RS_dis_index))
				(U4_RS_dis_op (select U4_RS_op U4_RS_dis_index))
				(U4_RS_dis_op_type (select U4_RS_op_type U4_RS_dis_index))
				(U4_RS_dis_imm (select U4_RS_imm U4_RS_dis_index))
				(U4_RS_dis_ROB_dst (select U4_RS_ROB_dst U4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(ALU1_result (ALU1 U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
			)
		(let
			(
				(U4_RS_result
					(ite (= U4_RS_dis_op_type Rtype) ALU1_result
					(ite (= U4_RS_dis_op_type Branch) Branch_result
					(ite (= U4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(U4_ROB_result_update (store U4_ROB_result U4_RS_dis_ROB_dst U4_RS_result))
				(U4_ROB_done_update (store U4_ROB_done U4_RS_dis_ROB_dst (_ bv1 1)))
				(U4_ROB_exception_update (store U4_ROB_exception U4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(U4_ROB_result (ite (= U4_RS_entry_dispatched #b1) U4_ROB_result_update U4_ROB_result))
				(U4_ROB_done (ite (= U4_RS_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				(U4_ROB_exception (ite (and (= U4_RS_dis_op_type Branch) (= U4_RS_result 1) (= U4_RS_entry_dispatched #b1)) U4_ROB_exception_update U4_ROB_exception))
			)
		(let
			(
				(U4_RS_op_type_update (store U4_RS_op_type U4_RS_dis_index 0))
				(U4_RS_op_update (store U4_RS_op U4_RS_dis_index 0))
				(U4_RS_ROB_dst_update (store U4_RS_ROB_dst U4_RS_dis_index (_ bv0 3)))
				(U4_RS_vj_update (store U4_RS_vj U4_RS_dis_index 0))
				(U4_RS_vk_update (store U4_RS_vk U4_RS_dis_index 0))
				(U4_RS_qj_update (store U4_RS_qj U4_RS_dis_index (_ bv0 3)))
				(U4_RS_qk_update (store U4_RS_qk U4_RS_dis_index (_ bv0 3)))
				(U4_RS_imm_update (store U4_RS_imm U4_RS_dis_index 0))
				(U4_RS_dis_update (store U4_RS_dis U4_RS_dis_index (_ bv0 1)))
				(U4_RS_busy_update (store U4_RS_busy U4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_RS_op_type (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_type_update U4_RS_op_type))
				(U4_RS_op (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_update U4_RS_op))
				(U4_RS_ROB_dst (ite (= U4_RS_entry_dispatched #b1) U4_RS_ROB_dst_update U4_RS_ROB_dst))
				(U4_RS_vj (ite (= U4_RS_entry_dispatched #b1) U4_RS_vj_update U4_RS_vj))
				(U4_RS_vk (ite (= U4_RS_entry_dispatched #b1) U4_RS_vk_update U4_RS_vk))
				(U4_RS_qj (ite (= U4_RS_entry_dispatched #b1) U4_RS_qj_update U4_RS_qj))
				(U4_RS_qk (ite (= U4_RS_entry_dispatched #b1) U4_RS_qk_update U4_RS_qk))
				(U4_RS_imm (ite (= U4_RS_entry_dispatched #b1) U4_RS_imm_update U4_RS_imm))
				(U4_RS_dis (ite (= U4_RS_entry_dispatched #b1) U4_RS_dis_update U4_RS_dis))
				(U4_RS_busy (ite (= U4_RS_entry_dispatched #b1) U4_RS_busy_update U4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(U4_LSQ0_dis (select U4_LSQ_dis (_ bv0 2)))
				(U4_LSQ1_dis (select U4_LSQ_dis (_ bv1 2)))
				(U4_LSQ2_dis (select U4_LSQ_dis (_ bv2 2)))
				(U4_LSQ3_dis (select U4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(U4_LSQ_dis_index
					(ite (= U4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= U4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= U4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= U4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_LSQ_entry_dispatched (bvor U4_LSQ0_dis U4_LSQ1_dis U4_LSQ2_dis U4_LSQ3_dis))
			)	
		(let
			(
				(U4_LSQ_dis_vj (select U4_LSQ_vj U4_LSQ_dis_index))
				(U4_LSQ_dis_vk (select U4_LSQ_vk U4_LSQ_dis_index))
				(U4_LSQ_dis_qj (select U4_LSQ_qj U4_LSQ_dis_index))
				(U4_LSQ_dis_qk (select U4_LSQ_qk U4_LSQ_dis_index))
				(U4_LSQ_dis_op (select U4_LSQ_op U4_LSQ_dis_index))
				(U4_LSQ_dis_op_type (select U4_LSQ_op_type U4_LSQ_dis_index))
				(U4_LSQ_dis_imm (select U4_LSQ_imm U4_LSQ_dis_index))
				(U4_LSQ_dis_ROB_dst (select U4_LSQ_ROB_dst U4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
				(Store_address (STORE_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select U4_DM LOAD_addr))
				(U4_Cache0_Hit_Load (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Load (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Load (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Load (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
			)
		(let
			(
				(U4_Cache_Hit_load (bvor U4_Cache0_Hit_Load U4_Cache1_Hit_Load U4_Cache2_Hit_Load U4_Cache3_Hit_Load))
			)
		(let
			(
				(U4_LSQ_result
					(ite (= U4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= U4_LSQ_dis_op_type Store) U4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(U4_ROB_destination_update (store U4_ROB_destination U4_LSQ_dis_ROB_dst Store_address))
				(U4_ROB_result_load (store U4_ROB_result U4_LSQ_dis_ROB_dst LOAD_Value))
				(U4_ROB_result_store (store U4_ROB_result U4_LSQ_dis_ROB_dst U4_LSQ_dis_vk))
				(U4_ROB_done_update (store U4_ROB_done U4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(U4_Cache_tag_Update_Load (store U4_Cache_Tag Available_U4_Cache_Line LOAD_addr))
				
				(U4_Cache_data_Update_Load (store U4_Cache_Data Available_U4_Cache_Line LOAD_Value))
				
				(U4_Cache_valid_Update_Load (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag ))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid ))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
				
			)
		(let
			(
				(U4_Evict_Tag (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Index_update U4_Evict_Index))
			)
		(let
			(
				(U4_ROB_destination (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_destination_update U4_ROB_destination))
				(U4_ROB_result
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Load)) U4_ROB_result_load
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_result_store
					U4_ROB_result
					))
				)
				(U4_ROB_done (ite (= U4_LSQ_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				
				(U4_Cache_Tag
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_tag_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Tag
					)
				)
				(U4_Cache_Data
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_data_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Data
					)
				)
				(U4_Cache_Valid
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_valid_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Valid
					)
				)
			)
		(let
			(
				(U4_LSQ_op_type_update (store U4_LSQ_op_type U4_LSQ_dis_index 0))
				(U4_LSQ_op_update (store U4_LSQ_op U4_LSQ_dis_index 0))
				(U4_LSQ_ROB_dst_update (store U4_LSQ_ROB_dst U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_vj_update (store U4_LSQ_vj U4_LSQ_dis_index 0))
				(U4_LSQ_vk_update (store U4_LSQ_vk U4_LSQ_dis_index 0))
				(U4_LSQ_qj_update (store U4_LSQ_qj U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_qk_update (store U4_LSQ_qk U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_imm_update (store U4_LSQ_imm U4_LSQ_dis_index 0))
				(U4_LSQ_dis_update (store U4_LSQ_dis U4_LSQ_dis_index (_ bv0 1)))
				(U4_LSQ_busy_update (store U4_LSQ_busy U4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_LSQ_op_type (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_type_update U4_LSQ_op_type))
				(U4_LSQ_op (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_update U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_ROB_dst_update U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qk_update U4_LSQ_qk))
				(U4_LSQ_imm (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_imm_update U4_LSQ_imm))
				(U4_LSQ_dis (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_dis_update U4_LSQ_dis))
				(U4_LSQ_busy (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_busy_update U4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_qj_ROB_done (select U4_ROB_done U4_RS0_qj))
				(U4_RS0_qj_ROB_result (select U4_ROB_result U4_RS0_qj))
				(U4_RS0_qk_ROB_done (select U4_ROB_done U4_RS0_qk))
				(U4_RS0_qk_ROB_result (select U4_ROB_result U4_RS0_qk))
				(U4_RS1_qj_ROB_done (select U4_ROB_done U4_RS1_qj))
				(U4_RS1_qj_ROB_result (select U4_ROB_result U4_RS1_qj))
				(U4_RS1_qk_ROB_done (select U4_ROB_done U4_RS1_qk))
				(U4_RS1_qk_ROB_result (select U4_ROB_result U4_RS1_qk))
				(U4_RS2_qj_ROB_done (select U4_ROB_done U4_RS2_qj))
				(U4_RS2_qj_ROB_result (select U4_ROB_result U4_RS2_qj))
				(U4_RS2_qk_ROB_done (select U4_ROB_done U4_RS2_qk))
				(U4_RS2_qk_ROB_result (select U4_ROB_result U4_RS2_qk))
				(U4_RS3_qj_ROB_done (select U4_ROB_done U4_RS3_qj))
				(U4_RS3_qj_ROB_result (select U4_ROB_result U4_RS3_qj))
				(U4_RS3_qk_ROB_done (select U4_ROB_done U4_RS3_qk))
				(U4_RS3_qk_ROB_result (select U4_ROB_result U4_RS3_qk))
				
				(U4_LSQ0_qj_ROB_done (select U4_ROB_done U4_LSQ0_qj))
				(U4_LSQ0_qj_ROB_result (select U4_ROB_result U4_LSQ0_qj))
				(U4_LSQ0_qk_ROB_done (select U4_ROB_done U4_LSQ0_qk))
				(U4_LSQ0_qk_ROB_result (select U4_ROB_result U4_LSQ0_qk))
				(U4_LSQ1_qj_ROB_done (select U4_ROB_done U4_LSQ1_qj))
				(U4_LSQ1_qj_ROB_result (select U4_ROB_result U4_LSQ1_qj))
				(U4_LSQ1_qk_ROB_done (select U4_ROB_done U4_LSQ1_qk))
				(U4_LSQ1_qk_ROB_result (select U4_ROB_result U4_LSQ1_qk))
				(U4_LSQ2_qj_ROB_done (select U4_ROB_done U4_LSQ2_qj))
				(U4_LSQ2_qj_ROB_result (select U4_ROB_result U4_LSQ2_qj))
				(U4_LSQ2_qk_ROB_done (select U4_ROB_done U4_LSQ2_qk))
				(U4_LSQ2_qk_ROB_result (select U4_ROB_result U4_LSQ2_qk))
				(U4_LSQ3_qj_ROB_done (select U4_ROB_done U4_LSQ3_qj))
				(U4_LSQ3_qj_ROB_result (select U4_ROB_result U4_LSQ3_qj))
				(U4_LSQ3_qk_ROB_done (select U4_ROB_done U4_LSQ3_qk))
				(U4_LSQ3_qk_ROB_result (select U4_ROB_result U4_LSQ3_qk))
			)
		(let
			(
				(U4_RS0_vj_update (store U4_RS_vj (_ bv0 2) U4_RS0_qj_ROB_result))
				(U4_RS0_vk_update (store U4_RS_vk (_ bv0 2) U4_RS0_qk_ROB_result))					
				(U4_RS0_qj_update (store U4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(U4_RS0_qk_update (store U4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_vj_update (store U4_LSQ_vj (_ bv0 2) U4_LSQ0_qj_ROB_result))	
				(U4_LSQ0_vk_update (store U4_LSQ_vk (_ bv0 2) U4_LSQ0_qk_ROB_result))	
				(U4_LSQ0_qj_update (store U4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_qk_update (store U4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS1_vj_update (store U4_RS_vj (_ bv1 2) U4_RS1_qj_ROB_result))	
				(U4_RS1_vk_update (store U4_RS_vk (_ bv1 2) U4_RS1_qk_ROB_result))	
				(U4_RS1_qj_update (store U4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(U4_RS1_qk_update (store U4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_vj_update (store U4_LSQ_vj (_ bv1 2) U4_LSQ1_qj_ROB_result))	
				(U4_LSQ1_vk_update (store U4_LSQ_vk (_ bv1 2) U4_LSQ1_qk_ROB_result))	
				(U4_LSQ1_qj_update (store U4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_qk_update (store U4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS2_vj_update (store U4_RS_vj (_ bv2 2) U4_RS2_qj_ROB_result))	
				(U4_RS2_vk_update (store U4_RS_vk (_ bv2 2) U4_RS2_qk_ROB_result))	
				(U4_RS2_qj_update (store U4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(U4_RS2_qk_update (store U4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_vj_update (store U4_LSQ_vj (_ bv2 2) U4_LSQ2_qj_ROB_result))	
				(U4_LSQ2_vk_update (store U4_LSQ_vk (_ bv2 2) U4_LSQ2_qk_ROB_result))	
				(U4_LSQ2_qj_update (store U4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_qk_update (store U4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS3_vj_update (store U4_RS_vj (_ bv3 2) U4_RS3_qj_ROB_result))	
				(U4_RS3_vk_update (store U4_RS_vk (_ bv3 2) U4_RS3_qk_ROB_result))	
				(U4_RS3_qj_update (store U4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(U4_RS3_qk_update (store U4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_vj_update (store U4_LSQ_vj (_ bv3 2) U4_LSQ3_qj_ROB_result))	
				(U4_LSQ3_vk_update (store U4_LSQ_vk (_ bv3 2) U4_LSQ3_qk_ROB_result))	
				(U4_LSQ3_qj_update (store U4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_qk_update (store U4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_dis (ite (and (= #b1 U4_RS0_busy) (= #b000 U4_RS0_qj) (= #b000 U4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS1_dis (ite (and (= #b1 U4_RS1_busy) (= #b000 U4_RS1_qj) (= #b000 U4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS2_dis (ite (and (= #b1 U4_RS2_busy) (= #b000 U4_RS2_qj) (= #b000 U4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS3_dis (ite (and (= #b1 U4_RS3_busy) (= #b000 U4_RS3_qj) (= #b000 U4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U4_LSQ0_dis (ite (and (= #b1 U4_LSQ0_busy) (= #b000 U4_LSQ0_qj) (= #b000 U4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ1_dis (ite (and (= #b1 U4_LSQ1_busy) (= #b000 U4_LSQ1_qj) (= #b000 U4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ2_dis (ite (and (= #b1 U4_LSQ2_busy) (= #b000 U4_LSQ2_qj) (= #b000 U4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ3_dis (ite (and (= #b1 U4_LSQ3_busy) (= #b000 U4_LSQ3_qj) (= #b000 U4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv0 2) U4_RS0_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv0 2) U4_LSQ0_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv1 2) U4_RS1_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv1 2) U4_LSQ1_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv2 2) U4_RS2_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv2 2) U4_LSQ2_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv3 2) U4_RS3_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv3 2) U4_LSQ3_dis))
			)
		(let
			(
				(U4_RF (ite (= 0 0) U4_RF U4_RF))
				(U4_DM (ite (= 0 0) U4_DM U4_DM))
				
				(U4_Cache_Tag (ite (= 0 0) U4_Cache_Tag U4_Cache_Tag))
				(U4_Cache_Data (ite (= 0 0) U4_Cache_Data U4_Cache_Data))
				(U4_Cache_Valid (ite (= 0 0) U4_Cache_Valid U4_Cache_Valid))
				
				(U4_PC (ite (= 0 0) U4_PC U4_PC))
				
				(U4_IP (ite (= 0 0) U4_IP U4_IP))
				(U4_CP (ite (= 0 0) U4_CP U4_CP))
				
				(U4_ROB_busy (ite (= 0 0) U4_ROB_busy U4_ROB_busy))
				(U4_ROB_op_type (ite (= 0 0) U4_ROB_op_type U4_ROB_op_type))
				(U4_ROB_destination (ite (= 0 0) U4_ROB_destination U4_ROB_destination))
				(U4_ROB_result (ite (= 0 0) U4_ROB_result U4_ROB_result))
				(U4_ROB_exception (ite (= 0 0) U4_ROB_exception U4_ROB_exception))
				(U4_ROB_done (ite (= 0 0) U4_ROB_done U4_ROB_done))
				
				(U4_RS_op_type (ite (= 0 0) U4_RS_op_type U4_RS_op_type))
				(U4_RS_op (ite (= 0 0) U4_RS_op U4_RS_op))
				(U4_RS_ROB_dst (ite (= 0 0) U4_RS_ROB_dst U4_RS_ROB_dst))
				(U4_RS_vj (ite (= 0 0) U4_RS_vj U4_RS_vj))
				(U4_RS_vk (ite (= 0 0) U4_RS_vk U4_RS_vk))
				(U4_RS_qj (ite (= 0 0) U4_RS_qj U4_RS_qj))
				(U4_RS_qk (ite (= 0 0) U4_RS_qk U4_RS_qk))
				(U4_RS_imm (ite (= 0 0) U4_RS_imm U4_RS_imm))
				(U4_RS_dis (ite (= 0 0) U4_RS_dis U4_RS_dis))
				(U4_RS_busy (ite (= 0 0) U4_RS_busy U4_RS_busy))
				
				(U4_LSQ_op_type (ite (= 0 0) U4_LSQ_op_type U4_LSQ_op_type))
				(U4_LSQ_op (ite (= 0 0) U4_LSQ_op U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= 0 0) U4_LSQ_ROB_dst U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= 0 0) U4_LSQ_vj U4_LSQ_vj))
				(U4_LSQ_vk (ite (= 0 0) U4_LSQ_vk U4_LSQ_vk))
				(U4_LSQ_qj (ite (= 0 0) U4_LSQ_qj U4_LSQ_qj))
				(U4_LSQ_qk (ite (= 0 0) U4_LSQ_qk U4_LSQ_qk))
				(U4_LSQ_imm (ite (= 0 0) U4_LSQ_imm U4_LSQ_imm))
				(U4_LSQ_dis (ite (= 0 0) U4_LSQ_dis U4_LSQ_dis))
				(U4_LSQ_busy (ite (= 0 0) U4_LSQ_busy U4_LSQ_busy))
				
				(U4_Evict_Tag (ite (= 0 0) U4_Evict_Tag U4_Evict_Tag))
				(U4_Evict_Valid (ite (= 0 0) U4_Evict_Valid U4_Evict_Valid))
				(U4_Evict_Index (ite (= 0 0) U4_Evict_Index U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(U4_RS0_dis (select U4_RS_dis (_ bv0 2)))
				(U4_RS1_dis (select U4_RS_dis (_ bv1 2)))
				(U4_RS2_dis (select U4_RS_dis (_ bv2 2)))
				(U4_RS3_dis (select U4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(U4_RS_dis_index
					(ite (= U4_RS0_dis #b1) (_ bv0 2)
					(ite (= U4_RS1_dis #b1) (_ bv1 2)
					(ite (= U4_RS2_dis #b1) (_ bv2 2)
					(ite (= U4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_RS_entry_dispatched (bvor U4_RS0_dis U4_RS1_dis U4_RS2_dis U4_RS3_dis))
			)	
		(let
			(
				(U4_RS_dis_vj (select U4_RS_vj U4_RS_dis_index))
				(U4_RS_dis_vk (select U4_RS_vk U4_RS_dis_index))
				(U4_RS_dis_qj (select U4_RS_qj U4_RS_dis_index))
				(U4_RS_dis_qk (select U4_RS_qk U4_RS_dis_index))
				(U4_RS_dis_op (select U4_RS_op U4_RS_dis_index))
				(U4_RS_dis_op_type (select U4_RS_op_type U4_RS_dis_index))
				(U4_RS_dis_imm (select U4_RS_imm U4_RS_dis_index))
				(U4_RS_dis_ROB_dst (select U4_RS_ROB_dst U4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(ALU1_result (ALU1 U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
			)
		(let
			(
				(U4_RS_result
					(ite (= U4_RS_dis_op_type Rtype) ALU1_result
					(ite (= U4_RS_dis_op_type Branch) Branch_result
					(ite (= U4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(U4_ROB_result_update (store U4_ROB_result U4_RS_dis_ROB_dst U4_RS_result))
				(U4_ROB_done_update (store U4_ROB_done U4_RS_dis_ROB_dst (_ bv1 1)))
				(U4_ROB_exception_update (store U4_ROB_exception U4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(U4_ROB_result (ite (= U4_RS_entry_dispatched #b1) U4_ROB_result_update U4_ROB_result))
				(U4_ROB_done (ite (= U4_RS_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				(U4_ROB_exception (ite (and (= U4_RS_dis_op_type Branch) (= U4_RS_result 1) (= U4_RS_entry_dispatched #b1)) U4_ROB_exception_update U4_ROB_exception))
			)
		(let
			(
				(U4_RS_op_type_update (store U4_RS_op_type U4_RS_dis_index 0))
				(U4_RS_op_update (store U4_RS_op U4_RS_dis_index 0))
				(U4_RS_ROB_dst_update (store U4_RS_ROB_dst U4_RS_dis_index (_ bv0 3)))
				(U4_RS_vj_update (store U4_RS_vj U4_RS_dis_index 0))
				(U4_RS_vk_update (store U4_RS_vk U4_RS_dis_index 0))
				(U4_RS_qj_update (store U4_RS_qj U4_RS_dis_index (_ bv0 3)))
				(U4_RS_qk_update (store U4_RS_qk U4_RS_dis_index (_ bv0 3)))
				(U4_RS_imm_update (store U4_RS_imm U4_RS_dis_index 0))
				(U4_RS_dis_update (store U4_RS_dis U4_RS_dis_index (_ bv0 1)))
				(U4_RS_busy_update (store U4_RS_busy U4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_RS_op_type (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_type_update U4_RS_op_type))
				(U4_RS_op (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_update U4_RS_op))
				(U4_RS_ROB_dst (ite (= U4_RS_entry_dispatched #b1) U4_RS_ROB_dst_update U4_RS_ROB_dst))
				(U4_RS_vj (ite (= U4_RS_entry_dispatched #b1) U4_RS_vj_update U4_RS_vj))
				(U4_RS_vk (ite (= U4_RS_entry_dispatched #b1) U4_RS_vk_update U4_RS_vk))
				(U4_RS_qj (ite (= U4_RS_entry_dispatched #b1) U4_RS_qj_update U4_RS_qj))
				(U4_RS_qk (ite (= U4_RS_entry_dispatched #b1) U4_RS_qk_update U4_RS_qk))
				(U4_RS_imm (ite (= U4_RS_entry_dispatched #b1) U4_RS_imm_update U4_RS_imm))
				(U4_RS_dis (ite (= U4_RS_entry_dispatched #b1) U4_RS_dis_update U4_RS_dis))
				(U4_RS_busy (ite (= U4_RS_entry_dispatched #b1) U4_RS_busy_update U4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(U4_LSQ0_dis (select U4_LSQ_dis (_ bv0 2)))
				(U4_LSQ1_dis (select U4_LSQ_dis (_ bv1 2)))
				(U4_LSQ2_dis (select U4_LSQ_dis (_ bv2 2)))
				(U4_LSQ3_dis (select U4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(U4_LSQ_dis_index
					(ite (= U4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= U4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= U4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= U4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_LSQ_entry_dispatched (bvor U4_LSQ0_dis U4_LSQ1_dis U4_LSQ2_dis U4_LSQ3_dis))
			)	
		(let
			(
				(U4_LSQ_dis_vj (select U4_LSQ_vj U4_LSQ_dis_index))
				(U4_LSQ_dis_vk (select U4_LSQ_vk U4_LSQ_dis_index))
				(U4_LSQ_dis_qj (select U4_LSQ_qj U4_LSQ_dis_index))
				(U4_LSQ_dis_qk (select U4_LSQ_qk U4_LSQ_dis_index))
				(U4_LSQ_dis_op (select U4_LSQ_op U4_LSQ_dis_index))
				(U4_LSQ_dis_op_type (select U4_LSQ_op_type U4_LSQ_dis_index))
				(U4_LSQ_dis_imm (select U4_LSQ_imm U4_LSQ_dis_index))
				(U4_LSQ_dis_ROB_dst (select U4_LSQ_ROB_dst U4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
				(Store_address (STORE_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select U4_DM LOAD_addr))
				(U4_Cache0_Hit_Load (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Load (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Load (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Load (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
			)
		(let
			(
				(U4_Cache_Hit_load (bvor U4_Cache0_Hit_Load U4_Cache1_Hit_Load U4_Cache2_Hit_Load U4_Cache3_Hit_Load))
			)
		(let
			(
				(U4_LSQ_result
					(ite (= U4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= U4_LSQ_dis_op_type Store) U4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(U4_ROB_destination_update (store U4_ROB_destination U4_LSQ_dis_ROB_dst Store_address))
				(U4_ROB_result_load (store U4_ROB_result U4_LSQ_dis_ROB_dst LOAD_Value))
				(U4_ROB_result_store (store U4_ROB_result U4_LSQ_dis_ROB_dst U4_LSQ_dis_vk))
				(U4_ROB_done_update (store U4_ROB_done U4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(U4_Cache_tag_Update_Load (store U4_Cache_Tag Available_U4_Cache_Line LOAD_addr))
				
				(U4_Cache_data_Update_Load (store U4_Cache_Data Available_U4_Cache_Line LOAD_Value))
				
				(U4_Cache_valid_Update_Load (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag ))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid ))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
				
			)
		(let
			(
				(U4_Evict_Tag (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Index_update U4_Evict_Index))
			)
		(let
			(
				(U4_ROB_destination (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_destination_update U4_ROB_destination))
				(U4_ROB_result
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Load)) U4_ROB_result_load
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_result_store
					U4_ROB_result
					))
				)
				(U4_ROB_done (ite (= U4_LSQ_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				
				(U4_Cache_Tag
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_tag_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Tag
					)
				)
				(U4_Cache_Data
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_data_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Data
					)
				)
				(U4_Cache_Valid
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_valid_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Valid
					)
				)
			)
		(let
			(
				(U4_LSQ_op_type_update (store U4_LSQ_op_type U4_LSQ_dis_index 0))
				(U4_LSQ_op_update (store U4_LSQ_op U4_LSQ_dis_index 0))
				(U4_LSQ_ROB_dst_update (store U4_LSQ_ROB_dst U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_vj_update (store U4_LSQ_vj U4_LSQ_dis_index 0))
				(U4_LSQ_vk_update (store U4_LSQ_vk U4_LSQ_dis_index 0))
				(U4_LSQ_qj_update (store U4_LSQ_qj U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_qk_update (store U4_LSQ_qk U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_imm_update (store U4_LSQ_imm U4_LSQ_dis_index 0))
				(U4_LSQ_dis_update (store U4_LSQ_dis U4_LSQ_dis_index (_ bv0 1)))
				(U4_LSQ_busy_update (store U4_LSQ_busy U4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_LSQ_op_type (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_type_update U4_LSQ_op_type))
				(U4_LSQ_op (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_update U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_ROB_dst_update U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qk_update U4_LSQ_qk))
				(U4_LSQ_imm (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_imm_update U4_LSQ_imm))
				(U4_LSQ_dis (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_dis_update U4_LSQ_dis))
				(U4_LSQ_busy (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_busy_update U4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_qj_ROB_done (select U4_ROB_done U4_RS0_qj))
				(U4_RS0_qj_ROB_result (select U4_ROB_result U4_RS0_qj))
				(U4_RS0_qk_ROB_done (select U4_ROB_done U4_RS0_qk))
				(U4_RS0_qk_ROB_result (select U4_ROB_result U4_RS0_qk))
				(U4_RS1_qj_ROB_done (select U4_ROB_done U4_RS1_qj))
				(U4_RS1_qj_ROB_result (select U4_ROB_result U4_RS1_qj))
				(U4_RS1_qk_ROB_done (select U4_ROB_done U4_RS1_qk))
				(U4_RS1_qk_ROB_result (select U4_ROB_result U4_RS1_qk))
				(U4_RS2_qj_ROB_done (select U4_ROB_done U4_RS2_qj))
				(U4_RS2_qj_ROB_result (select U4_ROB_result U4_RS2_qj))
				(U4_RS2_qk_ROB_done (select U4_ROB_done U4_RS2_qk))
				(U4_RS2_qk_ROB_result (select U4_ROB_result U4_RS2_qk))
				(U4_RS3_qj_ROB_done (select U4_ROB_done U4_RS3_qj))
				(U4_RS3_qj_ROB_result (select U4_ROB_result U4_RS3_qj))
				(U4_RS3_qk_ROB_done (select U4_ROB_done U4_RS3_qk))
				(U4_RS3_qk_ROB_result (select U4_ROB_result U4_RS3_qk))
				
				(U4_LSQ0_qj_ROB_done (select U4_ROB_done U4_LSQ0_qj))
				(U4_LSQ0_qj_ROB_result (select U4_ROB_result U4_LSQ0_qj))
				(U4_LSQ0_qk_ROB_done (select U4_ROB_done U4_LSQ0_qk))
				(U4_LSQ0_qk_ROB_result (select U4_ROB_result U4_LSQ0_qk))
				(U4_LSQ1_qj_ROB_done (select U4_ROB_done U4_LSQ1_qj))
				(U4_LSQ1_qj_ROB_result (select U4_ROB_result U4_LSQ1_qj))
				(U4_LSQ1_qk_ROB_done (select U4_ROB_done U4_LSQ1_qk))
				(U4_LSQ1_qk_ROB_result (select U4_ROB_result U4_LSQ1_qk))
				(U4_LSQ2_qj_ROB_done (select U4_ROB_done U4_LSQ2_qj))
				(U4_LSQ2_qj_ROB_result (select U4_ROB_result U4_LSQ2_qj))
				(U4_LSQ2_qk_ROB_done (select U4_ROB_done U4_LSQ2_qk))
				(U4_LSQ2_qk_ROB_result (select U4_ROB_result U4_LSQ2_qk))
				(U4_LSQ3_qj_ROB_done (select U4_ROB_done U4_LSQ3_qj))
				(U4_LSQ3_qj_ROB_result (select U4_ROB_result U4_LSQ3_qj))
				(U4_LSQ3_qk_ROB_done (select U4_ROB_done U4_LSQ3_qk))
				(U4_LSQ3_qk_ROB_result (select U4_ROB_result U4_LSQ3_qk))
			)
		(let
			(
				(U4_RS0_vj_update (store U4_RS_vj (_ bv0 2) U4_RS0_qj_ROB_result))
				(U4_RS0_vk_update (store U4_RS_vk (_ bv0 2) U4_RS0_qk_ROB_result))					
				(U4_RS0_qj_update (store U4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(U4_RS0_qk_update (store U4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_vj_update (store U4_LSQ_vj (_ bv0 2) U4_LSQ0_qj_ROB_result))	
				(U4_LSQ0_vk_update (store U4_LSQ_vk (_ bv0 2) U4_LSQ0_qk_ROB_result))	
				(U4_LSQ0_qj_update (store U4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_qk_update (store U4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS1_vj_update (store U4_RS_vj (_ bv1 2) U4_RS1_qj_ROB_result))	
				(U4_RS1_vk_update (store U4_RS_vk (_ bv1 2) U4_RS1_qk_ROB_result))	
				(U4_RS1_qj_update (store U4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(U4_RS1_qk_update (store U4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_vj_update (store U4_LSQ_vj (_ bv1 2) U4_LSQ1_qj_ROB_result))	
				(U4_LSQ1_vk_update (store U4_LSQ_vk (_ bv1 2) U4_LSQ1_qk_ROB_result))	
				(U4_LSQ1_qj_update (store U4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_qk_update (store U4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS2_vj_update (store U4_RS_vj (_ bv2 2) U4_RS2_qj_ROB_result))	
				(U4_RS2_vk_update (store U4_RS_vk (_ bv2 2) U4_RS2_qk_ROB_result))	
				(U4_RS2_qj_update (store U4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(U4_RS2_qk_update (store U4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_vj_update (store U4_LSQ_vj (_ bv2 2) U4_LSQ2_qj_ROB_result))	
				(U4_LSQ2_vk_update (store U4_LSQ_vk (_ bv2 2) U4_LSQ2_qk_ROB_result))	
				(U4_LSQ2_qj_update (store U4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_qk_update (store U4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS3_vj_update (store U4_RS_vj (_ bv3 2) U4_RS3_qj_ROB_result))	
				(U4_RS3_vk_update (store U4_RS_vk (_ bv3 2) U4_RS3_qk_ROB_result))	
				(U4_RS3_qj_update (store U4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(U4_RS3_qk_update (store U4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_vj_update (store U4_LSQ_vj (_ bv3 2) U4_LSQ3_qj_ROB_result))	
				(U4_LSQ3_vk_update (store U4_LSQ_vk (_ bv3 2) U4_LSQ3_qk_ROB_result))	
				(U4_LSQ3_qj_update (store U4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_qk_update (store U4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_dis (ite (and (= #b1 U4_RS0_busy) (= #b000 U4_RS0_qj) (= #b000 U4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS1_dis (ite (and (= #b1 U4_RS1_busy) (= #b000 U4_RS1_qj) (= #b000 U4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS2_dis (ite (and (= #b1 U4_RS2_busy) (= #b000 U4_RS2_qj) (= #b000 U4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS3_dis (ite (and (= #b1 U4_RS3_busy) (= #b000 U4_RS3_qj) (= #b000 U4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U4_LSQ0_dis (ite (and (= #b1 U4_LSQ0_busy) (= #b000 U4_LSQ0_qj) (= #b000 U4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ1_dis (ite (and (= #b1 U4_LSQ1_busy) (= #b000 U4_LSQ1_qj) (= #b000 U4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ2_dis (ite (and (= #b1 U4_LSQ2_busy) (= #b000 U4_LSQ2_qj) (= #b000 U4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ3_dis (ite (and (= #b1 U4_LSQ3_busy) (= #b000 U4_LSQ3_qj) (= #b000 U4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv0 2) U4_RS0_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv0 2) U4_LSQ0_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv1 2) U4_RS1_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv1 2) U4_LSQ1_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv2 2) U4_RS2_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv2 2) U4_LSQ2_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv3 2) U4_RS3_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv3 2) U4_LSQ3_dis))
			)
		(let
			(
				(U4_RF (ite (= 0 0) U4_RF U4_RF))
				(U4_DM (ite (= 0 0) U4_DM U4_DM))
				
				(U4_Cache_Tag (ite (= 0 0) U4_Cache_Tag U4_Cache_Tag))
				(U4_Cache_Data (ite (= 0 0) U4_Cache_Data U4_Cache_Data))
				(U4_Cache_Valid (ite (= 0 0) U4_Cache_Valid U4_Cache_Valid))
				
				(U4_PC (ite (= 0 0) U4_PC U4_PC))
				
				(U4_IP (ite (= 0 0) U4_IP U4_IP))
				(U4_CP (ite (= 0 0) U4_CP U4_CP))
				
				(U4_ROB_busy (ite (= 0 0) U4_ROB_busy U4_ROB_busy))
				(U4_ROB_op_type (ite (= 0 0) U4_ROB_op_type U4_ROB_op_type))
				(U4_ROB_destination (ite (= 0 0) U4_ROB_destination U4_ROB_destination))
				(U4_ROB_result (ite (= 0 0) U4_ROB_result U4_ROB_result))
				(U4_ROB_exception (ite (= 0 0) U4_ROB_exception U4_ROB_exception))
				(U4_ROB_done (ite (= 0 0) U4_ROB_done U4_ROB_done))
				
				(U4_RS_op_type (ite (= 0 0) U4_RS_op_type U4_RS_op_type))
				(U4_RS_op (ite (= 0 0) U4_RS_op U4_RS_op))
				(U4_RS_ROB_dst (ite (= 0 0) U4_RS_ROB_dst U4_RS_ROB_dst))
				(U4_RS_vj (ite (= 0 0) U4_RS_vj U4_RS_vj))
				(U4_RS_vk (ite (= 0 0) U4_RS_vk U4_RS_vk))
				(U4_RS_qj (ite (= 0 0) U4_RS_qj U4_RS_qj))
				(U4_RS_qk (ite (= 0 0) U4_RS_qk U4_RS_qk))
				(U4_RS_imm (ite (= 0 0) U4_RS_imm U4_RS_imm))
				(U4_RS_dis (ite (= 0 0) U4_RS_dis U4_RS_dis))
				(U4_RS_busy (ite (= 0 0) U4_RS_busy U4_RS_busy))
				
				(U4_LSQ_op_type (ite (= 0 0) U4_LSQ_op_type U4_LSQ_op_type))
				(U4_LSQ_op (ite (= 0 0) U4_LSQ_op U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= 0 0) U4_LSQ_ROB_dst U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= 0 0) U4_LSQ_vj U4_LSQ_vj))
				(U4_LSQ_vk (ite (= 0 0) U4_LSQ_vk U4_LSQ_vk))
				(U4_LSQ_qj (ite (= 0 0) U4_LSQ_qj U4_LSQ_qj))
				(U4_LSQ_qk (ite (= 0 0) U4_LSQ_qk U4_LSQ_qk))
				(U4_LSQ_imm (ite (= 0 0) U4_LSQ_imm U4_LSQ_imm))
				(U4_LSQ_dis (ite (= 0 0) U4_LSQ_dis U4_LSQ_dis))
				(U4_LSQ_busy (ite (= 0 0) U4_LSQ_busy U4_LSQ_busy))
				
				(U4_Evict_Tag (ite (= 0 0) U4_Evict_Tag U4_Evict_Tag))
				(U4_Evict_Valid (ite (= 0 0) U4_Evict_Valid U4_Evict_Valid))
				(U4_Evict_Index (ite (= 0 0) U4_Evict_Index U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(U4_RS0_dis (select U4_RS_dis (_ bv0 2)))
				(U4_RS1_dis (select U4_RS_dis (_ bv1 2)))
				(U4_RS2_dis (select U4_RS_dis (_ bv2 2)))
				(U4_RS3_dis (select U4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(U4_RS_dis_index
					(ite (= U4_RS0_dis #b1) (_ bv0 2)
					(ite (= U4_RS1_dis #b1) (_ bv1 2)
					(ite (= U4_RS2_dis #b1) (_ bv2 2)
					(ite (= U4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_RS_entry_dispatched (bvor U4_RS0_dis U4_RS1_dis U4_RS2_dis U4_RS3_dis))
			)	
		(let
			(
				(U4_RS_dis_vj (select U4_RS_vj U4_RS_dis_index))
				(U4_RS_dis_vk (select U4_RS_vk U4_RS_dis_index))
				(U4_RS_dis_qj (select U4_RS_qj U4_RS_dis_index))
				(U4_RS_dis_qk (select U4_RS_qk U4_RS_dis_index))
				(U4_RS_dis_op (select U4_RS_op U4_RS_dis_index))
				(U4_RS_dis_op_type (select U4_RS_op_type U4_RS_dis_index))
				(U4_RS_dis_imm (select U4_RS_imm U4_RS_dis_index))
				(U4_RS_dis_ROB_dst (select U4_RS_ROB_dst U4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(ALU1_result (ALU1 U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV U4_RS_dis_vj U4_RS_dis_vk U4_RS_dis_imm U4_RS_dis_op))
			)
		(let
			(
				(U4_RS_result
					(ite (= U4_RS_dis_op_type Rtype) ALU1_result
					(ite (= U4_RS_dis_op_type Branch) Branch_result
					(ite (= U4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(U4_ROB_result_update (store U4_ROB_result U4_RS_dis_ROB_dst U4_RS_result))
				(U4_ROB_done_update (store U4_ROB_done U4_RS_dis_ROB_dst (_ bv1 1)))
				(U4_ROB_exception_update (store U4_ROB_exception U4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(U4_ROB_result (ite (= U4_RS_entry_dispatched #b1) U4_ROB_result_update U4_ROB_result))
				(U4_ROB_done (ite (= U4_RS_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				(U4_ROB_exception (ite (and (= U4_RS_dis_op_type Branch) (= U4_RS_result 1) (= U4_RS_entry_dispatched #b1)) U4_ROB_exception_update U4_ROB_exception))
			)
		(let
			(
				(U4_RS_op_type_update (store U4_RS_op_type U4_RS_dis_index 0))
				(U4_RS_op_update (store U4_RS_op U4_RS_dis_index 0))
				(U4_RS_ROB_dst_update (store U4_RS_ROB_dst U4_RS_dis_index (_ bv0 3)))
				(U4_RS_vj_update (store U4_RS_vj U4_RS_dis_index 0))
				(U4_RS_vk_update (store U4_RS_vk U4_RS_dis_index 0))
				(U4_RS_qj_update (store U4_RS_qj U4_RS_dis_index (_ bv0 3)))
				(U4_RS_qk_update (store U4_RS_qk U4_RS_dis_index (_ bv0 3)))
				(U4_RS_imm_update (store U4_RS_imm U4_RS_dis_index 0))
				(U4_RS_dis_update (store U4_RS_dis U4_RS_dis_index (_ bv0 1)))
				(U4_RS_busy_update (store U4_RS_busy U4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_RS_op_type (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_type_update U4_RS_op_type))
				(U4_RS_op (ite (= U4_RS_entry_dispatched #b1) U4_RS_op_update U4_RS_op))
				(U4_RS_ROB_dst (ite (= U4_RS_entry_dispatched #b1) U4_RS_ROB_dst_update U4_RS_ROB_dst))
				(U4_RS_vj (ite (= U4_RS_entry_dispatched #b1) U4_RS_vj_update U4_RS_vj))
				(U4_RS_vk (ite (= U4_RS_entry_dispatched #b1) U4_RS_vk_update U4_RS_vk))
				(U4_RS_qj (ite (= U4_RS_entry_dispatched #b1) U4_RS_qj_update U4_RS_qj))
				(U4_RS_qk (ite (= U4_RS_entry_dispatched #b1) U4_RS_qk_update U4_RS_qk))
				(U4_RS_imm (ite (= U4_RS_entry_dispatched #b1) U4_RS_imm_update U4_RS_imm))
				(U4_RS_dis (ite (= U4_RS_entry_dispatched #b1) U4_RS_dis_update U4_RS_dis))
				(U4_RS_busy (ite (= U4_RS_entry_dispatched #b1) U4_RS_busy_update U4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(U4_LSQ0_dis (select U4_LSQ_dis (_ bv0 2)))
				(U4_LSQ1_dis (select U4_LSQ_dis (_ bv1 2)))
				(U4_LSQ2_dis (select U4_LSQ_dis (_ bv2 2)))
				(U4_LSQ3_dis (select U4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(U4_LSQ_dis_index
					(ite (= U4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= U4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= U4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= U4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(U4_LSQ_entry_dispatched (bvor U4_LSQ0_dis U4_LSQ1_dis U4_LSQ2_dis U4_LSQ3_dis))
			)	
		(let
			(
				(U4_LSQ_dis_vj (select U4_LSQ_vj U4_LSQ_dis_index))
				(U4_LSQ_dis_vk (select U4_LSQ_vk U4_LSQ_dis_index))
				(U4_LSQ_dis_qj (select U4_LSQ_qj U4_LSQ_dis_index))
				(U4_LSQ_dis_qk (select U4_LSQ_qk U4_LSQ_dis_index))
				(U4_LSQ_dis_op (select U4_LSQ_op U4_LSQ_dis_index))
				(U4_LSQ_dis_op_type (select U4_LSQ_op_type U4_LSQ_dis_index))
				(U4_LSQ_dis_imm (select U4_LSQ_imm U4_LSQ_dis_index))
				(U4_LSQ_dis_ROB_dst (select U4_LSQ_ROB_dst U4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
				(Store_address (STORE_Unit U4_LSQ_dis_vj U4_LSQ_dis_imm U4_LSQ_dis_op))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select U4_DM LOAD_addr))
				(U4_Cache0_Hit_Load (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Load (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Load (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Load (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
			)
		(let
			(
				(U4_Cache_Hit_load (bvor U4_Cache0_Hit_Load U4_Cache1_Hit_Load U4_Cache2_Hit_Load U4_Cache3_Hit_Load))
			)
		(let
			(
				(U4_LSQ_result
					(ite (= U4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= U4_LSQ_dis_op_type Store) U4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(U4_ROB_destination_update (store U4_ROB_destination U4_LSQ_dis_ROB_dst Store_address))
				(U4_ROB_result_load (store U4_ROB_result U4_LSQ_dis_ROB_dst LOAD_Value))
				(U4_ROB_result_store (store U4_ROB_result U4_LSQ_dis_ROB_dst U4_LSQ_dis_vk))
				(U4_ROB_done_update (store U4_ROB_done U4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(U4_Cache_tag_Update_Load (store U4_Cache_Tag Available_U4_Cache_Line LOAD_addr))
				
				(U4_Cache_data_Update_Load (store U4_Cache_Data Available_U4_Cache_Line LOAD_Value))
				
				(U4_Cache_valid_Update_Load (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag ))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid ))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
				
			)
		(let
			(
				(U4_Evict_Tag (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load) (= #b00 Available_U4_Cache_Line) (= U4_Cache0_Valid #b1)) U4_Evict_Index_update U4_Evict_Index))
			)
		(let
			(
				(U4_ROB_destination (ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_destination_update U4_ROB_destination))
				(U4_ROB_result
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Load)) U4_ROB_result_load
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_LSQ_dis_op_type Store)) U4_ROB_result_store
					U4_ROB_result
					))
				)
				(U4_ROB_done (ite (= U4_LSQ_entry_dispatched #b1) U4_ROB_done_update U4_ROB_done))
				
				(U4_Cache_Tag
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_tag_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Tag
					)
				)
				(U4_Cache_Data
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_data_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Data
					)
				)
				(U4_Cache_Valid
					(ite (and (= U4_LSQ_entry_dispatched #b1) (= U4_Cache_Hit_load #b0) (= U4_LSQ_dis_op_type Load)) U4_Cache_valid_Update_Load			;If load and U4_Cache miss, update the U4_Cache
					U4_Cache_Valid
					)
				)
			)
		(let
			(
				(U4_LSQ_op_type_update (store U4_LSQ_op_type U4_LSQ_dis_index 0))
				(U4_LSQ_op_update (store U4_LSQ_op U4_LSQ_dis_index 0))
				(U4_LSQ_ROB_dst_update (store U4_LSQ_ROB_dst U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_vj_update (store U4_LSQ_vj U4_LSQ_dis_index 0))
				(U4_LSQ_vk_update (store U4_LSQ_vk U4_LSQ_dis_index 0))
				(U4_LSQ_qj_update (store U4_LSQ_qj U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_qk_update (store U4_LSQ_qk U4_LSQ_dis_index (_ bv0 3)))
				(U4_LSQ_imm_update (store U4_LSQ_imm U4_LSQ_dis_index 0))
				(U4_LSQ_dis_update (store U4_LSQ_dis U4_LSQ_dis_index (_ bv0 1)))
				(U4_LSQ_busy_update (store U4_LSQ_busy U4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(U4_LSQ_op_type (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_type_update U4_LSQ_op_type))
				(U4_LSQ_op (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_op_update U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_ROB_dst_update U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_qk_update U4_LSQ_qk))
				(U4_LSQ_imm (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_imm_update U4_LSQ_imm))
				(U4_LSQ_dis (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_dis_update U4_LSQ_dis))
				(U4_LSQ_busy (ite (= U4_LSQ_entry_dispatched #b1) U4_LSQ_busy_update U4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_qj_ROB_done (select U4_ROB_done U4_RS0_qj))
				(U4_RS0_qj_ROB_result (select U4_ROB_result U4_RS0_qj))
				(U4_RS0_qk_ROB_done (select U4_ROB_done U4_RS0_qk))
				(U4_RS0_qk_ROB_result (select U4_ROB_result U4_RS0_qk))
				(U4_RS1_qj_ROB_done (select U4_ROB_done U4_RS1_qj))
				(U4_RS1_qj_ROB_result (select U4_ROB_result U4_RS1_qj))
				(U4_RS1_qk_ROB_done (select U4_ROB_done U4_RS1_qk))
				(U4_RS1_qk_ROB_result (select U4_ROB_result U4_RS1_qk))
				(U4_RS2_qj_ROB_done (select U4_ROB_done U4_RS2_qj))
				(U4_RS2_qj_ROB_result (select U4_ROB_result U4_RS2_qj))
				(U4_RS2_qk_ROB_done (select U4_ROB_done U4_RS2_qk))
				(U4_RS2_qk_ROB_result (select U4_ROB_result U4_RS2_qk))
				(U4_RS3_qj_ROB_done (select U4_ROB_done U4_RS3_qj))
				(U4_RS3_qj_ROB_result (select U4_ROB_result U4_RS3_qj))
				(U4_RS3_qk_ROB_done (select U4_ROB_done U4_RS3_qk))
				(U4_RS3_qk_ROB_result (select U4_ROB_result U4_RS3_qk))
				
				(U4_LSQ0_qj_ROB_done (select U4_ROB_done U4_LSQ0_qj))
				(U4_LSQ0_qj_ROB_result (select U4_ROB_result U4_LSQ0_qj))
				(U4_LSQ0_qk_ROB_done (select U4_ROB_done U4_LSQ0_qk))
				(U4_LSQ0_qk_ROB_result (select U4_ROB_result U4_LSQ0_qk))
				(U4_LSQ1_qj_ROB_done (select U4_ROB_done U4_LSQ1_qj))
				(U4_LSQ1_qj_ROB_result (select U4_ROB_result U4_LSQ1_qj))
				(U4_LSQ1_qk_ROB_done (select U4_ROB_done U4_LSQ1_qk))
				(U4_LSQ1_qk_ROB_result (select U4_ROB_result U4_LSQ1_qk))
				(U4_LSQ2_qj_ROB_done (select U4_ROB_done U4_LSQ2_qj))
				(U4_LSQ2_qj_ROB_result (select U4_ROB_result U4_LSQ2_qj))
				(U4_LSQ2_qk_ROB_done (select U4_ROB_done U4_LSQ2_qk))
				(U4_LSQ2_qk_ROB_result (select U4_ROB_result U4_LSQ2_qk))
				(U4_LSQ3_qj_ROB_done (select U4_ROB_done U4_LSQ3_qj))
				(U4_LSQ3_qj_ROB_result (select U4_ROB_result U4_LSQ3_qj))
				(U4_LSQ3_qk_ROB_done (select U4_ROB_done U4_LSQ3_qk))
				(U4_LSQ3_qk_ROB_result (select U4_ROB_result U4_LSQ3_qk))
			)
		(let
			(
				(U4_RS0_vj_update (store U4_RS_vj (_ bv0 2) U4_RS0_qj_ROB_result))
				(U4_RS0_vk_update (store U4_RS_vk (_ bv0 2) U4_RS0_qk_ROB_result))					
				(U4_RS0_qj_update (store U4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(U4_RS0_qk_update (store U4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_vj_update (store U4_LSQ_vj (_ bv0 2) U4_LSQ0_qj_ROB_result))	
				(U4_LSQ0_vk_update (store U4_LSQ_vk (_ bv0 2) U4_LSQ0_qk_ROB_result))	
				(U4_LSQ0_qj_update (store U4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(U4_LSQ0_qk_update (store U4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qj)) (= #b1 U4_RS0_qj_ROB_done)) U4_RS0_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS0_busy) (not (= #b000 U4_RS0_qk)) (= #b1 U4_RS0_qk_ROB_done)) U4_RS0_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qj)) (= #b1 U4_LSQ0_qj_ROB_done)) U4_LSQ0_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ0_busy) (not (= #b000 U4_LSQ0_qk)) (= #b1 U4_LSQ0_qk_ROB_done)) U4_LSQ0_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS1_vj_update (store U4_RS_vj (_ bv1 2) U4_RS1_qj_ROB_result))	
				(U4_RS1_vk_update (store U4_RS_vk (_ bv1 2) U4_RS1_qk_ROB_result))	
				(U4_RS1_qj_update (store U4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(U4_RS1_qk_update (store U4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_vj_update (store U4_LSQ_vj (_ bv1 2) U4_LSQ1_qj_ROB_result))	
				(U4_LSQ1_vk_update (store U4_LSQ_vk (_ bv1 2) U4_LSQ1_qk_ROB_result))	
				(U4_LSQ1_qj_update (store U4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(U4_LSQ1_qk_update (store U4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qj)) (= #b1 U4_RS1_qj_ROB_done)) U4_RS1_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS1_busy) (not (= #b000 U4_RS1_qk)) (= #b1 U4_RS1_qk_ROB_done)) U4_RS1_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qj)) (= #b1 U4_LSQ1_qj_ROB_done)) U4_LSQ1_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ1_busy) (not (= #b000 U4_LSQ1_qk)) (= #b1 U4_LSQ1_qk_ROB_done)) U4_LSQ1_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS2_vj_update (store U4_RS_vj (_ bv2 2) U4_RS2_qj_ROB_result))	
				(U4_RS2_vk_update (store U4_RS_vk (_ bv2 2) U4_RS2_qk_ROB_result))	
				(U4_RS2_qj_update (store U4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(U4_RS2_qk_update (store U4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_vj_update (store U4_LSQ_vj (_ bv2 2) U4_LSQ2_qj_ROB_result))	
				(U4_LSQ2_vk_update (store U4_LSQ_vk (_ bv2 2) U4_LSQ2_qk_ROB_result))	
				(U4_LSQ2_qj_update (store U4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(U4_LSQ2_qk_update (store U4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qj)) (= #b1 U4_RS2_qj_ROB_done)) U4_RS2_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS2_busy) (not (= #b000 U4_RS2_qk)) (= #b1 U4_RS2_qk_ROB_done)) U4_RS2_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qj)) (= #b1 U4_LSQ2_qj_ROB_done)) U4_LSQ2_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ2_busy) (not (= #b000 U4_LSQ2_qk)) (= #b1 U4_LSQ2_qk_ROB_done)) U4_LSQ2_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS3_vj_update (store U4_RS_vj (_ bv3 2) U4_RS3_qj_ROB_result))	
				(U4_RS3_vk_update (store U4_RS_vk (_ bv3 2) U4_RS3_qk_ROB_result))	
				(U4_RS3_qj_update (store U4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(U4_RS3_qk_update (store U4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_vj_update (store U4_LSQ_vj (_ bv3 2) U4_LSQ3_qj_ROB_result))	
				(U4_LSQ3_vk_update (store U4_LSQ_vk (_ bv3 2) U4_LSQ3_qk_ROB_result))	
				(U4_LSQ3_qj_update (store U4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(U4_LSQ3_qk_update (store U4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(U4_RS_vj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_vj_update U4_RS_vj))
				(U4_RS_vk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_vk_update U4_RS_vk))
				(U4_RS_qj (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qj)) (= #b1 U4_RS3_qj_ROB_done)) U4_RS3_qj_update U4_RS_qj))
				(U4_RS_qk (ite (and (= #b1 U4_RS3_busy) (not (= #b000 U4_RS3_qk)) (= #b1 U4_RS3_qk_ROB_done)) U4_RS3_qk_update U4_RS_qk))
				(U4_LSQ_vj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_vj_update U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_vk_update U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qj)) (= #b1 U4_LSQ3_qj_ROB_done)) U4_LSQ3_qj_update U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= #b1 U4_LSQ3_busy) (not (= #b000 U4_LSQ3_qk)) (= #b1 U4_LSQ3_qk_ROB_done)) U4_LSQ3_qk_update U4_LSQ_qk))
			)
		(let
			(
				(U4_RS0_busy (select U4_RS_busy (_ bv0 2)))
				(U4_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(U4_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(U4_RS1_busy (select U4_RS_busy (_ bv1 2)))
				(U4_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(U4_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(U4_RS2_busy (select U4_RS_busy (_ bv2 2)))
				(U4_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(U4_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(U4_RS3_busy (select U4_RS_busy (_ bv3 2)))
				(U4_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(U4_RS3_qk (select U4_RS_qk (_ bv3 2)))
				(U4_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				(U4_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(U4_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(U4_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				(U4_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(U4_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(U4_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				(U4_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(U4_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(U4_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				(U4_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(U4_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(U4_RS0_dis (ite (and (= #b1 U4_RS0_busy) (= #b000 U4_RS0_qj) (= #b000 U4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS1_dis (ite (and (= #b1 U4_RS1_busy) (= #b000 U4_RS1_qj) (= #b000 U4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS2_dis (ite (and (= #b1 U4_RS2_busy) (= #b000 U4_RS2_qj) (= #b000 U4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_RS3_dis (ite (and (= #b1 U4_RS3_busy) (= #b000 U4_RS3_qj) (= #b000 U4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(U4_LSQ0_dis (ite (and (= #b1 U4_LSQ0_busy) (= #b000 U4_LSQ0_qj) (= #b000 U4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ1_dis (ite (and (= #b1 U4_LSQ1_busy) (= #b000 U4_LSQ1_qj) (= #b000 U4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ2_dis (ite (and (= #b1 U4_LSQ2_busy) (= #b000 U4_LSQ2_qj) (= #b000 U4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(U4_LSQ3_dis (ite (and (= #b1 U4_LSQ3_busy) (= #b000 U4_LSQ3_qj) (= #b000 U4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv0 2) U4_RS0_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv0 2) U4_LSQ0_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv1 2) U4_RS1_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv1 2) U4_LSQ1_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv2 2) U4_RS2_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv2 2) U4_LSQ2_dis))
			)
		(let
			(
				(U4_RS_dis (store U4_RS_dis (_ bv3 2) U4_RS3_dis))
				(U4_LSQ_dis (store U4_LSQ_dis (_ bv3 2) U4_LSQ3_dis))
			)
		(let
			(
				(U4_RF (ite (= 0 0) U4_RF U4_RF))
				(U4_DM (ite (= 0 0) U4_DM U4_DM))
				
				(U4_Cache_Tag (ite (= 0 0) U4_Cache_Tag U4_Cache_Tag))
				(U4_Cache_Data (ite (= 0 0) U4_Cache_Data U4_Cache_Data))
				(U4_Cache_Valid (ite (= 0 0) U4_Cache_Valid U4_Cache_Valid))
				
				(U4_PC (ite (= 0 0) U4_PC U4_PC))
				
				(U4_IP (ite (= 0 0) U4_IP U4_IP))
				(U4_CP (ite (= 0 0) U4_CP U4_CP))
				
				(U4_ROB_busy (ite (= 0 0) U4_ROB_busy U4_ROB_busy))
				(U4_ROB_op_type (ite (= 0 0) U4_ROB_op_type U4_ROB_op_type))
				(U4_ROB_destination (ite (= 0 0) U4_ROB_destination U4_ROB_destination))
				(U4_ROB_result (ite (= 0 0) U4_ROB_result U4_ROB_result))
				(U4_ROB_exception (ite (= 0 0) U4_ROB_exception U4_ROB_exception))
				(U4_ROB_done (ite (= 0 0) U4_ROB_done U4_ROB_done))
				
				(U4_RS_op_type (ite (= 0 0) U4_RS_op_type U4_RS_op_type))
				(U4_RS_op (ite (= 0 0) U4_RS_op U4_RS_op))
				(U4_RS_ROB_dst (ite (= 0 0) U4_RS_ROB_dst U4_RS_ROB_dst))
				(U4_RS_vj (ite (= 0 0) U4_RS_vj U4_RS_vj))
				(U4_RS_vk (ite (= 0 0) U4_RS_vk U4_RS_vk))
				(U4_RS_qj (ite (= 0 0) U4_RS_qj U4_RS_qj))
				(U4_RS_qk (ite (= 0 0) U4_RS_qk U4_RS_qk))
				(U4_RS_imm (ite (= 0 0) U4_RS_imm U4_RS_imm))
				(U4_RS_dis (ite (= 0 0) U4_RS_dis U4_RS_dis))
				(U4_RS_busy (ite (= 0 0) U4_RS_busy U4_RS_busy))
				
				(U4_LSQ_op_type (ite (= 0 0) U4_LSQ_op_type U4_LSQ_op_type))
				(U4_LSQ_op (ite (= 0 0) U4_LSQ_op U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (= 0 0) U4_LSQ_ROB_dst U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (= 0 0) U4_LSQ_vj U4_LSQ_vj))
				(U4_LSQ_vk (ite (= 0 0) U4_LSQ_vk U4_LSQ_vk))
				(U4_LSQ_qj (ite (= 0 0) U4_LSQ_qj U4_LSQ_qj))
				(U4_LSQ_qk (ite (= 0 0) U4_LSQ_qk U4_LSQ_qk))
				(U4_LSQ_imm (ite (= 0 0) U4_LSQ_imm U4_LSQ_imm))
				(U4_LSQ_dis (ite (= 0 0) U4_LSQ_dis U4_LSQ_dis))
				(U4_LSQ_busy (ite (= 0 0) U4_LSQ_busy U4_LSQ_busy))
				
				(U4_Evict_Tag (ite (= 0 0) U4_Evict_Tag U4_Evict_Tag))
				(U4_Evict_Valid (ite (= 0 0) U4_Evict_Valid U4_Evict_Valid))
				(U4_Evict_Index (ite (= 0 0) U4_Evict_Index U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_U4_ROB_busy (select U4_ROB_busy U4_CP))
				(CP_U4_ROB_op_type (select U4_ROB_op_type U4_CP))
				(CP_U4_ROB_destination (select U4_ROB_destination U4_CP))
				(CP_U4_ROB_result (select U4_ROB_result U4_CP))
				(CP_U4_ROB_exception (select U4_ROB_exception U4_CP))
				(CP_U4_ROB_done (select U4_ROB_done U4_CP))
			)
		(let
			(
				(CP_update (bvadd U4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store U4_RF CP_U4_ROB_destination CP_U4_ROB_result))
				(DM_update (store U4_DM CP_U4_ROB_destination CP_U4_ROB_result))
				
				(U4_ROB_busy_update (store U4_ROB_busy U4_CP (_ bv0 1)))
				(U4_ROB_op_type_update (store U4_ROB_op_type U4_CP 0))
				(U4_ROB_destination_update (store U4_ROB_destination U4_CP 0))
				(U4_ROB_resulU4_update (store U4_ROB_result U4_CP 0))
				(U4_ROB_exception_update (store U4_ROB_exception U4_CP (_ bv0 1)))
				(U4_ROB_done_update (store U4_ROB_done U4_CP (_ bv0 1)))
			)
		(let
			(
				(U4_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(U4_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(U4_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(U4_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(U4_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(U4_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(U4_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(U4_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(U4_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(U4_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				(U4_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				(U4_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(U4_Cache0_Hit_Store (ite (and (= U4_Cache0_Valid #b1) (= U4_Cache0_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache1_Hit_Store (ite (and (= U4_Cache1_Valid #b1) (= U4_Cache1_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache2_Hit_Store (ite (and (= U4_Cache2_Valid #b1) (= U4_Cache2_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(U4_Cache3_Hit_Store (ite (and (= U4_Cache3_Valid #b1) (= U4_Cache3_Tag CP_U4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_U4_Cache_Line 
					(ite (= U4_Cache0_Valid #b0) (_ bv0 2)	;check if U4_Cache line 0 is free
					(ite (= U4_Cache1_Valid #b0) (_ bv1 2)	;check if U4_Cache line 1 is free
					(ite (= U4_Cache2_Valid #b0) (_ bv2 2)	;check if U4_Cache line 2 is free
					(ite (= U4_Cache3_Valid #b0) (_ bv3 2)	;check if U4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye U4_Cache line 0 
					))))
				)
				(U4_Cache_Store_Hit_Index
					(ite (= U4_Cache0_Hit_Store #b1) (_ bv0 2)		;If U4_Cache has a hit for store, then whats the line index
					(ite (= U4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= U4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= U4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(U4_Cache_Hit_Store (bvor U4_Cache0_Hit_Store U4_Cache1_Hit_Store U4_Cache2_Hit_Store U4_Cache3_Hit_Store))
			)
		(let
			(
				(U4_Cache_tag_Update_Store_Hit (store U4_Cache_Tag U4_Cache_Store_Hit_Index CP_U4_ROB_destination))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_tag_Update_Store_Miss (store U4_Cache_Tag Available_U4_Cache_Line CP_U4_ROB_destination))	
				
				(U4_Cache_data_Update_Store_Hit (store U4_Cache_Data U4_Cache_Store_Hit_Index CP_U4_ROB_result))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_data_Update_Store_Miss (store U4_Cache_Data Available_U4_Cache_Line CP_U4_ROB_result))	;if U4_Cache is a miss, update the available entry with data
				
				(U4_Cache_valid_Update_Store_Hit (store U4_Cache_Valid U4_Cache_Store_Hit_Index (_ bv1 1)))	;if U4_Cache is a hit, update the line with new data
				(U4_Cache_valid_Update_Store_Miss (store U4_Cache_Valid Available_U4_Cache_Line (_ bv1 1)))	;if U4_Cache is a miss, update the available entry with data
				
				(CP_U4_ROB_exception (ite (and (= CP_U4_ROB_op_type Branch) (= 1 CP_U4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(U4_Evict_Tag_update (store U4_Evict_Tag U4_Evict_Index U4_Cache0_Tag))
				(U4_Evict_Valid_update (store U4_Evict_Valid U4_Evict_Index U4_Cache0_Valid))
				(U4_Evict_Index_update (bvadd (_ bv1 3) U4_Evict_Index))
			)
		(let
			(
				(U4_RF (ite (and (= CP_U4_ROB_done #b1) (or (= CP_U4_ROB_op_type Rtype) (= CP_U4_ROB_op_type Mul_div) (= CP_U4_ROB_op_type Load))) RF_update U4_RF))
				(U4_DM (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) DM_update U4_DM))
				
				(U4_PC (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) CP_U4_ROB_destination U4_PC))
				(U4_IP (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) U4_IP))
				(U4_CP 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_U4_ROB_done #b1) CP_update
					U4_CP))
				)
				(U4_ROB_busy 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_busy_update
					U4_ROB_busy))
				)
				(U4_ROB_op_type 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_op_type_update
					U4_ROB_op_type))
				)
				(U4_ROB_destination 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_destination_update
					U4_ROB_destination))
				)
				(U4_ROB_result 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_U4_ROB_done #b1) U4_ROB_resulU4_update
					U4_ROB_result))
				)
				(U4_ROB_exception 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_exception_update
					U4_ROB_exception))
				)
				(U4_ROB_done 
					(ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_U4_ROB_done #b1) U4_ROB_done_update
					U4_ROB_done))
				)
				
				(U4_RS_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op_type))
				(U4_RS_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_op))
				(U4_RS_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_ROB_dst))
				(U4_RS_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vj))
				(U4_RS_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_vk))
				(U4_RS_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qj))
				(U4_RS_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_RS_qk))
				(U4_RS_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_RS_imm))
				(U4_RS_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_dis))
				(U4_RS_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_RS_busy))
				
				(U4_LSQ_op_type (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op_type))
				(U4_LSQ_op (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_op))
				(U4_LSQ_ROB_dst (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_ROB_dst))
				(U4_LSQ_vj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vj))
				(U4_LSQ_vk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_vk))
				(U4_LSQ_qj (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qj))
				(U4_LSQ_qk (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_3bit U4_LSQ_qk))
				(U4_LSQ_imm (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_int U4_LSQ_imm))
				(U4_LSQ_dis (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_dis))
				(U4_LSQ_busy (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Branch) (= CP_U4_ROB_exception #b1)) empty_RS_LSQ_1bit U4_LSQ_busy))				
				
				(U4_Cache_Tag
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_tag_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Tag
					))
				)
				(U4_Cache_Data
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_data_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Data
					))
				)
				(U4_Cache_Valid
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b0) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Miss	;If Store and U4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_U4_ROB_done #b1) (= U4_Cache_Hit_Store #b1) (= CP_U4_ROB_op_type Store)) U4_Cache_valid_Update_Store_Hit		;If Store and U4_Cache hit, update the line with new data
					U4_Cache_Valid
					))
				)
				(U4_Evict_Tag (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Tag_update U4_Evict_Tag))
				(U4_Evict_Valid (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Valid_update U4_Evict_Valid))
				(U4_Evict_Index (ite (and (= CP_U4_ROB_done #b1) (= CP_U4_ROB_op_type Store)) U4_Evict_Index_update U4_Evict_Index))
			)





;===============================================================================================



;===============================================================================================
;---------------------------Issue--------------------------------------------------------------		
		(let
			(
				(Instruction (select T_IM T_PC))
			)
		(let
			(
				(op (Inst_op Instruction))
				(op_type (Inst_op_type Instruction))
				(rs (Inst_rs Instruction))
				(rt (Inst_rt Instruction))
				(rd (Inst_rd Instruction))
				(imm (Inst_imm Instruction))
				(PC_plus_one (+ T_PC 4))
				
				(ROB1_busy (select T_ROB_busy (_ bv1 3)))
				(ROB2_busy (select T_ROB_busy (_ bv2 3)))
				(ROB3_busy (select T_ROB_busy (_ bv3 3)))
				(ROB4_busy (select T_ROB_busy (_ bv4 3)))
				
				(RS0_busy (select T_RS_busy (_ bv0 2)))
				(RS1_busy (select T_RS_busy (_ bv1 2)))
				(RS2_busy (select T_RS_busy (_ bv2 2)))
				(RS3_busy (select T_RS_busy (_ bv3 2)))
				
				(LSQ0_busy (select T_LSQ_busy (_ bv0 2)))
				(LSQ1_busy (select T_LSQ_busy (_ bv1 2)))
				(LSQ2_busy (select T_LSQ_busy (_ bv2 2)))
				(LSQ3_busy (select T_LSQ_busy (_ bv3 2)))
			)
		(let
			(
				(RF_rs (select T_RF rs))
				(RF_rt (select T_RF rt))
			)
		(let((IP_m1 (subtract T_IP)))
		(let((IP_m2 (subtract IP_m1)))
		(let((IP_m3 (subtract IP_m2)))
		(let((IP_m4 (subtract IP_m3)))
		(let
			(	
				(RAT_rs
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rs (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rs (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rs (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rs (select T_ROB_destination IP_m4))) IP_m4
					(_ bv0 3)
					))))
				)
				(RAT_rt
					(ite (and (= #b1 (select T_ROB_busy IP_m1)) (or (= Mul_div (select T_ROB_op_type IP_m1)) (= Rtype (select T_ROB_op_type IP_m1)) (= Load (select T_ROB_op_type IP_m1))) (= rt (select T_ROB_destination IP_m1))) IP_m1
					(ite (and (= #b1 (select T_ROB_busy IP_m2)) (or (= Mul_div (select T_ROB_op_type IP_m2)) (= Rtype (select T_ROB_op_type IP_m2)) (= Load (select T_ROB_op_type IP_m2))) (= rt (select T_ROB_destination IP_m2))) IP_m2
					(ite (and (= #b1 (select T_ROB_busy IP_m3)) (or (= Mul_div (select T_ROB_op_type IP_m3)) (= Rtype (select T_ROB_op_type IP_m3)) (= Load (select T_ROB_op_type IP_m3))) (= rt (select T_ROB_destination IP_m3))) IP_m3
					(ite (and (= #b1 (select T_ROB_busy IP_m4)) (or (= Mul_div (select T_ROB_op_type IP_m4)) (= Rtype (select T_ROB_op_type IP_m4)) (= Load (select T_ROB_op_type IP_m4))) (= rt (select T_ROB_destination IP_m4))) IP_m4
					(_ bv0 3)
					))))
				)
			)
		(let
			(
				(scs_stall (ite (and (= SCS #b1) (not (= #b000 T_MRB)) (= op_type Load)) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(stall
					(ite (= #b1 scs_stall) (_ bv1 1)
					(ite (= #b1 W_path_stall) (_ bv1 1)
					(ite (= #b1 (select T_ROB_busy T_IP)) (_ bv1 1)
					(ite (= #b1 (bvand ROB1_busy ROB2_busy ROB3_busy ROB4_busy)) (_ bv1 1)
					(_ bv0 1)
					))))
				)
				(RF_destination 
					(ite (= op_type Load) rt
					(ite (= op_type Rtype) rd
					(ite (= op_type Branch) imm
					0
					)))
				)
				(IP_update (bvadd T_IP (_ bv1 3)))
			)
		(let
			(
				(issue_to_rs0 (ite (and (= RS0_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq3 (ite (and (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs1 (ite (and (= issue_to_rs0 #b0) (= RS1_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq2 (ite (and (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs2 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= RS2_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq1 (ite (and (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(issue_to_rs3 (ite (and (= issue_to_rs0 #b0) (= issue_to_rs1 #b0) (= issue_to_rs2 #b0) (= RS3_busy #b0) (or (= op_type Rtype) (= op_type Branch) (= op_type Mul_div))) (_ bv1 1) (_ bv0 1)))
				(issue_to_lsq0 (ite (and (= issue_to_lsq1 #b0) (= issue_to_lsq2 #b0) (= issue_to_lsq3 #b0) (= LSQ3_busy #b0) (or (= op_type Load) (= op_type Store))) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(RS_Issue_index 
					(ite (= issue_to_rs0 #b1) (_ bv0 2)
					(ite (= issue_to_rs1 #b1) (_ bv1 2)
					(ite (= issue_to_rs2 #b1) (_ bv2 2)
					(ite (= issue_to_rs3 #b1) (_ bv3 2) (_ bv0 2)))))
				)
				(LSQ_Issue_index 
					(ite (= issue_to_lsq3 #b1) (_ bv3 2)
					(ite (= issue_to_lsq2 #b1) (_ bv2 2)
					(ite (= issue_to_lsq1 #b1) (_ bv1 2)
					(ite (= issue_to_lsq0 #b1) (_ bv0 2) (_ bv0 2)))))
				)
				(RS_issued (bvor issue_to_rs0 issue_to_rs1 issue_to_rs2 issue_to_rs3))
				(LSQ_issued (bvor issue_to_lsq3 issue_to_lsq2 issue_to_lsq1 issue_to_lsq0))
			)
		(let
			(
				(ROB_busy_update (store T_ROB_busy T_IP (_ bv1 1)))
				(ROB_op_type_update (store T_ROB_op_type T_IP op_type))
				(ROB_destination_update (store T_ROB_destination T_IP RF_destination))
				(ROB_result_update (store T_ROB_result T_IP 0))
				(ROB_exception_update (store T_ROB_exception T_IP (_ bv0 1)))
				(ROB_done_update (store T_ROB_done T_IP (_ bv0 1)))
				
				(IP_update (ite (= IP_update #b101) (_ bv1 3) IP_update))	;if IP+1= 5 then Loop back to 1
				
				(RS_op_type_update (store T_RS_op_type RS_Issue_index op_type))
				(RS_op_update (store T_RS_op RS_Issue_index op))
				(RS_ROB_dst_update (store T_RS_ROB_dst RS_Issue_index T_IP))
				(RS_vj_update (store T_RS_vj RS_Issue_index RF_rs))
				(RS_vk_update (store T_RS_vk RS_Issue_index RF_rt))
				(RS_qj_update (store T_RS_qj RS_Issue_index RAT_rs))
				(RS_qk_update (store T_RS_qk RS_Issue_index RAT_rt))
				(RS_imm_update (store T_RS_imm RS_Issue_index imm))
				(RS_dis_update (store T_RS_dis RS_Issue_index (_ bv0 1)))
				(RS_busy_update (store T_RS_busy RS_Issue_index (_ bv1 1)))
				
				(LSQ_op_type_update (store T_LSQ_op_type LSQ_Issue_index op_type))
				(LSQ_op_update (store T_LSQ_op LSQ_Issue_index op))
				(LSQ_ROB_dst_update (store T_LSQ_ROB_dst LSQ_Issue_index T_IP))
				(LSQ_vj_update (store T_LSQ_vj LSQ_Issue_index RF_rs))
				(LSQ_vk_update (store T_LSQ_vk LSQ_Issue_index RF_rt))
				(LSQ_qj_update (store T_LSQ_qj LSQ_Issue_index RAT_rs))
				(LSQ_qk_update (store T_LSQ_qk LSQ_Issue_index RAT_rt))
				(LSQ_imm_update (store T_LSQ_imm LSQ_Issue_index imm))
				(LSQ_dis_update (store T_LSQ_dis LSQ_Issue_index (_ bv0 1)))
				(LSQ_busy_update (store T_LSQ_busy LSQ_Issue_index (_ bv1 1)))
			)
		(let
			(
				
				(W1_RF (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_RF T_RF))
				(W1_DM (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_DM T_DM))
				
				(W1_Cache_Tag (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Tag T_Cache_Tag))
				(W1_Cache_Data (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Data T_Cache_Data))
				(W1_Cache_Valid (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Cache_Valid T_Cache_Valid))
				
				(W1_PC
					(ite (= op_type Jump) imm
					(ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) PC_plus_one 
					T_PC))
				)
				
				(W1_IP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) IP_update T_IP))
				(W1_CP (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_CP T_CP))
				
				(W1_ROB_busy (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_busy_update T_ROB_busy))
				(W1_ROB_op_type (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_op_type_update T_ROB_op_type))
				(W1_ROB_destination (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_destination_update T_ROB_destination))
				(W1_ROB_result (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_result_update T_ROB_result))
				(W1_ROB_exception (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_exception_update T_ROB_exception))
				(W1_ROB_done (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) ROB_done_update T_ROB_done))
				
				(W1_RS_op_type (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_type_update T_RS_op_type))
				(W1_RS_op (ite (and (= stall #b0) (= RS_issued #b1)) RS_op_update T_RS_op))
				(W1_RS_ROB_dst (ite (and (= stall #b0) (= RS_issued #b1)) RS_ROB_dst_update T_RS_ROB_dst))
				(W1_RS_vj (ite (and (= stall #b0) (= RS_issued #b1)) RS_vj_update T_RS_vj))
				(W1_RS_vk (ite (and (= stall #b0) (= RS_issued #b1)) RS_vk_update T_RS_vk))
				(W1_RS_qj (ite (and (= stall #b0) (= RS_issued #b1)) RS_qj_update T_RS_qj))
				(W1_RS_qk (ite (and (= stall #b0) (= RS_issued #b1)) RS_qk_update T_RS_qk))
				(W1_RS_imm (ite (and (= stall #b0) (= RS_issued #b1)) RS_imm_update T_RS_imm))
				(W1_RS_dis (ite (and (= stall #b0) (= RS_issued #b1)) RS_dis_update T_RS_dis))
				(W1_RS_busy (ite (and (= stall #b0) (= RS_issued #b1)) RS_busy_update T_RS_busy))
				
				(W1_LSQ_op_type (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_type_update T_LSQ_op_type))
				(W1_LSQ_op (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_op_update T_LSQ_op))
				(W1_LSQ_ROB_dst (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_ROB_dst_update T_LSQ_ROB_dst))
				(W1_LSQ_vj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vj_update T_LSQ_vj))
				(W1_LSQ_vk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_vk_update T_LSQ_vk))
				(W1_LSQ_qj (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qj_update T_LSQ_qj))
				(W1_LSQ_qk (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_qk_update T_LSQ_qk))
				(W1_LSQ_imm (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_imm_update T_LSQ_imm))
				(W1_LSQ_dis (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_dis_update T_LSQ_dis))
				(W1_LSQ_busy (ite (and (= stall #b0) (= LSQ_issued #b1)) LSQ_busy_update T_LSQ_busy))
			
				(W1_Evict_Tag (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Tag T_Evict_Tag))
				(W1_Evict_Valid (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Valid T_Evict_Valid))
				(W1_Evict_Index (ite (and (= stall #b0) (or (= RS_issued #b1) (= LSQ_issued #b1))) T_Evict_Index T_Evict_Index))
			)
;---------------------------Update--------------------------------------------------------------	
		(let
			(
				(W1_RS0_busy (select W1_RS_busy (_ bv0 2)))
				(W1_RS0_qj (select W1_RS_qj (_ bv0 2)))
				(W1_RS0_qk (select W1_RS_qk (_ bv0 2)))
				(W1_RS1_busy (select W1_RS_busy (_ bv1 2)))
				(W1_RS1_qj (select W1_RS_qj (_ bv1 2)))
				(W1_RS1_qk (select W1_RS_qk (_ bv1 2)))
				(W1_RS2_busy (select W1_RS_busy (_ bv2 2)))
				(W1_RS2_qj (select W1_RS_qj (_ bv2 2)))
				(W1_RS2_qk (select W1_RS_qk (_ bv2 2)))
				(W1_RS3_busy (select W1_RS_busy (_ bv3 2)))
				(W1_RS3_qj (select W1_RS_qj (_ bv3 2)))
				(W1_RS3_qk (select W1_RS_qk (_ bv3 2)))
				
				(W1_LSQ0_busy (select W1_LSQ_busy (_ bv0 2)))
				(W1_LSQ0_qj (select W1_LSQ_qj (_ bv0 2)))
				(W1_LSQ0_qk (select W1_LSQ_qk (_ bv0 2)))
				(W1_LSQ1_busy (select W1_LSQ_busy (_ bv1 2)))
				(W1_LSQ1_qj (select W1_LSQ_qj (_ bv1 2)))
				(W1_LSQ1_qk (select W1_LSQ_qk (_ bv1 2)))
				(W1_LSQ2_busy (select W1_LSQ_busy (_ bv2 2)))
				(W1_LSQ2_qj (select W1_LSQ_qj (_ bv2 2)))
				(W1_LSQ2_qk (select W1_LSQ_qk (_ bv2 2)))
				(W1_LSQ3_busy (select W1_LSQ_busy (_ bv3 2)))
				(W1_LSQ3_qj (select W1_LSQ_qj (_ bv3 2)))
				(W1_LSQ3_qk (select W1_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W1_RS0_qj_ROB_done (select W1_ROB_done W1_RS0_qj))
				(W1_RS0_qj_ROB_result (select W1_ROB_result W1_RS0_qj))
				(W1_RS0_qk_ROB_done (select W1_ROB_done W1_RS0_qk))
				(W1_RS0_qk_ROB_result (select W1_ROB_result W1_RS0_qk))
				(W1_RS1_qj_ROB_done (select W1_ROB_done W1_RS1_qj))
				(W1_RS1_qj_ROB_result (select W1_ROB_result W1_RS1_qj))
				(W1_RS1_qk_ROB_done (select W1_ROB_done W1_RS1_qk))
				(W1_RS1_qk_ROB_result (select W1_ROB_result W1_RS1_qk))
				(W1_RS2_qj_ROB_done (select W1_ROB_done W1_RS2_qj))
				(W1_RS2_qj_ROB_result (select W1_ROB_result W1_RS2_qj))
				(W1_RS2_qk_ROB_done (select W1_ROB_done W1_RS2_qk))
				(W1_RS2_qk_ROB_result (select W1_ROB_result W1_RS2_qk))
				(W1_RS3_qj_ROB_done (select W1_ROB_done W1_RS3_qj))
				(W1_RS3_qj_ROB_result (select W1_ROB_result W1_RS3_qj))
				(W1_RS3_qk_ROB_done (select W1_ROB_done W1_RS3_qk))
				(W1_RS3_qk_ROB_result (select W1_ROB_result W1_RS3_qk))
				
				(W1_LSQ0_qj_ROB_done (select W1_ROB_done W1_LSQ0_qj))
				(W1_LSQ0_qj_ROB_result (select W1_ROB_result W1_LSQ0_qj))
				(W1_LSQ0_qk_ROB_done (select W1_ROB_done W1_LSQ0_qk))
				(W1_LSQ0_qk_ROB_result (select W1_ROB_result W1_LSQ0_qk))
				(W1_LSQ1_qj_ROB_done (select W1_ROB_done W1_LSQ1_qj))
				(W1_LSQ1_qj_ROB_result (select W1_ROB_result W1_LSQ1_qj))
				(W1_LSQ1_qk_ROB_done (select W1_ROB_done W1_LSQ1_qk))
				(W1_LSQ1_qk_ROB_result (select W1_ROB_result W1_LSQ1_qk))
				(W1_LSQ2_qj_ROB_done (select W1_ROB_done W1_LSQ2_qj))
				(W1_LSQ2_qj_ROB_result (select W1_ROB_result W1_LSQ2_qj))
				(W1_LSQ2_qk_ROB_done (select W1_ROB_done W1_LSQ2_qk))
				(W1_LSQ2_qk_ROB_result (select W1_ROB_result W1_LSQ2_qk))
				(W1_LSQ3_qj_ROB_done (select W1_ROB_done W1_LSQ3_qj))
				(W1_LSQ3_qj_ROB_result (select W1_ROB_result W1_LSQ3_qj))
				(W1_LSQ3_qk_ROB_done (select W1_ROB_done W1_LSQ3_qk))
				(W1_LSQ3_qk_ROB_result (select W1_ROB_result W1_LSQ3_qk))
			)
		(let
			(
				(W1_RS0_vj_update (store W1_RS_vj (_ bv0 2) W1_RS0_qj_ROB_result))
				(W1_RS0_vk_update (store W1_RS_vk (_ bv0 2) W1_RS0_qk_ROB_result))					
				(W1_RS0_qj_update (store W1_RS_qj (_ bv0 2) (_ bv0 3)))	
				(W1_RS0_qk_update (store W1_RS_qk (_ bv0 2) (_ bv0 3)))	
				(W1_LSQ0_vj_update (store W1_LSQ_vj (_ bv0 2) W1_LSQ0_qj_ROB_result))	
				(W1_LSQ0_vk_update (store W1_LSQ_vk (_ bv0 2) W1_LSQ0_qk_ROB_result))	
				(W1_LSQ0_qj_update (store W1_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(W1_LSQ0_qk_update (store W1_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(W2_RS_vj (ite (and (= #b1 W1_RS0_busy) (not (= #b000 W1_RS0_qj)) (= #b1 W1_RS0_qj_ROB_done)) W1_RS0_vj_update W1_RS_vj))
				(W2_RS_vk (ite (and (= #b1 W1_RS0_busy) (not (= #b000 W1_RS0_qk)) (= #b1 W1_RS0_qk_ROB_done)) W1_RS0_vk_update W1_RS_vk))
				(W2_RS_qj (ite (and (= #b1 W1_RS0_busy) (not (= #b000 W1_RS0_qj)) (= #b1 W1_RS0_qj_ROB_done)) W1_RS0_qj_update W1_RS_qj))
				(W2_RS_qk (ite (and (= #b1 W1_RS0_busy) (not (= #b000 W1_RS0_qk)) (= #b1 W1_RS0_qk_ROB_done)) W1_RS0_qk_update W1_RS_qk))
				(W2_LSQ_vj (ite (and (= #b1 W1_LSQ0_busy) (not (= #b000 W1_LSQ0_qj)) (= #b1 W1_LSQ0_qj_ROB_done)) W1_LSQ0_vj_update W1_LSQ_vj))
				(W2_LSQ_vk (ite (and (= #b1 W1_LSQ0_busy) (not (= #b000 W1_LSQ0_qk)) (= #b1 W1_LSQ0_qk_ROB_done)) W1_LSQ0_vk_update W1_LSQ_vk))
				(W2_LSQ_qj (ite (and (= #b1 W1_LSQ0_busy) (not (= #b000 W1_LSQ0_qj)) (= #b1 W1_LSQ0_qj_ROB_done)) W1_LSQ0_qj_update W1_LSQ_qj))
				(W2_LSQ_qk (ite (and (= #b1 W1_LSQ0_busy) (not (= #b000 W1_LSQ0_qk)) (= #b1 W1_LSQ0_qk_ROB_done)) W1_LSQ0_qk_update W1_LSQ_qk))
			)
		(let
			(
				(W1_RS1_vj_update (store W2_RS_vj (_ bv1 2) W1_RS1_qj_ROB_result))	
				(W1_RS1_vk_update (store W2_RS_vk (_ bv1 2) W1_RS1_qk_ROB_result))	
				(W1_RS1_qj_update (store W2_RS_qj (_ bv1 2) (_ bv0 3)))	
				(W1_RS1_qk_update (store W2_RS_qk (_ bv1 2) (_ bv0 3)))	
				(W1_LSQ1_vj_update (store W2_LSQ_vj (_ bv1 2) W1_LSQ1_qj_ROB_result))	
				(W1_LSQ1_vk_update (store W2_LSQ_vk (_ bv1 2) W1_LSQ1_qk_ROB_result))	
				(W1_LSQ1_qj_update (store W2_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(W1_LSQ1_qk_update (store W2_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(W2_RS_vj (ite (and (= #b1 W1_RS1_busy) (not (= #b000 W1_RS1_qj)) (= #b1 W1_RS1_qj_ROB_done)) W1_RS1_vj_update W2_RS_vj))
				(W2_RS_vk (ite (and (= #b1 W1_RS1_busy) (not (= #b000 W1_RS1_qk)) (= #b1 W1_RS1_qk_ROB_done)) W1_RS1_vk_update W2_RS_vk))
				(W2_RS_qj (ite (and (= #b1 W1_RS1_busy) (not (= #b000 W1_RS1_qj)) (= #b1 W1_RS1_qj_ROB_done)) W1_RS1_qj_update W2_RS_qj))
				(W2_RS_qk (ite (and (= #b1 W1_RS1_busy) (not (= #b000 W1_RS1_qk)) (= #b1 W1_RS1_qk_ROB_done)) W1_RS1_qk_update W2_RS_qk))
				(W2_LSQ_vj (ite (and (= #b1 W1_LSQ1_busy) (not (= #b000 W1_LSQ1_qj)) (= #b1 W1_LSQ1_qj_ROB_done)) W1_LSQ1_vj_update W2_LSQ_vj))
				(W2_LSQ_vk (ite (and (= #b1 W1_LSQ1_busy) (not (= #b000 W1_LSQ1_qk)) (= #b1 W1_LSQ1_qk_ROB_done)) W1_LSQ1_vk_update W2_LSQ_vk))
				(W2_LSQ_qj (ite (and (= #b1 W1_LSQ1_busy) (not (= #b000 W1_LSQ1_qj)) (= #b1 W1_LSQ1_qj_ROB_done)) W1_LSQ1_qj_update W2_LSQ_qj))
				(W2_LSQ_qk (ite (and (= #b1 W1_LSQ1_busy) (not (= #b000 W1_LSQ1_qk)) (= #b1 W1_LSQ1_qk_ROB_done)) W1_LSQ1_qk_update W2_LSQ_qk))
			)
		(let
			(
				(W1_RS2_vj_update (store W2_RS_vj (_ bv2 2) W1_RS2_qj_ROB_result))	
				(W1_RS2_vk_update (store W2_RS_vk (_ bv2 2) W1_RS2_qk_ROB_result))	
				(W1_RS2_qj_update (store W2_RS_qj (_ bv2 2) (_ bv0 3)))	
				(W1_RS2_qk_update (store W2_RS_qk (_ bv2 2) (_ bv0 3)))	
				(W1_LSQ2_vj_update (store W2_LSQ_vj (_ bv2 2) W1_LSQ2_qj_ROB_result))	
				(W1_LSQ2_vk_update (store W2_LSQ_vk (_ bv2 2) W1_LSQ2_qk_ROB_result))	
				(W1_LSQ2_qj_update (store W2_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(W1_LSQ2_qk_update (store W2_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(W2_RS_vj (ite (and (= #b1 W1_RS2_busy) (not (= #b000 W1_RS2_qj)) (= #b1 W1_RS2_qj_ROB_done)) W1_RS2_vj_update W2_RS_vj))
				(W2_RS_vk (ite (and (= #b1 W1_RS2_busy) (not (= #b000 W1_RS2_qk)) (= #b1 W1_RS2_qk_ROB_done)) W1_RS2_vk_update W2_RS_vk))
				(W2_RS_qj (ite (and (= #b1 W1_RS2_busy) (not (= #b000 W1_RS2_qj)) (= #b1 W1_RS2_qj_ROB_done)) W1_RS2_qj_update W2_RS_qj))
				(W2_RS_qk (ite (and (= #b1 W1_RS2_busy) (not (= #b000 W1_RS2_qk)) (= #b1 W1_RS2_qk_ROB_done)) W1_RS2_qk_update W2_RS_qk))
				(W2_LSQ_vj (ite (and (= #b1 W1_LSQ2_busy) (not (= #b000 W1_LSQ2_qj)) (= #b1 W1_LSQ2_qj_ROB_done)) W1_LSQ2_vj_update W2_LSQ_vj))
				(W2_LSQ_vk (ite (and (= #b1 W1_LSQ2_busy) (not (= #b000 W1_LSQ2_qk)) (= #b1 W1_LSQ2_qk_ROB_done)) W1_LSQ2_vk_update W2_LSQ_vk))
				(W2_LSQ_qj (ite (and (= #b1 W1_LSQ2_busy) (not (= #b000 W1_LSQ2_qj)) (= #b1 W1_LSQ2_qj_ROB_done)) W1_LSQ2_qj_update W2_LSQ_qj))
				(W2_LSQ_qk (ite (and (= #b1 W1_LSQ2_busy) (not (= #b000 W1_LSQ2_qk)) (= #b1 W1_LSQ2_qk_ROB_done)) W1_LSQ2_qk_update W2_LSQ_qk))
			)
		(let
			(
				(W1_RS3_vj_update (store W2_RS_vj (_ bv3 2) W1_RS3_qj_ROB_result))	
				(W1_RS3_vk_update (store W2_RS_vk (_ bv3 2) W1_RS3_qk_ROB_result))	
				(W1_RS3_qj_update (store W2_RS_qj (_ bv3 2) (_ bv0 3)))	
				(W1_RS3_qk_update (store W2_RS_qk (_ bv3 2) (_ bv0 3)))	
				(W1_LSQ3_vj_update (store W2_LSQ_vj (_ bv3 2) W1_LSQ3_qj_ROB_result))	
				(W1_LSQ3_vk_update (store W2_LSQ_vk (_ bv3 2) W1_LSQ3_qk_ROB_result))	
				(W1_LSQ3_qj_update (store W2_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(W1_LSQ3_qk_update (store W2_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(W2_RS_vj (ite (and (= #b1 W1_RS3_busy) (not (= #b000 W1_RS3_qj)) (= #b1 W1_RS3_qj_ROB_done)) W1_RS3_vj_update W2_RS_vj))
				(W2_RS_vk (ite (and (= #b1 W1_RS3_busy) (not (= #b000 W1_RS3_qk)) (= #b1 W1_RS3_qk_ROB_done)) W1_RS3_vk_update W2_RS_vk))
				(W2_RS_qj (ite (and (= #b1 W1_RS3_busy) (not (= #b000 W1_RS3_qj)) (= #b1 W1_RS3_qj_ROB_done)) W1_RS3_qj_update W2_RS_qj))
				(W2_RS_qk (ite (and (= #b1 W1_RS3_busy) (not (= #b000 W1_RS3_qk)) (= #b1 W1_RS3_qk_ROB_done)) W1_RS3_qk_update W2_RS_qk))
				(W2_LSQ_vj (ite (and (= #b1 W1_LSQ3_busy) (not (= #b000 W1_LSQ3_qj)) (= #b1 W1_LSQ3_qj_ROB_done)) W1_LSQ3_vj_update W2_LSQ_vj))
				(W2_LSQ_vk (ite (and (= #b1 W1_LSQ3_busy) (not (= #b000 W1_LSQ3_qk)) (= #b1 W1_LSQ3_qk_ROB_done)) W1_LSQ3_vk_update W2_LSQ_vk))
				(W2_LSQ_qj (ite (and (= #b1 W1_LSQ3_busy) (not (= #b000 W1_LSQ3_qj)) (= #b1 W1_LSQ3_qj_ROB_done)) W1_LSQ3_qj_update W2_LSQ_qj))
				(W2_LSQ_qk (ite (and (= #b1 W1_LSQ3_busy) (not (= #b000 W1_LSQ3_qk)) (= #b1 W1_LSQ3_qk_ROB_done)) W1_LSQ3_qk_update W2_LSQ_qk))
			)
		(let
			(
				(W2_RS0_busy (select W1_RS_busy (_ bv0 2)))
				(W2_RS0_qj (select W2_RS_qj (_ bv0 2)))
				(W2_RS0_qk (select W2_RS_qk (_ bv0 2)))
				(W2_RS1_busy (select W1_RS_busy (_ bv1 2)))
				(W2_RS1_qj (select W2_RS_qj (_ bv1 2)))
				(W2_RS1_qk (select W2_RS_qk (_ bv1 2)))
				(W2_RS2_busy (select W1_RS_busy (_ bv2 2)))
				(W2_RS2_qj (select W2_RS_qj (_ bv2 2)))
				(W2_RS2_qk (select W2_RS_qk (_ bv2 2)))
				(W2_RS3_busy (select W1_RS_busy (_ bv3 2)))
				(W2_RS3_qj (select W2_RS_qj (_ bv3 2)))
				(W2_RS3_qk (select W2_RS_qk (_ bv3 2)))
				(W2_LSQ0_busy (select W1_LSQ_busy (_ bv0 2)))
				(W2_LSQ0_qj (select W2_LSQ_qj (_ bv0 2)))
				(W2_LSQ0_qk (select W2_LSQ_qk (_ bv0 2)))
				(W2_LSQ1_busy (select W1_LSQ_busy (_ bv1 2)))
				(W2_LSQ1_qj (select W2_LSQ_qj (_ bv1 2)))
				(W2_LSQ1_qk (select W2_LSQ_qk (_ bv1 2)))
				(W2_LSQ2_busy (select W1_LSQ_busy (_ bv2 2)))
				(W2_LSQ2_qj (select W2_LSQ_qj (_ bv2 2)))
				(W2_LSQ2_qk (select W2_LSQ_qk (_ bv2 2)))
				(W2_LSQ3_busy (select W1_LSQ_busy (_ bv3 2)))
				(W2_LSQ3_qj (select W2_LSQ_qj (_ bv3 2)))
				(W2_LSQ3_qk (select W2_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W2_RS0_dis (ite (and (= #b1 W2_RS0_busy) (= #b000 W2_RS0_qj) (= #b000 W2_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_RS1_dis (ite (and (= #b1 W2_RS1_busy) (= #b000 W2_RS1_qj) (= #b000 W2_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_RS2_dis (ite (and (= #b1 W2_RS2_busy) (= #b000 W2_RS2_qj) (= #b000 W2_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_RS3_dis (ite (and (= #b1 W2_RS3_busy) (= #b000 W2_RS3_qj) (= #b000 W2_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(W2_LSQ0_dis (ite (and (= #b1 W2_LSQ0_busy) (= #b000 W2_LSQ0_qj) (= #b000 W2_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_LSQ1_dis (ite (and (= #b1 W2_LSQ1_busy) (= #b000 W2_LSQ1_qj) (= #b000 W2_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_LSQ2_dis (ite (and (= #b1 W2_LSQ2_busy) (= #b000 W2_LSQ2_qj) (= #b000 W2_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(W2_LSQ3_dis (ite (and (= #b1 W2_LSQ3_busy) (= #b000 W2_LSQ3_qj) (= #b000 W2_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(W2_RS_dis (store W1_RS_dis (_ bv0 2) W2_RS0_dis))
				(W2_LSQ_dis (store W1_LSQ_dis (_ bv0 2) W2_LSQ0_dis))
			)
		(let
			(
				(W2_RS_dis (store W2_RS_dis (_ bv1 2) W2_RS1_dis))
				(W2_LSQ_dis (store W2_LSQ_dis (_ bv1 2) W2_LSQ1_dis))
			)
		(let
			(
				(W2_RS_dis (store W2_RS_dis (_ bv2 2) W2_RS2_dis))
				(W2_LSQ_dis (store W2_LSQ_dis (_ bv2 2) W2_LSQ2_dis))
			)
		(let
			(
				(W2_RS_dis (store W2_RS_dis (_ bv3 2) W2_RS3_dis))
				(W2_LSQ_dis (store W2_LSQ_dis (_ bv3 2) W2_LSQ3_dis))
			)
		(let
			(
				(W2_RF (ite (= 0 0) W1_RF W1_RF))
				(W2_DM (ite (= 0 0) W1_DM W1_DM))
				
				(W2_Cache_Tag (ite (= 0 0) W1_Cache_Tag W1_Cache_Tag))
				(W2_Cache_Data (ite (= 0 0) W1_Cache_Data W1_Cache_Data))
				(W2_Cache_Valid (ite (= 0 0) W1_Cache_Valid W1_Cache_Valid))
				
				(W2_PC (ite (= 0 0) W1_PC W1_PC))
				
				(W2_IP (ite (= 0 0) W1_IP W1_IP))
				(W2_CP (ite (= 0 0) W1_CP W1_CP))
				
				(W2_ROB_busy (ite (= 0 0) W1_ROB_busy W1_ROB_busy))
				(W2_ROB_op_type (ite (= 0 0) W1_ROB_op_type W1_ROB_op_type))
				(W2_ROB_destination (ite (= 0 0) W1_ROB_destination W1_ROB_destination))
				(W2_ROB_result (ite (= 0 0) W1_ROB_result W1_ROB_result))
				(W2_ROB_exception (ite (= 0 0) W1_ROB_exception W1_ROB_exception))
				(W2_ROB_done (ite (= 0 0) W1_ROB_done W1_ROB_done))
				
				(W2_RS_op_type (ite (= 0 0) W1_RS_op_type W1_RS_op_type))
				(W2_RS_op (ite (= 0 0) W1_RS_op W1_RS_op))
				(W2_RS_ROB_dst (ite (= 0 0) W1_RS_ROB_dst W1_RS_ROB_dst))
				(W2_RS_vj (ite (= 0 0) W2_RS_vj W2_RS_vj))
				(W2_RS_vk (ite (= 0 0) W2_RS_vk W2_RS_vk))
				(W2_RS_qj (ite (= 0 0) W2_RS_qj W2_RS_qj))
				(W2_RS_qk (ite (= 0 0) W2_RS_qk W2_RS_qk))
				(W2_RS_imm (ite (= 0 0) W1_RS_imm W1_RS_imm))
				(W2_RS_dis (ite (= 0 0) W2_RS_dis W2_RS_dis))
				(W2_RS_busy (ite (= 0 0) W1_RS_busy W1_RS_busy))
				
				(W2_LSQ_op_type (ite (= 0 0) W1_LSQ_op_type W1_LSQ_op_type))
				(W2_LSQ_op (ite (= 0 0) W1_LSQ_op W1_LSQ_op))
				(W2_LSQ_ROB_dst (ite (= 0 0) W1_LSQ_ROB_dst W1_LSQ_ROB_dst))
				(W2_LSQ_vj (ite (= 0 0) W2_LSQ_vj W2_LSQ_vj))
				(W2_LSQ_vk (ite (= 0 0) W2_LSQ_vk W2_LSQ_vk))
				(W2_LSQ_qj (ite (= 0 0) W2_LSQ_qj W2_LSQ_qj))
				(W2_LSQ_qk (ite (= 0 0) W2_LSQ_qk W2_LSQ_qk))
				(W2_LSQ_imm (ite (= 0 0) W1_LSQ_imm W1_LSQ_imm))
				(W2_LSQ_dis (ite (= 0 0) W2_LSQ_dis W2_LSQ_dis))
				(W2_LSQ_busy (ite (= 0 0) W1_LSQ_busy W1_LSQ_busy))
				
				(W2_Evict_Tag (ite (= 0 0) W1_Evict_Tag W1_Evict_Tag))
				(W2_Evict_Valid (ite (= 0 0) W1_Evict_Valid W1_Evict_Valid))
				(W2_Evict_Index (ite (= 0 0) W1_Evict_Index W1_Evict_Index))
			)
			
;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(W2_RS0_dis (select W2_RS_dis (_ bv0 2)))
				(W2_RS1_dis (select W2_RS_dis (_ bv1 2)))
				(W2_RS2_dis (select W2_RS_dis (_ bv2 2)))
				(W2_RS3_dis (select W2_RS_dis (_ bv3 2)))
			)
		(let
			(
				(W2_RS_dis_index
					(ite (= W2_RS0_dis #b1) (_ bv0 2)
					(ite (= W2_RS1_dis #b1) (_ bv1 2)
					(ite (= W2_RS2_dis #b1) (_ bv2 2)
					(ite (= W2_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W2_RS_entry_dispatched (bvor W2_RS0_dis W2_RS1_dis W2_RS2_dis W2_RS3_dis))
			)	
		(let
			(
				(W2_RS_dis_vj (select W2_RS_vj W2_RS_dis_index))
				(W2_RS_dis_vk (select W2_RS_vk W2_RS_dis_index))
				(W2_RS_dis_qj (select W2_RS_qj W2_RS_dis_index))
				(W2_RS_dis_qk (select W2_RS_qk W2_RS_dis_index))
				(W2_RS_dis_op (select W2_RS_op W2_RS_dis_index))
				(W2_RS_dis_op_type (select W2_RS_op_type W2_RS_dis_index))
				(W2_RS_dis_imm (select W2_RS_imm W2_RS_dis_index))
				(W2_RS_dis_ROB_dst (select W2_RS_ROB_dst W2_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR W2_RS_dis_vj W2_RS_dis_vk W2_RS_dis_imm W2_RS_dis_op))
				(ALW1_result (ALU1 W2_RS_dis_vj W2_RS_dis_vk W2_RS_dis_imm W2_RS_dis_op))
				(MUL_DIV_result (MUL_DIV W2_RS_dis_vj W2_RS_dis_vk W2_RS_dis_imm W2_RS_dis_op))
			)
		(let
			(
				(W2_RS_result
					(ite (= W2_RS_dis_op_type Rtype) ALW1_result
					(ite (= W2_RS_dis_op_type Branch) Branch_result
					(ite (= W2_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(W2_ROB_result_update (store W2_ROB_result W2_RS_dis_ROB_dst W2_RS_result))
				(W2_ROB_done_update (store W2_ROB_done W2_RS_dis_ROB_dst (_ bv1 1)))
				(W2_ROB_exception_update (store W2_ROB_exception W2_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(W3_ROB_result (ite (= W2_RS_entry_dispatched #b1) W2_ROB_result_update W2_ROB_result))
				(W3_ROB_done (ite (= W2_RS_entry_dispatched #b1) W2_ROB_done_update W2_ROB_done))
				(W3_ROB_exception (ite (and (= W2_RS_dis_op_type Branch) (= W2_RS_result 1) (= W2_RS_entry_dispatched #b1)) W2_ROB_exception_update W2_ROB_exception))
			)
		(let
			(
				(W2_RS_op_type_update (store W2_RS_op_type W2_RS_dis_index 0))
				(W2_RS_op_update (store W2_RS_op W2_RS_dis_index 0))
				(W2_RS_ROB_dst_update (store W2_RS_ROB_dst W2_RS_dis_index (_ bv0 3)))
				(W2_RS_vj_update (store W2_RS_vj W2_RS_dis_index 0))
				(W2_RS_vk_update (store W2_RS_vk W2_RS_dis_index 0))
				(W2_RS_qj_update (store W2_RS_qj W2_RS_dis_index (_ bv0 3)))
				(W2_RS_qk_update (store W2_RS_qk W2_RS_dis_index (_ bv0 3)))
				(W2_RS_imm_update (store W2_RS_imm W2_RS_dis_index 0))
				(W2_RS_dis_update (store W2_RS_dis W2_RS_dis_index (_ bv0 1)))
				(W2_RS_busy_update (store W2_RS_busy W2_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(W3_RS_op_type (ite (= W2_RS_entry_dispatched #b1) W2_RS_op_type_update W2_RS_op_type))
				(W3_RS_op (ite (= W2_RS_entry_dispatched #b1) W2_RS_op_update W2_RS_op))
				(W3_RS_ROB_dst (ite (= W2_RS_entry_dispatched #b1) W2_RS_ROB_dst_update W2_RS_ROB_dst))
				(W3_RS_vj (ite (= W2_RS_entry_dispatched #b1) W2_RS_vj_update W2_RS_vj))
				(W3_RS_vk (ite (= W2_RS_entry_dispatched #b1) W2_RS_vk_update W2_RS_vk))
				(W3_RS_qj (ite (= W2_RS_entry_dispatched #b1) W2_RS_qj_update W2_RS_qj))
				(W3_RS_qk (ite (= W2_RS_entry_dispatched #b1) W2_RS_qk_update W2_RS_qk))
				(W3_RS_imm (ite (= W2_RS_entry_dispatched #b1) W2_RS_imm_update W2_RS_imm))
				(W3_RS_dis (ite (= W2_RS_entry_dispatched #b1) W2_RS_dis_update W2_RS_dis))
				(W3_RS_busy (ite (= W2_RS_entry_dispatched #b1) W2_RS_busy_update W2_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(W2_LSQ0_dis (select W2_LSQ_dis (_ bv0 2)))
				(W2_LSQ1_dis (select W2_LSQ_dis (_ bv1 2)))
				(W2_LSQ2_dis (select W2_LSQ_dis (_ bv2 2)))
				(W2_LSQ3_dis (select W2_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(W2_LSQ_dis_index
					(ite (= W2_LSQ0_dis #b1) (_ bv0 2)
					(ite (= W2_LSQ1_dis #b1) (_ bv1 2)
					(ite (= W2_LSQ2_dis #b1) (_ bv2 2)
					(ite (= W2_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W2_LSQ_entry_dispatched (bvor W2_LSQ0_dis W2_LSQ1_dis W2_LSQ2_dis W2_LSQ3_dis))
			)	
		(let
			(
				(W2_LSQ_dis_vj (select W2_LSQ_vj W2_LSQ_dis_index))
				(W2_LSQ_dis_vk (select W2_LSQ_vk W2_LSQ_dis_index))
				(W2_LSQ_dis_qj (select W2_LSQ_qj W2_LSQ_dis_index))
				(W2_LSQ_dis_qk (select W2_LSQ_qk W2_LSQ_dis_index))
				(W2_LSQ_dis_op (select W2_LSQ_op W2_LSQ_dis_index))
				(W2_LSQ_dis_op_type (select W2_LSQ_op_type W2_LSQ_dis_index))
				(W2_LSQ_dis_imm (select W2_LSQ_imm W2_LSQ_dis_index))
				(W2_LSQ_dis_ROB_dst (select W2_LSQ_ROB_dst W2_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit W2_LSQ_dis_vj W2_LSQ_dis_imm W2_LSQ_dis_op))
				(Store_address (STORE_Unit W2_LSQ_dis_vj W2_LSQ_dis_imm W2_LSQ_dis_op))
			)
		(let
			(
				(W2_Cache0_Tag (select W2_Cache_Tag (_ bv0 2)))
				(W2_Cache0_Data (select W2_Cache_Data (_ bv0 2)))
				(W2_Cache0_Valid (select W2_Cache_Valid (_ bv0 2)))
				(W2_Cache1_Tag (select W2_Cache_Tag (_ bv1 2)))
				(W2_Cache1_Data (select W2_Cache_Data (_ bv1 2)))
				(W2_Cache1_Valid (select W2_Cache_Valid (_ bv1 2)))
				(W2_Cache2_Tag (select W2_Cache_Tag (_ bv2 2)))
				(W2_Cache2_Data (select W2_Cache_Data (_ bv2 2)))
				(W2_Cache2_Valid (select W2_Cache_Valid (_ bv2 2)))
				(W2_Cache3_Tag (select W2_Cache_Tag (_ bv3 2)))
				(W2_Cache3_Data (select W2_Cache_Data (_ bv3 2)))
				(W2_Cache3_Valid (select W2_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select W2_DM LOAD_addr))
				(W2_Cache0_Hit_Load (ite (and (= W2_Cache0_Valid #b1) (= W2_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W2_Cache1_Hit_Load (ite (and (= W2_Cache1_Valid #b1) (= W2_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W2_Cache2_Hit_Load (ite (and (= W2_Cache2_Valid #b1) (= W2_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W2_Cache3_Hit_Load (ite (and (= W2_Cache3_Valid #b1) (= W2_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_W2_Cache_Line 
					(ite (= W2_Cache0_Valid #b0) (_ bv0 2)	;check if W2_Cache line 0 is free
					(ite (= W2_Cache1_Valid #b0) (_ bv1 2)	;check if W2_Cache line 1 is free
					(ite (= W2_Cache2_Valid #b0) (_ bv2 2)	;check if W2_Cache line 2 is free
					(ite (= W2_Cache3_Valid #b0) (_ bv3 2)	;check if W2_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W2_Cache line 0 
					))))
				)
			)
		(let
			(
				(W2_Cache_Hit_load (bvor W2_Cache0_Hit_Load W2_Cache1_Hit_Load W2_Cache2_Hit_Load W2_Cache3_Hit_Load))
			)
		(let
			(
				(W2_LSQ_result
					(ite (= W2_LSQ_dis_op_type Load) LOAD_Value
					(ite (= W2_LSQ_dis_op_type Store) W2_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(W2_ROB_destination_update (store W2_ROB_destination W2_LSQ_dis_ROB_dst Store_address))
				(W2_ROB_result_load (store W3_ROB_result W2_LSQ_dis_ROB_dst LOAD_Value))
				(W2_ROB_result_store (store W3_ROB_result W2_LSQ_dis_ROB_dst W2_LSQ_dis_vk))
				(W2_ROB_done_update (store W3_ROB_done W2_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(W2_Cache_tag_Update_Load (store W2_Cache_Tag Available_W2_Cache_Line LOAD_addr))
				
				(W2_Cache_data_Update_Load (store W2_Cache_Data Available_W2_Cache_Line LOAD_Value))
				
				(W2_Cache_valid_Update_Load (store W2_Cache_Valid Available_W2_Cache_Line (_ bv1 1)))
				
				(W2_Evict_Tag_update (store W2_Evict_Tag W2_Evict_Index W2_Cache0_Tag ))
				(W2_Evict_Valid_update (store W2_Evict_Valid W2_Evict_Index W2_Cache0_Valid ))
				(W2_Evict_Index_update (bvadd (_ bv1 3) W2_Evict_Index))
				
			)
		(let
			(
				(W3_Evict_Tag (ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load) (= #b00 Available_W2_Cache_Line) (= W2_Cache0_Valid #b1)) W2_Evict_Tag_update W2_Evict_Tag))
				(W3_Evict_Valid (ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load) (= #b00 Available_W2_Cache_Line) (= W2_Cache0_Valid #b1)) W2_Evict_Valid_update W2_Evict_Valid))
				(W3_Evict_Index (ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load) (= #b00 Available_W2_Cache_Line) (= W2_Cache0_Valid #b1)) W2_Evict_Index_update W2_Evict_Index))
			)
		(let
			(
				(W3_ROB_destination (ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_LSQ_dis_op_type Store)) W2_ROB_destination_update W2_ROB_destination))
				(W3_ROB_result
					(ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_LSQ_dis_op_type Load)) W2_ROB_result_load
					(ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_LSQ_dis_op_type Store)) W2_ROB_result_store
					W3_ROB_result
					))
				)
				(W3_ROB_done (ite (= W2_LSQ_entry_dispatched #b1) W2_ROB_done_update W3_ROB_done))
				
				(W3_Cache_Tag
					(ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load)) W2_Cache_tag_Update_Load			;If load and W2_Cache miss, update the W2_Cache
					W2_Cache_Tag
					)
				)
				(W3_Cache_Data
					(ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load)) W2_Cache_data_Update_Load			;If load and W2_Cache miss, update the W2_Cache
					W2_Cache_Data
					)
				)
				(W3_Cache_Valid
					(ite (and (= W2_LSQ_entry_dispatched #b1) (= W2_Cache_Hit_load #b0) (= W2_LSQ_dis_op_type Load)) W2_Cache_valid_Update_Load			;If load and W2_Cache miss, update the W2_Cache
					W2_Cache_Valid
					)
				)
			)
		(let
			(
				(W2_LSQ_op_type_update (store W2_LSQ_op_type W2_LSQ_dis_index 0))
				(W2_LSQ_op_update (store W2_LSQ_op W2_LSQ_dis_index 0))
				(W2_LSQ_ROB_dst_update (store W2_LSQ_ROB_dst W2_LSQ_dis_index (_ bv0 3)))
				(W2_LSQ_vj_update (store W2_LSQ_vj W2_LSQ_dis_index 0))
				(W2_LSQ_vk_update (store W2_LSQ_vk W2_LSQ_dis_index 0))
				(W2_LSQ_qj_update (store W2_LSQ_qj W2_LSQ_dis_index (_ bv0 3)))
				(W2_LSQ_qk_update (store W2_LSQ_qk W2_LSQ_dis_index (_ bv0 3)))
				(W2_LSQ_imm_update (store W2_LSQ_imm W2_LSQ_dis_index 0))
				(W2_LSQ_dis_update (store W2_LSQ_dis W2_LSQ_dis_index (_ bv0 1)))
				(W2_LSQ_busy_update (store W2_LSQ_busy W2_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(W3_LSQ_op_type (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_op_type_update W2_LSQ_op_type))
				(W3_LSQ_op (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_op_update W2_LSQ_op))
				(W3_LSQ_ROB_dst (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_ROB_dst_update W2_LSQ_ROB_dst))
				(W3_LSQ_vj (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_vj_update W2_LSQ_vj))
				(W3_LSQ_vk (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_vk_update W2_LSQ_vk))
				(W3_LSQ_qj (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_qj_update W2_LSQ_qj))
				(W3_LSQ_qk (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_qk_update W2_LSQ_qk))
				(W3_LSQ_imm (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_imm_update W2_LSQ_imm))
				(W3_LSQ_dis (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_dis_update W2_LSQ_dis))
				(W3_LSQ_busy (ite (= W2_LSQ_entry_dispatched #b1) W2_LSQ_busy_update W2_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(W3_RS0_busy (select W3_RS_busy (_ bv0 2)))
				(W3_RS0_qj (select W3_RS_qj (_ bv0 2)))
				(W3_RS0_qk (select W3_RS_qk (_ bv0 2)))
				(W3_RS1_busy (select W3_RS_busy (_ bv1 2)))
				(W3_RS1_qj (select W3_RS_qj (_ bv1 2)))
				(W3_RS1_qk (select W3_RS_qk (_ bv1 2)))
				(W3_RS2_busy (select W3_RS_busy (_ bv2 2)))
				(W3_RS2_qj (select W3_RS_qj (_ bv2 2)))
				(W3_RS2_qk (select W3_RS_qk (_ bv2 2)))
				(W3_RS3_busy (select W3_RS_busy (_ bv3 2)))
				(W3_RS3_qj (select W3_RS_qj (_ bv3 2)))
				(W3_RS3_qk (select W3_RS_qk (_ bv3 2)))
				
				(W3_LSQ0_busy (select W3_LSQ_busy (_ bv0 2)))
				(W3_LSQ0_qj (select W3_LSQ_qj (_ bv0 2)))
				(W3_LSQ0_qk (select W3_LSQ_qk (_ bv0 2)))
				(W3_LSQ1_busy (select W3_LSQ_busy (_ bv1 2)))
				(W3_LSQ1_qj (select W3_LSQ_qj (_ bv1 2)))
				(W3_LSQ1_qk (select W3_LSQ_qk (_ bv1 2)))
				(W3_LSQ2_busy (select W3_LSQ_busy (_ bv2 2)))
				(W3_LSQ2_qj (select W3_LSQ_qj (_ bv2 2)))
				(W3_LSQ2_qk (select W3_LSQ_qk (_ bv2 2)))
				(W3_LSQ3_busy (select W3_LSQ_busy (_ bv3 2)))
				(W3_LSQ3_qj (select W3_LSQ_qj (_ bv3 2)))
				(W3_LSQ3_qk (select W3_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W3_RS0_qj_ROB_done (select W3_ROB_done W3_RS0_qj))
				(W3_RS0_qj_ROB_result (select W3_ROB_result W3_RS0_qj))
				(W3_RS0_qk_ROB_done (select W3_ROB_done W3_RS0_qk))
				(W3_RS0_qk_ROB_result (select W3_ROB_result W3_RS0_qk))
				(W3_RS1_qj_ROB_done (select W3_ROB_done W3_RS1_qj))
				(W3_RS1_qj_ROB_result (select W3_ROB_result W3_RS1_qj))
				(W3_RS1_qk_ROB_done (select W3_ROB_done W3_RS1_qk))
				(W3_RS1_qk_ROB_result (select W3_ROB_result W3_RS1_qk))
				(W3_RS2_qj_ROB_done (select W3_ROB_done W3_RS2_qj))
				(W3_RS2_qj_ROB_result (select W3_ROB_result W3_RS2_qj))
				(W3_RS2_qk_ROB_done (select W3_ROB_done W3_RS2_qk))
				(W3_RS2_qk_ROB_result (select W3_ROB_result W3_RS2_qk))
				(W3_RS3_qj_ROB_done (select W3_ROB_done W3_RS3_qj))
				(W3_RS3_qj_ROB_result (select W3_ROB_result W3_RS3_qj))
				(W3_RS3_qk_ROB_done (select W3_ROB_done W3_RS3_qk))
				(W3_RS3_qk_ROB_result (select W3_ROB_result W3_RS3_qk))
				
				(W3_LSQ0_qj_ROB_done (select W3_ROB_done W3_LSQ0_qj))
				(W3_LSQ0_qj_ROB_result (select W3_ROB_result W3_LSQ0_qj))
				(W3_LSQ0_qk_ROB_done (select W3_ROB_done W3_LSQ0_qk))
				(W3_LSQ0_qk_ROB_result (select W3_ROB_result W3_LSQ0_qk))
				(W3_LSQ1_qj_ROB_done (select W3_ROB_done W3_LSQ1_qj))
				(W3_LSQ1_qj_ROB_result (select W3_ROB_result W3_LSQ1_qj))
				(W3_LSQ1_qk_ROB_done (select W3_ROB_done W3_LSQ1_qk))
				(W3_LSQ1_qk_ROB_result (select W3_ROB_result W3_LSQ1_qk))
				(W3_LSQ2_qj_ROB_done (select W3_ROB_done W3_LSQ2_qj))
				(W3_LSQ2_qj_ROB_result (select W3_ROB_result W3_LSQ2_qj))
				(W3_LSQ2_qk_ROB_done (select W3_ROB_done W3_LSQ2_qk))
				(W3_LSQ2_qk_ROB_result (select W3_ROB_result W3_LSQ2_qk))
				(W3_LSQ3_qj_ROB_done (select W3_ROB_done W3_LSQ3_qj))
				(W3_LSQ3_qj_ROB_result (select W3_ROB_result W3_LSQ3_qj))
				(W3_LSQ3_qk_ROB_done (select W3_ROB_done W3_LSQ3_qk))
				(W3_LSQ3_qk_ROB_result (select W3_ROB_result W3_LSQ3_qk))
			)
		(let
			(
				(W3_RS0_vj_update (store W3_RS_vj (_ bv0 2) W3_RS0_qj_ROB_result))
				(W3_RS0_vk_update (store W3_RS_vk (_ bv0 2) W3_RS0_qk_ROB_result))					
				(W3_RS0_qj_update (store W3_RS_qj (_ bv0 2) (_ bv0 3)))	
				(W3_RS0_qk_update (store W3_RS_qk (_ bv0 2) (_ bv0 3)))	
				(W3_LSQ0_vj_update (store W3_LSQ_vj (_ bv0 2) W3_LSQ0_qj_ROB_result))	
				(W3_LSQ0_vk_update (store W3_LSQ_vk (_ bv0 2) W3_LSQ0_qk_ROB_result))	
				(W3_LSQ0_qj_update (store W3_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(W3_LSQ0_qk_update (store W3_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(W3_RS_vj (ite (and (= #b1 W3_RS0_busy) (not (= #b000 W3_RS0_qj)) (= #b1 W3_RS0_qj_ROB_done)) W3_RS0_vj_update W3_RS_vj))
				(W3_RS_vk (ite (and (= #b1 W3_RS0_busy) (not (= #b000 W3_RS0_qk)) (= #b1 W3_RS0_qk_ROB_done)) W3_RS0_vk_update W3_RS_vk))
				(W3_RS_qj (ite (and (= #b1 W3_RS0_busy) (not (= #b000 W3_RS0_qj)) (= #b1 W3_RS0_qj_ROB_done)) W3_RS0_qj_update W3_RS_qj))
				(W3_RS_qk (ite (and (= #b1 W3_RS0_busy) (not (= #b000 W3_RS0_qk)) (= #b1 W3_RS0_qk_ROB_done)) W3_RS0_qk_update W3_RS_qk))
				(W3_LSQ_vj (ite (and (= #b1 W3_LSQ0_busy) (not (= #b000 W3_LSQ0_qj)) (= #b1 W3_LSQ0_qj_ROB_done)) W3_LSQ0_vj_update W3_LSQ_vj))
				(W3_LSQ_vk (ite (and (= #b1 W3_LSQ0_busy) (not (= #b000 W3_LSQ0_qk)) (= #b1 W3_LSQ0_qk_ROB_done)) W3_LSQ0_vk_update W3_LSQ_vk))
				(W3_LSQ_qj (ite (and (= #b1 W3_LSQ0_busy) (not (= #b000 W3_LSQ0_qj)) (= #b1 W3_LSQ0_qj_ROB_done)) W3_LSQ0_qj_update W3_LSQ_qj))
				(W3_LSQ_qk (ite (and (= #b1 W3_LSQ0_busy) (not (= #b000 W3_LSQ0_qk)) (= #b1 W3_LSQ0_qk_ROB_done)) W3_LSQ0_qk_update W3_LSQ_qk))
			)
		(let
			(
				(W3_RS1_vj_update (store W3_RS_vj (_ bv1 2) W3_RS1_qj_ROB_result))	
				(W3_RS1_vk_update (store W3_RS_vk (_ bv1 2) W3_RS1_qk_ROB_result))	
				(W3_RS1_qj_update (store W3_RS_qj (_ bv1 2) (_ bv0 3)))	
				(W3_RS1_qk_update (store W3_RS_qk (_ bv1 2) (_ bv0 3)))	
				(W3_LSQ1_vj_update (store W3_LSQ_vj (_ bv1 2) W3_LSQ1_qj_ROB_result))	
				(W3_LSQ1_vk_update (store W3_LSQ_vk (_ bv1 2) W3_LSQ1_qk_ROB_result))	
				(W3_LSQ1_qj_update (store W3_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(W3_LSQ1_qk_update (store W3_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(W3_RS_vj (ite (and (= #b1 W3_RS1_busy) (not (= #b000 W3_RS1_qj)) (= #b1 W3_RS1_qj_ROB_done)) W3_RS1_vj_update W3_RS_vj))
				(W3_RS_vk (ite (and (= #b1 W3_RS1_busy) (not (= #b000 W3_RS1_qk)) (= #b1 W3_RS1_qk_ROB_done)) W3_RS1_vk_update W3_RS_vk))
				(W3_RS_qj (ite (and (= #b1 W3_RS1_busy) (not (= #b000 W3_RS1_qj)) (= #b1 W3_RS1_qj_ROB_done)) W3_RS1_qj_update W3_RS_qj))
				(W3_RS_qk (ite (and (= #b1 W3_RS1_busy) (not (= #b000 W3_RS1_qk)) (= #b1 W3_RS1_qk_ROB_done)) W3_RS1_qk_update W3_RS_qk))
				(W3_LSQ_vj (ite (and (= #b1 W3_LSQ1_busy) (not (= #b000 W3_LSQ1_qj)) (= #b1 W3_LSQ1_qj_ROB_done)) W3_LSQ1_vj_update W3_LSQ_vj))
				(W3_LSQ_vk (ite (and (= #b1 W3_LSQ1_busy) (not (= #b000 W3_LSQ1_qk)) (= #b1 W3_LSQ1_qk_ROB_done)) W3_LSQ1_vk_update W3_LSQ_vk))
				(W3_LSQ_qj (ite (and (= #b1 W3_LSQ1_busy) (not (= #b000 W3_LSQ1_qj)) (= #b1 W3_LSQ1_qj_ROB_done)) W3_LSQ1_qj_update W3_LSQ_qj))
				(W3_LSQ_qk (ite (and (= #b1 W3_LSQ1_busy) (not (= #b000 W3_LSQ1_qk)) (= #b1 W3_LSQ1_qk_ROB_done)) W3_LSQ1_qk_update W3_LSQ_qk))
			)
		(let
			(
				(W3_RS2_vj_update (store W3_RS_vj (_ bv2 2) W3_RS2_qj_ROB_result))	
				(W3_RS2_vk_update (store W3_RS_vk (_ bv2 2) W3_RS2_qk_ROB_result))	
				(W3_RS2_qj_update (store W3_RS_qj (_ bv2 2) (_ bv0 3)))	
				(W3_RS2_qk_update (store W3_RS_qk (_ bv2 2) (_ bv0 3)))	
				(W3_LSQ2_vj_update (store W3_LSQ_vj (_ bv2 2) W3_LSQ2_qj_ROB_result))	
				(W3_LSQ2_vk_update (store W3_LSQ_vk (_ bv2 2) W3_LSQ2_qk_ROB_result))	
				(W3_LSQ2_qj_update (store W3_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(W3_LSQ2_qk_update (store W3_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(W3_RS_vj (ite (and (= #b1 W3_RS2_busy) (not (= #b000 W3_RS2_qj)) (= #b1 W3_RS2_qj_ROB_done)) W3_RS2_vj_update W3_RS_vj))
				(W3_RS_vk (ite (and (= #b1 W3_RS2_busy) (not (= #b000 W3_RS2_qk)) (= #b1 W3_RS2_qk_ROB_done)) W3_RS2_vk_update W3_RS_vk))
				(W3_RS_qj (ite (and (= #b1 W3_RS2_busy) (not (= #b000 W3_RS2_qj)) (= #b1 W3_RS2_qj_ROB_done)) W3_RS2_qj_update W3_RS_qj))
				(W3_RS_qk (ite (and (= #b1 W3_RS2_busy) (not (= #b000 W3_RS2_qk)) (= #b1 W3_RS2_qk_ROB_done)) W3_RS2_qk_update W3_RS_qk))
				(W3_LSQ_vj (ite (and (= #b1 W3_LSQ2_busy) (not (= #b000 W3_LSQ2_qj)) (= #b1 W3_LSQ2_qj_ROB_done)) W3_LSQ2_vj_update W3_LSQ_vj))
				(W3_LSQ_vk (ite (and (= #b1 W3_LSQ2_busy) (not (= #b000 W3_LSQ2_qk)) (= #b1 W3_LSQ2_qk_ROB_done)) W3_LSQ2_vk_update W3_LSQ_vk))
				(W3_LSQ_qj (ite (and (= #b1 W3_LSQ2_busy) (not (= #b000 W3_LSQ2_qj)) (= #b1 W3_LSQ2_qj_ROB_done)) W3_LSQ2_qj_update W3_LSQ_qj))
				(W3_LSQ_qk (ite (and (= #b1 W3_LSQ2_busy) (not (= #b000 W3_LSQ2_qk)) (= #b1 W3_LSQ2_qk_ROB_done)) W3_LSQ2_qk_update W3_LSQ_qk))
			)
		(let
			(
				(W3_RS3_vj_update (store W3_RS_vj (_ bv3 2) W3_RS3_qj_ROB_result))	
				(W3_RS3_vk_update (store W3_RS_vk (_ bv3 2) W3_RS3_qk_ROB_result))	
				(W3_RS3_qj_update (store W3_RS_qj (_ bv3 2) (_ bv0 3)))	
				(W3_RS3_qk_update (store W3_RS_qk (_ bv3 2) (_ bv0 3)))	
				(W3_LSQ3_vj_update (store W3_LSQ_vj (_ bv3 2) W3_LSQ3_qj_ROB_result))	
				(W3_LSQ3_vk_update (store W3_LSQ_vk (_ bv3 2) W3_LSQ3_qk_ROB_result))	
				(W3_LSQ3_qj_update (store W3_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(W3_LSQ3_qk_update (store W3_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(W3_RS_vj (ite (and (= #b1 W3_RS3_busy) (not (= #b000 W3_RS3_qj)) (= #b1 W3_RS3_qj_ROB_done)) W3_RS3_vj_update W3_RS_vj))
				(W3_RS_vk (ite (and (= #b1 W3_RS3_busy) (not (= #b000 W3_RS3_qk)) (= #b1 W3_RS3_qk_ROB_done)) W3_RS3_vk_update W3_RS_vk))
				(W3_RS_qj (ite (and (= #b1 W3_RS3_busy) (not (= #b000 W3_RS3_qj)) (= #b1 W3_RS3_qj_ROB_done)) W3_RS3_qj_update W3_RS_qj))
				(W3_RS_qk (ite (and (= #b1 W3_RS3_busy) (not (= #b000 W3_RS3_qk)) (= #b1 W3_RS3_qk_ROB_done)) W3_RS3_qk_update W3_RS_qk))
				(W3_LSQ_vj (ite (and (= #b1 W3_LSQ3_busy) (not (= #b000 W3_LSQ3_qj)) (= #b1 W3_LSQ3_qj_ROB_done)) W3_LSQ3_vj_update W3_LSQ_vj))
				(W3_LSQ_vk (ite (and (= #b1 W3_LSQ3_busy) (not (= #b000 W3_LSQ3_qk)) (= #b1 W3_LSQ3_qk_ROB_done)) W3_LSQ3_vk_update W3_LSQ_vk))
				(W3_LSQ_qj (ite (and (= #b1 W3_LSQ3_busy) (not (= #b000 W3_LSQ3_qj)) (= #b1 W3_LSQ3_qj_ROB_done)) W3_LSQ3_qj_update W3_LSQ_qj))
				(W3_LSQ_qk (ite (and (= #b1 W3_LSQ3_busy) (not (= #b000 W3_LSQ3_qk)) (= #b1 W3_LSQ3_qk_ROB_done)) W3_LSQ3_qk_update W3_LSQ_qk))
			)
		(let
			(
				(W3_RS0_busy (select W3_RS_busy (_ bv0 2)))
				(W3_RS0_qj (select W3_RS_qj (_ bv0 2)))
				(W3_RS0_qk (select W3_RS_qk (_ bv0 2)))
				(W3_RS1_busy (select W3_RS_busy (_ bv1 2)))
				(W3_RS1_qj (select W3_RS_qj (_ bv1 2)))
				(W3_RS1_qk (select W3_RS_qk (_ bv1 2)))
				(W3_RS2_busy (select W3_RS_busy (_ bv2 2)))
				(W3_RS2_qj (select W3_RS_qj (_ bv2 2)))
				(W3_RS2_qk (select W3_RS_qk (_ bv2 2)))
				(W3_RS3_busy (select W3_RS_busy (_ bv3 2)))
				(W3_RS3_qj (select W3_RS_qj (_ bv3 2)))
				(W3_RS3_qk (select W3_RS_qk (_ bv3 2)))
				(W3_LSQ0_busy (select W3_LSQ_busy (_ bv0 2)))
				(W3_LSQ0_qj (select W3_LSQ_qj (_ bv0 2)))
				(W3_LSQ0_qk (select W3_LSQ_qk (_ bv0 2)))
				(W3_LSQ1_busy (select W3_LSQ_busy (_ bv1 2)))
				(W3_LSQ1_qj (select W3_LSQ_qj (_ bv1 2)))
				(W3_LSQ1_qk (select W3_LSQ_qk (_ bv1 2)))
				(W3_LSQ2_busy (select W3_LSQ_busy (_ bv2 2)))
				(W3_LSQ2_qj (select W3_LSQ_qj (_ bv2 2)))
				(W3_LSQ2_qk (select W3_LSQ_qk (_ bv2 2)))
				(W3_LSQ3_busy (select W3_LSQ_busy (_ bv3 2)))
				(W3_LSQ3_qj (select W3_LSQ_qj (_ bv3 2)))
				(W3_LSQ3_qk (select W3_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W3_RS0_dis (ite (and (= #b1 W3_RS0_busy) (= #b000 W3_RS0_qj) (= #b000 W3_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_RS1_dis (ite (and (= #b1 W3_RS1_busy) (= #b000 W3_RS1_qj) (= #b000 W3_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_RS2_dis (ite (and (= #b1 W3_RS2_busy) (= #b000 W3_RS2_qj) (= #b000 W3_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_RS3_dis (ite (and (= #b1 W3_RS3_busy) (= #b000 W3_RS3_qj) (= #b000 W3_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(W3_LSQ0_dis (ite (and (= #b1 W3_LSQ0_busy) (= #b000 W3_LSQ0_qj) (= #b000 W3_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_LSQ1_dis (ite (and (= #b1 W3_LSQ1_busy) (= #b000 W3_LSQ1_qj) (= #b000 W3_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_LSQ2_dis (ite (and (= #b1 W3_LSQ2_busy) (= #b000 W3_LSQ2_qj) (= #b000 W3_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(W3_LSQ3_dis (ite (and (= #b1 W3_LSQ3_busy) (= #b000 W3_LSQ3_qj) (= #b000 W3_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(W3_RS_dis (store W3_RS_dis (_ bv0 2) W3_RS0_dis))
				(W3_LSQ_dis (store W3_LSQ_dis (_ bv0 2) W3_LSQ0_dis))
			)
		(let
			(
				(W3_RS_dis (store W3_RS_dis (_ bv1 2) W3_RS1_dis))
				(W3_LSQ_dis (store W3_LSQ_dis (_ bv1 2) W3_LSQ1_dis))
			)
		(let
			(
				(W3_RS_dis (store W3_RS_dis (_ bv2 2) W3_RS2_dis))
				(W3_LSQ_dis (store W3_LSQ_dis (_ bv2 2) W3_LSQ2_dis))
			)
		(let
			(
				(W3_RS_dis (store W3_RS_dis (_ bv3 2) W3_RS3_dis))
				(W3_LSQ_dis (store W3_LSQ_dis (_ bv3 2) W3_LSQ3_dis))
			)
		(let
			(
				(W3_RF (ite (= 0 0) W2_RF W2_RF))
				(W3_DM (ite (= 0 0) W2_DM W2_DM))
				
				(W3_Cache_Tag (ite (= 0 0) W3_Cache_Tag W3_Cache_Tag))
				(W3_Cache_Data (ite (= 0 0) W3_Cache_Data W3_Cache_Data))
				(W3_Cache_Valid (ite (= 0 0) W3_Cache_Valid W3_Cache_Valid))
				
				(W3_PC (ite (= 0 0) W2_PC W2_PC))
				
				(W3_IP (ite (= 0 0) W2_IP W2_IP))
				(W3_CP (ite (= 0 0) W2_CP W2_CP))
				
				(W3_ROB_busy (ite (= 0 0) W2_ROB_busy W2_ROB_busy))
				(W3_ROB_op_type (ite (= 0 0) W2_ROB_op_type W2_ROB_op_type))
				(W3_ROB_destination (ite (= 0 0) W3_ROB_destination W3_ROB_destination))
				(W3_ROB_result (ite (= 0 0) W3_ROB_result W3_ROB_result))
				(W3_ROB_exception (ite (= 0 0) W3_ROB_exception W3_ROB_exception))
				(W3_ROB_done (ite (= 0 0) W3_ROB_done W3_ROB_done))
				
				(W3_RS_op_type (ite (= 0 0) W3_RS_op_type W3_RS_op_type))
				(W3_RS_op (ite (= 0 0) W3_RS_op W3_RS_op))
				(W3_RS_ROB_dst (ite (= 0 0) W3_RS_ROB_dst W3_RS_ROB_dst))
				(W3_RS_vj (ite (= 0 0) W3_RS_vj W3_RS_vj))
				(W3_RS_vk (ite (= 0 0) W3_RS_vk W3_RS_vk))
				(W3_RS_qj (ite (= 0 0) W3_RS_qj W3_RS_qj))
				(W3_RS_qk (ite (= 0 0) W3_RS_qk W3_RS_qk))
				(W3_RS_imm (ite (= 0 0) W3_RS_imm W3_RS_imm))
				(W3_RS_dis (ite (= 0 0) W3_RS_dis W3_RS_dis))
				(W3_RS_busy (ite (= 0 0) W3_RS_busy W3_RS_busy))
				
				(W3_LSQ_op_type (ite (= 0 0) W3_LSQ_op_type W3_LSQ_op_type))
				(W3_LSQ_op (ite (= 0 0) W3_LSQ_op W3_LSQ_op))
				(W3_LSQ_ROB_dst (ite (= 0 0) W3_LSQ_ROB_dst W3_LSQ_ROB_dst))
				(W3_LSQ_vj (ite (= 0 0) W3_LSQ_vj W3_LSQ_vj))
				(W3_LSQ_vk (ite (= 0 0) W3_LSQ_vk W3_LSQ_vk))
				(W3_LSQ_qj (ite (= 0 0) W3_LSQ_qj W3_LSQ_qj))
				(W3_LSQ_qk (ite (= 0 0) W3_LSQ_qk W3_LSQ_qk))
				(W3_LSQ_imm (ite (= 0 0) W3_LSQ_imm W3_LSQ_imm))
				(W3_LSQ_dis (ite (= 0 0) W3_LSQ_dis W3_LSQ_dis))
				(W3_LSQ_busy (ite (= 0 0) W3_LSQ_busy W3_LSQ_busy))
				
				(W3_Evict_Tag (ite (= 0 0) W3_Evict_Tag W3_Evict_Tag))
				(W3_Evict_Valid (ite (= 0 0) W3_Evict_Valid W3_Evict_Valid))
				(W3_Evict_Index (ite (= 0 0) W3_Evict_Index W3_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W3_ROB_busy (select W3_ROB_busy W3_CP))
				(CP_W3_ROB_op_type (select W3_ROB_op_type W3_CP))
				(CP_W3_ROB_destination (select W3_ROB_destination W3_CP))
				(CP_W3_ROB_result (select W3_ROB_result W3_CP))
				(CP_W3_ROB_exception (select W3_ROB_exception W3_CP))
				(CP_W3_ROB_done (select W3_ROB_done W3_CP))
			)
		(let
			(
				(CP_update (bvadd W3_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W3_RF CP_W3_ROB_destination CP_W3_ROB_result))
				(DM_update (store W3_DM CP_W3_ROB_destination CP_W3_ROB_result))
				
				(W3_ROB_busy_update (store W3_ROB_busy W3_CP (_ bv0 1)))
				(W3_ROB_op_type_update (store W3_ROB_op_type W3_CP 0))
				(W3_ROB_destination_update (store W3_ROB_destination W3_CP 0))
				(W3_ROB_resulW3_update (store W3_ROB_result W3_CP 0))
				(W3_ROB_exception_update (store W3_ROB_exception W3_CP (_ bv0 1)))
				(W3_ROB_done_update (store W3_ROB_done W3_CP (_ bv0 1)))
			)
		(let
			(
				(W3_Cache0_Tag (select W3_Cache_Tag (_ bv0 2)))
				(W3_Cache0_Data (select W3_Cache_Data (_ bv0 2)))
				(W3_Cache0_Valid (select W3_Cache_Valid (_ bv0 2)))
				(W3_Cache1_Tag (select W3_Cache_Tag (_ bv1 2)))
				(W3_Cache1_Data (select W3_Cache_Data (_ bv1 2)))
				(W3_Cache1_Valid (select W3_Cache_Valid (_ bv1 2)))
				(W3_Cache2_Tag (select W3_Cache_Tag (_ bv2 2)))
				(W3_Cache2_Data (select W3_Cache_Data (_ bv2 2)))
				(W3_Cache2_Valid (select W3_Cache_Valid (_ bv2 2)))
				(W3_Cache3_Tag (select W3_Cache_Tag (_ bv3 2)))
				(W3_Cache3_Data (select W3_Cache_Data (_ bv3 2)))
				(W3_Cache3_Valid (select W3_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W3_Cache0_Hit_Store (ite (and (= W3_Cache0_Valid #b1) (= W3_Cache0_Tag CP_W3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W3_Cache1_Hit_Store (ite (and (= W3_Cache1_Valid #b1) (= W3_Cache1_Tag CP_W3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W3_Cache2_Hit_Store (ite (and (= W3_Cache2_Valid #b1) (= W3_Cache2_Tag CP_W3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W3_Cache3_Hit_Store (ite (and (= W3_Cache3_Valid #b1) (= W3_Cache3_Tag CP_W3_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W3_Cache_Line 
					(ite (= W3_Cache0_Valid #b0) (_ bv0 2)	;check if W3_Cache line 0 is free
					(ite (= W3_Cache1_Valid #b0) (_ bv1 2)	;check if W3_Cache line 1 is free
					(ite (= W3_Cache2_Valid #b0) (_ bv2 2)	;check if W3_Cache line 2 is free
					(ite (= W3_Cache3_Valid #b0) (_ bv3 2)	;check if W3_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W3_Cache line 0 
					))))
				)
				(W3_Cache_Store_Hit_Index
					(ite (= W3_Cache0_Hit_Store #b1) (_ bv0 2)		;If W3_Cache has a hit for store, then whats the line index
					(ite (= W3_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W3_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W3_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W3_Cache_Hit_Store (bvor W3_Cache0_Hit_Store W3_Cache1_Hit_Store W3_Cache2_Hit_Store W3_Cache3_Hit_Store))
			)
		(let
			(
				(W3_Cache_tag_Update_Store_Hit (store W3_Cache_Tag W3_Cache_Store_Hit_Index CP_W3_ROB_destination))	;if W3_Cache is a hit, update the line with new data
				(W3_Cache_tag_Update_Store_Miss (store W3_Cache_Tag Available_W3_Cache_Line CP_W3_ROB_destination))	
				
				(W3_Cache_data_Update_Store_Hit (store W3_Cache_Data W3_Cache_Store_Hit_Index CP_W3_ROB_result))	;if W3_Cache is a hit, update the line with new data
				(W3_Cache_data_Update_Store_Miss (store W3_Cache_Data Available_W3_Cache_Line CP_W3_ROB_result))	;if W3_Cache is a miss, update the available entry with data
				
				(W3_Cache_valid_Update_Store_Hit (store W3_Cache_Valid W3_Cache_Store_Hit_Index (_ bv1 1)))	;if W3_Cache is a hit, update the line with new data
				(W3_Cache_valid_Update_Store_Miss (store W3_Cache_Valid Available_W3_Cache_Line (_ bv1 1)))	;if W3_Cache is a miss, update the available entry with data
				
				(CP_W3_ROB_exception (ite (and (= CP_W3_ROB_op_type Branch) (= 1 CP_W3_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W3_Evict_Tag_update (store W3_Evict_Tag W3_Evict_Index W3_Cache0_Tag))
				(W3_Evict_Valid_update (store W3_Evict_Valid W3_Evict_Index W3_Cache0_Valid))
				(W3_Evict_Index_update (bvadd (_ bv1 3) W3_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W3_ROB_done #b1) (or (= CP_W3_ROB_op_type Rtype) (= CP_W3_ROB_op_type Mul_div) (= CP_W3_ROB_op_type Load))) RF_update W3_RF))
				(W4_DM (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Store)) DM_update W3_DM))
				
				(W4_PC (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) CP_W3_ROB_destination W3_PC))
				(W4_IP (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) (_ bv1 3) W3_IP))
				(W4_CP 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W3_ROB_done #b1) CP_update
					W3_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W3_ROB_done #b1) W3_ROB_busy_update
					W3_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W3_ROB_done #b1) W3_ROB_op_type_update
					W3_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W3_ROB_done #b1) W3_ROB_destination_update
					W3_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W3_ROB_done #b1) W3_ROB_resulW3_update
					W3_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W3_ROB_done #b1) W3_ROB_exception_update
					W3_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W3_ROB_done #b1) W3_ROB_done_update
					W3_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_RS_op_type))
				(W4_RS_op (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_RS_vj))
				(W4_RS_vk (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_RS_vk))
				(W4_RS_qj (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_RS_qj))
				(W4_RS_qk (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_RS_qk))
				(W4_RS_imm (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_RS_imm))
				(W4_RS_dis (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_1bit W3_RS_dis))
				(W4_RS_busy (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_1bit W3_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_3bit W3_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_int W3_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_1bit W3_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Branch) (= CP_W3_ROB_exception #b1)) empty_RS_LSQ_1bit W3_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b0) (= CP_W3_ROB_op_type Store)) W3_Cache_tag_Update_Store_Miss	;If Store and W3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b1) (= CP_W3_ROB_op_type Store)) W3_Cache_tag_Update_Store_Hit		;If Store and W3_Cache hit, update the line with new data
					W3_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b0) (= CP_W3_ROB_op_type Store)) W3_Cache_data_Update_Store_Miss	;If Store and W3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b1) (= CP_W3_ROB_op_type Store)) W3_Cache_data_Update_Store_Hit		;If Store and W3_Cache hit, update the line with new data
					W3_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b0) (= CP_W3_ROB_op_type Store)) W3_Cache_valid_Update_Store_Miss	;If Store and W3_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W3_ROB_done #b1) (= W3_Cache_Hit_Store #b1) (= CP_W3_ROB_op_type Store)) W3_Cache_valid_Update_Store_Hit		;If Store and W3_Cache hit, update the line with new data
					W3_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Store)) W3_Evict_Tag_update W3_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Store)) W3_Evict_Valid_update W3_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W3_ROB_done #b1) (= CP_W3_ROB_op_type Store)) W3_Evict_Index_update W3_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(W4_RS0_dis (select W4_RS_dis (_ bv0 2)))
				(W4_RS1_dis (select W4_RS_dis (_ bv1 2)))
				(W4_RS2_dis (select W4_RS_dis (_ bv2 2)))
				(W4_RS3_dis (select W4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(W4_RS_dis_index
					(ite (= W4_RS0_dis #b1) (_ bv0 2)
					(ite (= W4_RS1_dis #b1) (_ bv1 2)
					(ite (= W4_RS2_dis #b1) (_ bv2 2)
					(ite (= W4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_RS_entry_dispatched (bvor W4_RS0_dis W4_RS1_dis W4_RS2_dis W4_RS3_dis))
			)	
		(let
			(
				(W4_RS_dis_vj (select W4_RS_vj W4_RS_dis_index))
				(W4_RS_dis_vk (select W4_RS_vk W4_RS_dis_index))
				(W4_RS_dis_qj (select W4_RS_qj W4_RS_dis_index))
				(W4_RS_dis_qk (select W4_RS_qk W4_RS_dis_index))
				(W4_RS_dis_op (select W4_RS_op W4_RS_dis_index))
				(W4_RS_dis_op_type (select W4_RS_op_type W4_RS_dis_index))
				(W4_RS_dis_imm (select W4_RS_imm W4_RS_dis_index))
				(W4_RS_dis_ROB_dst (select W4_RS_ROB_dst W4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(ALW1_result (ALU1 W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
			)
		(let
			(
				(W4_RS_result
					(ite (= W4_RS_dis_op_type Rtype) ALW1_result
					(ite (= W4_RS_dis_op_type Branch) Branch_result
					(ite (= W4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(W4_ROB_result_update (store W4_ROB_result W4_RS_dis_ROB_dst W4_RS_result))
				(W4_ROB_done_update (store W4_ROB_done W4_RS_dis_ROB_dst (_ bv1 1)))
				(W4_ROB_exception_update (store W4_ROB_exception W4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(W4_ROB_result (ite (= W4_RS_entry_dispatched #b1) W4_ROB_result_update W4_ROB_result))
				(W4_ROB_done (ite (= W4_RS_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				(W4_ROB_exception (ite (and (= W4_RS_dis_op_type Branch) (= W4_RS_result 1) (= W4_RS_entry_dispatched #b1)) W4_ROB_exception_update W4_ROB_exception))
			)
		(let
			(
				(W4_RS_op_type_update (store W4_RS_op_type W4_RS_dis_index 0))
				(W4_RS_op_update (store W4_RS_op W4_RS_dis_index 0))
				(W4_RS_ROB_dst_update (store W4_RS_ROB_dst W4_RS_dis_index (_ bv0 3)))
				(W4_RS_vj_update (store W4_RS_vj W4_RS_dis_index 0))
				(W4_RS_vk_update (store W4_RS_vk W4_RS_dis_index 0))
				(W4_RS_qj_update (store W4_RS_qj W4_RS_dis_index (_ bv0 3)))
				(W4_RS_qk_update (store W4_RS_qk W4_RS_dis_index (_ bv0 3)))
				(W4_RS_imm_update (store W4_RS_imm W4_RS_dis_index 0))
				(W4_RS_dis_update (store W4_RS_dis W4_RS_dis_index (_ bv0 1)))
				(W4_RS_busy_update (store W4_RS_busy W4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_RS_op_type (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_type_update W4_RS_op_type))
				(W4_RS_op (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_update W4_RS_op))
				(W4_RS_ROB_dst (ite (= W4_RS_entry_dispatched #b1) W4_RS_ROB_dst_update W4_RS_ROB_dst))
				(W4_RS_vj (ite (= W4_RS_entry_dispatched #b1) W4_RS_vj_update W4_RS_vj))
				(W4_RS_vk (ite (= W4_RS_entry_dispatched #b1) W4_RS_vk_update W4_RS_vk))
				(W4_RS_qj (ite (= W4_RS_entry_dispatched #b1) W4_RS_qj_update W4_RS_qj))
				(W4_RS_qk (ite (= W4_RS_entry_dispatched #b1) W4_RS_qk_update W4_RS_qk))
				(W4_RS_imm (ite (= W4_RS_entry_dispatched #b1) W4_RS_imm_update W4_RS_imm))
				(W4_RS_dis (ite (= W4_RS_entry_dispatched #b1) W4_RS_dis_update W4_RS_dis))
				(W4_RS_busy (ite (= W4_RS_entry_dispatched #b1) W4_RS_busy_update W4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(W4_LSQ0_dis (select W4_LSQ_dis (_ bv0 2)))
				(W4_LSQ1_dis (select W4_LSQ_dis (_ bv1 2)))
				(W4_LSQ2_dis (select W4_LSQ_dis (_ bv2 2)))
				(W4_LSQ3_dis (select W4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(W4_LSQ_dis_index
					(ite (= W4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= W4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= W4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= W4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_LSQ_entry_dispatched (bvor W4_LSQ0_dis W4_LSQ1_dis W4_LSQ2_dis W4_LSQ3_dis))
			)	
		(let
			(
				(W4_LSQ_dis_vj (select W4_LSQ_vj W4_LSQ_dis_index))
				(W4_LSQ_dis_vk (select W4_LSQ_vk W4_LSQ_dis_index))
				(W4_LSQ_dis_qj (select W4_LSQ_qj W4_LSQ_dis_index))
				(W4_LSQ_dis_qk (select W4_LSQ_qk W4_LSQ_dis_index))
				(W4_LSQ_dis_op (select W4_LSQ_op W4_LSQ_dis_index))
				(W4_LSQ_dis_op_type (select W4_LSQ_op_type W4_LSQ_dis_index))
				(W4_LSQ_dis_imm (select W4_LSQ_imm W4_LSQ_dis_index))
				(W4_LSQ_dis_ROB_dst (select W4_LSQ_ROB_dst W4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
				(Store_address (STORE_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select W4_DM LOAD_addr))
				(W4_Cache0_Hit_Load (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Load (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Load (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Load (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
			)
		(let
			(
				(W4_Cache_Hit_load (bvor W4_Cache0_Hit_Load W4_Cache1_Hit_Load W4_Cache2_Hit_Load W4_Cache3_Hit_Load))
			)
		(let
			(
				(W4_LSQ_result
					(ite (= W4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= W4_LSQ_dis_op_type Store) W4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(W4_ROB_destination_update (store W4_ROB_destination W4_LSQ_dis_ROB_dst Store_address))
				(W4_ROB_result_load (store W4_ROB_result W4_LSQ_dis_ROB_dst LOAD_Value))
				(W4_ROB_result_store (store W4_ROB_result W4_LSQ_dis_ROB_dst W4_LSQ_dis_vk))
				(W4_ROB_done_update (store W4_ROB_done W4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(W4_Cache_tag_Update_Load (store W4_Cache_Tag Available_W4_Cache_Line LOAD_addr))
				
				(W4_Cache_data_Update_Load (store W4_Cache_Data Available_W4_Cache_Line LOAD_Value))
				
				(W4_Cache_valid_Update_Load (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag ))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid ))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
				
			)
		(let
			(
				(W4_Evict_Tag (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Index_update W4_Evict_Index))
			)
		(let
			(
				(W4_ROB_destination (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_destination_update W4_ROB_destination))
				(W4_ROB_result
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Load)) W4_ROB_result_load
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_result_store
					W4_ROB_result
					))
				)
				(W4_ROB_done (ite (= W4_LSQ_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				
				(W4_Cache_Tag
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_tag_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Tag
					)
				)
				(W4_Cache_Data
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_data_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Data
					)
				)
				(W4_Cache_Valid
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_valid_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Valid
					)
				)
			)
		(let
			(
				(W4_LSQ_op_type_update (store W4_LSQ_op_type W4_LSQ_dis_index 0))
				(W4_LSQ_op_update (store W4_LSQ_op W4_LSQ_dis_index 0))
				(W4_LSQ_ROB_dst_update (store W4_LSQ_ROB_dst W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_vj_update (store W4_LSQ_vj W4_LSQ_dis_index 0))
				(W4_LSQ_vk_update (store W4_LSQ_vk W4_LSQ_dis_index 0))
				(W4_LSQ_qj_update (store W4_LSQ_qj W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_qk_update (store W4_LSQ_qk W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_imm_update (store W4_LSQ_imm W4_LSQ_dis_index 0))
				(W4_LSQ_dis_update (store W4_LSQ_dis W4_LSQ_dis_index (_ bv0 1)))
				(W4_LSQ_busy_update (store W4_LSQ_busy W4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_LSQ_op_type (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_type_update W4_LSQ_op_type))
				(W4_LSQ_op (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_update W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_ROB_dst_update W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qk_update W4_LSQ_qk))
				(W4_LSQ_imm (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_imm_update W4_LSQ_imm))
				(W4_LSQ_dis (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_dis_update W4_LSQ_dis))
				(W4_LSQ_busy (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_busy_update W4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_qj_ROB_done (select W4_ROB_done W4_RS0_qj))
				(W4_RS0_qj_ROB_result (select W4_ROB_result W4_RS0_qj))
				(W4_RS0_qk_ROB_done (select W4_ROB_done W4_RS0_qk))
				(W4_RS0_qk_ROB_result (select W4_ROB_result W4_RS0_qk))
				(W4_RS1_qj_ROB_done (select W4_ROB_done W4_RS1_qj))
				(W4_RS1_qj_ROB_result (select W4_ROB_result W4_RS1_qj))
				(W4_RS1_qk_ROB_done (select W4_ROB_done W4_RS1_qk))
				(W4_RS1_qk_ROB_result (select W4_ROB_result W4_RS1_qk))
				(W4_RS2_qj_ROB_done (select W4_ROB_done W4_RS2_qj))
				(W4_RS2_qj_ROB_result (select W4_ROB_result W4_RS2_qj))
				(W4_RS2_qk_ROB_done (select W4_ROB_done W4_RS2_qk))
				(W4_RS2_qk_ROB_result (select W4_ROB_result W4_RS2_qk))
				(W4_RS3_qj_ROB_done (select W4_ROB_done W4_RS3_qj))
				(W4_RS3_qj_ROB_result (select W4_ROB_result W4_RS3_qj))
				(W4_RS3_qk_ROB_done (select W4_ROB_done W4_RS3_qk))
				(W4_RS3_qk_ROB_result (select W4_ROB_result W4_RS3_qk))
				
				(W4_LSQ0_qj_ROB_done (select W4_ROB_done W4_LSQ0_qj))
				(W4_LSQ0_qj_ROB_result (select W4_ROB_result W4_LSQ0_qj))
				(W4_LSQ0_qk_ROB_done (select W4_ROB_done W4_LSQ0_qk))
				(W4_LSQ0_qk_ROB_result (select W4_ROB_result W4_LSQ0_qk))
				(W4_LSQ1_qj_ROB_done (select W4_ROB_done W4_LSQ1_qj))
				(W4_LSQ1_qj_ROB_result (select W4_ROB_result W4_LSQ1_qj))
				(W4_LSQ1_qk_ROB_done (select W4_ROB_done W4_LSQ1_qk))
				(W4_LSQ1_qk_ROB_result (select W4_ROB_result W4_LSQ1_qk))
				(W4_LSQ2_qj_ROB_done (select W4_ROB_done W4_LSQ2_qj))
				(W4_LSQ2_qj_ROB_result (select W4_ROB_result W4_LSQ2_qj))
				(W4_LSQ2_qk_ROB_done (select W4_ROB_done W4_LSQ2_qk))
				(W4_LSQ2_qk_ROB_result (select W4_ROB_result W4_LSQ2_qk))
				(W4_LSQ3_qj_ROB_done (select W4_ROB_done W4_LSQ3_qj))
				(W4_LSQ3_qj_ROB_result (select W4_ROB_result W4_LSQ3_qj))
				(W4_LSQ3_qk_ROB_done (select W4_ROB_done W4_LSQ3_qk))
				(W4_LSQ3_qk_ROB_result (select W4_ROB_result W4_LSQ3_qk))
			)
		(let
			(
				(W4_RS0_vj_update (store W4_RS_vj (_ bv0 2) W4_RS0_qj_ROB_result))
				(W4_RS0_vk_update (store W4_RS_vk (_ bv0 2) W4_RS0_qk_ROB_result))					
				(W4_RS0_qj_update (store W4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(W4_RS0_qk_update (store W4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_vj_update (store W4_LSQ_vj (_ bv0 2) W4_LSQ0_qj_ROB_result))	
				(W4_LSQ0_vk_update (store W4_LSQ_vk (_ bv0 2) W4_LSQ0_qk_ROB_result))	
				(W4_LSQ0_qj_update (store W4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_qk_update (store W4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS1_vj_update (store W4_RS_vj (_ bv1 2) W4_RS1_qj_ROB_result))	
				(W4_RS1_vk_update (store W4_RS_vk (_ bv1 2) W4_RS1_qk_ROB_result))	
				(W4_RS1_qj_update (store W4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(W4_RS1_qk_update (store W4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_vj_update (store W4_LSQ_vj (_ bv1 2) W4_LSQ1_qj_ROB_result))	
				(W4_LSQ1_vk_update (store W4_LSQ_vk (_ bv1 2) W4_LSQ1_qk_ROB_result))	
				(W4_LSQ1_qj_update (store W4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_qk_update (store W4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS2_vj_update (store W4_RS_vj (_ bv2 2) W4_RS2_qj_ROB_result))	
				(W4_RS2_vk_update (store W4_RS_vk (_ bv2 2) W4_RS2_qk_ROB_result))	
				(W4_RS2_qj_update (store W4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(W4_RS2_qk_update (store W4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_vj_update (store W4_LSQ_vj (_ bv2 2) W4_LSQ2_qj_ROB_result))	
				(W4_LSQ2_vk_update (store W4_LSQ_vk (_ bv2 2) W4_LSQ2_qk_ROB_result))	
				(W4_LSQ2_qj_update (store W4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_qk_update (store W4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS3_vj_update (store W4_RS_vj (_ bv3 2) W4_RS3_qj_ROB_result))	
				(W4_RS3_vk_update (store W4_RS_vk (_ bv3 2) W4_RS3_qk_ROB_result))	
				(W4_RS3_qj_update (store W4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(W4_RS3_qk_update (store W4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_vj_update (store W4_LSQ_vj (_ bv3 2) W4_LSQ3_qj_ROB_result))	
				(W4_LSQ3_vk_update (store W4_LSQ_vk (_ bv3 2) W4_LSQ3_qk_ROB_result))	
				(W4_LSQ3_qj_update (store W4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_qk_update (store W4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_dis (ite (and (= #b1 W4_RS0_busy) (= #b000 W4_RS0_qj) (= #b000 W4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS1_dis (ite (and (= #b1 W4_RS1_busy) (= #b000 W4_RS1_qj) (= #b000 W4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS2_dis (ite (and (= #b1 W4_RS2_busy) (= #b000 W4_RS2_qj) (= #b000 W4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS3_dis (ite (and (= #b1 W4_RS3_busy) (= #b000 W4_RS3_qj) (= #b000 W4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(W4_LSQ0_dis (ite (and (= #b1 W4_LSQ0_busy) (= #b000 W4_LSQ0_qj) (= #b000 W4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ1_dis (ite (and (= #b1 W4_LSQ1_busy) (= #b000 W4_LSQ1_qj) (= #b000 W4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ2_dis (ite (and (= #b1 W4_LSQ2_busy) (= #b000 W4_LSQ2_qj) (= #b000 W4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ3_dis (ite (and (= #b1 W4_LSQ3_busy) (= #b000 W4_LSQ3_qj) (= #b000 W4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv0 2) W4_RS0_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv0 2) W4_LSQ0_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv1 2) W4_RS1_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv1 2) W4_LSQ1_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv2 2) W4_RS2_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv2 2) W4_LSQ2_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv3 2) W4_RS3_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv3 2) W4_LSQ3_dis))
			)
		(let
			(
				(W4_RF (ite (= 0 0) W4_RF W4_RF))
				(W4_DM (ite (= 0 0) W4_DM W4_DM))
				
				(W4_Cache_Tag (ite (= 0 0) W4_Cache_Tag W4_Cache_Tag))
				(W4_Cache_Data (ite (= 0 0) W4_Cache_Data W4_Cache_Data))
				(W4_Cache_Valid (ite (= 0 0) W4_Cache_Valid W4_Cache_Valid))
				
				(W4_PC (ite (= 0 0) W4_PC W4_PC))
				
				(W4_IP (ite (= 0 0) W4_IP W4_IP))
				(W4_CP (ite (= 0 0) W4_CP W4_CP))
				
				(W4_ROB_busy (ite (= 0 0) W4_ROB_busy W4_ROB_busy))
				(W4_ROB_op_type (ite (= 0 0) W4_ROB_op_type W4_ROB_op_type))
				(W4_ROB_destination (ite (= 0 0) W4_ROB_destination W4_ROB_destination))
				(W4_ROB_result (ite (= 0 0) W4_ROB_result W4_ROB_result))
				(W4_ROB_exception (ite (= 0 0) W4_ROB_exception W4_ROB_exception))
				(W4_ROB_done (ite (= 0 0) W4_ROB_done W4_ROB_done))
				
				(W4_RS_op_type (ite (= 0 0) W4_RS_op_type W4_RS_op_type))
				(W4_RS_op (ite (= 0 0) W4_RS_op W4_RS_op))
				(W4_RS_ROB_dst (ite (= 0 0) W4_RS_ROB_dst W4_RS_ROB_dst))
				(W4_RS_vj (ite (= 0 0) W4_RS_vj W4_RS_vj))
				(W4_RS_vk (ite (= 0 0) W4_RS_vk W4_RS_vk))
				(W4_RS_qj (ite (= 0 0) W4_RS_qj W4_RS_qj))
				(W4_RS_qk (ite (= 0 0) W4_RS_qk W4_RS_qk))
				(W4_RS_imm (ite (= 0 0) W4_RS_imm W4_RS_imm))
				(W4_RS_dis (ite (= 0 0) W4_RS_dis W4_RS_dis))
				(W4_RS_busy (ite (= 0 0) W4_RS_busy W4_RS_busy))
				
				(W4_LSQ_op_type (ite (= 0 0) W4_LSQ_op_type W4_LSQ_op_type))
				(W4_LSQ_op (ite (= 0 0) W4_LSQ_op W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= 0 0) W4_LSQ_ROB_dst W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= 0 0) W4_LSQ_vj W4_LSQ_vj))
				(W4_LSQ_vk (ite (= 0 0) W4_LSQ_vk W4_LSQ_vk))
				(W4_LSQ_qj (ite (= 0 0) W4_LSQ_qj W4_LSQ_qj))
				(W4_LSQ_qk (ite (= 0 0) W4_LSQ_qk W4_LSQ_qk))
				(W4_LSQ_imm (ite (= 0 0) W4_LSQ_imm W4_LSQ_imm))
				(W4_LSQ_dis (ite (= 0 0) W4_LSQ_dis W4_LSQ_dis))
				(W4_LSQ_busy (ite (= 0 0) W4_LSQ_busy W4_LSQ_busy))
				
				(W4_Evict_Tag (ite (= 0 0) W4_Evict_Tag W4_Evict_Tag))
				(W4_Evict_Valid (ite (= 0 0) W4_Evict_Valid W4_Evict_Valid))
				(W4_Evict_Index (ite (= 0 0) W4_Evict_Index W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Mul_div) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(W4_RS0_dis (select W4_RS_dis (_ bv0 2)))
				(W4_RS1_dis (select W4_RS_dis (_ bv1 2)))
				(W4_RS2_dis (select W4_RS_dis (_ bv2 2)))
				(W4_RS3_dis (select W4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(W4_RS_dis_index
					(ite (= W4_RS0_dis #b1) (_ bv0 2)
					(ite (= W4_RS1_dis #b1) (_ bv1 2)
					(ite (= W4_RS2_dis #b1) (_ bv2 2)
					(ite (= W4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_RS_entry_dispatched (bvor W4_RS0_dis W4_RS1_dis W4_RS2_dis W4_RS3_dis))
			)	
		(let
			(
				(W4_RS_dis_vj (select W4_RS_vj W4_RS_dis_index))
				(W4_RS_dis_vk (select W4_RS_vk W4_RS_dis_index))
				(W4_RS_dis_qj (select W4_RS_qj W4_RS_dis_index))
				(W4_RS_dis_qk (select W4_RS_qk W4_RS_dis_index))
				(W4_RS_dis_op (select W4_RS_op W4_RS_dis_index))
				(W4_RS_dis_op_type (select W4_RS_op_type W4_RS_dis_index))
				(W4_RS_dis_imm (select W4_RS_imm W4_RS_dis_index))
				(W4_RS_dis_ROB_dst (select W4_RS_ROB_dst W4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(ALW1_result (ALU1 W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
			)
		(let
			(
				(W4_RS_result
					(ite (= W4_RS_dis_op_type Rtype) ALW1_result
					(ite (= W4_RS_dis_op_type Branch) Branch_result
					(ite (= W4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(W4_ROB_result_update (store W4_ROB_result W4_RS_dis_ROB_dst W4_RS_result))
				(W4_ROB_done_update (store W4_ROB_done W4_RS_dis_ROB_dst (_ bv1 1)))
				(W4_ROB_exception_update (store W4_ROB_exception W4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(W4_ROB_result (ite (= W4_RS_entry_dispatched #b1) W4_ROB_result_update W4_ROB_result))
				(W4_ROB_done (ite (= W4_RS_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				(W4_ROB_exception (ite (and (= W4_RS_dis_op_type Branch) (= W4_RS_result 1) (= W4_RS_entry_dispatched #b1)) W4_ROB_exception_update W4_ROB_exception))
			)
		(let
			(
				(W4_RS_op_type_update (store W4_RS_op_type W4_RS_dis_index 0))
				(W4_RS_op_update (store W4_RS_op W4_RS_dis_index 0))
				(W4_RS_ROB_dst_update (store W4_RS_ROB_dst W4_RS_dis_index (_ bv0 3)))
				(W4_RS_vj_update (store W4_RS_vj W4_RS_dis_index 0))
				(W4_RS_vk_update (store W4_RS_vk W4_RS_dis_index 0))
				(W4_RS_qj_update (store W4_RS_qj W4_RS_dis_index (_ bv0 3)))
				(W4_RS_qk_update (store W4_RS_qk W4_RS_dis_index (_ bv0 3)))
				(W4_RS_imm_update (store W4_RS_imm W4_RS_dis_index 0))
				(W4_RS_dis_update (store W4_RS_dis W4_RS_dis_index (_ bv0 1)))
				(W4_RS_busy_update (store W4_RS_busy W4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_RS_op_type (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_type_update W4_RS_op_type))
				(W4_RS_op (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_update W4_RS_op))
				(W4_RS_ROB_dst (ite (= W4_RS_entry_dispatched #b1) W4_RS_ROB_dst_update W4_RS_ROB_dst))
				(W4_RS_vj (ite (= W4_RS_entry_dispatched #b1) W4_RS_vj_update W4_RS_vj))
				(W4_RS_vk (ite (= W4_RS_entry_dispatched #b1) W4_RS_vk_update W4_RS_vk))
				(W4_RS_qj (ite (= W4_RS_entry_dispatched #b1) W4_RS_qj_update W4_RS_qj))
				(W4_RS_qk (ite (= W4_RS_entry_dispatched #b1) W4_RS_qk_update W4_RS_qk))
				(W4_RS_imm (ite (= W4_RS_entry_dispatched #b1) W4_RS_imm_update W4_RS_imm))
				(W4_RS_dis (ite (= W4_RS_entry_dispatched #b1) W4_RS_dis_update W4_RS_dis))
				(W4_RS_busy (ite (= W4_RS_entry_dispatched #b1) W4_RS_busy_update W4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(W4_LSQ0_dis (select W4_LSQ_dis (_ bv0 2)))
				(W4_LSQ1_dis (select W4_LSQ_dis (_ bv1 2)))
				(W4_LSQ2_dis (select W4_LSQ_dis (_ bv2 2)))
				(W4_LSQ3_dis (select W4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(W4_LSQ_dis_index
					(ite (= W4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= W4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= W4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= W4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_LSQ_entry_dispatched (bvor W4_LSQ0_dis W4_LSQ1_dis W4_LSQ2_dis W4_LSQ3_dis))
			)	
		(let
			(
				(W4_LSQ_dis_vj (select W4_LSQ_vj W4_LSQ_dis_index))
				(W4_LSQ_dis_vk (select W4_LSQ_vk W4_LSQ_dis_index))
				(W4_LSQ_dis_qj (select W4_LSQ_qj W4_LSQ_dis_index))
				(W4_LSQ_dis_qk (select W4_LSQ_qk W4_LSQ_dis_index))
				(W4_LSQ_dis_op (select W4_LSQ_op W4_LSQ_dis_index))
				(W4_LSQ_dis_op_type (select W4_LSQ_op_type W4_LSQ_dis_index))
				(W4_LSQ_dis_imm (select W4_LSQ_imm W4_LSQ_dis_index))
				(W4_LSQ_dis_ROB_dst (select W4_LSQ_ROB_dst W4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
				(Store_address (STORE_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select W4_DM LOAD_addr))
				(W4_Cache0_Hit_Load (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Load (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Load (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Load (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
			)
		(let
			(
				(W4_Cache_Hit_load (bvor W4_Cache0_Hit_Load W4_Cache1_Hit_Load W4_Cache2_Hit_Load W4_Cache3_Hit_Load))
			)
		(let
			(
				(W4_LSQ_result
					(ite (= W4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= W4_LSQ_dis_op_type Store) W4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(W4_ROB_destination_update (store W4_ROB_destination W4_LSQ_dis_ROB_dst Store_address))
				(W4_ROB_result_load (store W4_ROB_result W4_LSQ_dis_ROB_dst LOAD_Value))
				(W4_ROB_result_store (store W4_ROB_result W4_LSQ_dis_ROB_dst W4_LSQ_dis_vk))
				(W4_ROB_done_update (store W4_ROB_done W4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(W4_Cache_tag_Update_Load (store W4_Cache_Tag Available_W4_Cache_Line LOAD_addr))
				
				(W4_Cache_data_Update_Load (store W4_Cache_Data Available_W4_Cache_Line LOAD_Value))
				
				(W4_Cache_valid_Update_Load (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag ))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid ))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
				
			)
		(let
			(
				(W4_Evict_Tag (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Index_update W4_Evict_Index))
			)
		(let
			(
				(W4_ROB_destination (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_destination_update W4_ROB_destination))
				(W4_ROB_result
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Load)) W4_ROB_result_load
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_result_store
					W4_ROB_result
					))
				)
				(W4_ROB_done (ite (= W4_LSQ_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				
				(W4_Cache_Tag
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_tag_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Tag
					)
				)
				(W4_Cache_Data
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_data_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Data
					)
				)
				(W4_Cache_Valid
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_valid_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Valid
					)
				)
			)
		(let
			(
				(W4_LSQ_op_type_update (store W4_LSQ_op_type W4_LSQ_dis_index 0))
				(W4_LSQ_op_update (store W4_LSQ_op W4_LSQ_dis_index 0))
				(W4_LSQ_ROB_dst_update (store W4_LSQ_ROB_dst W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_vj_update (store W4_LSQ_vj W4_LSQ_dis_index 0))
				(W4_LSQ_vk_update (store W4_LSQ_vk W4_LSQ_dis_index 0))
				(W4_LSQ_qj_update (store W4_LSQ_qj W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_qk_update (store W4_LSQ_qk W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_imm_update (store W4_LSQ_imm W4_LSQ_dis_index 0))
				(W4_LSQ_dis_update (store W4_LSQ_dis W4_LSQ_dis_index (_ bv0 1)))
				(W4_LSQ_busy_update (store W4_LSQ_busy W4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_LSQ_op_type (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_type_update W4_LSQ_op_type))
				(W4_LSQ_op (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_update W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_ROB_dst_update W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qk_update W4_LSQ_qk))
				(W4_LSQ_imm (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_imm_update W4_LSQ_imm))
				(W4_LSQ_dis (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_dis_update W4_LSQ_dis))
				(W4_LSQ_busy (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_busy_update W4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_qj_ROB_done (select W4_ROB_done W4_RS0_qj))
				(W4_RS0_qj_ROB_result (select W4_ROB_result W4_RS0_qj))
				(W4_RS0_qk_ROB_done (select W4_ROB_done W4_RS0_qk))
				(W4_RS0_qk_ROB_result (select W4_ROB_result W4_RS0_qk))
				(W4_RS1_qj_ROB_done (select W4_ROB_done W4_RS1_qj))
				(W4_RS1_qj_ROB_result (select W4_ROB_result W4_RS1_qj))
				(W4_RS1_qk_ROB_done (select W4_ROB_done W4_RS1_qk))
				(W4_RS1_qk_ROB_result (select W4_ROB_result W4_RS1_qk))
				(W4_RS2_qj_ROB_done (select W4_ROB_done W4_RS2_qj))
				(W4_RS2_qj_ROB_result (select W4_ROB_result W4_RS2_qj))
				(W4_RS2_qk_ROB_done (select W4_ROB_done W4_RS2_qk))
				(W4_RS2_qk_ROB_result (select W4_ROB_result W4_RS2_qk))
				(W4_RS3_qj_ROB_done (select W4_ROB_done W4_RS3_qj))
				(W4_RS3_qj_ROB_result (select W4_ROB_result W4_RS3_qj))
				(W4_RS3_qk_ROB_done (select W4_ROB_done W4_RS3_qk))
				(W4_RS3_qk_ROB_result (select W4_ROB_result W4_RS3_qk))
				
				(W4_LSQ0_qj_ROB_done (select W4_ROB_done W4_LSQ0_qj))
				(W4_LSQ0_qj_ROB_result (select W4_ROB_result W4_LSQ0_qj))
				(W4_LSQ0_qk_ROB_done (select W4_ROB_done W4_LSQ0_qk))
				(W4_LSQ0_qk_ROB_result (select W4_ROB_result W4_LSQ0_qk))
				(W4_LSQ1_qj_ROB_done (select W4_ROB_done W4_LSQ1_qj))
				(W4_LSQ1_qj_ROB_result (select W4_ROB_result W4_LSQ1_qj))
				(W4_LSQ1_qk_ROB_done (select W4_ROB_done W4_LSQ1_qk))
				(W4_LSQ1_qk_ROB_result (select W4_ROB_result W4_LSQ1_qk))
				(W4_LSQ2_qj_ROB_done (select W4_ROB_done W4_LSQ2_qj))
				(W4_LSQ2_qj_ROB_result (select W4_ROB_result W4_LSQ2_qj))
				(W4_LSQ2_qk_ROB_done (select W4_ROB_done W4_LSQ2_qk))
				(W4_LSQ2_qk_ROB_result (select W4_ROB_result W4_LSQ2_qk))
				(W4_LSQ3_qj_ROB_done (select W4_ROB_done W4_LSQ3_qj))
				(W4_LSQ3_qj_ROB_result (select W4_ROB_result W4_LSQ3_qj))
				(W4_LSQ3_qk_ROB_done (select W4_ROB_done W4_LSQ3_qk))
				(W4_LSQ3_qk_ROB_result (select W4_ROB_result W4_LSQ3_qk))
			)
		(let
			(
				(W4_RS0_vj_update (store W4_RS_vj (_ bv0 2) W4_RS0_qj_ROB_result))
				(W4_RS0_vk_update (store W4_RS_vk (_ bv0 2) W4_RS0_qk_ROB_result))					
				(W4_RS0_qj_update (store W4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(W4_RS0_qk_update (store W4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_vj_update (store W4_LSQ_vj (_ bv0 2) W4_LSQ0_qj_ROB_result))	
				(W4_LSQ0_vk_update (store W4_LSQ_vk (_ bv0 2) W4_LSQ0_qk_ROB_result))	
				(W4_LSQ0_qj_update (store W4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_qk_update (store W4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS1_vj_update (store W4_RS_vj (_ bv1 2) W4_RS1_qj_ROB_result))	
				(W4_RS1_vk_update (store W4_RS_vk (_ bv1 2) W4_RS1_qk_ROB_result))	
				(W4_RS1_qj_update (store W4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(W4_RS1_qk_update (store W4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_vj_update (store W4_LSQ_vj (_ bv1 2) W4_LSQ1_qj_ROB_result))	
				(W4_LSQ1_vk_update (store W4_LSQ_vk (_ bv1 2) W4_LSQ1_qk_ROB_result))	
				(W4_LSQ1_qj_update (store W4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_qk_update (store W4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS2_vj_update (store W4_RS_vj (_ bv2 2) W4_RS2_qj_ROB_result))	
				(W4_RS2_vk_update (store W4_RS_vk (_ bv2 2) W4_RS2_qk_ROB_result))	
				(W4_RS2_qj_update (store W4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(W4_RS2_qk_update (store W4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_vj_update (store W4_LSQ_vj (_ bv2 2) W4_LSQ2_qj_ROB_result))	
				(W4_LSQ2_vk_update (store W4_LSQ_vk (_ bv2 2) W4_LSQ2_qk_ROB_result))	
				(W4_LSQ2_qj_update (store W4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_qk_update (store W4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS3_vj_update (store W4_RS_vj (_ bv3 2) W4_RS3_qj_ROB_result))	
				(W4_RS3_vk_update (store W4_RS_vk (_ bv3 2) W4_RS3_qk_ROB_result))	
				(W4_RS3_qj_update (store W4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(W4_RS3_qk_update (store W4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_vj_update (store W4_LSQ_vj (_ bv3 2) W4_LSQ3_qj_ROB_result))	
				(W4_LSQ3_vk_update (store W4_LSQ_vk (_ bv3 2) W4_LSQ3_qk_ROB_result))	
				(W4_LSQ3_qj_update (store W4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_qk_update (store W4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_dis (ite (and (= #b1 W4_RS0_busy) (= #b000 W4_RS0_qj) (= #b000 W4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS1_dis (ite (and (= #b1 W4_RS1_busy) (= #b000 W4_RS1_qj) (= #b000 W4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS2_dis (ite (and (= #b1 W4_RS2_busy) (= #b000 W4_RS2_qj) (= #b000 W4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS3_dis (ite (and (= #b1 W4_RS3_busy) (= #b000 W4_RS3_qj) (= #b000 W4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(W4_LSQ0_dis (ite (and (= #b1 W4_LSQ0_busy) (= #b000 W4_LSQ0_qj) (= #b000 W4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ1_dis (ite (and (= #b1 W4_LSQ1_busy) (= #b000 W4_LSQ1_qj) (= #b000 W4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ2_dis (ite (and (= #b1 W4_LSQ2_busy) (= #b000 W4_LSQ2_qj) (= #b000 W4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ3_dis (ite (and (= #b1 W4_LSQ3_busy) (= #b000 W4_LSQ3_qj) (= #b000 W4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv0 2) W4_RS0_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv0 2) W4_LSQ0_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv1 2) W4_RS1_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv1 2) W4_LSQ1_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv2 2) W4_RS2_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv2 2) W4_LSQ2_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv3 2) W4_RS3_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv3 2) W4_LSQ3_dis))
			)
		(let
			(
				(W4_RF (ite (= 0 0) W4_RF W4_RF))
				(W4_DM (ite (= 0 0) W4_DM W4_DM))
				
				(W4_Cache_Tag (ite (= 0 0) W4_Cache_Tag W4_Cache_Tag))
				(W4_Cache_Data (ite (= 0 0) W4_Cache_Data W4_Cache_Data))
				(W4_Cache_Valid (ite (= 0 0) W4_Cache_Valid W4_Cache_Valid))
				
				(W4_PC (ite (= 0 0) W4_PC W4_PC))
				
				(W4_IP (ite (= 0 0) W4_IP W4_IP))
				(W4_CP (ite (= 0 0) W4_CP W4_CP))
				
				(W4_ROB_busy (ite (= 0 0) W4_ROB_busy W4_ROB_busy))
				(W4_ROB_op_type (ite (= 0 0) W4_ROB_op_type W4_ROB_op_type))
				(W4_ROB_destination (ite (= 0 0) W4_ROB_destination W4_ROB_destination))
				(W4_ROB_result (ite (= 0 0) W4_ROB_result W4_ROB_result))
				(W4_ROB_exception (ite (= 0 0) W4_ROB_exception W4_ROB_exception))
				(W4_ROB_done (ite (= 0 0) W4_ROB_done W4_ROB_done))
				
				(W4_RS_op_type (ite (= 0 0) W4_RS_op_type W4_RS_op_type))
				(W4_RS_op (ite (= 0 0) W4_RS_op W4_RS_op))
				(W4_RS_ROB_dst (ite (= 0 0) W4_RS_ROB_dst W4_RS_ROB_dst))
				(W4_RS_vj (ite (= 0 0) W4_RS_vj W4_RS_vj))
				(W4_RS_vk (ite (= 0 0) W4_RS_vk W4_RS_vk))
				(W4_RS_qj (ite (= 0 0) W4_RS_qj W4_RS_qj))
				(W4_RS_qk (ite (= 0 0) W4_RS_qk W4_RS_qk))
				(W4_RS_imm (ite (= 0 0) W4_RS_imm W4_RS_imm))
				(W4_RS_dis (ite (= 0 0) W4_RS_dis W4_RS_dis))
				(W4_RS_busy (ite (= 0 0) W4_RS_busy W4_RS_busy))
				
				(W4_LSQ_op_type (ite (= 0 0) W4_LSQ_op_type W4_LSQ_op_type))
				(W4_LSQ_op (ite (= 0 0) W4_LSQ_op W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= 0 0) W4_LSQ_ROB_dst W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= 0 0) W4_LSQ_vj W4_LSQ_vj))
				(W4_LSQ_vk (ite (= 0 0) W4_LSQ_vk W4_LSQ_vk))
				(W4_LSQ_qj (ite (= 0 0) W4_LSQ_qj W4_LSQ_qj))
				(W4_LSQ_qk (ite (= 0 0) W4_LSQ_qk W4_LSQ_qk))
				(W4_LSQ_imm (ite (= 0 0) W4_LSQ_imm W4_LSQ_imm))
				(W4_LSQ_dis (ite (= 0 0) W4_LSQ_dis W4_LSQ_dis))
				(W4_LSQ_busy (ite (= 0 0) W4_LSQ_busy W4_LSQ_busy))
				
				(W4_Evict_Tag (ite (= 0 0) W4_Evict_Tag W4_Evict_Tag))
				(W4_Evict_Valid (ite (= 0 0) W4_Evict_Valid W4_Evict_Valid))
				(W4_Evict_Index (ite (= 0 0) W4_Evict_Index W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Mul_div) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)





;---------------------------Dispatch, Broadcast and update-----------------------------------------------------------
		(let
			(
				(W4_RS0_dis (select W4_RS_dis (_ bv0 2)))
				(W4_RS1_dis (select W4_RS_dis (_ bv1 2)))
				(W4_RS2_dis (select W4_RS_dis (_ bv2 2)))
				(W4_RS3_dis (select W4_RS_dis (_ bv3 2)))
			)
		(let
			(
				(W4_RS_dis_index
					(ite (= W4_RS0_dis #b1) (_ bv0 2)
					(ite (= W4_RS1_dis #b1) (_ bv1 2)
					(ite (= W4_RS2_dis #b1) (_ bv2 2)
					(ite (= W4_RS3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_RS_entry_dispatched (bvor W4_RS0_dis W4_RS1_dis W4_RS2_dis W4_RS3_dis))
			)	
		(let
			(
				(W4_RS_dis_vj (select W4_RS_vj W4_RS_dis_index))
				(W4_RS_dis_vk (select W4_RS_vk W4_RS_dis_index))
				(W4_RS_dis_qj (select W4_RS_qj W4_RS_dis_index))
				(W4_RS_dis_qk (select W4_RS_qk W4_RS_dis_index))
				(W4_RS_dis_op (select W4_RS_op W4_RS_dis_index))
				(W4_RS_dis_op_type (select W4_RS_op_type W4_RS_dis_index))
				(W4_RS_dis_imm (select W4_RS_imm W4_RS_dis_index))
				(W4_RS_dis_ROB_dst (select W4_RS_ROB_dst W4_RS_dis_index))
			)
		(let
			(
				(Branch_result (ALU2_BR W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(ALW1_result (ALU1 W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
				(MUL_DIV_result (MUL_DIV W4_RS_dis_vj W4_RS_dis_vk W4_RS_dis_imm W4_RS_dis_op))
			)
		(let
			(
				(W4_RS_result
					(ite (= W4_RS_dis_op_type Rtype) ALW1_result
					(ite (= W4_RS_dis_op_type Branch) Branch_result
					(ite (= W4_RS_dis_op_type Mul_div) MUL_DIV_result 0
					)))
				)
			)
		(let
			(
				(W4_ROB_result_update (store W4_ROB_result W4_RS_dis_ROB_dst W4_RS_result))
				(W4_ROB_done_update (store W4_ROB_done W4_RS_dis_ROB_dst (_ bv1 1)))
				(W4_ROB_exception_update (store W4_ROB_exception W4_RS_dis_ROB_dst (_ bv1 1)))
			)
		(let
			(
				(W4_ROB_result (ite (= W4_RS_entry_dispatched #b1) W4_ROB_result_update W4_ROB_result))
				(W4_ROB_done (ite (= W4_RS_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				(W4_ROB_exception (ite (and (= W4_RS_dis_op_type Branch) (= W4_RS_result 1) (= W4_RS_entry_dispatched #b1)) W4_ROB_exception_update W4_ROB_exception))
			)
		(let
			(
				(W4_RS_op_type_update (store W4_RS_op_type W4_RS_dis_index 0))
				(W4_RS_op_update (store W4_RS_op W4_RS_dis_index 0))
				(W4_RS_ROB_dst_update (store W4_RS_ROB_dst W4_RS_dis_index (_ bv0 3)))
				(W4_RS_vj_update (store W4_RS_vj W4_RS_dis_index 0))
				(W4_RS_vk_update (store W4_RS_vk W4_RS_dis_index 0))
				(W4_RS_qj_update (store W4_RS_qj W4_RS_dis_index (_ bv0 3)))
				(W4_RS_qk_update (store W4_RS_qk W4_RS_dis_index (_ bv0 3)))
				(W4_RS_imm_update (store W4_RS_imm W4_RS_dis_index 0))
				(W4_RS_dis_update (store W4_RS_dis W4_RS_dis_index (_ bv0 1)))
				(W4_RS_busy_update (store W4_RS_busy W4_RS_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_RS_op_type (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_type_update W4_RS_op_type))
				(W4_RS_op (ite (= W4_RS_entry_dispatched #b1) W4_RS_op_update W4_RS_op))
				(W4_RS_ROB_dst (ite (= W4_RS_entry_dispatched #b1) W4_RS_ROB_dst_update W4_RS_ROB_dst))
				(W4_RS_vj (ite (= W4_RS_entry_dispatched #b1) W4_RS_vj_update W4_RS_vj))
				(W4_RS_vk (ite (= W4_RS_entry_dispatched #b1) W4_RS_vk_update W4_RS_vk))
				(W4_RS_qj (ite (= W4_RS_entry_dispatched #b1) W4_RS_qj_update W4_RS_qj))
				(W4_RS_qk (ite (= W4_RS_entry_dispatched #b1) W4_RS_qk_update W4_RS_qk))
				(W4_RS_imm (ite (= W4_RS_entry_dispatched #b1) W4_RS_imm_update W4_RS_imm))
				(W4_RS_dis (ite (= W4_RS_entry_dispatched #b1) W4_RS_dis_update W4_RS_dis))
				(W4_RS_busy (ite (= W4_RS_entry_dispatched #b1) W4_RS_busy_update W4_RS_busy))
			)
;=============================================================================================================
		(let
			(
				(W4_LSQ0_dis (select W4_LSQ_dis (_ bv0 2)))
				(W4_LSQ1_dis (select W4_LSQ_dis (_ bv1 2)))
				(W4_LSQ2_dis (select W4_LSQ_dis (_ bv2 2)))
				(W4_LSQ3_dis (select W4_LSQ_dis (_ bv3 2)))
			)
		(let
			(
				(W4_LSQ_dis_index
					(ite (= W4_LSQ0_dis #b1) (_ bv0 2)
					(ite (= W4_LSQ1_dis #b1) (_ bv1 2)
					(ite (= W4_LSQ2_dis #b1) (_ bv2 2)
					(ite (= W4_LSQ3_dis #b1) (_ bv3 2) (_ bv0 2)
					))))
				)
				(W4_LSQ_entry_dispatched (bvor W4_LSQ0_dis W4_LSQ1_dis W4_LSQ2_dis W4_LSQ3_dis))
			)	
		(let
			(
				(W4_LSQ_dis_vj (select W4_LSQ_vj W4_LSQ_dis_index))
				(W4_LSQ_dis_vk (select W4_LSQ_vk W4_LSQ_dis_index))
				(W4_LSQ_dis_qj (select W4_LSQ_qj W4_LSQ_dis_index))
				(W4_LSQ_dis_qk (select W4_LSQ_qk W4_LSQ_dis_index))
				(W4_LSQ_dis_op (select W4_LSQ_op W4_LSQ_dis_index))
				(W4_LSQ_dis_op_type (select W4_LSQ_op_type W4_LSQ_dis_index))
				(W4_LSQ_dis_imm (select W4_LSQ_imm W4_LSQ_dis_index))
				(W4_LSQ_dis_ROB_dst (select W4_LSQ_ROB_dst W4_LSQ_dis_index))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
				(Store_address (STORE_Unit W4_LSQ_dis_vj W4_LSQ_dis_imm W4_LSQ_dis_op))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(LOAD_Value (select W4_DM LOAD_addr))
				(W4_Cache0_Hit_Load (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Load (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Load (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Load (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
			)
		(let
			(
				(W4_Cache_Hit_load (bvor W4_Cache0_Hit_Load W4_Cache1_Hit_Load W4_Cache2_Hit_Load W4_Cache3_Hit_Load))
			)
		(let
			(
				(W4_LSQ_result
					(ite (= W4_LSQ_dis_op_type Load) LOAD_Value
					(ite (= W4_LSQ_dis_op_type Store) W4_LSQ_dis_vk
					0))
				)
			)
		(let
			(
				(W4_ROB_destination_update (store W4_ROB_destination W4_LSQ_dis_ROB_dst Store_address))
				(W4_ROB_result_load (store W4_ROB_result W4_LSQ_dis_ROB_dst LOAD_Value))
				(W4_ROB_result_store (store W4_ROB_result W4_LSQ_dis_ROB_dst W4_LSQ_dis_vk))
				(W4_ROB_done_update (store W4_ROB_done W4_LSQ_dis_ROB_dst (_ bv1 1)))
				
				(W4_Cache_tag_Update_Load (store W4_Cache_Tag Available_W4_Cache_Line LOAD_addr))
				
				(W4_Cache_data_Update_Load (store W4_Cache_Data Available_W4_Cache_Line LOAD_Value))
				
				(W4_Cache_valid_Update_Load (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag ))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid ))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
				
			)
		(let
			(
				(W4_Evict_Tag (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Index_update W4_Evict_Index))
			)
		(let
			(
				(W4_ROB_destination (ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_destination_update W4_ROB_destination))
				(W4_ROB_result
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Load)) W4_ROB_result_load
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_LSQ_dis_op_type Store)) W4_ROB_result_store
					W4_ROB_result
					))
				)
				(W4_ROB_done (ite (= W4_LSQ_entry_dispatched #b1) W4_ROB_done_update W4_ROB_done))
				
				(W4_Cache_Tag
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_tag_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Tag
					)
				)
				(W4_Cache_Data
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_data_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Data
					)
				)
				(W4_Cache_Valid
					(ite (and (= W4_LSQ_entry_dispatched #b1) (= W4_Cache_Hit_load #b0) (= W4_LSQ_dis_op_type Load)) W4_Cache_valid_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Valid
					)
				)
			)
		(let
			(
				(W4_LSQ_op_type_update (store W4_LSQ_op_type W4_LSQ_dis_index 0))
				(W4_LSQ_op_update (store W4_LSQ_op W4_LSQ_dis_index 0))
				(W4_LSQ_ROB_dst_update (store W4_LSQ_ROB_dst W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_vj_update (store W4_LSQ_vj W4_LSQ_dis_index 0))
				(W4_LSQ_vk_update (store W4_LSQ_vk W4_LSQ_dis_index 0))
				(W4_LSQ_qj_update (store W4_LSQ_qj W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_qk_update (store W4_LSQ_qk W4_LSQ_dis_index (_ bv0 3)))
				(W4_LSQ_imm_update (store W4_LSQ_imm W4_LSQ_dis_index 0))
				(W4_LSQ_dis_update (store W4_LSQ_dis W4_LSQ_dis_index (_ bv0 1)))
				(W4_LSQ_busy_update (store W4_LSQ_busy W4_LSQ_dis_index (_ bv0 1)))
			)
		(let
			(
				(W4_LSQ_op_type (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_type_update W4_LSQ_op_type))
				(W4_LSQ_op (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_op_update W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_ROB_dst_update W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_qk_update W4_LSQ_qk))
				(W4_LSQ_imm (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_imm_update W4_LSQ_imm))
				(W4_LSQ_dis (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_dis_update W4_LSQ_dis))
				(W4_LSQ_busy (ite (= W4_LSQ_entry_dispatched #b1) W4_LSQ_busy_update W4_LSQ_busy))
			)
;==================================update======================================================================
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_qj_ROB_done (select W4_ROB_done W4_RS0_qj))
				(W4_RS0_qj_ROB_result (select W4_ROB_result W4_RS0_qj))
				(W4_RS0_qk_ROB_done (select W4_ROB_done W4_RS0_qk))
				(W4_RS0_qk_ROB_result (select W4_ROB_result W4_RS0_qk))
				(W4_RS1_qj_ROB_done (select W4_ROB_done W4_RS1_qj))
				(W4_RS1_qj_ROB_result (select W4_ROB_result W4_RS1_qj))
				(W4_RS1_qk_ROB_done (select W4_ROB_done W4_RS1_qk))
				(W4_RS1_qk_ROB_result (select W4_ROB_result W4_RS1_qk))
				(W4_RS2_qj_ROB_done (select W4_ROB_done W4_RS2_qj))
				(W4_RS2_qj_ROB_result (select W4_ROB_result W4_RS2_qj))
				(W4_RS2_qk_ROB_done (select W4_ROB_done W4_RS2_qk))
				(W4_RS2_qk_ROB_result (select W4_ROB_result W4_RS2_qk))
				(W4_RS3_qj_ROB_done (select W4_ROB_done W4_RS3_qj))
				(W4_RS3_qj_ROB_result (select W4_ROB_result W4_RS3_qj))
				(W4_RS3_qk_ROB_done (select W4_ROB_done W4_RS3_qk))
				(W4_RS3_qk_ROB_result (select W4_ROB_result W4_RS3_qk))
				
				(W4_LSQ0_qj_ROB_done (select W4_ROB_done W4_LSQ0_qj))
				(W4_LSQ0_qj_ROB_result (select W4_ROB_result W4_LSQ0_qj))
				(W4_LSQ0_qk_ROB_done (select W4_ROB_done W4_LSQ0_qk))
				(W4_LSQ0_qk_ROB_result (select W4_ROB_result W4_LSQ0_qk))
				(W4_LSQ1_qj_ROB_done (select W4_ROB_done W4_LSQ1_qj))
				(W4_LSQ1_qj_ROB_result (select W4_ROB_result W4_LSQ1_qj))
				(W4_LSQ1_qk_ROB_done (select W4_ROB_done W4_LSQ1_qk))
				(W4_LSQ1_qk_ROB_result (select W4_ROB_result W4_LSQ1_qk))
				(W4_LSQ2_qj_ROB_done (select W4_ROB_done W4_LSQ2_qj))
				(W4_LSQ2_qj_ROB_result (select W4_ROB_result W4_LSQ2_qj))
				(W4_LSQ2_qk_ROB_done (select W4_ROB_done W4_LSQ2_qk))
				(W4_LSQ2_qk_ROB_result (select W4_ROB_result W4_LSQ2_qk))
				(W4_LSQ3_qj_ROB_done (select W4_ROB_done W4_LSQ3_qj))
				(W4_LSQ3_qj_ROB_result (select W4_ROB_result W4_LSQ3_qj))
				(W4_LSQ3_qk_ROB_done (select W4_ROB_done W4_LSQ3_qk))
				(W4_LSQ3_qk_ROB_result (select W4_ROB_result W4_LSQ3_qk))
			)
		(let
			(
				(W4_RS0_vj_update (store W4_RS_vj (_ bv0 2) W4_RS0_qj_ROB_result))
				(W4_RS0_vk_update (store W4_RS_vk (_ bv0 2) W4_RS0_qk_ROB_result))					
				(W4_RS0_qj_update (store W4_RS_qj (_ bv0 2) (_ bv0 3)))	
				(W4_RS0_qk_update (store W4_RS_qk (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_vj_update (store W4_LSQ_vj (_ bv0 2) W4_LSQ0_qj_ROB_result))	
				(W4_LSQ0_vk_update (store W4_LSQ_vk (_ bv0 2) W4_LSQ0_qk_ROB_result))	
				(W4_LSQ0_qj_update (store W4_LSQ_qj (_ bv0 2) (_ bv0 3)))	
				(W4_LSQ0_qk_update (store W4_LSQ_qk (_ bv0 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qj)) (= #b1 W4_RS0_qj_ROB_done)) W4_RS0_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS0_busy) (not (= #b000 W4_RS0_qk)) (= #b1 W4_RS0_qk_ROB_done)) W4_RS0_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qj)) (= #b1 W4_LSQ0_qj_ROB_done)) W4_LSQ0_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ0_busy) (not (= #b000 W4_LSQ0_qk)) (= #b1 W4_LSQ0_qk_ROB_done)) W4_LSQ0_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS1_vj_update (store W4_RS_vj (_ bv1 2) W4_RS1_qj_ROB_result))	
				(W4_RS1_vk_update (store W4_RS_vk (_ bv1 2) W4_RS1_qk_ROB_result))	
				(W4_RS1_qj_update (store W4_RS_qj (_ bv1 2) (_ bv0 3)))	
				(W4_RS1_qk_update (store W4_RS_qk (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_vj_update (store W4_LSQ_vj (_ bv1 2) W4_LSQ1_qj_ROB_result))	
				(W4_LSQ1_vk_update (store W4_LSQ_vk (_ bv1 2) W4_LSQ1_qk_ROB_result))	
				(W4_LSQ1_qj_update (store W4_LSQ_qj (_ bv1 2) (_ bv0 3)))	
				(W4_LSQ1_qk_update (store W4_LSQ_qk (_ bv1 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qj)) (= #b1 W4_RS1_qj_ROB_done)) W4_RS1_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS1_busy) (not (= #b000 W4_RS1_qk)) (= #b1 W4_RS1_qk_ROB_done)) W4_RS1_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qj)) (= #b1 W4_LSQ1_qj_ROB_done)) W4_LSQ1_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ1_busy) (not (= #b000 W4_LSQ1_qk)) (= #b1 W4_LSQ1_qk_ROB_done)) W4_LSQ1_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS2_vj_update (store W4_RS_vj (_ bv2 2) W4_RS2_qj_ROB_result))	
				(W4_RS2_vk_update (store W4_RS_vk (_ bv2 2) W4_RS2_qk_ROB_result))	
				(W4_RS2_qj_update (store W4_RS_qj (_ bv2 2) (_ bv0 3)))	
				(W4_RS2_qk_update (store W4_RS_qk (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_vj_update (store W4_LSQ_vj (_ bv2 2) W4_LSQ2_qj_ROB_result))	
				(W4_LSQ2_vk_update (store W4_LSQ_vk (_ bv2 2) W4_LSQ2_qk_ROB_result))	
				(W4_LSQ2_qj_update (store W4_LSQ_qj (_ bv2 2) (_ bv0 3)))	
				(W4_LSQ2_qk_update (store W4_LSQ_qk (_ bv2 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qj)) (= #b1 W4_RS2_qj_ROB_done)) W4_RS2_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS2_busy) (not (= #b000 W4_RS2_qk)) (= #b1 W4_RS2_qk_ROB_done)) W4_RS2_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qj)) (= #b1 W4_LSQ2_qj_ROB_done)) W4_LSQ2_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ2_busy) (not (= #b000 W4_LSQ2_qk)) (= #b1 W4_LSQ2_qk_ROB_done)) W4_LSQ2_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS3_vj_update (store W4_RS_vj (_ bv3 2) W4_RS3_qj_ROB_result))	
				(W4_RS3_vk_update (store W4_RS_vk (_ bv3 2) W4_RS3_qk_ROB_result))	
				(W4_RS3_qj_update (store W4_RS_qj (_ bv3 2) (_ bv0 3)))	
				(W4_RS3_qk_update (store W4_RS_qk (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_vj_update (store W4_LSQ_vj (_ bv3 2) W4_LSQ3_qj_ROB_result))	
				(W4_LSQ3_vk_update (store W4_LSQ_vk (_ bv3 2) W4_LSQ3_qk_ROB_result))	
				(W4_LSQ3_qj_update (store W4_LSQ_qj (_ bv3 2) (_ bv0 3)))	
				(W4_LSQ3_qk_update (store W4_LSQ_qk (_ bv3 2) (_ bv0 3)))	
			)
		(let
			(
				(W4_RS_vj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_vj_update W4_RS_vj))
				(W4_RS_vk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_vk_update W4_RS_vk))
				(W4_RS_qj (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qj)) (= #b1 W4_RS3_qj_ROB_done)) W4_RS3_qj_update W4_RS_qj))
				(W4_RS_qk (ite (and (= #b1 W4_RS3_busy) (not (= #b000 W4_RS3_qk)) (= #b1 W4_RS3_qk_ROB_done)) W4_RS3_qk_update W4_RS_qk))
				(W4_LSQ_vj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_vj_update W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_vk_update W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qj)) (= #b1 W4_LSQ3_qj_ROB_done)) W4_LSQ3_qj_update W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= #b1 W4_LSQ3_busy) (not (= #b000 W4_LSQ3_qk)) (= #b1 W4_LSQ3_qk_ROB_done)) W4_LSQ3_qk_update W4_LSQ_qk))
			)
		(let
			(
				(W4_RS0_busy (select W4_RS_busy (_ bv0 2)))
				(W4_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(W4_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(W4_RS1_busy (select W4_RS_busy (_ bv1 2)))
				(W4_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(W4_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(W4_RS2_busy (select W4_RS_busy (_ bv2 2)))
				(W4_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(W4_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(W4_RS3_busy (select W4_RS_busy (_ bv3 2)))
				(W4_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(W4_RS3_qk (select W4_RS_qk (_ bv3 2)))
				(W4_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				(W4_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(W4_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(W4_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				(W4_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(W4_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(W4_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				(W4_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(W4_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(W4_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				(W4_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(W4_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
			)
		(let
			(
				(W4_RS0_dis (ite (and (= #b1 W4_RS0_busy) (= #b000 W4_RS0_qj) (= #b000 W4_RS0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS1_dis (ite (and (= #b1 W4_RS1_busy) (= #b000 W4_RS1_qj) (= #b000 W4_RS1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS2_dis (ite (and (= #b1 W4_RS2_busy) (= #b000 W4_RS2_qj) (= #b000 W4_RS2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_RS3_dis (ite (and (= #b1 W4_RS3_busy) (= #b000 W4_RS3_qj) (= #b000 W4_RS3_qk)) (_ bv1 1) (_ bv0 1)))	
				(W4_LSQ0_dis (ite (and (= #b1 W4_LSQ0_busy) (= #b000 W4_LSQ0_qj) (= #b000 W4_LSQ0_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ1_dis (ite (and (= #b1 W4_LSQ1_busy) (= #b000 W4_LSQ1_qj) (= #b000 W4_LSQ1_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ2_dis (ite (and (= #b1 W4_LSQ2_busy) (= #b000 W4_LSQ2_qj) (= #b000 W4_LSQ2_qk)) (_ bv1 1) (_ bv0 1)))
				(W4_LSQ3_dis (ite (and (= #b1 W4_LSQ3_busy) (= #b000 W4_LSQ3_qj) (= #b000 W4_LSQ3_qk)) (_ bv1 1) (_ bv0 1)))	
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv0 2) W4_RS0_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv0 2) W4_LSQ0_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv1 2) W4_RS1_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv1 2) W4_LSQ1_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv2 2) W4_RS2_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv2 2) W4_LSQ2_dis))
			)
		(let
			(
				(W4_RS_dis (store W4_RS_dis (_ bv3 2) W4_RS3_dis))
				(W4_LSQ_dis (store W4_LSQ_dis (_ bv3 2) W4_LSQ3_dis))
			)
		(let
			(
				(W4_RF (ite (= 0 0) W4_RF W4_RF))
				(W4_DM (ite (= 0 0) W4_DM W4_DM))
				
				(W4_Cache_Tag (ite (= 0 0) W4_Cache_Tag W4_Cache_Tag))
				(W4_Cache_Data (ite (= 0 0) W4_Cache_Data W4_Cache_Data))
				(W4_Cache_Valid (ite (= 0 0) W4_Cache_Valid W4_Cache_Valid))
				
				(W4_PC (ite (= 0 0) W4_PC W4_PC))
				
				(W4_IP (ite (= 0 0) W4_IP W4_IP))
				(W4_CP (ite (= 0 0) W4_CP W4_CP))
				
				(W4_ROB_busy (ite (= 0 0) W4_ROB_busy W4_ROB_busy))
				(W4_ROB_op_type (ite (= 0 0) W4_ROB_op_type W4_ROB_op_type))
				(W4_ROB_destination (ite (= 0 0) W4_ROB_destination W4_ROB_destination))
				(W4_ROB_result (ite (= 0 0) W4_ROB_result W4_ROB_result))
				(W4_ROB_exception (ite (= 0 0) W4_ROB_exception W4_ROB_exception))
				(W4_ROB_done (ite (= 0 0) W4_ROB_done W4_ROB_done))
				
				(W4_RS_op_type (ite (= 0 0) W4_RS_op_type W4_RS_op_type))
				(W4_RS_op (ite (= 0 0) W4_RS_op W4_RS_op))
				(W4_RS_ROB_dst (ite (= 0 0) W4_RS_ROB_dst W4_RS_ROB_dst))
				(W4_RS_vj (ite (= 0 0) W4_RS_vj W4_RS_vj))
				(W4_RS_vk (ite (= 0 0) W4_RS_vk W4_RS_vk))
				(W4_RS_qj (ite (= 0 0) W4_RS_qj W4_RS_qj))
				(W4_RS_qk (ite (= 0 0) W4_RS_qk W4_RS_qk))
				(W4_RS_imm (ite (= 0 0) W4_RS_imm W4_RS_imm))
				(W4_RS_dis (ite (= 0 0) W4_RS_dis W4_RS_dis))
				(W4_RS_busy (ite (= 0 0) W4_RS_busy W4_RS_busy))
				
				(W4_LSQ_op_type (ite (= 0 0) W4_LSQ_op_type W4_LSQ_op_type))
				(W4_LSQ_op (ite (= 0 0) W4_LSQ_op W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (= 0 0) W4_LSQ_ROB_dst W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (= 0 0) W4_LSQ_vj W4_LSQ_vj))
				(W4_LSQ_vk (ite (= 0 0) W4_LSQ_vk W4_LSQ_vk))
				(W4_LSQ_qj (ite (= 0 0) W4_LSQ_qj W4_LSQ_qj))
				(W4_LSQ_qk (ite (= 0 0) W4_LSQ_qk W4_LSQ_qk))
				(W4_LSQ_imm (ite (= 0 0) W4_LSQ_imm W4_LSQ_imm))
				(W4_LSQ_dis (ite (= 0 0) W4_LSQ_dis W4_LSQ_dis))
				(W4_LSQ_busy (ite (= 0 0) W4_LSQ_busy W4_LSQ_busy))
				
				(W4_Evict_Tag (ite (= 0 0) W4_Evict_Tag W4_Evict_Tag))
				(W4_Evict_Valid (ite (= 0 0) W4_Evict_Valid W4_Evict_Valid))
				(W4_Evict_Index (ite (= 0 0) W4_Evict_Index W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Mul_div) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Mul_div) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)
;---------------------------Commit--------------------------------------------------------------
		(let
			(
				(CP_W4_ROB_busy (select W4_ROB_busy W4_CP))
				(CP_W4_ROB_op_type (select W4_ROB_op_type W4_CP))
				(CP_W4_ROB_destination (select W4_ROB_destination W4_CP))
				(CP_W4_ROB_result (select W4_ROB_result W4_CP))
				(CP_W4_ROB_exception (select W4_ROB_exception W4_CP))
				(CP_W4_ROB_done (select W4_ROB_done W4_CP))
			)
		(let
			(
				(CP_update (bvadd W4_CP (_ bv1 3)))
			)
		(let
			(
				(CP_update (ite (= CP_update #b101) (_ bv1 3) CP_update))
				(RF_update (store W4_RF CP_W4_ROB_destination CP_W4_ROB_result))
				(DM_update (store W4_DM CP_W4_ROB_destination CP_W4_ROB_result))
				
				(W4_ROB_busy_update (store W4_ROB_busy W4_CP (_ bv0 1)))
				(W4_ROB_op_type_update (store W4_ROB_op_type W4_CP 0))
				(W4_ROB_destination_update (store W4_ROB_destination W4_CP 0))
				(W4_ROB_resulW4_update (store W4_ROB_result W4_CP 0))
				(W4_ROB_exception_update (store W4_ROB_exception W4_CP (_ bv0 1)))
				(W4_ROB_done_update (store W4_ROB_done W4_CP (_ bv0 1)))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag CP_W4_ROB_destination) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index CP_W4_ROB_destination))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line CP_W4_ROB_destination))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index CP_W4_ROB_result))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line CP_W4_ROB_result))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				(CP_W4_ROB_exception (ite (and (= CP_W4_ROB_op_type Branch) (= 1 CP_W4_ROB_result)) (_ bv1 1) (_ bv0 1))) ;temporary
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
			)
		(let
			(
				(W4_RF (ite (and (= CP_W4_ROB_done #b1) (or (= CP_W4_ROB_op_type Rtype) (= CP_W4_ROB_op_type Mul_div) (= CP_W4_ROB_op_type Load))) RF_update W4_RF))
				(W4_DM (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) DM_update W4_DM))
				
				(W4_PC (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) CP_W4_ROB_destination W4_PC))
				(W4_IP (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) W4_IP))
				(W4_CP 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) (_ bv1 3) 
					(ite (= CP_W4_ROB_done #b1) CP_update
					W4_CP))
				)
				(W4_ROB_busy 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_busy_update
					W4_ROB_busy))
				)
				(W4_ROB_op_type 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_op_type_update
					W4_ROB_op_type))
				)
				(W4_ROB_destination 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_destination_update
					W4_ROB_destination))
				)
				(W4_ROB_result 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_int
					(ite (= CP_W4_ROB_done #b1) W4_ROB_resulW4_update
					W4_ROB_result))
				)
				(W4_ROB_exception 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_exception_update
					W4_ROB_exception))
				)
				(W4_ROB_done 
					(ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_ROB_1bit
					(ite (= CP_W4_ROB_done #b1) W4_ROB_done_update
					W4_ROB_done))
				)
				
				(W4_RS_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op_type))
				(W4_RS_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_op))
				(W4_RS_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_ROB_dst))
				(W4_RS_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vj))
				(W4_RS_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_vk))
				(W4_RS_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qj))
				(W4_RS_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_RS_qk))
				(W4_RS_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_RS_imm))
				(W4_RS_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_dis))
				(W4_RS_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_RS_busy))
				
				(W4_LSQ_op_type (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op_type))
				(W4_LSQ_op (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_op))
				(W4_LSQ_ROB_dst (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_ROB_dst))
				(W4_LSQ_vj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vj))
				(W4_LSQ_vk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_vk))
				(W4_LSQ_qj (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qj))
				(W4_LSQ_qk (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_3bit W4_LSQ_qk))
				(W4_LSQ_imm (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_int W4_LSQ_imm))
				(W4_LSQ_dis (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_dis))
				(W4_LSQ_busy (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Branch) (= CP_W4_ROB_exception #b1)) empty_RS_LSQ_1bit W4_LSQ_busy))				
				
				(W4_Cache_Tag
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Tag
					))
				)
				(W4_Cache_Data
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Data
					))
				)
				(W4_Cache_Valid
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b0) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Miss	;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= CP_W4_ROB_done #b1) (= W4_Cache_Hit_Store #b1) (= CP_W4_ROB_op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					W4_Cache_Valid
					))
				)
				(W4_Evict_Tag (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Tag_update W4_Evict_Tag))
				(W4_Evict_Valid (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Valid_update W4_Evict_Valid))
				(W4_Evict_Index (ite (and (= CP_W4_ROB_done #b1) (= CP_W4_ROB_op_type Store)) W4_Evict_Index_update W4_Evict_Index))
			)


;===============================================ISA==============================================================================================================
		(let
			(
				(Instruction (select T_IM W4_PC))
			)
		(let
			(
				(op (Inst_op Instruction))
				(op_type (Inst_op_type Instruction))
				(rs (Inst_rs Instruction))
				(rt (Inst_rt Instruction))
				(rd (Inst_rd Instruction))
				(imm (Inst_imm Instruction))
				(PC_plus_one (+ W4_PC 4))
			)
		(let
			(
				(RF_rs (select W4_RF rs))
				(RF_rt (select W4_RF rt))
			)
		(let
			(
				(LOAD_addr (LOAD_Unit RF_rs imm op))
				(Store_address (STORE_Unit RF_rs imm op))
			)
		(let
			(
				(W4_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(W4_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(W4_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(W4_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(W4_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(W4_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(W4_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(W4_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(W4_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(W4_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				(W4_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				(W4_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
			)
		(let
			(
				(W4_Cache0_Hit_Store (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag Store_address) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Store (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag Store_address) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Store (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag Store_address) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Store (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag Store_address) ) (_ bv1 1) (_ bv0 1)))
			)
		(let
			(
				(LOAD_Value (select W4_DM LOAD_addr))
				(W4_Cache0_Hit_Load (ite (and (= W4_Cache0_Valid #b1) (= W4_Cache0_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache1_Hit_Load (ite (and (= W4_Cache1_Valid #b1) (= W4_Cache1_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache2_Hit_Load (ite (and (= W4_Cache2_Valid #b1) (= W4_Cache2_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))
				(W4_Cache3_Hit_Load (ite (and (= W4_Cache3_Valid #b1) (= W4_Cache3_Tag LOAD_addr) ) (_ bv1 1) (_ bv0 1)))	
			
				(Available_W4_Cache_Line 
					(ite (= W4_Cache0_Valid #b0) (_ bv0 2)	;check if W4_Cache line 0 is free
					(ite (= W4_Cache1_Valid #b0) (_ bv1 2)	;check if W4_Cache line 1 is free
					(ite (= W4_Cache2_Valid #b0) (_ bv2 2)	;check if W4_Cache line 2 is free
					(ite (= W4_Cache3_Valid #b0) (_ bv3 2)	;check if W4_Cache line 3 is free
					(_ bv0 2)							;Badluck nothing is free, bye bye W4_Cache line 0 
					))))
				)
				(W4_Cache_Store_Hit_Index
					(ite (= W4_Cache0_Hit_Store #b1) (_ bv0 2)		;If W4_Cache has a hit for store, then whats the line index
					(ite (= W4_Cache1_Hit_Store #b1) (_ bv1 2)
					(ite (= W4_Cache2_Hit_Store #b1) (_ bv2 2)
					(ite (= W4_Cache3_Hit_Store #b1) (_ bv3 2)
					(_ bv0 2)
					))))
				)
			)
		(let
			(
				(W4_Cache_Hit_load (bvor W4_Cache0_Hit_Load W4_Cache1_Hit_Load W4_Cache2_Hit_Load W4_Cache3_Hit_Load))
				(W4_Cache_Hit_Store (bvor W4_Cache0_Hit_Store W4_Cache1_Hit_Store W4_Cache2_Hit_Store W4_Cache3_Hit_Store))
			)
		(let
			(
				(W4_Cache_tag_Update_Load (store W4_Cache_Tag Available_W4_Cache_Line LOAD_addr))
				
				(W4_Cache_data_Update_Load (store W4_Cache_Data Available_W4_Cache_Line LOAD_Value))
				
				(W4_Cache_valid_Update_Load (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))
				
				(W4_Cache_tag_Update_Store_Hit (store W4_Cache_Tag W4_Cache_Store_Hit_Index Store_address))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_tag_Update_Store_Miss (store W4_Cache_Tag Available_W4_Cache_Line Store_address))	
				
				(W4_Cache_data_Update_Store_Hit (store W4_Cache_Data W4_Cache_Store_Hit_Index RF_rt))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_data_Update_Store_Miss (store W4_Cache_Data Available_W4_Cache_Line RF_rt))	;if W4_Cache is a miss, update the available entry with data
				
				(W4_Cache_valid_Update_Store_Hit (store W4_Cache_Valid W4_Cache_Store_Hit_Index (_ bv1 1)))	;if W4_Cache is a hit, update the line with new data
				(W4_Cache_valid_Update_Store_Miss (store W4_Cache_Valid Available_W4_Cache_Line (_ bv1 1)))	;if W4_Cache is a miss, update the available entry with data
				
				
				(W4_Evict_Tag_update (store W4_Evict_Tag W4_Evict_Index W4_Cache0_Tag ))
				(W4_Evict_Valid_update (store W4_Evict_Valid W4_Evict_Index W4_Cache0_Valid ))
				(W4_Evict_Index_update (bvadd (_ bv1 3) W4_Evict_Index))
				
			)
		(let
			(
				(I_Evict_Tag 
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Tag_update 
					(ite (= op_type Store) W4_Evict_Tag_update
					W4_Evict_Tag))
				)
					
				(I_Evict_Valid 
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Valid_update 
					(ite (= op_type Store) W4_Evict_Valid_update
					W4_Evict_Valid))
				)
				(I_Evict_Index 
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load) (= #b00 Available_W4_Cache_Line) (= W4_Cache0_Valid #b1)) W4_Evict_Index_update 
					(ite (= op_type Store) W4_Evict_Index_update 
					W4_Evict_Index))
				)
				
				(I_Cache_Tag
					(ite (and (= W4_Cache_Hit_Store #b0) (= op_type Store)) W4_Cache_tag_Update_Store_Miss		;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= W4_Cache_Hit_Store #b1) (= op_type Store)) W4_Cache_tag_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load)) W4_Cache_tag_Update_Load												;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Tag)))
				)
				(I_Cache_Data
					(ite (and (= W4_Cache_Hit_Store #b0) (= op_type Store)) W4_Cache_data_Update_Store_Miss		;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= W4_Cache_Hit_Store #b1) (= op_type Store)) W4_Cache_data_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load)) W4_Cache_data_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Data)))
				)
				(I_Cache_Valid
					(ite (and (= W4_Cache_Hit_Store #b0) (= op_type Store)) W4_Cache_valid_Update_Store_Miss		;If Store and W4_Cache miss, insert data in to avilable entry
					(ite (and (= W4_Cache_Hit_Store #b1) (= op_type Store)) W4_Cache_valid_Update_Store_Hit		;If Store and W4_Cache hit, update the line with new data
					(ite (and (= W4_Cache_Hit_load #b0) (= op_type Load)) W4_Cache_valid_Update_Load			;If load and W4_Cache miss, update the W4_Cache
					W4_Cache_Valid)))
				)
			)





		
		(let
			(
				(V_equals_U (V_U_cache_equivalence I_Cache_Tag I_Cache_Valid I_Evict_Tag I_Evict_Valid U4_Cache_Tag U4_Cache_Valid U4_Evict_Tag U4_Evict_Valid W4_Cache_Tag W4_Cache_Valid W4_Evict_Tag W4_Evict_Valid ))
				(V_equals_S (V_S_cache_equivalence I_Cache_Tag I_Cache_Valid I_Evict_Tag I_Evict_Valid U4_Cache_Tag U4_Cache_Valid U4_Evict_Tag U4_Evict_Valid W4_Cache_Tag W4_Cache_Valid W4_Evict_Tag W4_Evict_Valid ))
			)
;-----------------------------Calculations--------------------------------------------------------------		
		(let ((T_IP_m1 (subtract T_IP)))
		(let ((T_IP_m2 (subtract T_IP_m1)))
		(let ((T_IP_m3 (subtract T_IP_m2)))
		(let ((T_IP_m4 (subtract T_IP_m3)))





;-----------------------------Property--------------------------------------------------------------		
		(=>
			(and
;-----------------------------Invarint 1 IP-------------------------------------------------
				(not (= T_IP #b000)) (not (= T_IP #b101)) (not (= T_IP #b110)) (not (= T_IP #b111))	;done
				(not (= T_CP #b000)) (not (= T_CP #b101)) (not (= T_CP #b110)) (not (= T_CP #b111))	;done
				
				(=> (and (= #b1 (select T_RS_busy (_ bv0 2))) (= T_CP (select T_RS_ROB_dst (_ bv0 2)))) (= #b1 (select T_RS_dis (_ bv0 2))))
				(=> (and (= #b1 (select T_RS_busy (_ bv1 2))) (= T_CP (select T_RS_ROB_dst (_ bv1 2)))) (= #b1 (select T_RS_dis (_ bv1 2))))
				(=> (and (= #b1 (select T_RS_busy (_ bv2 2))) (= T_CP (select T_RS_ROB_dst (_ bv2 2)))) (= #b1 (select T_RS_dis (_ bv2 2))))
				(=> (and (= #b1 (select T_RS_busy (_ bv3 2))) (= T_CP (select T_RS_ROB_dst (_ bv3 2)))) (= #b1 (select T_RS_dis (_ bv3 2))))
				
				(=> (and (= #b1 (select T_LSQ_busy (_ bv3 2))) (= T_CP (select T_LSQ_ROB_dst (_ bv3 2)))) (= #b1 (select T_LSQ_dis (_ bv3 2))))

;-----------------------------Invarint 2 ROB-------------------------------------------------
				(= #b0 (select T_ROB_busy (_ bv0 3)))	;done
				(= #b0 (select T_ROB_busy (_ bv5 3)))	;done
				(= #b0 (select T_ROB_busy (_ bv6 3)))	;done
				(= #b0 (select T_ROB_busy (_ bv7 3)))	;done
				
				
			;	(= #b0 (select T_ROB_busy (_ bv1 3)))	;constraint
			;	(= #b0 (select T_ROB_busy (_ bv2 3)))	;constraint
				(= #b0 (select T_ROB_busy (_ bv3 3)))	;constraint
				(= #b0 (select T_ROB_busy (_ bv4 3)))	;constraint
				
			;	(= #b0 (select T_LSQ_busy (_ bv0 2))) 	;constraint
			;	(= #b0 (select T_LSQ_busy (_ bv1 2))) 	;constraint
			;	(= #b0 (select T_LSQ_busy (_ bv2 2))) 	;constraint
			;	(= #b0 (select T_LSQ_busy (_ bv3 2))) 	;constraint
				
			;	(not (= 4 (select T_ROB_op_type (_ bv1 3)))) 	;constraint
			;	(not (= 4 (select T_ROB_op_type (_ bv2 3)))) 	;constraint
			;	(not (= 4 (select T_ROB_op_type (_ bv3 3)))) 	;constraint
			;	(not (= 4 (select T_ROB_op_type (_ bv4 3)))) 	;constraint
				
				
				(=> (= #b0 (select T_ROB_busy (_ bv1 3))) (and (= (select T_ROB_op_type (_ bv1 3)) 0) (= (select T_ROB_destination (_ bv1 3)) 0) (= (select T_ROB_result (_ bv1 3)) 0) (= (select T_ROB_exception (_ bv1 3)) #b0) (= (select T_ROB_done (_ bv1 3)) #b0) ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv2 3))) (and (= (select T_ROB_op_type (_ bv2 3)) 0) (= (select T_ROB_destination (_ bv2 3)) 0) (= (select T_ROB_result (_ bv2 3)) 0) (= (select T_ROB_exception (_ bv2 3)) #b0) (= (select T_ROB_done (_ bv2 3)) #b0) ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv3 3))) (and (= (select T_ROB_op_type (_ bv3 3)) 0) (= (select T_ROB_destination (_ bv3 3)) 0) (= (select T_ROB_result (_ bv3 3)) 0) (= (select T_ROB_exception (_ bv3 3)) #b0) (= (select T_ROB_done (_ bv3 3)) #b0) ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv4 3))) (and (= (select T_ROB_op_type (_ bv4 3)) 0) (= (select T_ROB_destination (_ bv4 3)) 0) (= (select T_ROB_result (_ bv4 3)) 0) (= (select T_ROB_exception (_ bv4 3)) #b0) (= (select T_ROB_done (_ bv4 3)) #b0) ))	;done
				
				(=> (= #b1 (select T_ROB_busy (_ bv1 3))) (or (= (select T_ROB_op_type (_ bv1 3)) Rtype) (= (select T_ROB_op_type (_ bv1 3)) Branch) (= (select T_ROB_op_type (_ bv1 3)) Mul_div) (= (select T_ROB_op_type (_ bv1 3)) Load) (= (select T_ROB_op_type (_ bv1 3)) Store)))
				(=> (= #b1 (select T_ROB_busy (_ bv2 3))) (or (= (select T_ROB_op_type (_ bv2 3)) Rtype) (= (select T_ROB_op_type (_ bv2 3)) Branch) (= (select T_ROB_op_type (_ bv2 3)) Mul_div) (= (select T_ROB_op_type (_ bv2 3)) Load) (= (select T_ROB_op_type (_ bv2 3)) Store)))
				(=> (= #b1 (select T_ROB_busy (_ bv3 3))) (or (= (select T_ROB_op_type (_ bv3 3)) Rtype) (= (select T_ROB_op_type (_ bv3 3)) Branch) (= (select T_ROB_op_type (_ bv3 3)) Mul_div) (= (select T_ROB_op_type (_ bv3 3)) Load) (= (select T_ROB_op_type (_ bv3 3)) Store)))
				(=> (= #b1 (select T_ROB_busy (_ bv4 3))) (or (= (select T_ROB_op_type (_ bv4 3)) Rtype) (= (select T_ROB_op_type (_ bv4 3)) Branch) (= (select T_ROB_op_type (_ bv4 3)) Mul_div) (= (select T_ROB_op_type (_ bv4 3)) Load) (= (select T_ROB_op_type (_ bv4 3)) Store)))
				
				
;(----------------------------Invarint 3 ROB and RS/LSQ-------------------------------------------------
				(=> (= #b0 (select T_ROB_busy (_ bv1 3))) (and (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv2 3))) (and (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv3 3))) (and (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (= #b0 (select T_ROB_busy (_ bv4 3))) (and (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				
				(=> (and (= #b1 (select T_ROB_busy (_ bv1 3))) (= #b1 (select T_ROB_done (_ bv1 3)))) (and (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv1 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv2 3))) (= #b1 (select T_ROB_done (_ bv2 3)))) (and (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv2 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv3 3))) (= #b1 (select T_ROB_done (_ bv3 3)))) (and (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv3 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv4 3))) (= #b1 (select T_ROB_done (_ bv4 3)))) (and (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (_ bv4 3) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv3 2))))  ))	;done
				
				(=> (and (= #b1 (select T_ROB_busy (_ bv1 3))) (= #b0 (select T_ROB_done (_ bv1 3)))) (or (= (_ bv1 3) (select T_RS_ROB_dst (_ bv0 2))) (= (_ bv1 3) (select T_RS_ROB_dst (_ bv1 2))) (= (_ bv1 3) (select T_RS_ROB_dst (_ bv2 2))) (= (_ bv1 3) (select T_RS_ROB_dst (_ bv3 2))) (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv0 2))) (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv1 2))) (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv2 2))) (= (_ bv1 3) (select T_LSQ_ROB_dst (_ bv3 2)))))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv2 3))) (= #b0 (select T_ROB_done (_ bv2 3)))) (or (= (_ bv2 3) (select T_RS_ROB_dst (_ bv0 2))) (= (_ bv2 3) (select T_RS_ROB_dst (_ bv1 2))) (= (_ bv2 3) (select T_RS_ROB_dst (_ bv2 2))) (= (_ bv2 3) (select T_RS_ROB_dst (_ bv3 2))) (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv0 2))) (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv1 2))) (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv2 2))) (= (_ bv2 3) (select T_LSQ_ROB_dst (_ bv3 2)))))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv3 3))) (= #b0 (select T_ROB_done (_ bv3 3)))) (or (= (_ bv3 3) (select T_RS_ROB_dst (_ bv0 2))) (= (_ bv3 3) (select T_RS_ROB_dst (_ bv1 2))) (= (_ bv3 3) (select T_RS_ROB_dst (_ bv2 2))) (= (_ bv3 3) (select T_RS_ROB_dst (_ bv3 2))) (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv0 2))) (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv1 2))) (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv2 2))) (= (_ bv3 3) (select T_LSQ_ROB_dst (_ bv3 2)))))	;done
				(=> (and (= #b1 (select T_ROB_busy (_ bv4 3))) (= #b0 (select T_ROB_done (_ bv4 3)))) (or (= (_ bv4 3) (select T_RS_ROB_dst (_ bv0 2))) (= (_ bv4 3) (select T_RS_ROB_dst (_ bv1 2))) (= (_ bv4 3) (select T_RS_ROB_dst (_ bv2 2))) (= (_ bv4 3) (select T_RS_ROB_dst (_ bv3 2))) (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv0 2))) (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv1 2))) (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv2 2))) (= (_ bv4 3) (select T_LSQ_ROB_dst (_ bv3 2)))))	;done

				(=> (not (= #b000 (select T_RS_ROB_dst (_ bv0 2)))) (and (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv0 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv0 2))))))	;done
				(=> (not (= #b000 (select T_RS_ROB_dst (_ bv1 2)))) (and (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv1 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv1 2))))))	;done
				(=> (not (= #b000 (select T_RS_ROB_dst (_ bv2 2)))) (and (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv2 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv2 2))))))	;done
				(=> (not (= #b000 (select T_RS_ROB_dst (_ bv3 2)))) (and (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv3 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv3 2))))))	;done
				
				(=> (not (= #b000 (select T_LSQ_ROB_dst (_ bv0 2)))) (and (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv0 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv0 2))))))	;done
				(=> (not (= #b000 (select T_LSQ_ROB_dst (_ bv1 2)))) (and (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv1 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv1 2))))))	;done
				(=> (not (= #b000 (select T_LSQ_ROB_dst (_ bv2 2)))) (and (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv2 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv2 2))))))	;done
				(=> (not (= #b000 (select T_LSQ_ROB_dst (_ bv3 2)))) (and (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv3 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv3 2))))))	;done
;)

;(----------------------------Invarint 4 RS, LSQ-------------------------------------------------
				(=> (= #b1 (select T_RS_dis (_ bv0 2))) (and (= #b1 (select T_RS_busy (_ bv0 2))) (= #b000 (select T_RS_qj (_ bv0 2))) (= #b000 (select T_RS_qk (_ bv0 2)))))	;done
				(=> (= #b1 (select T_RS_dis (_ bv1 2))) (and (= #b1 (select T_RS_busy (_ bv1 2))) (= #b000 (select T_RS_qj (_ bv1 2))) (= #b000 (select T_RS_qk (_ bv1 2)))))	;done
				(=> (= #b1 (select T_RS_dis (_ bv2 2))) (and (= #b1 (select T_RS_busy (_ bv2 2))) (= #b000 (select T_RS_qj (_ bv2 2))) (= #b000 (select T_RS_qk (_ bv2 2)))))	;done
				(=> (= #b1 (select T_RS_dis (_ bv3 2))) (and (= #b1 (select T_RS_busy (_ bv3 2))) (= #b000 (select T_RS_qj (_ bv3 2))) (= #b000 (select T_RS_qk (_ bv3 2)))))	;done
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv0 2))) (select T_RS_op_type (_ bv0 2))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv0 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv0 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv1 2))) (select T_RS_op_type (_ bv1 2))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv1 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv1 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv2 2))) (select T_RS_op_type (_ bv2 2))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv2 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv2 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (and (= (select T_ROB_op_type (select T_RS_ROB_dst (_ bv3 2))) (select T_RS_op_type (_ bv3 2))) (= #b1 (select T_ROB_busy (select T_RS_ROB_dst (_ bv3 2)))) (= #b0 (select T_ROB_done (select T_RS_ROB_dst (_ bv3 2))))))	;done
				
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (and (not (= #b000 (select T_RS_ROB_dst (_ bv0 2)))) (not (= #b101 (select T_RS_ROB_dst (_ bv0 2)))) (not (= #b110 (select T_RS_ROB_dst (_ bv0 2)))) (not (= #b111 (select T_RS_ROB_dst (_ bv0 2)))) ))	;done
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (and (not (= #b000 (select T_RS_ROB_dst (_ bv1 2)))) (not (= #b101 (select T_RS_ROB_dst (_ bv1 2)))) (not (= #b110 (select T_RS_ROB_dst (_ bv1 2)))) (not (= #b111 (select T_RS_ROB_dst (_ bv1 2)))) ))	;done
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (and (not (= #b000 (select T_RS_ROB_dst (_ bv2 2)))) (not (= #b101 (select T_RS_ROB_dst (_ bv2 2)))) (not (= #b110 (select T_RS_ROB_dst (_ bv2 2)))) (not (= #b111 (select T_RS_ROB_dst (_ bv2 2)))) ))	;done
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (and (not (= #b000 (select T_RS_ROB_dst (_ bv3 2)))) (not (= #b101 (select T_RS_ROB_dst (_ bv3 2)))) (not (= #b110 (select T_RS_ROB_dst (_ bv3 2)))) (not (= #b111 (select T_RS_ROB_dst (_ bv3 2)))) ))	;done
				
				(=> (= #b0 (select T_RS_busy (_ bv0 2))) (and (= #b000 (select T_RS_ROB_dst (_ bv0 2))) (= #b0 (select T_RS_dis (_ bv0 2))))) ;done
				(=> (= #b0 (select T_RS_busy (_ bv1 2))) (and (= #b000 (select T_RS_ROB_dst (_ bv1 2))) (= #b0 (select T_RS_dis (_ bv1 2))))) ;done
				(=> (= #b0 (select T_RS_busy (_ bv2 2))) (and (= #b000 (select T_RS_ROB_dst (_ bv2 2))) (= #b0 (select T_RS_dis (_ bv2 2))))) ;done
				(=> (= #b0 (select T_RS_busy (_ bv3 2))) (and (= #b000 (select T_RS_ROB_dst (_ bv3 2))) (= #b0 (select T_RS_dis (_ bv3 2))))) ;done
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (and (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv3 2)))))) ;done
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (and (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv3 2)))))) ;done
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (and (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv3 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv3 2)))))) ;done
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (and (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv3 2)))))) ;done
				
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (and (not (= Load (select T_RS_op_type (_ bv0 2)))) (not (= Store (select T_RS_op_type (_ bv0 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (and (not (= Load (select T_RS_op_type (_ bv1 2)))) (not (= Store (select T_RS_op_type (_ bv1 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (and (not (= Load (select T_RS_op_type (_ bv2 2)))) (not (= Store (select T_RS_op_type (_ bv2 2))))))	;done
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (and (not (= Load (select T_RS_op_type (_ bv3 2)))) (not (= Store (select T_RS_op_type (_ bv3 2))))))	;done
				
				(=> (and (= #b1 (select T_RS_busy (_ bv0 2))) (not (= #b000 (select T_RS_qj (_ bv0 2))))) (= #b1 (select T_ROB_busy (select T_RS_qj (_ bv0 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv1 2))) (not (= #b000 (select T_RS_qj (_ bv1 2))))) (= #b1 (select T_ROB_busy (select T_RS_qj (_ bv1 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv2 2))) (not (= #b000 (select T_RS_qj (_ bv2 2))))) (= #b1 (select T_ROB_busy (select T_RS_qj (_ bv2 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv3 2))) (not (= #b000 (select T_RS_qj (_ bv3 2))))) (= #b1 (select T_ROB_busy (select T_RS_qj (_ bv3 2)))))
				
				(=> (and (= #b1 (select T_RS_busy (_ bv0 2))) (not (= #b000 (select T_RS_qk (_ bv0 2))))) (= #b1 (select T_ROB_busy (select T_RS_qk (_ bv0 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv1 2))) (not (= #b000 (select T_RS_qk (_ bv1 2))))) (= #b1 (select T_ROB_busy (select T_RS_qk (_ bv1 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv2 2))) (not (= #b000 (select T_RS_qk (_ bv2 2))))) (= #b1 (select T_ROB_busy (select T_RS_qk (_ bv2 2)))))
				(=> (and (= #b1 (select T_RS_busy (_ bv3 2))) (not (= #b000 (select T_RS_qk (_ bv3 2))))) (= #b1 (select T_ROB_busy (select T_RS_qk (_ bv3 2)))))
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_RS_qj (_ bv0 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_RS_qj (_ bv1 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_RS_qj (_ bv2 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_RS_qj (_ bv3 2)))))
				
				(=> (= #b1 (select T_RS_busy (_ bv0 2))) (not (= (select T_RS_ROB_dst (_ bv0 2)) (select T_RS_qk (_ bv0 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv1 2))) (not (= (select T_RS_ROB_dst (_ bv1 2)) (select T_RS_qk (_ bv1 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv2 2))) (not (= (select T_RS_ROB_dst (_ bv2 2)) (select T_RS_qk (_ bv2 2)))))
				(=> (= #b1 (select T_RS_busy (_ bv3 2))) (not (= (select T_RS_ROB_dst (_ bv3 2)) (select T_RS_qk (_ bv3 2)))))
				
				
				
				
				(=> (= #b1 (select T_LSQ_dis (_ bv0 2))) (and (= #b1 (select T_LSQ_busy (_ bv0 2))) (= #b000 (select T_LSQ_qj (_ bv0 2))) (= #b000 (select T_LSQ_qk (_ bv0 2)))))	;done
				(=> (= #b1 (select T_LSQ_dis (_ bv1 2))) (and (= #b1 (select T_LSQ_busy (_ bv1 2))) (= #b000 (select T_LSQ_qj (_ bv1 2))) (= #b000 (select T_LSQ_qk (_ bv1 2)))))	;done
				(=> (= #b1 (select T_LSQ_dis (_ bv2 2))) (and (= #b1 (select T_LSQ_busy (_ bv2 2))) (= #b000 (select T_LSQ_qj (_ bv2 2))) (= #b000 (select T_LSQ_qk (_ bv2 2)))))	;done
				(=> (= #b1 (select T_LSQ_dis (_ bv3 2))) (and (= #b1 (select T_LSQ_busy (_ bv3 2))) (= #b000 (select T_LSQ_qj (_ bv3 2))) (= #b000 (select T_LSQ_qk (_ bv3 2)))))	;done
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv0 2))) (select T_LSQ_op_type (_ bv0 2))) (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv0 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv0 2))))))	;pending
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv1 2))) (select T_LSQ_op_type (_ bv1 2)))  (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv1 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv1 2))))))	;pending
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv2 2))) (select T_LSQ_op_type (_ bv2 2)))  (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv2 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv2 2))))))	;pending
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (and (= (select T_ROB_op_type (select T_LSQ_ROB_dst (_ bv3 2))) (select T_LSQ_op_type (_ bv3 2)))  (= #b1 (select T_ROB_busy (select T_LSQ_ROB_dst (_ bv3 2)))) (= #b0 (select T_ROB_done (select T_LSQ_ROB_dst (_ bv3 2))))))	;pending
				
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (and (not (= #b000 (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= #b101 (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= #b110 (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= #b111 (select T_LSQ_ROB_dst (_ bv0 2)))) ))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (and (not (= #b000 (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= #b101 (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= #b110 (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= #b111 (select T_LSQ_ROB_dst (_ bv1 2)))) ))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (and (not (= #b000 (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= #b101 (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= #b110 (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= #b111 (select T_LSQ_ROB_dst (_ bv2 2)))) ))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (and (not (= #b000 (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= #b101 (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= #b110 (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= #b111 (select T_LSQ_ROB_dst (_ bv3 2)))) ))	;done
				
				(=> (= #b0 (select T_LSQ_busy (_ bv0 2))) (and (= #b000 (select T_LSQ_ROB_dst (_ bv0 2))) (= #b0 (select T_LSQ_dis (_ bv0 2))))) ;done
				(=> (= #b0 (select T_LSQ_busy (_ bv1 2))) (and (= #b000 (select T_LSQ_ROB_dst (_ bv1 2))) (= #b0 (select T_LSQ_dis (_ bv1 2))))) ;done
				(=> (= #b0 (select T_LSQ_busy (_ bv2 2))) (and (= #b000 (select T_LSQ_ROB_dst (_ bv2 2))) (= #b0 (select T_LSQ_dis (_ bv2 2))))) ;done
				(=> (= #b0 (select T_LSQ_busy (_ bv3 2))) (and (= #b000 (select T_LSQ_ROB_dst (_ bv3 2))) (= #b0 (select T_LSQ_dis (_ bv3 2))))) ;done
				
		
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (and (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_RS_ROB_dst (_ bv3 2)))))) 
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (and (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_RS_ROB_dst (_ bv3 2)))))) 
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (and (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_LSQ_ROB_dst (_ bv3 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_RS_ROB_dst (_ bv3 2)))))) 
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (and (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_LSQ_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv0 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv1 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv2 2)))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_RS_ROB_dst (_ bv3 2)))))) 
				
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (and (not (= Rtype (select T_LSQ_op_type (_ bv0 2)))) (not (= Mul_div (select T_LSQ_op_type (_ bv0 2)))) (not (= Branch (select T_LSQ_op_type (_ bv0 2))))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (and (not (= Rtype (select T_LSQ_op_type (_ bv1 2)))) (not (= Mul_div (select T_LSQ_op_type (_ bv1 2)))) (not (= Branch (select T_LSQ_op_type (_ bv1 2))))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (and (not (= Rtype (select T_LSQ_op_type (_ bv2 2)))) (not (= Mul_div (select T_LSQ_op_type (_ bv2 2)))) (not (= Branch (select T_LSQ_op_type (_ bv2 2))))))	;done
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (and (not (= Rtype (select T_LSQ_op_type (_ bv3 2)))) (not (= Mul_div (select T_LSQ_op_type (_ bv3 2)))) (not (= Branch (select T_LSQ_op_type (_ bv3 2))))))	;done
				
				(=> (and (= #b1 (select T_LSQ_busy (_ bv0 2))) (not (= #b000 (select T_LSQ_qj (_ bv0 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qj (_ bv0 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv1 2))) (not (= #b000 (select T_LSQ_qj (_ bv1 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qj (_ bv1 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv2 2))) (not (= #b000 (select T_LSQ_qj (_ bv2 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qj (_ bv2 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv3 2))) (not (= #b000 (select T_LSQ_qj (_ bv3 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qj (_ bv3 2)))))
				
				(=> (and (= #b1 (select T_LSQ_busy (_ bv0 2))) (not (= #b000 (select T_LSQ_qk (_ bv0 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qk (_ bv0 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv1 2))) (not (= #b000 (select T_LSQ_qk (_ bv1 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qk (_ bv1 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv2 2))) (not (= #b000 (select T_LSQ_qk (_ bv2 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qk (_ bv2 2)))))
				(=> (and (= #b1 (select T_LSQ_busy (_ bv3 2))) (not (= #b000 (select T_LSQ_qk (_ bv3 2))))) (= #b1 (select T_ROB_busy (select T_LSQ_qk (_ bv3 2)))))
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_LSQ_qj (_ bv0 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_LSQ_qj (_ bv1 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_LSQ_qj (_ bv2 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_LSQ_qj (_ bv3 2)))))
				
				(=> (= #b1 (select T_LSQ_busy (_ bv0 2))) (not (= (select T_LSQ_ROB_dst (_ bv0 2)) (select T_LSQ_qk (_ bv0 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv1 2))) (not (= (select T_LSQ_ROB_dst (_ bv1 2)) (select T_LSQ_qk (_ bv1 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv2 2))) (not (= (select T_LSQ_ROB_dst (_ bv2 2)) (select T_LSQ_qk (_ bv2 2)))))
				(=> (= #b1 (select T_LSQ_busy (_ bv3 2))) (not (= (select T_LSQ_ROB_dst (_ bv3 2)) (select T_LSQ_qk (_ bv3 2)))))
				
;)

;-----------------------------Invarint 5 All entries between Issue Pointer and Commit Pointer are Busy ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------				
				(=> (= T_CP T_IP_m1) (and (= #b1 (select T_ROB_busy T_IP_m1)) (= (select T_ROB_busy T_IP_m2) (select T_ROB_busy T_IP_m3) (select T_ROB_busy T_IP_m4) #b0)))	;done
				(=> (= T_CP T_IP_m2) (and (= #b1 (select T_ROB_busy T_IP_m1) (select T_ROB_busy T_IP_m2)) (= (select T_ROB_busy T_IP_m3) (select T_ROB_busy T_IP_m4) #b0)))	;done
				(=> (= T_CP T_IP_m3) (and (= #b1 (select T_ROB_busy T_IP_m1) (select T_ROB_busy T_IP_m2) (select T_ROB_busy T_IP_m3) ) (= (select T_ROB_busy T_IP_m4) #b0)));done
				(=> (= T_CP T_IP_m4) (or (= #b1 (select T_ROB_busy T_IP_m1) (select T_ROB_busy T_IP_m2) (select T_ROB_busy T_IP_m3) (select T_ROB_busy T_IP_m4))			;done
										 (= #b0 (select T_ROB_busy T_IP_m1) (select T_ROB_busy T_IP_m2) (select T_ROB_busy T_IP_m3) (select T_ROB_busy T_IP_m4))))
				
				
;(----------------------------Invarint 6 Cache-------------------------------------------------
				
				(=> (= #b1 (select T_Cache_Valid (_ bv0 2))) 
					(and
						(=> (= #b1 (select T_Cache_Valid (_ bv1 2)))  (not (= (select T_Cache_Tag (_ bv0 2)) (select T_Cache_Tag (_ bv1 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv2 2)))  (not (= (select T_Cache_Tag (_ bv0 2)) (select T_Cache_Tag (_ bv2 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv3 2)))  (not (= (select T_Cache_Tag (_ bv0 2)) (select T_Cache_Tag (_ bv3 2)))))
					)
				)
				(=> 
					(= #b1 (select T_Cache_Valid (_ bv1 2))) 
					(and
						(=> (= #b1 (select T_Cache_Valid (_ bv0 2)))  (not (= (select T_Cache_Tag (_ bv1 2)) (select T_Cache_Tag (_ bv0 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv2 2)))  (not (= (select T_Cache_Tag (_ bv1 2)) (select T_Cache_Tag (_ bv2 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv3 2)))  (not (= (select T_Cache_Tag (_ bv1 2)) (select T_Cache_Tag (_ bv3 2)))))
					)
				)
				(=> 
					(= #b1 (select T_Cache_Valid (_ bv2 2))) 
					(and
						(=> (= #b1 (select T_Cache_Valid (_ bv0 2)))  (not (= (select T_Cache_Tag (_ bv2 2)) (select T_Cache_Tag (_ bv0 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv1 2)))  (not (= (select T_Cache_Tag (_ bv2 2)) (select T_Cache_Tag (_ bv1 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv3 2)))  (not (= (select T_Cache_Tag (_ bv2 2)) (select T_Cache_Tag (_ bv3 2)))))
					)
				)
				(=> 
					(= #b1 (select T_Cache_Valid (_ bv3 2))) 
					(and
						(=> (= #b1 (select T_Cache_Valid (_ bv0 2)))  (not (= (select T_Cache_Tag (_ bv3 2)) (select T_Cache_Tag (_ bv0 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv1 2)))  (not (= (select T_Cache_Tag (_ bv3 2)) (select T_Cache_Tag (_ bv1 2)))))
						(=> (= #b1 (select T_Cache_Valid (_ bv2 2)))  (not (= (select T_Cache_Tag (_ bv3 2)) (select T_Cache_Tag (_ bv2 2)))))
					)
				)
				
				(=> (= #b1 (select T_Cache_Valid (_ bv0 2))) (= (select T_Cache_Data (_ bv0 2)) (select T_DM (select T_Cache_Tag (_ bv0 2)))))
				(=> (= #b1 (select T_Cache_Valid (_ bv1 2))) (= (select T_Cache_Data (_ bv1 2)) (select T_DM (select T_Cache_Tag (_ bv1 2))))) ;done
				(=> (= #b1 (select T_Cache_Valid (_ bv2 2))) (= (select T_Cache_Data (_ bv2 2)) (select T_DM (select T_Cache_Tag (_ bv2 2))))) ;done
				(=> (= #b1 (select T_Cache_Valid (_ bv3 2))) (= (select T_Cache_Data (_ bv3 2)) (select T_DM (select T_Cache_Tag (_ bv3 2))))) ;done
;)
				
;(----------------------------General Things-------------------------------------------------
				
				(= #b0 U_path_stall)
				(= #b1 W_path_stall)
				(= #b1 SCS)
				
				(= #b000 T_Evict_Index)
				(= 0 (select T_Evict_Tag (_ bv0 3)))
				(= 0 (select T_Evict_Tag (_ bv1 3)))
				(= 0 (select T_Evict_Tag (_ bv2 3)))
				(= 0 (select T_Evict_Tag (_ bv3 3)))
				(= 0 (select T_Evict_Tag (_ bv4 3)))
				(= 0 (select T_Evict_Tag (_ bv5 3)))
				(= 0 (select T_Evict_Tag (_ bv6 3)))
				(= 0 (select T_Evict_Tag (_ bv7 3)))
				
				(= #b0 (select T_Evict_Valid (_ bv0 3)))
				(= #b0 (select T_Evict_Valid (_ bv1 3)))
				(= #b0 (select T_Evict_Valid (_ bv2 3)))
				(= #b0 (select T_Evict_Valid (_ bv3 3)))
				(= #b0 (select T_Evict_Valid (_ bv4 3)))
				(= #b0 (select T_Evict_Valid (_ bv5 3)))
				(= #b0 (select T_Evict_Valid (_ bv6 3)))
				(= #b0 (select T_Evict_Valid (_ bv7 3)))
				
				
				
				
				(= 0 (select empty_ROB_int (_ bv0 3)))
				(= 0 (select empty_ROB_int (_ bv1 3)))
				(= 0 (select empty_ROB_int (_ bv2 3)))
				(= 0 (select empty_ROB_int (_ bv3 3)))
				(= 0 (select empty_ROB_int (_ bv4 3)))
				(= 0 (select empty_ROB_int (_ bv5 3)))
				(= 0 (select empty_ROB_int (_ bv6 3)))
				(= 0 (select empty_ROB_int (_ bv7 3)))
				
				(= #b0 (select empty_ROB_1bit (_ bv0 3)))
				(= #b0 (select empty_ROB_1bit (_ bv1 3)))
				(= #b0 (select empty_ROB_1bit (_ bv2 3)))
				(= #b0 (select empty_ROB_1bit (_ bv3 3)))
				(= #b0 (select empty_ROB_1bit (_ bv4 3)))
				(= #b0 (select empty_ROB_1bit (_ bv5 3)))
				(= #b0 (select empty_ROB_1bit (_ bv6 3)))
				(= #b0 (select empty_ROB_1bit (_ bv7 3)))
				
				(= #b0 (select empty_RS_LSQ_1bit (_ bv0 2)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv1 2)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv2 2)))
				(= #b0 (select empty_RS_LSQ_1bit (_ bv3 2)))
				
				(= #b000 (select empty_RS_LSQ_3bit (_ bv0 2)))
				(= #b000 (select empty_RS_LSQ_3bit (_ bv1 2)))
				(= #b000 (select empty_RS_LSQ_3bit (_ bv2 2)))
				(= #b000 (select empty_RS_LSQ_3bit (_ bv3 2)))
				
				(= 0 (select empty_RS_LSQ_int (_ bv0 2)))
				(= 0 (select empty_RS_LSQ_int (_ bv1 2)))
				(= 0 (select empty_RS_LSQ_int (_ bv2 2)))
				(= 0 (select empty_RS_LSQ_int (_ bv3 2)))
				
				
				(= Rtype 0)
				(= Branch 1)
				(= Mul_div 2)
				(= Load 3)
				(= Store 4)
				(= Jump 5)			
;)

;(----------------------------Visual-------------------------------------------------
				(= U4_state_ROB1_RF_dst_value (select U4_RF (select U1_ROB_destination (_ bv1 3))))
				(= U4_state_ROB2_RF_dst_value (select U4_RF (select U1_ROB_destination (_ bv2 3))))
				(= U4_state_ROB3_RF_dst_value (select U4_RF (select U1_ROB_destination (_ bv3 3))))
				(= U4_state_ROB4_RF_dst_value (select U4_RF (select U1_ROB_destination (_ bv4 3))))
				
				(= U4_state_ROB1_DM_dst_value (select U4_DM (select U1_ROB_destination (_ bv1 3))))
				(= U4_state_ROB2_DM_dst_value (select U4_DM (select U1_ROB_destination (_ bv2 3))))
				(= U4_state_ROB3_DM_dst_value (select U4_DM (select U1_ROB_destination (_ bv3 3))))
				(= U4_state_ROB4_DM_dst_value (select U4_DM (select U1_ROB_destination (_ bv4 3))))
				
				(= W4_state_ROB1_RF_dst_value (select W4_RF (select W1_ROB_destination (_ bv1 3))))
				(= W4_state_ROB2_RF_dst_value (select W4_RF (select W1_ROB_destination (_ bv2 3))))
				(= W4_state_ROB3_RF_dst_value (select W4_RF (select W1_ROB_destination (_ bv3 3))))
				(= W4_state_ROB4_RF_dst_value (select W4_RF (select W1_ROB_destination (_ bv4 3))))
				
				(= W4_state_ROB1_DM_dst_value (select W4_DM (select W1_ROB_destination (_ bv1 3))))
				(= W4_state_ROB2_DM_dst_value (select W4_DM (select W1_ROB_destination (_ bv2 3))))
				(= W4_state_ROB3_DM_dst_value (select W4_DM (select W1_ROB_destination (_ bv3 3))))
				(= W4_state_ROB4_DM_dst_value (select W4_DM (select W1_ROB_destination (_ bv4 3))))
				
		;		(= I_state_ROB1_RF_dst_value (select I_RF (select U1_ROB_destination (_ bv1 3))))
		;		(= I_state_ROB2_RF_dst_value (select I_RF (select U1_ROB_destination (_ bv2 3))))
		;		(= I_state_ROB3_RF_dst_value (select I_RF (select U1_ROB_destination (_ bv3 3))))
		;		(= I_state_ROB4_RF_dst_value (select I_RF (select U1_ROB_destination (_ bv4 3))))
		;		
		;		(= I_state_ROB1_DM_dst_value (select I_DM (select U1_ROB_destination (_ bv1 3))))
		;		(= I_state_ROB2_DM_dst_value (select I_DM (select U1_ROB_destination (_ bv2 3))))
		;		(= I_state_ROB3_DM_dst_value (select I_DM (select U1_ROB_destination (_ bv3 3))))
		;		(= I_state_ROB4_DM_dst_value (select I_DM (select U1_ROB_destination (_ bv4 3))))
				
				(= T_state_Cache0_Tag (select T_Cache_Tag (_ bv0 2)))
				(= T_state_Cache1_Tag (select T_Cache_Tag (_ bv1 2)))
				(= T_state_Cache2_Tag (select T_Cache_Tag (_ bv2 2)))
				(= T_state_Cache3_Tag (select T_Cache_Tag (_ bv3 2)))
				
				(= T_state_Cache0_Data (select T_Cache_Data (_ bv0 2)))
				(= T_state_Cache1_Data (select T_Cache_Data (_ bv1 2)))
				(= T_state_Cache2_Data (select T_Cache_Data (_ bv2 2)))
				(= T_state_Cache3_Data (select T_Cache_Data (_ bv3 2)))
				
				(= T_state_Cache0_Valid (select T_Cache_Valid (_ bv0 2)))
				(= T_state_Cache1_Valid (select T_Cache_Valid (_ bv1 2)))
				(= T_state_Cache2_Valid (select T_Cache_Valid (_ bv2 2)))
				(= T_state_Cache3_Valid (select T_Cache_Valid (_ bv3 2)))
				
				(= T_state_IP T_IP)
				(= T_state_CP T_CP)
				(= T_state_PC T_PC)
				
				(= T_state_ROB0_busy (select T_ROB_busy (_ bv0 3)))
				(= T_state_ROB0_op_type (select T_ROB_op_type (_ bv0 3)))
				(= T_state_ROB0_destination (select T_ROB_destination (_ bv0 3)))
				(= T_state_ROB0_result (select T_ROB_result (_ bv0 3)))
				(= T_state_ROB0_exception (select T_ROB_exception (_ bv0 3)))
				(= T_state_ROB0_done (select T_ROB_done (_ bv0 3)))
				
				(= T_state_ROB1_busy (select T_ROB_busy (_ bv1 3)))
				(= T_state_ROB1_op_type (select T_ROB_op_type (_ bv1 3)))
				(= T_state_ROB1_destination (select T_ROB_destination (_ bv1 3)))
				(= T_state_ROB1_result (select T_ROB_result (_ bv1 3)))
				(= T_state_ROB1_exception (select T_ROB_exception (_ bv1 3)))
				(= T_state_ROB1_done (select T_ROB_done (_ bv1 3)))
				
				(= T_state_ROB2_busy (select T_ROB_busy (_ bv2 3)))
				(= T_state_ROB2_op_type (select T_ROB_op_type (_ bv2 3)))
				(= T_state_ROB2_destination (select T_ROB_destination (_ bv2 3)))
				(= T_state_ROB2_result (select T_ROB_result (_ bv2 3)))
				(= T_state_ROB2_exception (select T_ROB_exception (_ bv2 3)))
				(= T_state_ROB2_done (select T_ROB_done (_ bv2 3)))
				
				(= T_state_ROB3_busy (select T_ROB_busy (_ bv3 3)))
				(= T_state_ROB3_op_type (select T_ROB_op_type (_ bv3 3)))
				(= T_state_ROB3_destination (select T_ROB_destination (_ bv3 3)))
				(= T_state_ROB3_result (select T_ROB_result (_ bv3 3)))
				(= T_state_ROB3_exception (select T_ROB_exception (_ bv3 3)))
				(= T_state_ROB3_done (select T_ROB_done (_ bv3 3)))
				
				(= T_state_ROB4_busy (select T_ROB_busy (_ bv4 3)))
				(= T_state_ROB4_op_type (select T_ROB_op_type (_ bv4 3)))
				(= T_state_ROB4_destination (select T_ROB_destination (_ bv4 3)))
				(= T_state_ROB4_result (select T_ROB_result (_ bv4 3)))
				(= T_state_ROB4_exception (select T_ROB_exception (_ bv4 3)))
				(= T_state_ROB4_done (select T_ROB_done (_ bv4 3)))
				
				(= T_state_ROB5_busy (select T_ROB_busy (_ bv5 3)))
				(= T_state_ROB5_op_type (select T_ROB_op_type (_ bv5 3)))
				(= T_state_ROB5_destination (select T_ROB_destination (_ bv5 3)))
				(= T_state_ROB5_result (select T_ROB_result (_ bv5 3)))
				(= T_state_ROB5_exception (select T_ROB_exception (_ bv5 3)))
				(= T_state_ROB5_done (select T_ROB_done (_ bv5 3)))
				
				(= T_state_ROB6_busy (select T_ROB_busy (_ bv6 3)))
				(= T_state_ROB6_op_type (select T_ROB_op_type (_ bv6 3)))
				(= T_state_ROB6_destination (select T_ROB_destination (_ bv6 3)))
				(= T_state_ROB6_result (select T_ROB_result (_ bv6 3)))
				(= T_state_ROB6_exception (select T_ROB_exception (_ bv6 3)))
				(= T_state_ROB6_done (select T_ROB_done (_ bv6 3)))
				
				(= T_state_ROB7_busy (select T_ROB_busy (_ bv7 3)))
				(= T_state_ROB7_op_type (select T_ROB_op_type (_ bv7 3)))
				(= T_state_ROB7_destination (select T_ROB_destination (_ bv7 3)))
				(= T_state_ROB7_result (select T_ROB_result (_ bv7 3)))
				(= T_state_ROB7_exception (select T_ROB_exception (_ bv7 3)))
				(= T_state_ROB7_done (select T_ROB_done (_ bv7 3)))
				
				(= T_state_RS0_op_type (select T_RS_op_type (_ bv0 2)))
				(= T_state_RS0_op (select T_RS_op (_ bv0 2)))
				(= T_state_RS0_ROB_dst (select T_RS_ROB_dst (_ bv0 2)))
				(= T_state_RS0_vj (select T_RS_vj (_ bv0 2)))
				(= T_state_RS0_vk (select T_RS_vk (_ bv0 2)))
				(= T_state_RS0_qj (select T_RS_qj (_ bv0 2)))
				(= T_state_RS0_qk (select T_RS_qk (_ bv0 2)))
				(= T_state_RS0_imm (select T_RS_imm (_ bv0 2)))
				(= T_state_RS0_dis (select T_RS_dis (_ bv0 2)))
				(= T_state_RS0_busy (select T_RS_busy (_ bv0 2)))
				
				(= T_state_RS1_op_type (select T_RS_op_type (_ bv1 2)))
				(= T_state_RS1_op (select T_RS_op (_ bv1 2)))
				(= T_state_RS1_ROB_dst (select T_RS_ROB_dst (_ bv1 2)))
				(= T_state_RS1_vj (select T_RS_vj (_ bv1 2)))
				(= T_state_RS1_vk (select T_RS_vk (_ bv1 2)))
				(= T_state_RS1_qj (select T_RS_qj (_ bv1 2)))
				(= T_state_RS1_qk (select T_RS_qk (_ bv1 2)))
				(= T_state_RS1_imm (select T_RS_imm (_ bv1 2)))
				(= T_state_RS1_dis (select T_RS_dis (_ bv1 2)))
				(= T_state_RS1_busy (select T_RS_busy (_ bv1 2)))
				
				(= T_state_RS2_op_type (select T_RS_op_type (_ bv2 2)))
				(= T_state_RS2_op (select T_RS_op (_ bv2 2)))
				(= T_state_RS2_ROB_dst (select T_RS_ROB_dst (_ bv2 2)))
				(= T_state_RS2_vj (select T_RS_vj (_ bv2 2)))
				(= T_state_RS2_vk (select T_RS_vk (_ bv2 2)))
				(= T_state_RS2_qj (select T_RS_qj (_ bv2 2)))
				(= T_state_RS2_qk (select T_RS_qk (_ bv2 2)))
				(= T_state_RS2_imm (select T_RS_imm (_ bv2 2)))
				(= T_state_RS2_dis (select T_RS_dis (_ bv2 2)))
				(= T_state_RS2_busy (select T_RS_busy (_ bv2 2)))
				
				(= T_state_RS3_op_type (select T_RS_op_type (_ bv3 2)))
				(= T_state_RS3_op (select T_RS_op (_ bv3 2)))
				(= T_state_RS3_ROB_dst (select T_RS_ROB_dst (_ bv3 2)))
				(= T_state_RS3_vj (select T_RS_vj (_ bv3 2)))
				(= T_state_RS3_vk (select T_RS_vk (_ bv3 2)))
				(= T_state_RS3_qj (select T_RS_qj (_ bv3 2)))
				(= T_state_RS3_qk (select T_RS_qk (_ bv3 2)))
				(= T_state_RS3_imm (select T_RS_imm (_ bv3 2)))
				(= T_state_RS3_dis (select T_RS_dis (_ bv3 2)))
				(= T_state_RS3_busy (select T_RS_busy (_ bv3 2)))
				
				(= T_state_LSQ0_op_type (select T_LSQ_op_type (_ bv0 2)))
				(= T_state_LSQ0_op (select T_LSQ_op (_ bv0 2)))
				(= T_state_LSQ0_ROB_dst (select T_LSQ_ROB_dst (_ bv0 2)))
				(= T_state_LSQ0_vj (select T_LSQ_vj (_ bv0 2)))
				(= T_state_LSQ0_vk (select T_LSQ_vk (_ bv0 2)))
				(= T_state_LSQ0_qj (select T_LSQ_qj (_ bv0 2)))
				(= T_state_LSQ0_qk (select T_LSQ_qk (_ bv0 2)))
				(= T_state_LSQ0_imm (select T_LSQ_imm (_ bv0 2)))
				(= T_state_LSQ0_dis (select T_LSQ_dis (_ bv0 2)))
				(= T_state_LSQ0_busy (select T_LSQ_busy (_ bv0 2)))
				
				(= T_state_LSQ1_op_type (select T_LSQ_op_type (_ bv1 2)))
				(= T_state_LSQ1_op (select T_LSQ_op (_ bv1 2)))
				(= T_state_LSQ1_ROB_dst (select T_LSQ_ROB_dst (_ bv1 2)))
				(= T_state_LSQ1_vj (select T_LSQ_vj (_ bv1 2)))
				(= T_state_LSQ1_vk (select T_LSQ_vk (_ bv1 2)))
				(= T_state_LSQ1_qj (select T_LSQ_qj (_ bv1 2)))
				(= T_state_LSQ1_qk (select T_LSQ_qk (_ bv1 2)))
				(= T_state_LSQ1_imm (select T_LSQ_imm (_ bv1 2)))
				(= T_state_LSQ1_dis (select T_LSQ_dis (_ bv1 2)))
				(= T_state_LSQ1_busy (select T_LSQ_busy (_ bv1 2)))
				
				(= T_state_LSQ2_op_type (select T_LSQ_op_type (_ bv2 2)))
				(= T_state_LSQ2_op (select T_LSQ_op (_ bv2 2)))
				(= T_state_LSQ2_ROB_dst (select T_LSQ_ROB_dst (_ bv2 2)))
				(= T_state_LSQ2_vj (select T_LSQ_vj (_ bv2 2)))
				(= T_state_LSQ2_vk (select T_LSQ_vk (_ bv2 2)))
				(= T_state_LSQ2_qj (select T_LSQ_qj (_ bv2 2)))
				(= T_state_LSQ2_qk (select T_LSQ_qk (_ bv2 2)))
				(= T_state_LSQ2_imm (select T_LSQ_imm (_ bv2 2)))
				(= T_state_LSQ2_dis (select T_LSQ_dis (_ bv2 2)))
				(= T_state_LSQ2_busy (select T_LSQ_busy (_ bv2 2)))
				
				(= T_state_LSQ3_op_type (select T_LSQ_op_type (_ bv3 2)))
				(= T_state_LSQ3_op (select T_LSQ_op (_ bv3 2)))
				(= T_state_LSQ3_ROB_dst (select T_LSQ_ROB_dst (_ bv3 2)))
				(= T_state_LSQ3_vj (select T_LSQ_vj (_ bv3 2)))
				(= T_state_LSQ3_vk (select T_LSQ_vk (_ bv3 2)))
				(= T_state_LSQ3_qj (select T_LSQ_qj (_ bv3 2)))
				(= T_state_LSQ3_qk (select T_LSQ_qk (_ bv3 2)))
				(= T_state_LSQ3_imm (select T_LSQ_imm (_ bv3 2)))
				(= T_state_LSQ3_dis (select T_LSQ_dis (_ bv3 2)))
				(= T_state_LSQ3_busy (select T_LSQ_busy (_ bv3 2)))
				
				(= T_state_Evict0_Valid (select T_Evict_Valid (_ bv0 3)))
				(= T_state_Evict1_Valid (select T_Evict_Valid (_ bv1 3)))
				(= T_state_Evict2_Valid (select T_Evict_Valid (_ bv2 3)))
				(= T_state_Evict3_Valid (select T_Evict_Valid (_ bv3 3)))
				(= T_state_Evict4_Valid (select T_Evict_Valid (_ bv4 3)))
				(= T_state_Evict5_Valid (select T_Evict_Valid (_ bv5 3)))
				(= T_state_Evict6_Valid (select T_Evict_Valid (_ bv6 3)))
				(= T_state_Evict7_Valid (select T_Evict_Valid (_ bv7 3)))
				
				(= T_state_Evict0_Tag (select T_Evict_Tag (_ bv0 3)))
				(= T_state_Evict1_Tag (select T_Evict_Tag (_ bv1 3)))
				(= T_state_Evict2_Tag (select T_Evict_Tag (_ bv2 3)))
				(= T_state_Evict3_Tag (select T_Evict_Tag (_ bv3 3)))
				(= T_state_Evict4_Tag (select T_Evict_Tag (_ bv4 3)))
				(= T_state_Evict5_Tag (select T_Evict_Tag (_ bv5 3)))
				(= T_state_Evict6_Tag (select T_Evict_Tag (_ bv6 3)))
				(= T_state_Evict7_Tag (select T_Evict_Tag (_ bv7 3)))
				
				(= U1_state_Cache0_Tag (select U1_Cache_Tag (_ bv0 2)))
				(= U1_state_Cache1_Tag (select U1_Cache_Tag (_ bv1 2)))
				(= U1_state_Cache2_Tag (select U1_Cache_Tag (_ bv2 2)))
				(= U1_state_Cache3_Tag (select U1_Cache_Tag (_ bv3 2)))
				
				(= U1_state_Cache0_Data (select U1_Cache_Data (_ bv0 2)))
				(= U1_state_Cache1_Data (select U1_Cache_Data (_ bv1 2)))
				(= U1_state_Cache2_Data (select U1_Cache_Data (_ bv2 2)))
				(= U1_state_Cache3_Data (select U1_Cache_Data (_ bv3 2)))
				
				(= U1_state_Cache0_Valid (select U1_Cache_Valid (_ bv0 2)))
				(= U1_state_Cache1_Valid (select U1_Cache_Valid (_ bv1 2)))
				(= U1_state_Cache2_Valid (select U1_Cache_Valid (_ bv2 2)))
				(= U1_state_Cache3_Valid (select U1_Cache_Valid (_ bv3 2)))
				
				(= U1_state_IP U1_IP)
				(= U1_state_CP U1_CP)
				(= U1_state_PC U1_PC)
				
				(= U1_state_ROB0_busy (select U1_ROB_busy (_ bv0 3)))
				(= U1_state_ROB0_op_type (select U1_ROB_op_type (_ bv0 3)))
				(= U1_state_ROB0_destination (select U1_ROB_destination (_ bv0 3)))
				(= U1_state_ROB0_result (select U1_ROB_result (_ bv0 3)))
				(= U1_state_ROB0_exception (select U1_ROB_exception (_ bv0 3)))
				(= U1_state_ROB0_done (select U1_ROB_done (_ bv0 3)))
				
				(= U1_state_ROB1_busy (select U1_ROB_busy (_ bv1 3)))
				(= U1_state_ROB1_op_type (select U1_ROB_op_type (_ bv1 3)))
				(= U1_state_ROB1_destination (select U1_ROB_destination (_ bv1 3)))
				(= U1_state_ROB1_result (select U1_ROB_result (_ bv1 3)))
				(= U1_state_ROB1_exception (select U1_ROB_exception (_ bv1 3)))
				(= U1_state_ROB1_done (select U1_ROB_done (_ bv1 3)))
				
				(= U1_state_ROB2_busy (select U1_ROB_busy (_ bv2 3)))
				(= U1_state_ROB2_op_type (select U1_ROB_op_type (_ bv2 3)))
				(= U1_state_ROB2_destination (select U1_ROB_destination (_ bv2 3)))
				(= U1_state_ROB2_result (select U1_ROB_result (_ bv2 3)))
				(= U1_state_ROB2_exception (select U1_ROB_exception (_ bv2 3)))
				(= U1_state_ROB2_done (select U1_ROB_done (_ bv2 3)))
				
				(= U1_state_ROB3_busy (select U1_ROB_busy (_ bv3 3)))
				(= U1_state_ROB3_op_type (select U1_ROB_op_type (_ bv3 3)))
				(= U1_state_ROB3_destination (select U1_ROB_destination (_ bv3 3)))
				(= U1_state_ROB3_result (select U1_ROB_result (_ bv3 3)))
				(= U1_state_ROB3_exception (select U1_ROB_exception (_ bv3 3)))
				(= U1_state_ROB3_done (select U1_ROB_done (_ bv3 3)))
				
				(= U1_state_ROB4_busy (select U1_ROB_busy (_ bv4 3)))
				(= U1_state_ROB4_op_type (select U1_ROB_op_type (_ bv4 3)))
				(= U1_state_ROB4_destination (select U1_ROB_destination (_ bv4 3)))
				(= U1_state_ROB4_result (select U1_ROB_result (_ bv4 3)))
				(= U1_state_ROB4_exception (select U1_ROB_exception (_ bv4 3)))
				(= U1_state_ROB4_done (select U1_ROB_done (_ bv4 3)))
				
				(= U1_state_ROB5_busy (select U1_ROB_busy (_ bv5 3)))
				(= U1_state_ROB5_op_type (select U1_ROB_op_type (_ bv5 3)))
				(= U1_state_ROB5_destination (select U1_ROB_destination (_ bv5 3)))
				(= U1_state_ROB5_result (select U1_ROB_result (_ bv5 3)))
				(= U1_state_ROB5_exception (select U1_ROB_exception (_ bv5 3)))
				(= U1_state_ROB5_done (select U1_ROB_done (_ bv5 3)))
				
				(= U1_state_ROB6_busy (select U1_ROB_busy (_ bv6 3)))
				(= U1_state_ROB6_op_type (select U1_ROB_op_type (_ bv6 3)))
				(= U1_state_ROB6_destination (select U1_ROB_destination (_ bv6 3)))
				(= U1_state_ROB6_result (select U1_ROB_result (_ bv6 3)))
				(= U1_state_ROB6_exception (select U1_ROB_exception (_ bv6 3)))
				(= U1_state_ROB6_done (select U1_ROB_done (_ bv6 3)))
				
				(= U1_state_ROB7_busy (select U1_ROB_busy (_ bv7 3)))
				(= U1_state_ROB7_op_type (select U1_ROB_op_type (_ bv7 3)))
				(= U1_state_ROB7_destination (select U1_ROB_destination (_ bv7 3)))
				(= U1_state_ROB7_result (select U1_ROB_result (_ bv7 3)))
				(= U1_state_ROB7_exception (select U1_ROB_exception (_ bv7 3)))
				(= U1_state_ROB7_done (select U1_ROB_done (_ bv7 3)))
				
				(= U1_state_RS0_op_type (select U1_RS_op_type (_ bv0 2)))
				(= U1_state_RS0_op (select U1_RS_op (_ bv0 2)))
				(= U1_state_RS0_ROB_dst (select U1_RS_ROB_dst (_ bv0 2)))
				(= U1_state_RS0_vj (select U1_RS_vj (_ bv0 2)))
				(= U1_state_RS0_vk (select U1_RS_vk (_ bv0 2)))
				(= U1_state_RS0_qj (select U1_RS_qj (_ bv0 2)))
				(= U1_state_RS0_qk (select U1_RS_qk (_ bv0 2)))
				(= U1_state_RS0_imm (select U1_RS_imm (_ bv0 2)))
				(= U1_state_RS0_dis (select U1_RS_dis (_ bv0 2)))
				(= U1_state_RS0_busy (select U1_RS_busy (_ bv0 2)))
				
				(= U1_state_RS1_op_type (select U1_RS_op_type (_ bv1 2)))
				(= U1_state_RS1_op (select U1_RS_op (_ bv1 2)))
				(= U1_state_RS1_ROB_dst (select U1_RS_ROB_dst (_ bv1 2)))
				(= U1_state_RS1_vj (select U1_RS_vj (_ bv1 2)))
				(= U1_state_RS1_vk (select U1_RS_vk (_ bv1 2)))
				(= U1_state_RS1_qj (select U1_RS_qj (_ bv1 2)))
				(= U1_state_RS1_qk (select U1_RS_qk (_ bv1 2)))
				(= U1_state_RS1_imm (select U1_RS_imm (_ bv1 2)))
				(= U1_state_RS1_dis (select U1_RS_dis (_ bv1 2)))
				(= U1_state_RS1_busy (select U1_RS_busy (_ bv1 2)))
				
				(= U1_state_RS2_op_type (select U1_RS_op_type (_ bv2 2)))
				(= U1_state_RS2_op (select U1_RS_op (_ bv2 2)))
				(= U1_state_RS2_ROB_dst (select U1_RS_ROB_dst (_ bv2 2)))
				(= U1_state_RS2_vj (select U1_RS_vj (_ bv2 2)))
				(= U1_state_RS2_vk (select U1_RS_vk (_ bv2 2)))
				(= U1_state_RS2_qj (select U1_RS_qj (_ bv2 2)))
				(= U1_state_RS2_qk (select U1_RS_qk (_ bv2 2)))
				(= U1_state_RS2_imm (select U1_RS_imm (_ bv2 2)))
				(= U1_state_RS2_dis (select U1_RS_dis (_ bv2 2)))
				(= U1_state_RS2_busy (select U1_RS_busy (_ bv2 2)))
				
				(= U1_state_RS3_op_type (select U1_RS_op_type (_ bv3 2)))
				(= U1_state_RS3_op (select U1_RS_op (_ bv3 2)))
				(= U1_state_RS3_ROB_dst (select U1_RS_ROB_dst (_ bv3 2)))
				(= U1_state_RS3_vj (select U1_RS_vj (_ bv3 2)))
				(= U1_state_RS3_vk (select U1_RS_vk (_ bv3 2)))
				(= U1_state_RS3_qj (select U1_RS_qj (_ bv3 2)))
				(= U1_state_RS3_qk (select U1_RS_qk (_ bv3 2)))
				(= U1_state_RS3_imm (select U1_RS_imm (_ bv3 2)))
				(= U1_state_RS3_dis (select U1_RS_dis (_ bv3 2)))
				(= U1_state_RS3_busy (select U1_RS_busy (_ bv3 2)))
				
				(= U1_state_LSQ0_op_type (select U1_LSQ_op_type (_ bv0 2)))
				(= U1_state_LSQ0_op (select U1_LSQ_op (_ bv0 2)))
				(= U1_state_LSQ0_ROB_dst (select U1_LSQ_ROB_dst (_ bv0 2)))
				(= U1_state_LSQ0_vj (select U1_LSQ_vj (_ bv0 2)))
				(= U1_state_LSQ0_vk (select U1_LSQ_vk (_ bv0 2)))
				(= U1_state_LSQ0_qj (select U1_LSQ_qj (_ bv0 2)))
				(= U1_state_LSQ0_qk (select U1_LSQ_qk (_ bv0 2)))
				(= U1_state_LSQ0_imm (select U1_LSQ_imm (_ bv0 2)))
				(= U1_state_LSQ0_dis (select U1_LSQ_dis (_ bv0 2)))
				(= U1_state_LSQ0_busy (select U1_LSQ_busy (_ bv0 2)))
				
				(= U1_state_LSQ1_op_type (select U1_LSQ_op_type (_ bv1 2)))
				(= U1_state_LSQ1_op (select U1_LSQ_op (_ bv1 2)))
				(= U1_state_LSQ1_ROB_dst (select U1_LSQ_ROB_dst (_ bv1 2)))
				(= U1_state_LSQ1_vj (select U1_LSQ_vj (_ bv1 2)))
				(= U1_state_LSQ1_vk (select U1_LSQ_vk (_ bv1 2)))
				(= U1_state_LSQ1_qj (select U1_LSQ_qj (_ bv1 2)))
				(= U1_state_LSQ1_qk (select U1_LSQ_qk (_ bv1 2)))
				(= U1_state_LSQ1_imm (select U1_LSQ_imm (_ bv1 2)))
				(= U1_state_LSQ1_dis (select U1_LSQ_dis (_ bv1 2)))
				(= U1_state_LSQ1_busy (select U1_LSQ_busy (_ bv1 2)))
				
				(= U1_state_LSQ2_op_type (select U1_LSQ_op_type (_ bv2 2)))
				(= U1_state_LSQ2_op (select U1_LSQ_op (_ bv2 2)))
				(= U1_state_LSQ2_ROB_dst (select U1_LSQ_ROB_dst (_ bv2 2)))
				(= U1_state_LSQ2_vj (select U1_LSQ_vj (_ bv2 2)))
				(= U1_state_LSQ2_vk (select U1_LSQ_vk (_ bv2 2)))
				(= U1_state_LSQ2_qj (select U1_LSQ_qj (_ bv2 2)))
				(= U1_state_LSQ2_qk (select U1_LSQ_qk (_ bv2 2)))
				(= U1_state_LSQ2_imm (select U1_LSQ_imm (_ bv2 2)))
				(= U1_state_LSQ2_dis (select U1_LSQ_dis (_ bv2 2)))
				(= U1_state_LSQ2_busy (select U1_LSQ_busy (_ bv2 2)))
				
				(= U1_state_LSQ3_op_type (select U1_LSQ_op_type (_ bv3 2)))
				(= U1_state_LSQ3_op (select U1_LSQ_op (_ bv3 2)))
				(= U1_state_LSQ3_ROB_dst (select U1_LSQ_ROB_dst (_ bv3 2)))
				(= U1_state_LSQ3_vj (select U1_LSQ_vj (_ bv3 2)))
				(= U1_state_LSQ3_vk (select U1_LSQ_vk (_ bv3 2)))
				(= U1_state_LSQ3_qj (select U1_LSQ_qj (_ bv3 2)))
				(= U1_state_LSQ3_qk (select U1_LSQ_qk (_ bv3 2)))
				(= U1_state_LSQ3_imm (select U1_LSQ_imm (_ bv3 2)))
				(= U1_state_LSQ3_dis (select U1_LSQ_dis (_ bv3 2)))
				(= U1_state_LSQ3_busy (select U1_LSQ_busy (_ bv3 2)))
				
				(= U1_state_Evict0_Valid (select U1_Evict_Valid (_ bv0 3)))
				(= U1_state_Evict1_Valid (select U1_Evict_Valid (_ bv1 3)))
				(= U1_state_Evict2_Valid (select U1_Evict_Valid (_ bv2 3)))
				(= U1_state_Evict3_Valid (select U1_Evict_Valid (_ bv3 3)))
				(= U1_state_Evict4_Valid (select U1_Evict_Valid (_ bv4 3)))
				(= U1_state_Evict5_Valid (select U1_Evict_Valid (_ bv5 3)))
				(= U1_state_Evict6_Valid (select U1_Evict_Valid (_ bv6 3)))
				(= U1_state_Evict7_Valid (select U1_Evict_Valid (_ bv7 3)))
				
				(= U1_state_Evict0_Tag (select U1_Evict_Tag (_ bv0 3)))
				(= U1_state_Evict1_Tag (select U1_Evict_Tag (_ bv1 3)))
				(= U1_state_Evict2_Tag (select U1_Evict_Tag (_ bv2 3)))
				(= U1_state_Evict3_Tag (select U1_Evict_Tag (_ bv3 3)))
				(= U1_state_Evict4_Tag (select U1_Evict_Tag (_ bv4 3)))
				(= U1_state_Evict5_Tag (select U1_Evict_Tag (_ bv5 3)))
				(= U1_state_Evict6_Tag (select U1_Evict_Tag (_ bv6 3)))
				(= U1_state_Evict7_Tag (select U1_Evict_Tag (_ bv7 3)))
				
				(= U2_state_Cache0_Tag (select U2_Cache_Tag (_ bv0 2)))
				(= U2_state_Cache1_Tag (select U2_Cache_Tag (_ bv1 2)))
				(= U2_state_Cache2_Tag (select U2_Cache_Tag (_ bv2 2)))
				(= U2_state_Cache3_Tag (select U2_Cache_Tag (_ bv3 2)))
				
				(= U2_state_Cache0_Data (select U2_Cache_Data (_ bv0 2)))
				(= U2_state_Cache1_Data (select U2_Cache_Data (_ bv1 2)))
				(= U2_state_Cache2_Data (select U2_Cache_Data (_ bv2 2)))
				(= U2_state_Cache3_Data (select U2_Cache_Data (_ bv3 2)))
				
				(= U2_state_Cache0_Valid (select U2_Cache_Valid (_ bv0 2)))
				(= U2_state_Cache1_Valid (select U2_Cache_Valid (_ bv1 2)))
				(= U2_state_Cache2_Valid (select U2_Cache_Valid (_ bv2 2)))
				(= U2_state_Cache3_Valid (select U2_Cache_Valid (_ bv3 2)))
				
				(= U2_state_IP U2_IP)
				(= U2_state_CP U2_CP)
				(= U2_state_PC U2_PC)
				
				(= U2_state_ROB0_busy (select U2_ROB_busy (_ bv0 3)))
				(= U2_state_ROB0_op_type (select U2_ROB_op_type (_ bv0 3)))
				(= U2_state_ROB0_destination (select U2_ROB_destination (_ bv0 3)))
				(= U2_state_ROB0_result (select U2_ROB_result (_ bv0 3)))
				(= U2_state_ROB0_exception (select U2_ROB_exception (_ bv0 3)))
				(= U2_state_ROB0_done (select U2_ROB_done (_ bv0 3)))
				
				(= U2_state_ROB1_busy (select U2_ROB_busy (_ bv1 3)))
				(= U2_state_ROB1_op_type (select U2_ROB_op_type (_ bv1 3)))
				(= U2_state_ROB1_destination (select U2_ROB_destination (_ bv1 3)))
				(= U2_state_ROB1_result (select U2_ROB_result (_ bv1 3)))
				(= U2_state_ROB1_exception (select U2_ROB_exception (_ bv1 3)))
				(= U2_state_ROB1_done (select U2_ROB_done (_ bv1 3)))
				
				(= U2_state_ROB2_busy (select U2_ROB_busy (_ bv2 3)))
				(= U2_state_ROB2_op_type (select U2_ROB_op_type (_ bv2 3)))
				(= U2_state_ROB2_destination (select U2_ROB_destination (_ bv2 3)))
				(= U2_state_ROB2_result (select U2_ROB_result (_ bv2 3)))
				(= U2_state_ROB2_exception (select U2_ROB_exception (_ bv2 3)))
				(= U2_state_ROB2_done (select U2_ROB_done (_ bv2 3)))
				
				(= U2_state_ROB3_busy (select U2_ROB_busy (_ bv3 3)))
				(= U2_state_ROB3_op_type (select U2_ROB_op_type (_ bv3 3)))
				(= U2_state_ROB3_destination (select U2_ROB_destination (_ bv3 3)))
				(= U2_state_ROB3_result (select U2_ROB_result (_ bv3 3)))
				(= U2_state_ROB3_exception (select U2_ROB_exception (_ bv3 3)))
				(= U2_state_ROB3_done (select U2_ROB_done (_ bv3 3)))
				
				(= U2_state_ROB4_busy (select U2_ROB_busy (_ bv4 3)))
				(= U2_state_ROB4_op_type (select U2_ROB_op_type (_ bv4 3)))
				(= U2_state_ROB4_destination (select U2_ROB_destination (_ bv4 3)))
				(= U2_state_ROB4_result (select U2_ROB_result (_ bv4 3)))
				(= U2_state_ROB4_exception (select U2_ROB_exception (_ bv4 3)))
				(= U2_state_ROB4_done (select U2_ROB_done (_ bv4 3)))
				
				(= U2_state_ROB5_busy (select U2_ROB_busy (_ bv5 3)))
				(= U2_state_ROB5_op_type (select U2_ROB_op_type (_ bv5 3)))
				(= U2_state_ROB5_destination (select U2_ROB_destination (_ bv5 3)))
				(= U2_state_ROB5_result (select U2_ROB_result (_ bv5 3)))
				(= U2_state_ROB5_exception (select U2_ROB_exception (_ bv5 3)))
				(= U2_state_ROB5_done (select U2_ROB_done (_ bv5 3)))
				
				(= U2_state_ROB6_busy (select U2_ROB_busy (_ bv6 3)))
				(= U2_state_ROB6_op_type (select U2_ROB_op_type (_ bv6 3)))
				(= U2_state_ROB6_destination (select U2_ROB_destination (_ bv6 3)))
				(= U2_state_ROB6_result (select U2_ROB_result (_ bv6 3)))
				(= U2_state_ROB6_exception (select U2_ROB_exception (_ bv6 3)))
				(= U2_state_ROB6_done (select U2_ROB_done (_ bv6 3)))
				
				(= U2_state_ROB7_busy (select U2_ROB_busy (_ bv7 3)))
				(= U2_state_ROB7_op_type (select U2_ROB_op_type (_ bv7 3)))
				(= U2_state_ROB7_destination (select U2_ROB_destination (_ bv7 3)))
				(= U2_state_ROB7_result (select U2_ROB_result (_ bv7 3)))
				(= U2_state_ROB7_exception (select U2_ROB_exception (_ bv7 3)))
				(= U2_state_ROB7_done (select U2_ROB_done (_ bv7 3)))
				
				(= U2_state_RS0_op_type (select U2_RS_op_type (_ bv0 2)))
				(= U2_state_RS0_op (select U2_RS_op (_ bv0 2)))
				(= U2_state_RS0_ROB_dst (select U2_RS_ROB_dst (_ bv0 2)))
				(= U2_state_RS0_vj (select U2_RS_vj (_ bv0 2)))
				(= U2_state_RS0_vk (select U2_RS_vk (_ bv0 2)))
				(= U2_state_RS0_qj (select U2_RS_qj (_ bv0 2)))
				(= U2_state_RS0_qk (select U2_RS_qk (_ bv0 2)))
				(= U2_state_RS0_imm (select U2_RS_imm (_ bv0 2)))
				(= U2_state_RS0_dis (select U2_RS_dis (_ bv0 2)))
				(= U2_state_RS0_busy (select U2_RS_busy (_ bv0 2)))
				
				(= U2_state_RS1_op_type (select U2_RS_op_type (_ bv1 2)))
				(= U2_state_RS1_op (select U2_RS_op (_ bv1 2)))
				(= U2_state_RS1_ROB_dst (select U2_RS_ROB_dst (_ bv1 2)))
				(= U2_state_RS1_vj (select U2_RS_vj (_ bv1 2)))
				(= U2_state_RS1_vk (select U2_RS_vk (_ bv1 2)))
				(= U2_state_RS1_qj (select U2_RS_qj (_ bv1 2)))
				(= U2_state_RS1_qk (select U2_RS_qk (_ bv1 2)))
				(= U2_state_RS1_imm (select U2_RS_imm (_ bv1 2)))
				(= U2_state_RS1_dis (select U2_RS_dis (_ bv1 2)))
				(= U2_state_RS1_busy (select U2_RS_busy (_ bv1 2)))
				
				(= U2_state_RS2_op_type (select U2_RS_op_type (_ bv2 2)))
				(= U2_state_RS2_op (select U2_RS_op (_ bv2 2)))
				(= U2_state_RS2_ROB_dst (select U2_RS_ROB_dst (_ bv2 2)))
				(= U2_state_RS2_vj (select U2_RS_vj (_ bv2 2)))
				(= U2_state_RS2_vk (select U2_RS_vk (_ bv2 2)))
				(= U2_state_RS2_qj (select U2_RS_qj (_ bv2 2)))
				(= U2_state_RS2_qk (select U2_RS_qk (_ bv2 2)))
				(= U2_state_RS2_imm (select U2_RS_imm (_ bv2 2)))
				(= U2_state_RS2_dis (select U2_RS_dis (_ bv2 2)))
				(= U2_state_RS2_busy (select U2_RS_busy (_ bv2 2)))
				
				(= U2_state_RS3_op_type (select U2_RS_op_type (_ bv3 2)))
				(= U2_state_RS3_op (select U2_RS_op (_ bv3 2)))
				(= U2_state_RS3_ROB_dst (select U2_RS_ROB_dst (_ bv3 2)))
				(= U2_state_RS3_vj (select U2_RS_vj (_ bv3 2)))
				(= U2_state_RS3_vk (select U2_RS_vk (_ bv3 2)))
				(= U2_state_RS3_qj (select U2_RS_qj (_ bv3 2)))
				(= U2_state_RS3_qk (select U2_RS_qk (_ bv3 2)))
				(= U2_state_RS3_imm (select U2_RS_imm (_ bv3 2)))
				(= U2_state_RS3_dis (select U2_RS_dis (_ bv3 2)))
				(= U2_state_RS3_busy (select U2_RS_busy (_ bv3 2)))
				
				(= U2_state_LSQ0_op_type (select U2_LSQ_op_type (_ bv0 2)))
				(= U2_state_LSQ0_op (select U2_LSQ_op (_ bv0 2)))
				(= U2_state_LSQ0_ROB_dst (select U2_LSQ_ROB_dst (_ bv0 2)))
				(= U2_state_LSQ0_vj (select U2_LSQ_vj (_ bv0 2)))
				(= U2_state_LSQ0_vk (select U2_LSQ_vk (_ bv0 2)))
				(= U2_state_LSQ0_qj (select U2_LSQ_qj (_ bv0 2)))
				(= U2_state_LSQ0_qk (select U2_LSQ_qk (_ bv0 2)))
				(= U2_state_LSQ0_imm (select U2_LSQ_imm (_ bv0 2)))
				(= U2_state_LSQ0_dis (select U2_LSQ_dis (_ bv0 2)))
				(= U2_state_LSQ0_busy (select U2_LSQ_busy (_ bv0 2)))
				
				(= U2_state_LSQ1_op_type (select U2_LSQ_op_type (_ bv1 2)))
				(= U2_state_LSQ1_op (select U2_LSQ_op (_ bv1 2)))
				(= U2_state_LSQ1_ROB_dst (select U2_LSQ_ROB_dst (_ bv1 2)))
				(= U2_state_LSQ1_vj (select U2_LSQ_vj (_ bv1 2)))
				(= U2_state_LSQ1_vk (select U2_LSQ_vk (_ bv1 2)))
				(= U2_state_LSQ1_qj (select U2_LSQ_qj (_ bv1 2)))
				(= U2_state_LSQ1_qk (select U2_LSQ_qk (_ bv1 2)))
				(= U2_state_LSQ1_imm (select U2_LSQ_imm (_ bv1 2)))
				(= U2_state_LSQ1_dis (select U2_LSQ_dis (_ bv1 2)))
				(= U2_state_LSQ1_busy (select U2_LSQ_busy (_ bv1 2)))
				
				(= U2_state_LSQ2_op_type (select U2_LSQ_op_type (_ bv2 2)))
				(= U2_state_LSQ2_op (select U2_LSQ_op (_ bv2 2)))
				(= U2_state_LSQ2_ROB_dst (select U2_LSQ_ROB_dst (_ bv2 2)))
				(= U2_state_LSQ2_vj (select U2_LSQ_vj (_ bv2 2)))
				(= U2_state_LSQ2_vk (select U2_LSQ_vk (_ bv2 2)))
				(= U2_state_LSQ2_qj (select U2_LSQ_qj (_ bv2 2)))
				(= U2_state_LSQ2_qk (select U2_LSQ_qk (_ bv2 2)))
				(= U2_state_LSQ2_imm (select U2_LSQ_imm (_ bv2 2)))
				(= U2_state_LSQ2_dis (select U2_LSQ_dis (_ bv2 2)))
				(= U2_state_LSQ2_busy (select U2_LSQ_busy (_ bv2 2)))
				
				(= U2_state_LSQ3_op_type (select U2_LSQ_op_type (_ bv3 2)))
				(= U2_state_LSQ3_op (select U2_LSQ_op (_ bv3 2)))
				(= U2_state_LSQ3_ROB_dst (select U2_LSQ_ROB_dst (_ bv3 2)))
				(= U2_state_LSQ3_vj (select U2_LSQ_vj (_ bv3 2)))
				(= U2_state_LSQ3_vk (select U2_LSQ_vk (_ bv3 2)))
				(= U2_state_LSQ3_qj (select U2_LSQ_qj (_ bv3 2)))
				(= U2_state_LSQ3_qk (select U2_LSQ_qk (_ bv3 2)))
				(= U2_state_LSQ3_imm (select U2_LSQ_imm (_ bv3 2)))
				(= U2_state_LSQ3_dis (select U2_LSQ_dis (_ bv3 2)))
				(= U2_state_LSQ3_busy (select U2_LSQ_busy (_ bv3 2)))
				
				(= U2_state_Evict0_Valid (select U2_Evict_Valid (_ bv0 3)))
				(= U2_state_Evict1_Valid (select U2_Evict_Valid (_ bv1 3)))
				(= U2_state_Evict2_Valid (select U2_Evict_Valid (_ bv2 3)))
				(= U2_state_Evict3_Valid (select U2_Evict_Valid (_ bv3 3)))
				(= U2_state_Evict4_Valid (select U2_Evict_Valid (_ bv4 3)))
				(= U2_state_Evict5_Valid (select U2_Evict_Valid (_ bv5 3)))
				(= U2_state_Evict6_Valid (select U2_Evict_Valid (_ bv6 3)))
				(= U2_state_Evict7_Valid (select U2_Evict_Valid (_ bv7 3)))
				
				(= U2_state_Evict0_Tag (select U2_Evict_Tag (_ bv0 3)))
				(= U2_state_Evict1_Tag (select U2_Evict_Tag (_ bv1 3)))
				(= U2_state_Evict2_Tag (select U2_Evict_Tag (_ bv2 3)))
				(= U2_state_Evict3_Tag (select U2_Evict_Tag (_ bv3 3)))
				(= U2_state_Evict4_Tag (select U2_Evict_Tag (_ bv4 3)))
				(= U2_state_Evict5_Tag (select U2_Evict_Tag (_ bv5 3)))
				(= U2_state_Evict6_Tag (select U2_Evict_Tag (_ bv6 3)))
				(= U2_state_Evict7_Tag (select U2_Evict_Tag (_ bv7 3)))
				
				(= U3_state_Cache0_Tag (select U3_Cache_Tag (_ bv0 2)))
				(= U3_state_Cache1_Tag (select U3_Cache_Tag (_ bv1 2)))
				(= U3_state_Cache2_Tag (select U3_Cache_Tag (_ bv2 2)))
				(= U3_state_Cache3_Tag (select U3_Cache_Tag (_ bv3 2)))
				
				(= U3_state_Cache0_Data (select U3_Cache_Data (_ bv0 2)))
				(= U3_state_Cache1_Data (select U3_Cache_Data (_ bv1 2)))
				(= U3_state_Cache2_Data (select U3_Cache_Data (_ bv2 2)))
				(= U3_state_Cache3_Data (select U3_Cache_Data (_ bv3 2)))
				
				(= U3_state_Cache0_Valid (select U3_Cache_Valid (_ bv0 2)))
				(= U3_state_Cache1_Valid (select U3_Cache_Valid (_ bv1 2)))
				(= U3_state_Cache2_Valid (select U3_Cache_Valid (_ bv2 2)))
				(= U3_state_Cache3_Valid (select U3_Cache_Valid (_ bv3 2)))
				
				(= U3_state_IP U3_IP)
				(= U3_state_CP U3_CP)
				(= U3_state_PC U3_PC)
				
				(= U3_state_ROB0_busy (select U3_ROB_busy (_ bv0 3)))
				(= U3_state_ROB0_op_type (select U3_ROB_op_type (_ bv0 3)))
				(= U3_state_ROB0_destination (select U3_ROB_destination (_ bv0 3)))
				(= U3_state_ROB0_result (select U3_ROB_result (_ bv0 3)))
				(= U3_state_ROB0_exception (select U3_ROB_exception (_ bv0 3)))
				(= U3_state_ROB0_done (select U3_ROB_done (_ bv0 3)))
				
				(= U3_state_ROB1_busy (select U3_ROB_busy (_ bv1 3)))
				(= U3_state_ROB1_op_type (select U3_ROB_op_type (_ bv1 3)))
				(= U3_state_ROB1_destination (select U3_ROB_destination (_ bv1 3)))
				(= U3_state_ROB1_result (select U3_ROB_result (_ bv1 3)))
				(= U3_state_ROB1_exception (select U3_ROB_exception (_ bv1 3)))
				(= U3_state_ROB1_done (select U3_ROB_done (_ bv1 3)))
				
				(= U3_state_ROB2_busy (select U3_ROB_busy (_ bv2 3)))
				(= U3_state_ROB2_op_type (select U3_ROB_op_type (_ bv2 3)))
				(= U3_state_ROB2_destination (select U3_ROB_destination (_ bv2 3)))
				(= U3_state_ROB2_result (select U3_ROB_result (_ bv2 3)))
				(= U3_state_ROB2_exception (select U3_ROB_exception (_ bv2 3)))
				(= U3_state_ROB2_done (select U3_ROB_done (_ bv2 3)))
				
				(= U3_state_ROB3_busy (select U3_ROB_busy (_ bv3 3)))
				(= U3_state_ROB3_op_type (select U3_ROB_op_type (_ bv3 3)))
				(= U3_state_ROB3_destination (select U3_ROB_destination (_ bv3 3)))
				(= U3_state_ROB3_result (select U3_ROB_result (_ bv3 3)))
				(= U3_state_ROB3_exception (select U3_ROB_exception (_ bv3 3)))
				(= U3_state_ROB3_done (select U3_ROB_done (_ bv3 3)))
				
				(= U3_state_ROB4_busy (select U3_ROB_busy (_ bv4 3)))
				(= U3_state_ROB4_op_type (select U3_ROB_op_type (_ bv4 3)))
				(= U3_state_ROB4_destination (select U3_ROB_destination (_ bv4 3)))
				(= U3_state_ROB4_result (select U3_ROB_result (_ bv4 3)))
				(= U3_state_ROB4_exception (select U3_ROB_exception (_ bv4 3)))
				(= U3_state_ROB4_done (select U3_ROB_done (_ bv4 3)))
				
				(= U3_state_ROB5_busy (select U3_ROB_busy (_ bv5 3)))
				(= U3_state_ROB5_op_type (select U3_ROB_op_type (_ bv5 3)))
				(= U3_state_ROB5_destination (select U3_ROB_destination (_ bv5 3)))
				(= U3_state_ROB5_result (select U3_ROB_result (_ bv5 3)))
				(= U3_state_ROB5_exception (select U3_ROB_exception (_ bv5 3)))
				(= U3_state_ROB5_done (select U3_ROB_done (_ bv5 3)))
				
				(= U3_state_ROB6_busy (select U3_ROB_busy (_ bv6 3)))
				(= U3_state_ROB6_op_type (select U3_ROB_op_type (_ bv6 3)))
				(= U3_state_ROB6_destination (select U3_ROB_destination (_ bv6 3)))
				(= U3_state_ROB6_result (select U3_ROB_result (_ bv6 3)))
				(= U3_state_ROB6_exception (select U3_ROB_exception (_ bv6 3)))
				(= U3_state_ROB6_done (select U3_ROB_done (_ bv6 3)))
				
				(= U3_state_ROB7_busy (select U3_ROB_busy (_ bv7 3)))
				(= U3_state_ROB7_op_type (select U3_ROB_op_type (_ bv7 3)))
				(= U3_state_ROB7_destination (select U3_ROB_destination (_ bv7 3)))
				(= U3_state_ROB7_result (select U3_ROB_result (_ bv7 3)))
				(= U3_state_ROB7_exception (select U3_ROB_exception (_ bv7 3)))
				(= U3_state_ROB7_done (select U3_ROB_done (_ bv7 3)))
				
				(= U3_state_RS0_op_type (select U3_RS_op_type (_ bv0 2)))
				(= U3_state_RS0_op (select U3_RS_op (_ bv0 2)))
				(= U3_state_RS0_ROB_dst (select U3_RS_ROB_dst (_ bv0 2)))
				(= U3_state_RS0_vj (select U3_RS_vj (_ bv0 2)))
				(= U3_state_RS0_vk (select U3_RS_vk (_ bv0 2)))
				(= U3_state_RS0_qj (select U3_RS_qj (_ bv0 2)))
				(= U3_state_RS0_qk (select U3_RS_qk (_ bv0 2)))
				(= U3_state_RS0_imm (select U3_RS_imm (_ bv0 2)))
				(= U3_state_RS0_dis (select U3_RS_dis (_ bv0 2)))
				(= U3_state_RS0_busy (select U3_RS_busy (_ bv0 2)))
				
				(= U3_state_RS1_op_type (select U3_RS_op_type (_ bv1 2)))
				(= U3_state_RS1_op (select U3_RS_op (_ bv1 2)))
				(= U3_state_RS1_ROB_dst (select U3_RS_ROB_dst (_ bv1 2)))
				(= U3_state_RS1_vj (select U3_RS_vj (_ bv1 2)))
				(= U3_state_RS1_vk (select U3_RS_vk (_ bv1 2)))
				(= U3_state_RS1_qj (select U3_RS_qj (_ bv1 2)))
				(= U3_state_RS1_qk (select U3_RS_qk (_ bv1 2)))
				(= U3_state_RS1_imm (select U3_RS_imm (_ bv1 2)))
				(= U3_state_RS1_dis (select U3_RS_dis (_ bv1 2)))
				(= U3_state_RS1_busy (select U3_RS_busy (_ bv1 2)))
				
				(= U3_state_RS2_op_type (select U3_RS_op_type (_ bv2 2)))
				(= U3_state_RS2_op (select U3_RS_op (_ bv2 2)))
				(= U3_state_RS2_ROB_dst (select U3_RS_ROB_dst (_ bv2 2)))
				(= U3_state_RS2_vj (select U3_RS_vj (_ bv2 2)))
				(= U3_state_RS2_vk (select U3_RS_vk (_ bv2 2)))
				(= U3_state_RS2_qj (select U3_RS_qj (_ bv2 2)))
				(= U3_state_RS2_qk (select U3_RS_qk (_ bv2 2)))
				(= U3_state_RS2_imm (select U3_RS_imm (_ bv2 2)))
				(= U3_state_RS2_dis (select U3_RS_dis (_ bv2 2)))
				(= U3_state_RS2_busy (select U3_RS_busy (_ bv2 2)))
				
				(= U3_state_RS3_op_type (select U3_RS_op_type (_ bv3 2)))
				(= U3_state_RS3_op (select U3_RS_op (_ bv3 2)))
				(= U3_state_RS3_ROB_dst (select U3_RS_ROB_dst (_ bv3 2)))
				(= U3_state_RS3_vj (select U3_RS_vj (_ bv3 2)))
				(= U3_state_RS3_vk (select U3_RS_vk (_ bv3 2)))
				(= U3_state_RS3_qj (select U3_RS_qj (_ bv3 2)))
				(= U3_state_RS3_qk (select U3_RS_qk (_ bv3 2)))
				(= U3_state_RS3_imm (select U3_RS_imm (_ bv3 2)))
				(= U3_state_RS3_dis (select U3_RS_dis (_ bv3 2)))
				(= U3_state_RS3_busy (select U3_RS_busy (_ bv3 2)))
				
				(= U3_state_LSQ0_op_type (select U3_LSQ_op_type (_ bv0 2)))
				(= U3_state_LSQ0_op (select U3_LSQ_op (_ bv0 2)))
				(= U3_state_LSQ0_ROB_dst (select U3_LSQ_ROB_dst (_ bv0 2)))
				(= U3_state_LSQ0_vj (select U3_LSQ_vj (_ bv0 2)))
				(= U3_state_LSQ0_vk (select U3_LSQ_vk (_ bv0 2)))
				(= U3_state_LSQ0_qj (select U3_LSQ_qj (_ bv0 2)))
				(= U3_state_LSQ0_qk (select U3_LSQ_qk (_ bv0 2)))
				(= U3_state_LSQ0_imm (select U3_LSQ_imm (_ bv0 2)))
				(= U3_state_LSQ0_dis (select U3_LSQ_dis (_ bv0 2)))
				(= U3_state_LSQ0_busy (select U3_LSQ_busy (_ bv0 2)))
				
				(= U3_state_LSQ1_op_type (select U3_LSQ_op_type (_ bv1 2)))
				(= U3_state_LSQ1_op (select U3_LSQ_op (_ bv1 2)))
				(= U3_state_LSQ1_ROB_dst (select U3_LSQ_ROB_dst (_ bv1 2)))
				(= U3_state_LSQ1_vj (select U3_LSQ_vj (_ bv1 2)))
				(= U3_state_LSQ1_vk (select U3_LSQ_vk (_ bv1 2)))
				(= U3_state_LSQ1_qj (select U3_LSQ_qj (_ bv1 2)))
				(= U3_state_LSQ1_qk (select U3_LSQ_qk (_ bv1 2)))
				(= U3_state_LSQ1_imm (select U3_LSQ_imm (_ bv1 2)))
				(= U3_state_LSQ1_dis (select U3_LSQ_dis (_ bv1 2)))
				(= U3_state_LSQ1_busy (select U3_LSQ_busy (_ bv1 2)))
				
				(= U3_state_LSQ2_op_type (select U3_LSQ_op_type (_ bv2 2)))
				(= U3_state_LSQ2_op (select U3_LSQ_op (_ bv2 2)))
				(= U3_state_LSQ2_ROB_dst (select U3_LSQ_ROB_dst (_ bv2 2)))
				(= U3_state_LSQ2_vj (select U3_LSQ_vj (_ bv2 2)))
				(= U3_state_LSQ2_vk (select U3_LSQ_vk (_ bv2 2)))
				(= U3_state_LSQ2_qj (select U3_LSQ_qj (_ bv2 2)))
				(= U3_state_LSQ2_qk (select U3_LSQ_qk (_ bv2 2)))
				(= U3_state_LSQ2_imm (select U3_LSQ_imm (_ bv2 2)))
				(= U3_state_LSQ2_dis (select U3_LSQ_dis (_ bv2 2)))
				(= U3_state_LSQ2_busy (select U3_LSQ_busy (_ bv2 2)))
				
				(= U3_state_LSQ3_op_type (select U3_LSQ_op_type (_ bv3 2)))
				(= U3_state_LSQ3_op (select U3_LSQ_op (_ bv3 2)))
				(= U3_state_LSQ3_ROB_dst (select U3_LSQ_ROB_dst (_ bv3 2)))
				(= U3_state_LSQ3_vj (select U3_LSQ_vj (_ bv3 2)))
				(= U3_state_LSQ3_vk (select U3_LSQ_vk (_ bv3 2)))
				(= U3_state_LSQ3_qj (select U3_LSQ_qj (_ bv3 2)))
				(= U3_state_LSQ3_qk (select U3_LSQ_qk (_ bv3 2)))
				(= U3_state_LSQ3_imm (select U3_LSQ_imm (_ bv3 2)))
				(= U3_state_LSQ3_dis (select U3_LSQ_dis (_ bv3 2)))
				(= U3_state_LSQ3_busy (select U3_LSQ_busy (_ bv3 2)))
				
				(= U3_state_Evict0_Valid (select U3_Evict_Valid (_ bv0 3)))
				(= U3_state_Evict1_Valid (select U3_Evict_Valid (_ bv1 3)))
				(= U3_state_Evict2_Valid (select U3_Evict_Valid (_ bv2 3)))
				(= U3_state_Evict3_Valid (select U3_Evict_Valid (_ bv3 3)))
				(= U3_state_Evict4_Valid (select U3_Evict_Valid (_ bv4 3)))
				(= U3_state_Evict5_Valid (select U3_Evict_Valid (_ bv5 3)))
				(= U3_state_Evict6_Valid (select U3_Evict_Valid (_ bv6 3)))
				(= U3_state_Evict7_Valid (select U3_Evict_Valid (_ bv7 3)))
				
				(= U3_state_Evict0_Tag (select U3_Evict_Tag (_ bv0 3)))
				(= U3_state_Evict1_Tag (select U3_Evict_Tag (_ bv1 3)))
				(= U3_state_Evict2_Tag (select U3_Evict_Tag (_ bv2 3)))
				(= U3_state_Evict3_Tag (select U3_Evict_Tag (_ bv3 3)))
				(= U3_state_Evict4_Tag (select U3_Evict_Tag (_ bv4 3)))
				(= U3_state_Evict5_Tag (select U3_Evict_Tag (_ bv5 3)))
				(= U3_state_Evict6_Tag (select U3_Evict_Tag (_ bv6 3)))
				(= U3_state_Evict7_Tag (select U3_Evict_Tag (_ bv7 3)))
				
				(= U4_state_Cache0_Tag (select U4_Cache_Tag (_ bv0 2)))
				(= U4_state_Cache1_Tag (select U4_Cache_Tag (_ bv1 2)))
				(= U4_state_Cache2_Tag (select U4_Cache_Tag (_ bv2 2)))
				(= U4_state_Cache3_Tag (select U4_Cache_Tag (_ bv3 2)))
				
				(= U4_state_Cache0_Data (select U4_Cache_Data (_ bv0 2)))
				(= U4_state_Cache1_Data (select U4_Cache_Data (_ bv1 2)))
				(= U4_state_Cache2_Data (select U4_Cache_Data (_ bv2 2)))
				(= U4_state_Cache3_Data (select U4_Cache_Data (_ bv3 2)))
				
				(= U4_state_Cache0_Valid (select U4_Cache_Valid (_ bv0 2)))
				(= U4_state_Cache1_Valid (select U4_Cache_Valid (_ bv1 2)))
				(= U4_state_Cache2_Valid (select U4_Cache_Valid (_ bv2 2)))
				(= U4_state_Cache3_Valid (select U4_Cache_Valid (_ bv3 2)))
				
				(= U4_state_IP U4_IP)
				(= U4_state_CP U4_CP)
				(= U4_state_PC U4_PC)
				
				(= U4_state_ROB0_busy (select U4_ROB_busy (_ bv0 3)))
				(= U4_state_ROB0_op_type (select U4_ROB_op_type (_ bv0 3)))
				(= U4_state_ROB0_destination (select U4_ROB_destination (_ bv0 3)))
				(= U4_state_ROB0_result (select U4_ROB_result (_ bv0 3)))
				(= U4_state_ROB0_exception (select U4_ROB_exception (_ bv0 3)))
				(= U4_state_ROB0_done (select U4_ROB_done (_ bv0 3)))
				
				(= U4_state_ROB1_busy (select U4_ROB_busy (_ bv1 3)))
				(= U4_state_ROB1_op_type (select U4_ROB_op_type (_ bv1 3)))
				(= U4_state_ROB1_destination (select U4_ROB_destination (_ bv1 3)))
				(= U4_state_ROB1_result (select U4_ROB_result (_ bv1 3)))
				(= U4_state_ROB1_exception (select U4_ROB_exception (_ bv1 3)))
				(= U4_state_ROB1_done (select U4_ROB_done (_ bv1 3)))
				
				(= U4_state_ROB2_busy (select U4_ROB_busy (_ bv2 3)))
				(= U4_state_ROB2_op_type (select U4_ROB_op_type (_ bv2 3)))
				(= U4_state_ROB2_destination (select U4_ROB_destination (_ bv2 3)))
				(= U4_state_ROB2_result (select U4_ROB_result (_ bv2 3)))
				(= U4_state_ROB2_exception (select U4_ROB_exception (_ bv2 3)))
				(= U4_state_ROB2_done (select U4_ROB_done (_ bv2 3)))
				
				(= U4_state_ROB3_busy (select U4_ROB_busy (_ bv3 3)))
				(= U4_state_ROB3_op_type (select U4_ROB_op_type (_ bv3 3)))
				(= U4_state_ROB3_destination (select U4_ROB_destination (_ bv3 3)))
				(= U4_state_ROB3_result (select U4_ROB_result (_ bv3 3)))
				(= U4_state_ROB3_exception (select U4_ROB_exception (_ bv3 3)))
				(= U4_state_ROB3_done (select U4_ROB_done (_ bv3 3)))
				
				(= U4_state_ROB4_busy (select U4_ROB_busy (_ bv4 3)))
				(= U4_state_ROB4_op_type (select U4_ROB_op_type (_ bv4 3)))
				(= U4_state_ROB4_destination (select U4_ROB_destination (_ bv4 3)))
				(= U4_state_ROB4_result (select U4_ROB_result (_ bv4 3)))
				(= U4_state_ROB4_exception (select U4_ROB_exception (_ bv4 3)))
				(= U4_state_ROB4_done (select U4_ROB_done (_ bv4 3)))
				
				(= U4_state_ROB5_busy (select U4_ROB_busy (_ bv5 3)))
				(= U4_state_ROB5_op_type (select U4_ROB_op_type (_ bv5 3)))
				(= U4_state_ROB5_destination (select U4_ROB_destination (_ bv5 3)))
				(= U4_state_ROB5_result (select U4_ROB_result (_ bv5 3)))
				(= U4_state_ROB5_exception (select U4_ROB_exception (_ bv5 3)))
				(= U4_state_ROB5_done (select U4_ROB_done (_ bv5 3)))
				
				(= U4_state_ROB6_busy (select U4_ROB_busy (_ bv6 3)))
				(= U4_state_ROB6_op_type (select U4_ROB_op_type (_ bv6 3)))
				(= U4_state_ROB6_destination (select U4_ROB_destination (_ bv6 3)))
				(= U4_state_ROB6_result (select U4_ROB_result (_ bv6 3)))
				(= U4_state_ROB6_exception (select U4_ROB_exception (_ bv6 3)))
				(= U4_state_ROB6_done (select U4_ROB_done (_ bv6 3)))
				
				(= U4_state_ROB7_busy (select U4_ROB_busy (_ bv7 3)))
				(= U4_state_ROB7_op_type (select U4_ROB_op_type (_ bv7 3)))
				(= U4_state_ROB7_destination (select U4_ROB_destination (_ bv7 3)))
				(= U4_state_ROB7_result (select U4_ROB_result (_ bv7 3)))
				(= U4_state_ROB7_exception (select U4_ROB_exception (_ bv7 3)))
				(= U4_state_ROB7_done (select U4_ROB_done (_ bv7 3)))
				
				(= U4_state_RS0_op_type (select U4_RS_op_type (_ bv0 2)))
				(= U4_state_RS0_op (select U4_RS_op (_ bv0 2)))
				(= U4_state_RS0_ROB_dst (select U4_RS_ROB_dst (_ bv0 2)))
				(= U4_state_RS0_vj (select U4_RS_vj (_ bv0 2)))
				(= U4_state_RS0_vk (select U4_RS_vk (_ bv0 2)))
				(= U4_state_RS0_qj (select U4_RS_qj (_ bv0 2)))
				(= U4_state_RS0_qk (select U4_RS_qk (_ bv0 2)))
				(= U4_state_RS0_imm (select U4_RS_imm (_ bv0 2)))
				(= U4_state_RS0_dis (select U4_RS_dis (_ bv0 2)))
				(= U4_state_RS0_busy (select U4_RS_busy (_ bv0 2)))
				
				(= U4_state_RS1_op_type (select U4_RS_op_type (_ bv1 2)))
				(= U4_state_RS1_op (select U4_RS_op (_ bv1 2)))
				(= U4_state_RS1_ROB_dst (select U4_RS_ROB_dst (_ bv1 2)))
				(= U4_state_RS1_vj (select U4_RS_vj (_ bv1 2)))
				(= U4_state_RS1_vk (select U4_RS_vk (_ bv1 2)))
				(= U4_state_RS1_qj (select U4_RS_qj (_ bv1 2)))
				(= U4_state_RS1_qk (select U4_RS_qk (_ bv1 2)))
				(= U4_state_RS1_imm (select U4_RS_imm (_ bv1 2)))
				(= U4_state_RS1_dis (select U4_RS_dis (_ bv1 2)))
				(= U4_state_RS1_busy (select U4_RS_busy (_ bv1 2)))
				
				(= U4_state_RS2_op_type (select U4_RS_op_type (_ bv2 2)))
				(= U4_state_RS2_op (select U4_RS_op (_ bv2 2)))
				(= U4_state_RS2_ROB_dst (select U4_RS_ROB_dst (_ bv2 2)))
				(= U4_state_RS2_vj (select U4_RS_vj (_ bv2 2)))
				(= U4_state_RS2_vk (select U4_RS_vk (_ bv2 2)))
				(= U4_state_RS2_qj (select U4_RS_qj (_ bv2 2)))
				(= U4_state_RS2_qk (select U4_RS_qk (_ bv2 2)))
				(= U4_state_RS2_imm (select U4_RS_imm (_ bv2 2)))
				(= U4_state_RS2_dis (select U4_RS_dis (_ bv2 2)))
				(= U4_state_RS2_busy (select U4_RS_busy (_ bv2 2)))
				
				(= U4_state_RS3_op_type (select U4_RS_op_type (_ bv3 2)))
				(= U4_state_RS3_op (select U4_RS_op (_ bv3 2)))
				(= U4_state_RS3_ROB_dst (select U4_RS_ROB_dst (_ bv3 2)))
				(= U4_state_RS3_vj (select U4_RS_vj (_ bv3 2)))
				(= U4_state_RS3_vk (select U4_RS_vk (_ bv3 2)))
				(= U4_state_RS3_qj (select U4_RS_qj (_ bv3 2)))
				(= U4_state_RS3_qk (select U4_RS_qk (_ bv3 2)))
				(= U4_state_RS3_imm (select U4_RS_imm (_ bv3 2)))
				(= U4_state_RS3_dis (select U4_RS_dis (_ bv3 2)))
				(= U4_state_RS3_busy (select U4_RS_busy (_ bv3 2)))
				
				(= U4_state_LSQ0_op_type (select U4_LSQ_op_type (_ bv0 2)))
				(= U4_state_LSQ0_op (select U4_LSQ_op (_ bv0 2)))
				(= U4_state_LSQ0_ROB_dst (select U4_LSQ_ROB_dst (_ bv0 2)))
				(= U4_state_LSQ0_vj (select U4_LSQ_vj (_ bv0 2)))
				(= U4_state_LSQ0_vk (select U4_LSQ_vk (_ bv0 2)))
				(= U4_state_LSQ0_qj (select U4_LSQ_qj (_ bv0 2)))
				(= U4_state_LSQ0_qk (select U4_LSQ_qk (_ bv0 2)))
				(= U4_state_LSQ0_imm (select U4_LSQ_imm (_ bv0 2)))
				(= U4_state_LSQ0_dis (select U4_LSQ_dis (_ bv0 2)))
				(= U4_state_LSQ0_busy (select U4_LSQ_busy (_ bv0 2)))
				
				(= U4_state_LSQ1_op_type (select U4_LSQ_op_type (_ bv1 2)))
				(= U4_state_LSQ1_op (select U4_LSQ_op (_ bv1 2)))
				(= U4_state_LSQ1_ROB_dst (select U4_LSQ_ROB_dst (_ bv1 2)))
				(= U4_state_LSQ1_vj (select U4_LSQ_vj (_ bv1 2)))
				(= U4_state_LSQ1_vk (select U4_LSQ_vk (_ bv1 2)))
				(= U4_state_LSQ1_qj (select U4_LSQ_qj (_ bv1 2)))
				(= U4_state_LSQ1_qk (select U4_LSQ_qk (_ bv1 2)))
				(= U4_state_LSQ1_imm (select U4_LSQ_imm (_ bv1 2)))
				(= U4_state_LSQ1_dis (select U4_LSQ_dis (_ bv1 2)))
				(= U4_state_LSQ1_busy (select U4_LSQ_busy (_ bv1 2)))
				
				(= U4_state_LSQ2_op_type (select U4_LSQ_op_type (_ bv2 2)))
				(= U4_state_LSQ2_op (select U4_LSQ_op (_ bv2 2)))
				(= U4_state_LSQ2_ROB_dst (select U4_LSQ_ROB_dst (_ bv2 2)))
				(= U4_state_LSQ2_vj (select U4_LSQ_vj (_ bv2 2)))
				(= U4_state_LSQ2_vk (select U4_LSQ_vk (_ bv2 2)))
				(= U4_state_LSQ2_qj (select U4_LSQ_qj (_ bv2 2)))
				(= U4_state_LSQ2_qk (select U4_LSQ_qk (_ bv2 2)))
				(= U4_state_LSQ2_imm (select U4_LSQ_imm (_ bv2 2)))
				(= U4_state_LSQ2_dis (select U4_LSQ_dis (_ bv2 2)))
				(= U4_state_LSQ2_busy (select U4_LSQ_busy (_ bv2 2)))
				
				(= U4_state_LSQ3_op_type (select U4_LSQ_op_type (_ bv3 2)))
				(= U4_state_LSQ3_op (select U4_LSQ_op (_ bv3 2)))
				(= U4_state_LSQ3_ROB_dst (select U4_LSQ_ROB_dst (_ bv3 2)))
				(= U4_state_LSQ3_vj (select U4_LSQ_vj (_ bv3 2)))
				(= U4_state_LSQ3_vk (select U4_LSQ_vk (_ bv3 2)))
				(= U4_state_LSQ3_qj (select U4_LSQ_qj (_ bv3 2)))
				(= U4_state_LSQ3_qk (select U4_LSQ_qk (_ bv3 2)))
				(= U4_state_LSQ3_imm (select U4_LSQ_imm (_ bv3 2)))
				(= U4_state_LSQ3_dis (select U4_LSQ_dis (_ bv3 2)))
				(= U4_state_LSQ3_busy (select U4_LSQ_busy (_ bv3 2)))
				
				(= U4_state_Evict0_Valid (select U4_Evict_Valid (_ bv0 3)))
				(= U4_state_Evict1_Valid (select U4_Evict_Valid (_ bv1 3)))
				(= U4_state_Evict2_Valid (select U4_Evict_Valid (_ bv2 3)))
				(= U4_state_Evict3_Valid (select U4_Evict_Valid (_ bv3 3)))
				(= U4_state_Evict4_Valid (select U4_Evict_Valid (_ bv4 3)))
				(= U4_state_Evict5_Valid (select U4_Evict_Valid (_ bv5 3)))
				(= U4_state_Evict6_Valid (select U4_Evict_Valid (_ bv6 3)))
				(= U4_state_Evict7_Valid (select U4_Evict_Valid (_ bv7 3)))
				
				(= U4_state_Evict0_Tag (select U4_Evict_Tag (_ bv0 3)))
				(= U4_state_Evict1_Tag (select U4_Evict_Tag (_ bv1 3)))
				(= U4_state_Evict2_Tag (select U4_Evict_Tag (_ bv2 3)))
				(= U4_state_Evict3_Tag (select U4_Evict_Tag (_ bv3 3)))
				(= U4_state_Evict4_Tag (select U4_Evict_Tag (_ bv4 3)))
				(= U4_state_Evict5_Tag (select U4_Evict_Tag (_ bv5 3)))
				(= U4_state_Evict6_Tag (select U4_Evict_Tag (_ bv6 3)))
				(= U4_state_Evict7_Tag (select U4_Evict_Tag (_ bv7 3)))
				
				
				(= W1_state_Cache0_Tag (select W1_Cache_Tag (_ bv0 2)))
				(= W1_state_Cache1_Tag (select W1_Cache_Tag (_ bv1 2)))
				(= W1_state_Cache2_Tag (select W1_Cache_Tag (_ bv2 2)))
				(= W1_state_Cache3_Tag (select W1_Cache_Tag (_ bv3 2)))
				
				(= W1_state_Cache0_Data (select W1_Cache_Data (_ bv0 2)))
				(= W1_state_Cache1_Data (select W1_Cache_Data (_ bv1 2)))
				(= W1_state_Cache2_Data (select W1_Cache_Data (_ bv2 2)))
				(= W1_state_Cache3_Data (select W1_Cache_Data (_ bv3 2)))
				
				(= W1_state_Cache0_Valid (select W1_Cache_Valid (_ bv0 2)))
				(= W1_state_Cache1_Valid (select W1_Cache_Valid (_ bv1 2)))
				(= W1_state_Cache2_Valid (select W1_Cache_Valid (_ bv2 2)))
				(= W1_state_Cache3_Valid (select W1_Cache_Valid (_ bv3 2)))
				
				(= W1_state_IP W1_IP)
				(= W1_state_CP W1_CP)
				(= W1_state_PC W1_PC)
				
				(= W1_state_ROB0_busy (select W1_ROB_busy (_ bv0 3)))
				(= W1_state_ROB0_op_type (select W1_ROB_op_type (_ bv0 3)))
				(= W1_state_ROB0_destination (select W1_ROB_destination (_ bv0 3)))
				(= W1_state_ROB0_result (select W1_ROB_result (_ bv0 3)))
				(= W1_state_ROB0_exception (select W1_ROB_exception (_ bv0 3)))
				(= W1_state_ROB0_done (select W1_ROB_done (_ bv0 3)))
				
				(= W1_state_ROB1_busy (select W1_ROB_busy (_ bv1 3)))
				(= W1_state_ROB1_op_type (select W1_ROB_op_type (_ bv1 3)))
				(= W1_state_ROB1_destination (select W1_ROB_destination (_ bv1 3)))
				(= W1_state_ROB1_result (select W1_ROB_result (_ bv1 3)))
				(= W1_state_ROB1_exception (select W1_ROB_exception (_ bv1 3)))
				(= W1_state_ROB1_done (select W1_ROB_done (_ bv1 3)))
				
				(= W1_state_ROB2_busy (select W1_ROB_busy (_ bv2 3)))
				(= W1_state_ROB2_op_type (select W1_ROB_op_type (_ bv2 3)))
				(= W1_state_ROB2_destination (select W1_ROB_destination (_ bv2 3)))
				(= W1_state_ROB2_result (select W1_ROB_result (_ bv2 3)))
				(= W1_state_ROB2_exception (select W1_ROB_exception (_ bv2 3)))
				(= W1_state_ROB2_done (select W1_ROB_done (_ bv2 3)))
				
				(= W1_state_ROB3_busy (select W1_ROB_busy (_ bv3 3)))
				(= W1_state_ROB3_op_type (select W1_ROB_op_type (_ bv3 3)))
				(= W1_state_ROB3_destination (select W1_ROB_destination (_ bv3 3)))
				(= W1_state_ROB3_result (select W1_ROB_result (_ bv3 3)))
				(= W1_state_ROB3_exception (select W1_ROB_exception (_ bv3 3)))
				(= W1_state_ROB3_done (select W1_ROB_done (_ bv3 3)))
				
				(= W1_state_ROB4_busy (select W1_ROB_busy (_ bv4 3)))
				(= W1_state_ROB4_op_type (select W1_ROB_op_type (_ bv4 3)))
				(= W1_state_ROB4_destination (select W1_ROB_destination (_ bv4 3)))
				(= W1_state_ROB4_result (select W1_ROB_result (_ bv4 3)))
				(= W1_state_ROB4_exception (select W1_ROB_exception (_ bv4 3)))
				(= W1_state_ROB4_done (select W1_ROB_done (_ bv4 3)))
				
				(= W1_state_ROB5_busy (select W1_ROB_busy (_ bv5 3)))
				(= W1_state_ROB5_op_type (select W1_ROB_op_type (_ bv5 3)))
				(= W1_state_ROB5_destination (select W1_ROB_destination (_ bv5 3)))
				(= W1_state_ROB5_result (select W1_ROB_result (_ bv5 3)))
				(= W1_state_ROB5_exception (select W1_ROB_exception (_ bv5 3)))
				(= W1_state_ROB5_done (select W1_ROB_done (_ bv5 3)))
				
				(= W1_state_ROB6_busy (select W1_ROB_busy (_ bv6 3)))
				(= W1_state_ROB6_op_type (select W1_ROB_op_type (_ bv6 3)))
				(= W1_state_ROB6_destination (select W1_ROB_destination (_ bv6 3)))
				(= W1_state_ROB6_result (select W1_ROB_result (_ bv6 3)))
				(= W1_state_ROB6_exception (select W1_ROB_exception (_ bv6 3)))
				(= W1_state_ROB6_done (select W1_ROB_done (_ bv6 3)))
				
				(= W1_state_ROB7_busy (select W1_ROB_busy (_ bv7 3)))
				(= W1_state_ROB7_op_type (select W1_ROB_op_type (_ bv7 3)))
				(= W1_state_ROB7_destination (select W1_ROB_destination (_ bv7 3)))
				(= W1_state_ROB7_result (select W1_ROB_result (_ bv7 3)))
				(= W1_state_ROB7_exception (select W1_ROB_exception (_ bv7 3)))
				(= W1_state_ROB7_done (select W1_ROB_done (_ bv7 3)))
				
				(= W1_state_RS0_op_type (select W1_RS_op_type (_ bv0 2)))
				(= W1_state_RS0_op (select W1_RS_op (_ bv0 2)))
				(= W1_state_RS0_ROB_dst (select W1_RS_ROB_dst (_ bv0 2)))
				(= W1_state_RS0_vj (select W1_RS_vj (_ bv0 2)))
				(= W1_state_RS0_vk (select W1_RS_vk (_ bv0 2)))
				(= W1_state_RS0_qj (select W1_RS_qj (_ bv0 2)))
				(= W1_state_RS0_qk (select W1_RS_qk (_ bv0 2)))
				(= W1_state_RS0_imm (select W1_RS_imm (_ bv0 2)))
				(= W1_state_RS0_dis (select W1_RS_dis (_ bv0 2)))
				(= W1_state_RS0_busy (select W1_RS_busy (_ bv0 2)))
				
				(= W1_state_RS1_op_type (select W1_RS_op_type (_ bv1 2)))
				(= W1_state_RS1_op (select W1_RS_op (_ bv1 2)))
				(= W1_state_RS1_ROB_dst (select W1_RS_ROB_dst (_ bv1 2)))
				(= W1_state_RS1_vj (select W1_RS_vj (_ bv1 2)))
				(= W1_state_RS1_vk (select W1_RS_vk (_ bv1 2)))
				(= W1_state_RS1_qj (select W1_RS_qj (_ bv1 2)))
				(= W1_state_RS1_qk (select W1_RS_qk (_ bv1 2)))
				(= W1_state_RS1_imm (select W1_RS_imm (_ bv1 2)))
				(= W1_state_RS1_dis (select W1_RS_dis (_ bv1 2)))
				(= W1_state_RS1_busy (select W1_RS_busy (_ bv1 2)))
				
				(= W1_state_RS2_op_type (select W1_RS_op_type (_ bv2 2)))
				(= W1_state_RS2_op (select W1_RS_op (_ bv2 2)))
				(= W1_state_RS2_ROB_dst (select W1_RS_ROB_dst (_ bv2 2)))
				(= W1_state_RS2_vj (select W1_RS_vj (_ bv2 2)))
				(= W1_state_RS2_vk (select W1_RS_vk (_ bv2 2)))
				(= W1_state_RS2_qj (select W1_RS_qj (_ bv2 2)))
				(= W1_state_RS2_qk (select W1_RS_qk (_ bv2 2)))
				(= W1_state_RS2_imm (select W1_RS_imm (_ bv2 2)))
				(= W1_state_RS2_dis (select W1_RS_dis (_ bv2 2)))
				(= W1_state_RS2_busy (select W1_RS_busy (_ bv2 2)))
				
				(= W1_state_RS3_op_type (select W1_RS_op_type (_ bv3 2)))
				(= W1_state_RS3_op (select W1_RS_op (_ bv3 2)))
				(= W1_state_RS3_ROB_dst (select W1_RS_ROB_dst (_ bv3 2)))
				(= W1_state_RS3_vj (select W1_RS_vj (_ bv3 2)))
				(= W1_state_RS3_vk (select W1_RS_vk (_ bv3 2)))
				(= W1_state_RS3_qj (select W1_RS_qj (_ bv3 2)))
				(= W1_state_RS3_qk (select W1_RS_qk (_ bv3 2)))
				(= W1_state_RS3_imm (select W1_RS_imm (_ bv3 2)))
				(= W1_state_RS3_dis (select W1_RS_dis (_ bv3 2)))
				(= W1_state_RS3_busy (select W1_RS_busy (_ bv3 2)))
				
				(= W1_state_LSQ0_op_type (select W1_LSQ_op_type (_ bv0 2)))
				(= W1_state_LSQ0_op (select W1_LSQ_op (_ bv0 2)))
				(= W1_state_LSQ0_ROB_dst (select W1_LSQ_ROB_dst (_ bv0 2)))
				(= W1_state_LSQ0_vj (select W1_LSQ_vj (_ bv0 2)))
				(= W1_state_LSQ0_vk (select W1_LSQ_vk (_ bv0 2)))
				(= W1_state_LSQ0_qj (select W1_LSQ_qj (_ bv0 2)))
				(= W1_state_LSQ0_qk (select W1_LSQ_qk (_ bv0 2)))
				(= W1_state_LSQ0_imm (select W1_LSQ_imm (_ bv0 2)))
				(= W1_state_LSQ0_dis (select W1_LSQ_dis (_ bv0 2)))
				(= W1_state_LSQ0_busy (select W1_LSQ_busy (_ bv0 2)))
				
				(= W1_state_LSQ1_op_type (select W1_LSQ_op_type (_ bv1 2)))
				(= W1_state_LSQ1_op (select W1_LSQ_op (_ bv1 2)))
				(= W1_state_LSQ1_ROB_dst (select W1_LSQ_ROB_dst (_ bv1 2)))
				(= W1_state_LSQ1_vj (select W1_LSQ_vj (_ bv1 2)))
				(= W1_state_LSQ1_vk (select W1_LSQ_vk (_ bv1 2)))
				(= W1_state_LSQ1_qj (select W1_LSQ_qj (_ bv1 2)))
				(= W1_state_LSQ1_qk (select W1_LSQ_qk (_ bv1 2)))
				(= W1_state_LSQ1_imm (select W1_LSQ_imm (_ bv1 2)))
				(= W1_state_LSQ1_dis (select W1_LSQ_dis (_ bv1 2)))
				(= W1_state_LSQ1_busy (select W1_LSQ_busy (_ bv1 2)))
				
				(= W1_state_LSQ2_op_type (select W1_LSQ_op_type (_ bv2 2)))
				(= W1_state_LSQ2_op (select W1_LSQ_op (_ bv2 2)))
				(= W1_state_LSQ2_ROB_dst (select W1_LSQ_ROB_dst (_ bv2 2)))
				(= W1_state_LSQ2_vj (select W1_LSQ_vj (_ bv2 2)))
				(= W1_state_LSQ2_vk (select W1_LSQ_vk (_ bv2 2)))
				(= W1_state_LSQ2_qj (select W1_LSQ_qj (_ bv2 2)))
				(= W1_state_LSQ2_qk (select W1_LSQ_qk (_ bv2 2)))
				(= W1_state_LSQ2_imm (select W1_LSQ_imm (_ bv2 2)))
				(= W1_state_LSQ2_dis (select W1_LSQ_dis (_ bv2 2)))
				(= W1_state_LSQ2_busy (select W1_LSQ_busy (_ bv2 2)))
				
				(= W1_state_LSQ3_op_type (select W1_LSQ_op_type (_ bv3 2)))
				(= W1_state_LSQ3_op (select W1_LSQ_op (_ bv3 2)))
				(= W1_state_LSQ3_ROB_dst (select W1_LSQ_ROB_dst (_ bv3 2)))
				(= W1_state_LSQ3_vj (select W1_LSQ_vj (_ bv3 2)))
				(= W1_state_LSQ3_vk (select W1_LSQ_vk (_ bv3 2)))
				(= W1_state_LSQ3_qj (select W1_LSQ_qj (_ bv3 2)))
				(= W1_state_LSQ3_qk (select W1_LSQ_qk (_ bv3 2)))
				(= W1_state_LSQ3_imm (select W1_LSQ_imm (_ bv3 2)))
				(= W1_state_LSQ3_dis (select W1_LSQ_dis (_ bv3 2)))
				(= W1_state_LSQ3_busy (select W1_LSQ_busy (_ bv3 2)))
				
				(= W1_state_Evict0_Valid (select W1_Evict_Valid (_ bv0 3)))
				(= W1_state_Evict1_Valid (select W1_Evict_Valid (_ bv1 3)))
				(= W1_state_Evict2_Valid (select W1_Evict_Valid (_ bv2 3)))
				(= W1_state_Evict3_Valid (select W1_Evict_Valid (_ bv3 3)))
				(= W1_state_Evict4_Valid (select W1_Evict_Valid (_ bv4 3)))
				(= W1_state_Evict5_Valid (select W1_Evict_Valid (_ bv5 3)))
				(= W1_state_Evict6_Valid (select W1_Evict_Valid (_ bv6 3)))
				(= W1_state_Evict7_Valid (select W1_Evict_Valid (_ bv7 3)))
				
				(= W1_state_Evict0_Tag (select W1_Evict_Tag (_ bv0 3)))
				(= W1_state_Evict1_Tag (select W1_Evict_Tag (_ bv1 3)))
				(= W1_state_Evict2_Tag (select W1_Evict_Tag (_ bv2 3)))
				(= W1_state_Evict3_Tag (select W1_Evict_Tag (_ bv3 3)))
				(= W1_state_Evict4_Tag (select W1_Evict_Tag (_ bv4 3)))
				(= W1_state_Evict5_Tag (select W1_Evict_Tag (_ bv5 3)))
				(= W1_state_Evict6_Tag (select W1_Evict_Tag (_ bv6 3)))
				(= W1_state_Evict7_Tag (select W1_Evict_Tag (_ bv7 3)))
				
				(= W2_state_Cache0_Tag (select W2_Cache_Tag (_ bv0 2)))
				(= W2_state_Cache1_Tag (select W2_Cache_Tag (_ bv1 2)))
				(= W2_state_Cache2_Tag (select W2_Cache_Tag (_ bv2 2)))
				(= W2_state_Cache3_Tag (select W2_Cache_Tag (_ bv3 2)))
				
				(= W2_state_Cache0_Data (select W2_Cache_Data (_ bv0 2)))
				(= W2_state_Cache1_Data (select W2_Cache_Data (_ bv1 2)))
				(= W2_state_Cache2_Data (select W2_Cache_Data (_ bv2 2)))
				(= W2_state_Cache3_Data (select W2_Cache_Data (_ bv3 2)))
				
				(= W2_state_Cache0_Valid (select W2_Cache_Valid (_ bv0 2)))
				(= W2_state_Cache1_Valid (select W2_Cache_Valid (_ bv1 2)))
				(= W2_state_Cache2_Valid (select W2_Cache_Valid (_ bv2 2)))
				(= W2_state_Cache3_Valid (select W2_Cache_Valid (_ bv3 2)))
				
				(= W2_state_IP W2_IP)
				(= W2_state_CP W2_CP)
				(= W2_state_PC W2_PC)
				
				(= W2_state_ROB0_busy (select W2_ROB_busy (_ bv0 3)))
				(= W2_state_ROB0_op_type (select W2_ROB_op_type (_ bv0 3)))
				(= W2_state_ROB0_destination (select W2_ROB_destination (_ bv0 3)))
				(= W2_state_ROB0_result (select W2_ROB_result (_ bv0 3)))
				(= W2_state_ROB0_exception (select W2_ROB_exception (_ bv0 3)))
				(= W2_state_ROB0_done (select W2_ROB_done (_ bv0 3)))
				
				(= W2_state_ROB1_busy (select W2_ROB_busy (_ bv1 3)))
				(= W2_state_ROB1_op_type (select W2_ROB_op_type (_ bv1 3)))
				(= W2_state_ROB1_destination (select W2_ROB_destination (_ bv1 3)))
				(= W2_state_ROB1_result (select W2_ROB_result (_ bv1 3)))
				(= W2_state_ROB1_exception (select W2_ROB_exception (_ bv1 3)))
				(= W2_state_ROB1_done (select W2_ROB_done (_ bv1 3)))
				
				(= W2_state_ROB2_busy (select W2_ROB_busy (_ bv2 3)))
				(= W2_state_ROB2_op_type (select W2_ROB_op_type (_ bv2 3)))
				(= W2_state_ROB2_destination (select W2_ROB_destination (_ bv2 3)))
				(= W2_state_ROB2_result (select W2_ROB_result (_ bv2 3)))
				(= W2_state_ROB2_exception (select W2_ROB_exception (_ bv2 3)))
				(= W2_state_ROB2_done (select W2_ROB_done (_ bv2 3)))
				
				(= W2_state_ROB3_busy (select W2_ROB_busy (_ bv3 3)))
				(= W2_state_ROB3_op_type (select W2_ROB_op_type (_ bv3 3)))
				(= W2_state_ROB3_destination (select W2_ROB_destination (_ bv3 3)))
				(= W2_state_ROB3_result (select W2_ROB_result (_ bv3 3)))
				(= W2_state_ROB3_exception (select W2_ROB_exception (_ bv3 3)))
				(= W2_state_ROB3_done (select W2_ROB_done (_ bv3 3)))
				
				(= W2_state_ROB4_busy (select W2_ROB_busy (_ bv4 3)))
				(= W2_state_ROB4_op_type (select W2_ROB_op_type (_ bv4 3)))
				(= W2_state_ROB4_destination (select W2_ROB_destination (_ bv4 3)))
				(= W2_state_ROB4_result (select W2_ROB_result (_ bv4 3)))
				(= W2_state_ROB4_exception (select W2_ROB_exception (_ bv4 3)))
				(= W2_state_ROB4_done (select W2_ROB_done (_ bv4 3)))
				
				(= W2_state_ROB5_busy (select W2_ROB_busy (_ bv5 3)))
				(= W2_state_ROB5_op_type (select W2_ROB_op_type (_ bv5 3)))
				(= W2_state_ROB5_destination (select W2_ROB_destination (_ bv5 3)))
				(= W2_state_ROB5_result (select W2_ROB_result (_ bv5 3)))
				(= W2_state_ROB5_exception (select W2_ROB_exception (_ bv5 3)))
				(= W2_state_ROB5_done (select W2_ROB_done (_ bv5 3)))
				
				(= W2_state_ROB6_busy (select W2_ROB_busy (_ bv6 3)))
				(= W2_state_ROB6_op_type (select W2_ROB_op_type (_ bv6 3)))
				(= W2_state_ROB6_destination (select W2_ROB_destination (_ bv6 3)))
				(= W2_state_ROB6_result (select W2_ROB_result (_ bv6 3)))
				(= W2_state_ROB6_exception (select W2_ROB_exception (_ bv6 3)))
				(= W2_state_ROB6_done (select W2_ROB_done (_ bv6 3)))
				
				(= W2_state_ROB7_busy (select W2_ROB_busy (_ bv7 3)))
				(= W2_state_ROB7_op_type (select W2_ROB_op_type (_ bv7 3)))
				(= W2_state_ROB7_destination (select W2_ROB_destination (_ bv7 3)))
				(= W2_state_ROB7_result (select W2_ROB_result (_ bv7 3)))
				(= W2_state_ROB7_exception (select W2_ROB_exception (_ bv7 3)))
				(= W2_state_ROB7_done (select W2_ROB_done (_ bv7 3)))
				
				(= W2_state_RS0_op_type (select W2_RS_op_type (_ bv0 2)))
				(= W2_state_RS0_op (select W2_RS_op (_ bv0 2)))
				(= W2_state_RS0_ROB_dst (select W2_RS_ROB_dst (_ bv0 2)))
				(= W2_state_RS0_vj (select W2_RS_vj (_ bv0 2)))
				(= W2_state_RS0_vk (select W2_RS_vk (_ bv0 2)))
				(= W2_state_RS0_qj (select W2_RS_qj (_ bv0 2)))
				(= W2_state_RS0_qk (select W2_RS_qk (_ bv0 2)))
				(= W2_state_RS0_imm (select W2_RS_imm (_ bv0 2)))
				(= W2_state_RS0_dis (select W2_RS_dis (_ bv0 2)))
				(= W2_state_RS0_busy (select W2_RS_busy (_ bv0 2)))
				
				(= W2_state_RS1_op_type (select W2_RS_op_type (_ bv1 2)))
				(= W2_state_RS1_op (select W2_RS_op (_ bv1 2)))
				(= W2_state_RS1_ROB_dst (select W2_RS_ROB_dst (_ bv1 2)))
				(= W2_state_RS1_vj (select W2_RS_vj (_ bv1 2)))
				(= W2_state_RS1_vk (select W2_RS_vk (_ bv1 2)))
				(= W2_state_RS1_qj (select W2_RS_qj (_ bv1 2)))
				(= W2_state_RS1_qk (select W2_RS_qk (_ bv1 2)))
				(= W2_state_RS1_imm (select W2_RS_imm (_ bv1 2)))
				(= W2_state_RS1_dis (select W2_RS_dis (_ bv1 2)))
				(= W2_state_RS1_busy (select W2_RS_busy (_ bv1 2)))
				
				(= W2_state_RS2_op_type (select W2_RS_op_type (_ bv2 2)))
				(= W2_state_RS2_op (select W2_RS_op (_ bv2 2)))
				(= W2_state_RS2_ROB_dst (select W2_RS_ROB_dst (_ bv2 2)))
				(= W2_state_RS2_vj (select W2_RS_vj (_ bv2 2)))
				(= W2_state_RS2_vk (select W2_RS_vk (_ bv2 2)))
				(= W2_state_RS2_qj (select W2_RS_qj (_ bv2 2)))
				(= W2_state_RS2_qk (select W2_RS_qk (_ bv2 2)))
				(= W2_state_RS2_imm (select W2_RS_imm (_ bv2 2)))
				(= W2_state_RS2_dis (select W2_RS_dis (_ bv2 2)))
				(= W2_state_RS2_busy (select W2_RS_busy (_ bv2 2)))
				
				(= W2_state_RS3_op_type (select W2_RS_op_type (_ bv3 2)))
				(= W2_state_RS3_op (select W2_RS_op (_ bv3 2)))
				(= W2_state_RS3_ROB_dst (select W2_RS_ROB_dst (_ bv3 2)))
				(= W2_state_RS3_vj (select W2_RS_vj (_ bv3 2)))
				(= W2_state_RS3_vk (select W2_RS_vk (_ bv3 2)))
				(= W2_state_RS3_qj (select W2_RS_qj (_ bv3 2)))
				(= W2_state_RS3_qk (select W2_RS_qk (_ bv3 2)))
				(= W2_state_RS3_imm (select W2_RS_imm (_ bv3 2)))
				(= W2_state_RS3_dis (select W2_RS_dis (_ bv3 2)))
				(= W2_state_RS3_busy (select W2_RS_busy (_ bv3 2)))
				
				(= W2_state_LSQ0_op_type (select W2_LSQ_op_type (_ bv0 2)))
				(= W2_state_LSQ0_op (select W2_LSQ_op (_ bv0 2)))
				(= W2_state_LSQ0_ROB_dst (select W2_LSQ_ROB_dst (_ bv0 2)))
				(= W2_state_LSQ0_vj (select W2_LSQ_vj (_ bv0 2)))
				(= W2_state_LSQ0_vk (select W2_LSQ_vk (_ bv0 2)))
				(= W2_state_LSQ0_qj (select W2_LSQ_qj (_ bv0 2)))
				(= W2_state_LSQ0_qk (select W2_LSQ_qk (_ bv0 2)))
				(= W2_state_LSQ0_imm (select W2_LSQ_imm (_ bv0 2)))
				(= W2_state_LSQ0_dis (select W2_LSQ_dis (_ bv0 2)))
				(= W2_state_LSQ0_busy (select W2_LSQ_busy (_ bv0 2)))
				
				(= W2_state_LSQ1_op_type (select W2_LSQ_op_type (_ bv1 2)))
				(= W2_state_LSQ1_op (select W2_LSQ_op (_ bv1 2)))
				(= W2_state_LSQ1_ROB_dst (select W2_LSQ_ROB_dst (_ bv1 2)))
				(= W2_state_LSQ1_vj (select W2_LSQ_vj (_ bv1 2)))
				(= W2_state_LSQ1_vk (select W2_LSQ_vk (_ bv1 2)))
				(= W2_state_LSQ1_qj (select W2_LSQ_qj (_ bv1 2)))
				(= W2_state_LSQ1_qk (select W2_LSQ_qk (_ bv1 2)))
				(= W2_state_LSQ1_imm (select W2_LSQ_imm (_ bv1 2)))
				(= W2_state_LSQ1_dis (select W2_LSQ_dis (_ bv1 2)))
				(= W2_state_LSQ1_busy (select W2_LSQ_busy (_ bv1 2)))
				
				(= W2_state_LSQ2_op_type (select W2_LSQ_op_type (_ bv2 2)))
				(= W2_state_LSQ2_op (select W2_LSQ_op (_ bv2 2)))
				(= W2_state_LSQ2_ROB_dst (select W2_LSQ_ROB_dst (_ bv2 2)))
				(= W2_state_LSQ2_vj (select W2_LSQ_vj (_ bv2 2)))
				(= W2_state_LSQ2_vk (select W2_LSQ_vk (_ bv2 2)))
				(= W2_state_LSQ2_qj (select W2_LSQ_qj (_ bv2 2)))
				(= W2_state_LSQ2_qk (select W2_LSQ_qk (_ bv2 2)))
				(= W2_state_LSQ2_imm (select W2_LSQ_imm (_ bv2 2)))
				(= W2_state_LSQ2_dis (select W2_LSQ_dis (_ bv2 2)))
				(= W2_state_LSQ2_busy (select W2_LSQ_busy (_ bv2 2)))
				
				(= W2_state_LSQ3_op_type (select W2_LSQ_op_type (_ bv3 2)))
				(= W2_state_LSQ3_op (select W2_LSQ_op (_ bv3 2)))
				(= W2_state_LSQ3_ROB_dst (select W2_LSQ_ROB_dst (_ bv3 2)))
				(= W2_state_LSQ3_vj (select W2_LSQ_vj (_ bv3 2)))
				(= W2_state_LSQ3_vk (select W2_LSQ_vk (_ bv3 2)))
				(= W2_state_LSQ3_qj (select W2_LSQ_qj (_ bv3 2)))
				(= W2_state_LSQ3_qk (select W2_LSQ_qk (_ bv3 2)))
				(= W2_state_LSQ3_imm (select W2_LSQ_imm (_ bv3 2)))
				(= W2_state_LSQ3_dis (select W2_LSQ_dis (_ bv3 2)))
				(= W2_state_LSQ3_busy (select W2_LSQ_busy (_ bv3 2)))
				
				(= W2_state_Evict0_Valid (select W2_Evict_Valid (_ bv0 3)))
				(= W2_state_Evict1_Valid (select W2_Evict_Valid (_ bv1 3)))
				(= W2_state_Evict2_Valid (select W2_Evict_Valid (_ bv2 3)))
				(= W2_state_Evict3_Valid (select W2_Evict_Valid (_ bv3 3)))
				(= W2_state_Evict4_Valid (select W2_Evict_Valid (_ bv4 3)))
				(= W2_state_Evict5_Valid (select W2_Evict_Valid (_ bv5 3)))
				(= W2_state_Evict6_Valid (select W2_Evict_Valid (_ bv6 3)))
				(= W2_state_Evict7_Valid (select W2_Evict_Valid (_ bv7 3)))
				
				(= W2_state_Evict0_Tag (select W2_Evict_Tag (_ bv0 3)))
				(= W2_state_Evict1_Tag (select W2_Evict_Tag (_ bv1 3)))
				(= W2_state_Evict2_Tag (select W2_Evict_Tag (_ bv2 3)))
				(= W2_state_Evict3_Tag (select W2_Evict_Tag (_ bv3 3)))
				(= W2_state_Evict4_Tag (select W2_Evict_Tag (_ bv4 3)))
				(= W2_state_Evict5_Tag (select W2_Evict_Tag (_ bv5 3)))
				(= W2_state_Evict6_Tag (select W2_Evict_Tag (_ bv6 3)))
				(= W2_state_Evict7_Tag (select W2_Evict_Tag (_ bv7 3)))
				
				(= W3_state_Cache0_Tag (select W3_Cache_Tag (_ bv0 2)))
				(= W3_state_Cache1_Tag (select W3_Cache_Tag (_ bv1 2)))
				(= W3_state_Cache2_Tag (select W3_Cache_Tag (_ bv2 2)))
				(= W3_state_Cache3_Tag (select W3_Cache_Tag (_ bv3 2)))
				
				(= W3_state_Cache0_Data (select W3_Cache_Data (_ bv0 2)))
				(= W3_state_Cache1_Data (select W3_Cache_Data (_ bv1 2)))
				(= W3_state_Cache2_Data (select W3_Cache_Data (_ bv2 2)))
				(= W3_state_Cache3_Data (select W3_Cache_Data (_ bv3 2)))
				
				(= W3_state_Cache0_Valid (select W3_Cache_Valid (_ bv0 2)))
				(= W3_state_Cache1_Valid (select W3_Cache_Valid (_ bv1 2)))
				(= W3_state_Cache2_Valid (select W3_Cache_Valid (_ bv2 2)))
				(= W3_state_Cache3_Valid (select W3_Cache_Valid (_ bv3 2)))
				
				(= W3_state_IP W3_IP)
				(= W3_state_CP W3_CP)
				(= W3_state_PC W3_PC)
				
				(= W3_state_ROB0_busy (select W3_ROB_busy (_ bv0 3)))
				(= W3_state_ROB0_op_type (select W3_ROB_op_type (_ bv0 3)))
				(= W3_state_ROB0_destination (select W3_ROB_destination (_ bv0 3)))
				(= W3_state_ROB0_result (select W3_ROB_result (_ bv0 3)))
				(= W3_state_ROB0_exception (select W3_ROB_exception (_ bv0 3)))
				(= W3_state_ROB0_done (select W3_ROB_done (_ bv0 3)))
				
				(= W3_state_ROB1_busy (select W3_ROB_busy (_ bv1 3)))
				(= W3_state_ROB1_op_type (select W3_ROB_op_type (_ bv1 3)))
				(= W3_state_ROB1_destination (select W3_ROB_destination (_ bv1 3)))
				(= W3_state_ROB1_result (select W3_ROB_result (_ bv1 3)))
				(= W3_state_ROB1_exception (select W3_ROB_exception (_ bv1 3)))
				(= W3_state_ROB1_done (select W3_ROB_done (_ bv1 3)))
				
				(= W3_state_ROB2_busy (select W3_ROB_busy (_ bv2 3)))
				(= W3_state_ROB2_op_type (select W3_ROB_op_type (_ bv2 3)))
				(= W3_state_ROB2_destination (select W3_ROB_destination (_ bv2 3)))
				(= W3_state_ROB2_result (select W3_ROB_result (_ bv2 3)))
				(= W3_state_ROB2_exception (select W3_ROB_exception (_ bv2 3)))
				(= W3_state_ROB2_done (select W3_ROB_done (_ bv2 3)))
				
				(= W3_state_ROB3_busy (select W3_ROB_busy (_ bv3 3)))
				(= W3_state_ROB3_op_type (select W3_ROB_op_type (_ bv3 3)))
				(= W3_state_ROB3_destination (select W3_ROB_destination (_ bv3 3)))
				(= W3_state_ROB3_result (select W3_ROB_result (_ bv3 3)))
				(= W3_state_ROB3_exception (select W3_ROB_exception (_ bv3 3)))
				(= W3_state_ROB3_done (select W3_ROB_done (_ bv3 3)))
				
				(= W3_state_ROB4_busy (select W3_ROB_busy (_ bv4 3)))
				(= W3_state_ROB4_op_type (select W3_ROB_op_type (_ bv4 3)))
				(= W3_state_ROB4_destination (select W3_ROB_destination (_ bv4 3)))
				(= W3_state_ROB4_result (select W3_ROB_result (_ bv4 3)))
				(= W3_state_ROB4_exception (select W3_ROB_exception (_ bv4 3)))
				(= W3_state_ROB4_done (select W3_ROB_done (_ bv4 3)))
				
				(= W3_state_ROB5_busy (select W3_ROB_busy (_ bv5 3)))
				(= W3_state_ROB5_op_type (select W3_ROB_op_type (_ bv5 3)))
				(= W3_state_ROB5_destination (select W3_ROB_destination (_ bv5 3)))
				(= W3_state_ROB5_result (select W3_ROB_result (_ bv5 3)))
				(= W3_state_ROB5_exception (select W3_ROB_exception (_ bv5 3)))
				(= W3_state_ROB5_done (select W3_ROB_done (_ bv5 3)))
				
				(= W3_state_ROB6_busy (select W3_ROB_busy (_ bv6 3)))
				(= W3_state_ROB6_op_type (select W3_ROB_op_type (_ bv6 3)))
				(= W3_state_ROB6_destination (select W3_ROB_destination (_ bv6 3)))
				(= W3_state_ROB6_result (select W3_ROB_result (_ bv6 3)))
				(= W3_state_ROB6_exception (select W3_ROB_exception (_ bv6 3)))
				(= W3_state_ROB6_done (select W3_ROB_done (_ bv6 3)))
				
				(= W3_state_ROB7_busy (select W3_ROB_busy (_ bv7 3)))
				(= W3_state_ROB7_op_type (select W3_ROB_op_type (_ bv7 3)))
				(= W3_state_ROB7_destination (select W3_ROB_destination (_ bv7 3)))
				(= W3_state_ROB7_result (select W3_ROB_result (_ bv7 3)))
				(= W3_state_ROB7_exception (select W3_ROB_exception (_ bv7 3)))
				(= W3_state_ROB7_done (select W3_ROB_done (_ bv7 3)))
				
				(= W3_state_RS0_op_type (select W3_RS_op_type (_ bv0 2)))
				(= W3_state_RS0_op (select W3_RS_op (_ bv0 2)))
				(= W3_state_RS0_ROB_dst (select W3_RS_ROB_dst (_ bv0 2)))
				(= W3_state_RS0_vj (select W3_RS_vj (_ bv0 2)))
				(= W3_state_RS0_vk (select W3_RS_vk (_ bv0 2)))
				(= W3_state_RS0_qj (select W3_RS_qj (_ bv0 2)))
				(= W3_state_RS0_qk (select W3_RS_qk (_ bv0 2)))
				(= W3_state_RS0_imm (select W3_RS_imm (_ bv0 2)))
				(= W3_state_RS0_dis (select W3_RS_dis (_ bv0 2)))
				(= W3_state_RS0_busy (select W3_RS_busy (_ bv0 2)))
				
				(= W3_state_RS1_op_type (select W3_RS_op_type (_ bv1 2)))
				(= W3_state_RS1_op (select W3_RS_op (_ bv1 2)))
				(= W3_state_RS1_ROB_dst (select W3_RS_ROB_dst (_ bv1 2)))
				(= W3_state_RS1_vj (select W3_RS_vj (_ bv1 2)))
				(= W3_state_RS1_vk (select W3_RS_vk (_ bv1 2)))
				(= W3_state_RS1_qj (select W3_RS_qj (_ bv1 2)))
				(= W3_state_RS1_qk (select W3_RS_qk (_ bv1 2)))
				(= W3_state_RS1_imm (select W3_RS_imm (_ bv1 2)))
				(= W3_state_RS1_dis (select W3_RS_dis (_ bv1 2)))
				(= W3_state_RS1_busy (select W3_RS_busy (_ bv1 2)))
				
				(= W3_state_RS2_op_type (select W3_RS_op_type (_ bv2 2)))
				(= W3_state_RS2_op (select W3_RS_op (_ bv2 2)))
				(= W3_state_RS2_ROB_dst (select W3_RS_ROB_dst (_ bv2 2)))
				(= W3_state_RS2_vj (select W3_RS_vj (_ bv2 2)))
				(= W3_state_RS2_vk (select W3_RS_vk (_ bv2 2)))
				(= W3_state_RS2_qj (select W3_RS_qj (_ bv2 2)))
				(= W3_state_RS2_qk (select W3_RS_qk (_ bv2 2)))
				(= W3_state_RS2_imm (select W3_RS_imm (_ bv2 2)))
				(= W3_state_RS2_dis (select W3_RS_dis (_ bv2 2)))
				(= W3_state_RS2_busy (select W3_RS_busy (_ bv2 2)))
				
				(= W3_state_RS3_op_type (select W3_RS_op_type (_ bv3 2)))
				(= W3_state_RS3_op (select W3_RS_op (_ bv3 2)))
				(= W3_state_RS3_ROB_dst (select W3_RS_ROB_dst (_ bv3 2)))
				(= W3_state_RS3_vj (select W3_RS_vj (_ bv3 2)))
				(= W3_state_RS3_vk (select W3_RS_vk (_ bv3 2)))
				(= W3_state_RS3_qj (select W3_RS_qj (_ bv3 2)))
				(= W3_state_RS3_qk (select W3_RS_qk (_ bv3 2)))
				(= W3_state_RS3_imm (select W3_RS_imm (_ bv3 2)))
				(= W3_state_RS3_dis (select W3_RS_dis (_ bv3 2)))
				(= W3_state_RS3_busy (select W3_RS_busy (_ bv3 2)))
				
				(= W3_state_LSQ0_op_type (select W3_LSQ_op_type (_ bv0 2)))
				(= W3_state_LSQ0_op (select W3_LSQ_op (_ bv0 2)))
				(= W3_state_LSQ0_ROB_dst (select W3_LSQ_ROB_dst (_ bv0 2)))
				(= W3_state_LSQ0_vj (select W3_LSQ_vj (_ bv0 2)))
				(= W3_state_LSQ0_vk (select W3_LSQ_vk (_ bv0 2)))
				(= W3_state_LSQ0_qj (select W3_LSQ_qj (_ bv0 2)))
				(= W3_state_LSQ0_qk (select W3_LSQ_qk (_ bv0 2)))
				(= W3_state_LSQ0_imm (select W3_LSQ_imm (_ bv0 2)))
				(= W3_state_LSQ0_dis (select W3_LSQ_dis (_ bv0 2)))
				(= W3_state_LSQ0_busy (select W3_LSQ_busy (_ bv0 2)))
				
				(= W3_state_LSQ1_op_type (select W3_LSQ_op_type (_ bv1 2)))
				(= W3_state_LSQ1_op (select W3_LSQ_op (_ bv1 2)))
				(= W3_state_LSQ1_ROB_dst (select W3_LSQ_ROB_dst (_ bv1 2)))
				(= W3_state_LSQ1_vj (select W3_LSQ_vj (_ bv1 2)))
				(= W3_state_LSQ1_vk (select W3_LSQ_vk (_ bv1 2)))
				(= W3_state_LSQ1_qj (select W3_LSQ_qj (_ bv1 2)))
				(= W3_state_LSQ1_qk (select W3_LSQ_qk (_ bv1 2)))
				(= W3_state_LSQ1_imm (select W3_LSQ_imm (_ bv1 2)))
				(= W3_state_LSQ1_dis (select W3_LSQ_dis (_ bv1 2)))
				(= W3_state_LSQ1_busy (select W3_LSQ_busy (_ bv1 2)))
				
				(= W3_state_LSQ2_op_type (select W3_LSQ_op_type (_ bv2 2)))
				(= W3_state_LSQ2_op (select W3_LSQ_op (_ bv2 2)))
				(= W3_state_LSQ2_ROB_dst (select W3_LSQ_ROB_dst (_ bv2 2)))
				(= W3_state_LSQ2_vj (select W3_LSQ_vj (_ bv2 2)))
				(= W3_state_LSQ2_vk (select W3_LSQ_vk (_ bv2 2)))
				(= W3_state_LSQ2_qj (select W3_LSQ_qj (_ bv2 2)))
				(= W3_state_LSQ2_qk (select W3_LSQ_qk (_ bv2 2)))
				(= W3_state_LSQ2_imm (select W3_LSQ_imm (_ bv2 2)))
				(= W3_state_LSQ2_dis (select W3_LSQ_dis (_ bv2 2)))
				(= W3_state_LSQ2_busy (select W3_LSQ_busy (_ bv2 2)))
				
				(= W3_state_LSQ3_op_type (select W3_LSQ_op_type (_ bv3 2)))
				(= W3_state_LSQ3_op (select W3_LSQ_op (_ bv3 2)))
				(= W3_state_LSQ3_ROB_dst (select W3_LSQ_ROB_dst (_ bv3 2)))
				(= W3_state_LSQ3_vj (select W3_LSQ_vj (_ bv3 2)))
				(= W3_state_LSQ3_vk (select W3_LSQ_vk (_ bv3 2)))
				(= W3_state_LSQ3_qj (select W3_LSQ_qj (_ bv3 2)))
				(= W3_state_LSQ3_qk (select W3_LSQ_qk (_ bv3 2)))
				(= W3_state_LSQ3_imm (select W3_LSQ_imm (_ bv3 2)))
				(= W3_state_LSQ3_dis (select W3_LSQ_dis (_ bv3 2)))
				(= W3_state_LSQ3_busy (select W3_LSQ_busy (_ bv3 2)))
				
				(= W3_state_Evict0_Valid (select W3_Evict_Valid (_ bv0 3)))
				(= W3_state_Evict1_Valid (select W3_Evict_Valid (_ bv1 3)))
				(= W3_state_Evict2_Valid (select W3_Evict_Valid (_ bv2 3)))
				(= W3_state_Evict3_Valid (select W3_Evict_Valid (_ bv3 3)))
				(= W3_state_Evict4_Valid (select W3_Evict_Valid (_ bv4 3)))
				(= W3_state_Evict5_Valid (select W3_Evict_Valid (_ bv5 3)))
				(= W3_state_Evict6_Valid (select W3_Evict_Valid (_ bv6 3)))
				(= W3_state_Evict7_Valid (select W3_Evict_Valid (_ bv7 3)))
				
				(= W3_state_Evict0_Tag (select W3_Evict_Tag (_ bv0 3)))
				(= W3_state_Evict1_Tag (select W3_Evict_Tag (_ bv1 3)))
				(= W3_state_Evict2_Tag (select W3_Evict_Tag (_ bv2 3)))
				(= W3_state_Evict3_Tag (select W3_Evict_Tag (_ bv3 3)))
				(= W3_state_Evict4_Tag (select W3_Evict_Tag (_ bv4 3)))
				(= W3_state_Evict5_Tag (select W3_Evict_Tag (_ bv5 3)))
				(= W3_state_Evict6_Tag (select W3_Evict_Tag (_ bv6 3)))
				(= W3_state_Evict7_Tag (select W3_Evict_Tag (_ bv7 3)))
				
				(= W4_state_Cache0_Tag (select W4_Cache_Tag (_ bv0 2)))
				(= W4_state_Cache1_Tag (select W4_Cache_Tag (_ bv1 2)))
				(= W4_state_Cache2_Tag (select W4_Cache_Tag (_ bv2 2)))
				(= W4_state_Cache3_Tag (select W4_Cache_Tag (_ bv3 2)))
				
				(= W4_state_Cache0_Data (select W4_Cache_Data (_ bv0 2)))
				(= W4_state_Cache1_Data (select W4_Cache_Data (_ bv1 2)))
				(= W4_state_Cache2_Data (select W4_Cache_Data (_ bv2 2)))
				(= W4_state_Cache3_Data (select W4_Cache_Data (_ bv3 2)))
				
				(= W4_state_Cache0_Valid (select W4_Cache_Valid (_ bv0 2)))
				(= W4_state_Cache1_Valid (select W4_Cache_Valid (_ bv1 2)))
				(= W4_state_Cache2_Valid (select W4_Cache_Valid (_ bv2 2)))
				(= W4_state_Cache3_Valid (select W4_Cache_Valid (_ bv3 2)))
				
				(= W4_state_IP W4_IP)
				(= W4_state_CP W4_CP)
				(= W4_state_PC W4_PC)
				
				(= W4_state_ROB0_busy (select W4_ROB_busy (_ bv0 3)))
				(= W4_state_ROB0_op_type (select W4_ROB_op_type (_ bv0 3)))
				(= W4_state_ROB0_destination (select W4_ROB_destination (_ bv0 3)))
				(= W4_state_ROB0_result (select W4_ROB_result (_ bv0 3)))
				(= W4_state_ROB0_exception (select W4_ROB_exception (_ bv0 3)))
				(= W4_state_ROB0_done (select W4_ROB_done (_ bv0 3)))
				
				(= W4_state_ROB1_busy (select W4_ROB_busy (_ bv1 3)))
				(= W4_state_ROB1_op_type (select W4_ROB_op_type (_ bv1 3)))
				(= W4_state_ROB1_destination (select W4_ROB_destination (_ bv1 3)))
				(= W4_state_ROB1_result (select W4_ROB_result (_ bv1 3)))
				(= W4_state_ROB1_exception (select W4_ROB_exception (_ bv1 3)))
				(= W4_state_ROB1_done (select W4_ROB_done (_ bv1 3)))
				
				(= W4_state_ROB2_busy (select W4_ROB_busy (_ bv2 3)))
				(= W4_state_ROB2_op_type (select W4_ROB_op_type (_ bv2 3)))
				(= W4_state_ROB2_destination (select W4_ROB_destination (_ bv2 3)))
				(= W4_state_ROB2_result (select W4_ROB_result (_ bv2 3)))
				(= W4_state_ROB2_exception (select W4_ROB_exception (_ bv2 3)))
				(= W4_state_ROB2_done (select W4_ROB_done (_ bv2 3)))
				
				(= W4_state_ROB3_busy (select W4_ROB_busy (_ bv3 3)))
				(= W4_state_ROB3_op_type (select W4_ROB_op_type (_ bv3 3)))
				(= W4_state_ROB3_destination (select W4_ROB_destination (_ bv3 3)))
				(= W4_state_ROB3_result (select W4_ROB_result (_ bv3 3)))
				(= W4_state_ROB3_exception (select W4_ROB_exception (_ bv3 3)))
				(= W4_state_ROB3_done (select W4_ROB_done (_ bv3 3)))
				
				(= W4_state_ROB4_busy (select W4_ROB_busy (_ bv4 3)))
				(= W4_state_ROB4_op_type (select W4_ROB_op_type (_ bv4 3)))
				(= W4_state_ROB4_destination (select W4_ROB_destination (_ bv4 3)))
				(= W4_state_ROB4_result (select W4_ROB_result (_ bv4 3)))
				(= W4_state_ROB4_exception (select W4_ROB_exception (_ bv4 3)))
				(= W4_state_ROB4_done (select W4_ROB_done (_ bv4 3)))
				
				(= W4_state_ROB5_busy (select W4_ROB_busy (_ bv5 3)))
				(= W4_state_ROB5_op_type (select W4_ROB_op_type (_ bv5 3)))
				(= W4_state_ROB5_destination (select W4_ROB_destination (_ bv5 3)))
				(= W4_state_ROB5_result (select W4_ROB_result (_ bv5 3)))
				(= W4_state_ROB5_exception (select W4_ROB_exception (_ bv5 3)))
				(= W4_state_ROB5_done (select W4_ROB_done (_ bv5 3)))
				
				(= W4_state_ROB6_busy (select W4_ROB_busy (_ bv6 3)))
				(= W4_state_ROB6_op_type (select W4_ROB_op_type (_ bv6 3)))
				(= W4_state_ROB6_destination (select W4_ROB_destination (_ bv6 3)))
				(= W4_state_ROB6_result (select W4_ROB_result (_ bv6 3)))
				(= W4_state_ROB6_exception (select W4_ROB_exception (_ bv6 3)))
				(= W4_state_ROB6_done (select W4_ROB_done (_ bv6 3)))
				
				(= W4_state_ROB7_busy (select W4_ROB_busy (_ bv7 3)))
				(= W4_state_ROB7_op_type (select W4_ROB_op_type (_ bv7 3)))
				(= W4_state_ROB7_destination (select W4_ROB_destination (_ bv7 3)))
				(= W4_state_ROB7_result (select W4_ROB_result (_ bv7 3)))
				(= W4_state_ROB7_exception (select W4_ROB_exception (_ bv7 3)))
				(= W4_state_ROB7_done (select W4_ROB_done (_ bv7 3)))
				
				(= W4_state_RS0_op_type (select W4_RS_op_type (_ bv0 2)))
				(= W4_state_RS0_op (select W4_RS_op (_ bv0 2)))
				(= W4_state_RS0_ROB_dst (select W4_RS_ROB_dst (_ bv0 2)))
				(= W4_state_RS0_vj (select W4_RS_vj (_ bv0 2)))
				(= W4_state_RS0_vk (select W4_RS_vk (_ bv0 2)))
				(= W4_state_RS0_qj (select W4_RS_qj (_ bv0 2)))
				(= W4_state_RS0_qk (select W4_RS_qk (_ bv0 2)))
				(= W4_state_RS0_imm (select W4_RS_imm (_ bv0 2)))
				(= W4_state_RS0_dis (select W4_RS_dis (_ bv0 2)))
				(= W4_state_RS0_busy (select W4_RS_busy (_ bv0 2)))
				
				(= W4_state_RS1_op_type (select W4_RS_op_type (_ bv1 2)))
				(= W4_state_RS1_op (select W4_RS_op (_ bv1 2)))
				(= W4_state_RS1_ROB_dst (select W4_RS_ROB_dst (_ bv1 2)))
				(= W4_state_RS1_vj (select W4_RS_vj (_ bv1 2)))
				(= W4_state_RS1_vk (select W4_RS_vk (_ bv1 2)))
				(= W4_state_RS1_qj (select W4_RS_qj (_ bv1 2)))
				(= W4_state_RS1_qk (select W4_RS_qk (_ bv1 2)))
				(= W4_state_RS1_imm (select W4_RS_imm (_ bv1 2)))
				(= W4_state_RS1_dis (select W4_RS_dis (_ bv1 2)))
				(= W4_state_RS1_busy (select W4_RS_busy (_ bv1 2)))
				
				(= W4_state_RS2_op_type (select W4_RS_op_type (_ bv2 2)))
				(= W4_state_RS2_op (select W4_RS_op (_ bv2 2)))
				(= W4_state_RS2_ROB_dst (select W4_RS_ROB_dst (_ bv2 2)))
				(= W4_state_RS2_vj (select W4_RS_vj (_ bv2 2)))
				(= W4_state_RS2_vk (select W4_RS_vk (_ bv2 2)))
				(= W4_state_RS2_qj (select W4_RS_qj (_ bv2 2)))
				(= W4_state_RS2_qk (select W4_RS_qk (_ bv2 2)))
				(= W4_state_RS2_imm (select W4_RS_imm (_ bv2 2)))
				(= W4_state_RS2_dis (select W4_RS_dis (_ bv2 2)))
				(= W4_state_RS2_busy (select W4_RS_busy (_ bv2 2)))
				
				(= W4_state_RS3_op_type (select W4_RS_op_type (_ bv3 2)))
				(= W4_state_RS3_op (select W4_RS_op (_ bv3 2)))
				(= W4_state_RS3_ROB_dst (select W4_RS_ROB_dst (_ bv3 2)))
				(= W4_state_RS3_vj (select W4_RS_vj (_ bv3 2)))
				(= W4_state_RS3_vk (select W4_RS_vk (_ bv3 2)))
				(= W4_state_RS3_qj (select W4_RS_qj (_ bv3 2)))
				(= W4_state_RS3_qk (select W4_RS_qk (_ bv3 2)))
				(= W4_state_RS3_imm (select W4_RS_imm (_ bv3 2)))
				(= W4_state_RS3_dis (select W4_RS_dis (_ bv3 2)))
				(= W4_state_RS3_busy (select W4_RS_busy (_ bv3 2)))
				
				(= W4_state_LSQ0_op_type (select W4_LSQ_op_type (_ bv0 2)))
				(= W4_state_LSQ0_op (select W4_LSQ_op (_ bv0 2)))
				(= W4_state_LSQ0_ROB_dst (select W4_LSQ_ROB_dst (_ bv0 2)))
				(= W4_state_LSQ0_vj (select W4_LSQ_vj (_ bv0 2)))
				(= W4_state_LSQ0_vk (select W4_LSQ_vk (_ bv0 2)))
				(= W4_state_LSQ0_qj (select W4_LSQ_qj (_ bv0 2)))
				(= W4_state_LSQ0_qk (select W4_LSQ_qk (_ bv0 2)))
				(= W4_state_LSQ0_imm (select W4_LSQ_imm (_ bv0 2)))
				(= W4_state_LSQ0_dis (select W4_LSQ_dis (_ bv0 2)))
				(= W4_state_LSQ0_busy (select W4_LSQ_busy (_ bv0 2)))
				
				(= W4_state_LSQ1_op_type (select W4_LSQ_op_type (_ bv1 2)))
				(= W4_state_LSQ1_op (select W4_LSQ_op (_ bv1 2)))
				(= W4_state_LSQ1_ROB_dst (select W4_LSQ_ROB_dst (_ bv1 2)))
				(= W4_state_LSQ1_vj (select W4_LSQ_vj (_ bv1 2)))
				(= W4_state_LSQ1_vk (select W4_LSQ_vk (_ bv1 2)))
				(= W4_state_LSQ1_qj (select W4_LSQ_qj (_ bv1 2)))
				(= W4_state_LSQ1_qk (select W4_LSQ_qk (_ bv1 2)))
				(= W4_state_LSQ1_imm (select W4_LSQ_imm (_ bv1 2)))
				(= W4_state_LSQ1_dis (select W4_LSQ_dis (_ bv1 2)))
				(= W4_state_LSQ1_busy (select W4_LSQ_busy (_ bv1 2)))
				
				(= W4_state_LSQ2_op_type (select W4_LSQ_op_type (_ bv2 2)))
				(= W4_state_LSQ2_op (select W4_LSQ_op (_ bv2 2)))
				(= W4_state_LSQ2_ROB_dst (select W4_LSQ_ROB_dst (_ bv2 2)))
				(= W4_state_LSQ2_vj (select W4_LSQ_vj (_ bv2 2)))
				(= W4_state_LSQ2_vk (select W4_LSQ_vk (_ bv2 2)))
				(= W4_state_LSQ2_qj (select W4_LSQ_qj (_ bv2 2)))
				(= W4_state_LSQ2_qk (select W4_LSQ_qk (_ bv2 2)))
				(= W4_state_LSQ2_imm (select W4_LSQ_imm (_ bv2 2)))
				(= W4_state_LSQ2_dis (select W4_LSQ_dis (_ bv2 2)))
				(= W4_state_LSQ2_busy (select W4_LSQ_busy (_ bv2 2)))
				
				(= W4_state_LSQ3_op_type (select W4_LSQ_op_type (_ bv3 2)))
				(= W4_state_LSQ3_op (select W4_LSQ_op (_ bv3 2)))
				(= W4_state_LSQ3_ROB_dst (select W4_LSQ_ROB_dst (_ bv3 2)))
				(= W4_state_LSQ3_vj (select W4_LSQ_vj (_ bv3 2)))
				(= W4_state_LSQ3_vk (select W4_LSQ_vk (_ bv3 2)))
				(= W4_state_LSQ3_qj (select W4_LSQ_qj (_ bv3 2)))
				(= W4_state_LSQ3_qk (select W4_LSQ_qk (_ bv3 2)))
				(= W4_state_LSQ3_imm (select W4_LSQ_imm (_ bv3 2)))
				(= W4_state_LSQ3_dis (select W4_LSQ_dis (_ bv3 2)))
				(= W4_state_LSQ3_busy (select W4_LSQ_busy (_ bv3 2)))
				
				(= W4_state_Evict0_Valid (select W4_Evict_Valid (_ bv0 3)))
				(= W4_state_Evict1_Valid (select W4_Evict_Valid (_ bv1 3)))
				(= W4_state_Evict2_Valid (select W4_Evict_Valid (_ bv2 3)))
				(= W4_state_Evict3_Valid (select W4_Evict_Valid (_ bv3 3)))
				(= W4_state_Evict4_Valid (select W4_Evict_Valid (_ bv4 3)))
				(= W4_state_Evict5_Valid (select W4_Evict_Valid (_ bv5 3)))
				(= W4_state_Evict6_Valid (select W4_Evict_Valid (_ bv6 3)))
				(= W4_state_Evict7_Valid (select W4_Evict_Valid (_ bv7 3)))
				
				(= W4_state_Evict0_Tag (select W4_Evict_Tag (_ bv0 3)))
				(= W4_state_Evict1_Tag (select W4_Evict_Tag (_ bv1 3)))
				(= W4_state_Evict2_Tag (select W4_Evict_Tag (_ bv2 3)))
				(= W4_state_Evict3_Tag (select W4_Evict_Tag (_ bv3 3)))
				(= W4_state_Evict4_Tag (select W4_Evict_Tag (_ bv4 3)))
				(= W4_state_Evict5_Tag (select W4_Evict_Tag (_ bv5 3)))
				(= W4_state_Evict6_Tag (select W4_Evict_Tag (_ bv6 3)))
				(= W4_state_Evict7_Tag (select W4_Evict_Tag (_ bv7 3)))
				
				
				(= W4_state_Evict0_Valid (select W4_Evict_Valid (_ bv0 3)))
				(= W4_state_Evict1_Valid (select W4_Evict_Valid (_ bv1 3)))
				(= W4_state_Evict2_Valid (select W4_Evict_Valid (_ bv2 3)))
				(= W4_state_Evict3_Valid (select W4_Evict_Valid (_ bv3 3)))
				(= W4_state_Evict4_Valid (select W4_Evict_Valid (_ bv4 3)))
				(= W4_state_Evict5_Valid (select W4_Evict_Valid (_ bv5 3)))
				(= W4_state_Evict6_Valid (select W4_Evict_Valid (_ bv6 3)))
				(= W4_state_Evict7_Valid (select W4_Evict_Valid (_ bv7 3)))
				
				(= W4_state_Evict0_Tag (select W4_Evict_Tag (_ bv0 3)))
				(= W4_state_Evict1_Tag (select W4_Evict_Tag (_ bv1 3)))
				(= W4_state_Evict2_Tag (select W4_Evict_Tag (_ bv2 3)))
				(= W4_state_Evict3_Tag (select W4_Evict_Tag (_ bv3 3)))
				(= W4_state_Evict4_Tag (select W4_Evict_Tag (_ bv4 3)))
				(= W4_state_Evict5_Tag (select W4_Evict_Tag (_ bv5 3)))
				(= W4_state_Evict6_Tag (select W4_Evict_Tag (_ bv6 3)))
				(= W4_state_Evict7_Tag (select W4_Evict_Tag (_ bv7 3)))
				
				(= I_state_Cache0_Tag (select I_Cache_Tag (_ bv0 2)))
				(= I_state_Cache1_Tag (select I_Cache_Tag (_ bv1 2)))
				(= I_state_Cache2_Tag (select I_Cache_Tag (_ bv2 2)))
				(= I_state_Cache3_Tag (select I_Cache_Tag (_ bv3 2)))
				
				(= I_state_Cache0_Data (select I_Cache_Data (_ bv0 2)))
				(= I_state_Cache1_Data (select I_Cache_Data (_ bv1 2)))
				(= I_state_Cache2_Data (select I_Cache_Data (_ bv2 2)))
				(= I_state_Cache3_Data (select I_Cache_Data (_ bv3 2)))
				
				(= I_state_Cache0_Valid (select I_Cache_Valid (_ bv0 2)))
				(= I_state_Cache1_Valid (select I_Cache_Valid (_ bv1 2)))
				(= I_state_Cache2_Valid (select I_Cache_Valid (_ bv2 2)))
				(= I_state_Cache3_Valid (select I_Cache_Valid (_ bv3 2)))
				
				(= I_state_Evict0_Valid (select I_Evict_Valid (_ bv0 3)))
				(= I_state_Evict1_Valid (select I_Evict_Valid (_ bv1 3)))
				(= I_state_Evict2_Valid (select I_Evict_Valid (_ bv2 3)))
				(= I_state_Evict3_Valid (select I_Evict_Valid (_ bv3 3)))
				(= I_state_Evict4_Valid (select I_Evict_Valid (_ bv4 3)))
				(= I_state_Evict5_Valid (select I_Evict_Valid (_ bv5 3)))
				(= I_state_Evict6_Valid (select I_Evict_Valid (_ bv6 3)))
				(= I_state_Evict7_Valid (select I_Evict_Valid (_ bv7 3)))
				
				(= I_state_Evict0_Tag (select I_Evict_Tag (_ bv0 3)))
				(= I_state_Evict1_Tag (select I_Evict_Tag (_ bv1 3)))
				(= I_state_Evict2_Tag (select I_Evict_Tag (_ bv2 3)))
				(= I_state_Evict3_Tag (select I_Evict_Tag (_ bv3 3)))
				(= I_state_Evict4_Tag (select I_Evict_Tag (_ bv4 3)))
				(= I_state_Evict5_Tag (select I_Evict_Tag (_ bv5 3)))
				(= I_state_Evict6_Tag (select I_Evict_Tag (_ bv6 3)))
				(= I_state_Evict7_Tag (select I_Evict_Tag (_ bv7 3)))
			)
			
		(or (= V_equals_U (_ bv1 1)) (= V_equals_S (_ bv1 1)))
		
		
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))))
		))))))))
	)
)
(check-sat)		

;(
(get-value (T_state_Cache0_Tag))
(get-value (T_state_Cache0_Data))
(get-value (T_state_Cache0_Valid))
(get-value (T_state_Cache1_Tag))
(get-value (T_state_Cache1_Data))
(get-value (T_state_Cache1_Valid))
(get-value (T_state_Cache2_Tag))
(get-value (T_state_Cache2_Data))
(get-value (T_state_Cache2_Valid))
(get-value (T_state_Cache3_Tag))
(get-value (T_state_Cache3_Data))
(get-value (T_state_Cache3_Valid))

(get-value (T_state_IP))
(get-value (T_state_CP))
(get-value (T_state_PC))

(get-value (T_state_ROB0_busy))
(get-value (T_state_ROB0_op_type))
(get-value (T_state_ROB0_destination))
(get-value (T_state_ROB0_result))
(get-value (T_state_ROB0_exception))
(get-value (T_state_ROB0_done))

(get-value (T_state_ROB1_busy))
(get-value (T_state_ROB1_op_type))
(get-value (T_state_ROB1_destination))
(get-value (T_state_ROB1_result))
(get-value (T_state_ROB1_exception))
(get-value (T_state_ROB1_done))

(get-value (T_state_ROB2_busy))
(get-value (T_state_ROB2_op_type))
(get-value (T_state_ROB2_destination))
(get-value (T_state_ROB2_result))
(get-value (T_state_ROB2_exception))
(get-value (T_state_ROB2_done))

(get-value (T_state_ROB3_busy))
(get-value (T_state_ROB3_op_type))
(get-value (T_state_ROB3_destination))
(get-value (T_state_ROB3_result))
(get-value (T_state_ROB3_exception))
(get-value (T_state_ROB3_done))

(get-value (T_state_ROB4_busy))
(get-value (T_state_ROB4_op_type))
(get-value (T_state_ROB4_destination))
(get-value (T_state_ROB4_result))
(get-value (T_state_ROB4_exception))
(get-value (T_state_ROB4_done))

(get-value (T_state_ROB5_busy))
(get-value (T_state_ROB5_op_type))
(get-value (T_state_ROB5_destination))
(get-value (T_state_ROB5_result))
(get-value (T_state_ROB5_exception))
(get-value (T_state_ROB5_done))

(get-value (T_state_ROB6_busy))
(get-value (T_state_ROB6_op_type))
(get-value (T_state_ROB6_destination))
(get-value (T_state_ROB6_result))
(get-value (T_state_ROB6_exception))
(get-value (T_state_ROB6_done))

(get-value (T_state_ROB7_busy))
(get-value (T_state_ROB7_op_type))
(get-value (T_state_ROB7_destination))
(get-value (T_state_ROB7_result))
(get-value (T_state_ROB7_exception))
(get-value (T_state_ROB7_done))

(get-value (T_state_RS0_op_type))
(get-value (T_state_RS0_op))
(get-value (T_state_RS0_ROB_dst))
(get-value (T_state_RS0_vj))
(get-value (T_state_RS0_vk))
(get-value (T_state_RS0_qj))
(get-value (T_state_RS0_qk))
(get-value (T_state_RS0_imm))
(get-value (T_state_RS0_dis))
(get-value (T_state_RS0_busy))

(get-value (T_state_RS1_op_type))
(get-value (T_state_RS1_op))
(get-value (T_state_RS1_ROB_dst))
(get-value (T_state_RS1_vj))
(get-value (T_state_RS1_vk))
(get-value (T_state_RS1_qj))
(get-value (T_state_RS1_qk))
(get-value (T_state_RS1_imm))
(get-value (T_state_RS1_dis))
(get-value (T_state_RS1_busy))

(get-value (T_state_RS2_op_type))
(get-value (T_state_RS2_op))
(get-value (T_state_RS2_ROB_dst))
(get-value (T_state_RS2_vj))
(get-value (T_state_RS2_vk))
(get-value (T_state_RS2_qj))
(get-value (T_state_RS2_qk))
(get-value (T_state_RS2_imm))
(get-value (T_state_RS2_dis))
(get-value (T_state_RS2_busy))

(get-value (T_state_RS3_op_type))
(get-value (T_state_RS3_op))
(get-value (T_state_RS3_ROB_dst))
(get-value (T_state_RS3_vj))
(get-value (T_state_RS3_vk))
(get-value (T_state_RS3_qj))
(get-value (T_state_RS3_qk))
(get-value (T_state_RS3_imm))
(get-value (T_state_RS3_dis))
(get-value (T_state_RS3_busy))

(get-value (T_state_LSQ0_op_type))
(get-value (T_state_LSQ0_op))
(get-value (T_state_LSQ0_ROB_dst))
(get-value (T_state_LSQ0_vj))
(get-value (T_state_LSQ0_vk))
(get-value (T_state_LSQ0_qj))
(get-value (T_state_LSQ0_qk))
(get-value (T_state_LSQ0_imm))
(get-value (T_state_LSQ0_dis))
(get-value (T_state_LSQ0_busy))

(get-value (T_state_LSQ1_op_type))
(get-value (T_state_LSQ1_op))
(get-value (T_state_LSQ1_ROB_dst))
(get-value (T_state_LSQ1_vj))
(get-value (T_state_LSQ1_vk))
(get-value (T_state_LSQ1_qj))
(get-value (T_state_LSQ1_qk))
(get-value (T_state_LSQ1_imm))
(get-value (T_state_LSQ1_dis))
(get-value (T_state_LSQ1_busy))

(get-value (T_state_LSQ2_op_type))
(get-value (T_state_LSQ2_op))
(get-value (T_state_LSQ2_ROB_dst))
(get-value (T_state_LSQ2_vj))
(get-value (T_state_LSQ2_vk))
(get-value (T_state_LSQ2_qj))
(get-value (T_state_LSQ2_qk))
(get-value (T_state_LSQ2_imm))
(get-value (T_state_LSQ2_dis))
(get-value (T_state_LSQ2_busy))

(get-value (T_state_LSQ3_op_type))
(get-value (T_state_LSQ3_op))
(get-value (T_state_LSQ3_ROB_dst))
(get-value (T_state_LSQ3_vj))
(get-value (T_state_LSQ3_vk))
(get-value (T_state_LSQ3_qj))
(get-value (T_state_LSQ3_qk))
(get-value (T_state_LSQ3_imm))
(get-value (T_state_LSQ3_dis))
(get-value (T_state_LSQ3_busy))			
			
(get-value (U1_state_Cache0_Tag))
(get-value (U1_state_Cache0_Data))
(get-value (U1_state_Cache0_Valid))
(get-value (U1_state_Cache1_Tag))
(get-value (U1_state_Cache1_Data))
(get-value (U1_state_Cache1_Valid))
(get-value (U1_state_Cache2_Tag))
(get-value (U1_state_Cache2_Data))
(get-value (U1_state_Cache2_Valid))
(get-value (U1_state_Cache3_Tag))
(get-value (U1_state_Cache3_Data))
(get-value (U1_state_Cache3_Valid))

(get-value (U1_state_IP))
(get-value (U1_state_CP))
(get-value (U1_state_PC))

(get-value (U1_state_ROB0_busy))
(get-value (U1_state_ROB0_op_type))
(get-value (U1_state_ROB0_destination))
(get-value (U1_state_ROB0_result))
(get-value (U1_state_ROB0_exception))
(get-value (U1_state_ROB0_done))

(get-value (U1_state_ROB1_busy))
(get-value (U1_state_ROB1_op_type))
(get-value (U1_state_ROB1_destination))
(get-value (U1_state_ROB1_result))
(get-value (U1_state_ROB1_exception))
(get-value (U1_state_ROB1_done))

(get-value (U1_state_ROB2_busy))
(get-value (U1_state_ROB2_op_type))
(get-value (U1_state_ROB2_destination))
(get-value (U1_state_ROB2_result))
(get-value (U1_state_ROB2_exception))
(get-value (U1_state_ROB2_done))

(get-value (U1_state_ROB3_busy))
(get-value (U1_state_ROB3_op_type))
(get-value (U1_state_ROB3_destination))
(get-value (U1_state_ROB3_result))
(get-value (U1_state_ROB3_exception))
(get-value (U1_state_ROB3_done))

(get-value (U1_state_ROB4_busy))
(get-value (U1_state_ROB4_op_type))
(get-value (U1_state_ROB4_destination))
(get-value (U1_state_ROB4_result))
(get-value (U1_state_ROB4_exception))
(get-value (U1_state_ROB4_done))

(get-value (U1_state_ROB5_busy))
(get-value (U1_state_ROB5_op_type))
(get-value (U1_state_ROB5_destination))
(get-value (U1_state_ROB5_result))
(get-value (U1_state_ROB5_exception))
(get-value (U1_state_ROB5_done))

(get-value (U1_state_ROB6_busy))
(get-value (U1_state_ROB6_op_type))
(get-value (U1_state_ROB6_destination))
(get-value (U1_state_ROB6_result))
(get-value (U1_state_ROB6_exception))
(get-value (U1_state_ROB6_done))

(get-value (U1_state_ROB7_busy))
(get-value (U1_state_ROB7_op_type))
(get-value (U1_state_ROB7_destination))
(get-value (U1_state_ROB7_result))
(get-value (U1_state_ROB7_exception))
(get-value (U1_state_ROB7_done))

(get-value (U1_state_RS0_op_type))
(get-value (U1_state_RS0_op))
(get-value (U1_state_RS0_ROB_dst))
(get-value (U1_state_RS0_vj))
(get-value (U1_state_RS0_vk))
(get-value (U1_state_RS0_qj))
(get-value (U1_state_RS0_qk))
(get-value (U1_state_RS0_imm))
(get-value (U1_state_RS0_dis))
(get-value (U1_state_RS0_busy))

(get-value (U1_state_RS1_op_type))
(get-value (U1_state_RS1_op))
(get-value (U1_state_RS1_ROB_dst))
(get-value (U1_state_RS1_vj))
(get-value (U1_state_RS1_vk))
(get-value (U1_state_RS1_qj))
(get-value (U1_state_RS1_qk))
(get-value (U1_state_RS1_imm))
(get-value (U1_state_RS1_dis))
(get-value (U1_state_RS1_busy))

(get-value (U1_state_RS2_op_type))
(get-value (U1_state_RS2_op))
(get-value (U1_state_RS2_ROB_dst))
(get-value (U1_state_RS2_vj))
(get-value (U1_state_RS2_vk))
(get-value (U1_state_RS2_qj))
(get-value (U1_state_RS2_qk))
(get-value (U1_state_RS2_imm))
(get-value (U1_state_RS2_dis))
(get-value (U1_state_RS2_busy))

(get-value (U1_state_RS3_op_type))
(get-value (U1_state_RS3_op))
(get-value (U1_state_RS3_ROB_dst))
(get-value (U1_state_RS3_vj))
(get-value (U1_state_RS3_vk))
(get-value (U1_state_RS3_qj))
(get-value (U1_state_RS3_qk))
(get-value (U1_state_RS3_imm))
(get-value (U1_state_RS3_dis))
(get-value (U1_state_RS3_busy))

(get-value (U1_state_LSQ0_op_type))
(get-value (U1_state_LSQ0_op))
(get-value (U1_state_LSQ0_ROB_dst))
(get-value (U1_state_LSQ0_vj))
(get-value (U1_state_LSQ0_vk))
(get-value (U1_state_LSQ0_qj))
(get-value (U1_state_LSQ0_qk))
(get-value (U1_state_LSQ0_imm))
(get-value (U1_state_LSQ0_dis))
(get-value (U1_state_LSQ0_busy))

(get-value (U1_state_LSQ1_op_type))
(get-value (U1_state_LSQ1_op))
(get-value (U1_state_LSQ1_ROB_dst))
(get-value (U1_state_LSQ1_vj))
(get-value (U1_state_LSQ1_vk))
(get-value (U1_state_LSQ1_qj))
(get-value (U1_state_LSQ1_qk))
(get-value (U1_state_LSQ1_imm))
(get-value (U1_state_LSQ1_dis))
(get-value (U1_state_LSQ1_busy))

(get-value (U1_state_LSQ2_op_type))
(get-value (U1_state_LSQ2_op))
(get-value (U1_state_LSQ2_ROB_dst))
(get-value (U1_state_LSQ2_vj))
(get-value (U1_state_LSQ2_vk))
(get-value (U1_state_LSQ2_qj))
(get-value (U1_state_LSQ2_qk))
(get-value (U1_state_LSQ2_imm))
(get-value (U1_state_LSQ2_dis))
(get-value (U1_state_LSQ2_busy))

(get-value (U1_state_LSQ3_op_type))
(get-value (U1_state_LSQ3_op))
(get-value (U1_state_LSQ3_ROB_dst))
(get-value (U1_state_LSQ3_vj))
(get-value (U1_state_LSQ3_vk))
(get-value (U1_state_LSQ3_qj))
(get-value (U1_state_LSQ3_qk))
(get-value (U1_state_LSQ3_imm))
(get-value (U1_state_LSQ3_dis))
(get-value (U1_state_LSQ3_busy))

(get-value (U2_state_Cache0_Tag))
(get-value (U2_state_Cache0_Data))
(get-value (U2_state_Cache0_Valid))
(get-value (U2_state_Cache1_Tag))
(get-value (U2_state_Cache1_Data))
(get-value (U2_state_Cache1_Valid))
(get-value (U2_state_Cache2_Tag))
(get-value (U2_state_Cache2_Data))
(get-value (U2_state_Cache2_Valid))
(get-value (U2_state_Cache3_Tag))
(get-value (U2_state_Cache3_Data))
(get-value (U2_state_Cache3_Valid))

(get-value (U2_state_IP))
(get-value (U2_state_CP))
(get-value (U2_state_PC))

(get-value (U2_state_ROB0_busy))
(get-value (U2_state_ROB0_op_type))
(get-value (U2_state_ROB0_destination))
(get-value (U2_state_ROB0_result))
(get-value (U2_state_ROB0_exception))
(get-value (U2_state_ROB0_done))

(get-value (U2_state_ROB1_busy))
(get-value (U2_state_ROB1_op_type))
(get-value (U2_state_ROB1_destination))
(get-value (U2_state_ROB1_result))
(get-value (U2_state_ROB1_exception))
(get-value (U2_state_ROB1_done))

(get-value (U2_state_ROB2_busy))
(get-value (U2_state_ROB2_op_type))
(get-value (U2_state_ROB2_destination))
(get-value (U2_state_ROB2_result))
(get-value (U2_state_ROB2_exception))
(get-value (U2_state_ROB2_done))

(get-value (U2_state_ROB3_busy))
(get-value (U2_state_ROB3_op_type))
(get-value (U2_state_ROB3_destination))
(get-value (U2_state_ROB3_result))
(get-value (U2_state_ROB3_exception))
(get-value (U2_state_ROB3_done))

(get-value (U2_state_ROB4_busy))
(get-value (U2_state_ROB4_op_type))
(get-value (U2_state_ROB4_destination))
(get-value (U2_state_ROB4_result))
(get-value (U2_state_ROB4_exception))
(get-value (U2_state_ROB4_done))

(get-value (U2_state_ROB5_busy))
(get-value (U2_state_ROB5_op_type))
(get-value (U2_state_ROB5_destination))
(get-value (U2_state_ROB5_result))
(get-value (U2_state_ROB5_exception))
(get-value (U2_state_ROB5_done))

(get-value (U2_state_ROB6_busy))
(get-value (U2_state_ROB6_op_type))
(get-value (U2_state_ROB6_destination))
(get-value (U2_state_ROB6_result))
(get-value (U2_state_ROB6_exception))
(get-value (U2_state_ROB6_done))

(get-value (U2_state_ROB7_busy))
(get-value (U2_state_ROB7_op_type))
(get-value (U2_state_ROB7_destination))
(get-value (U2_state_ROB7_result))
(get-value (U2_state_ROB7_exception))
(get-value (U2_state_ROB7_done))

(get-value (U2_state_RS0_op_type))
(get-value (U2_state_RS0_op))
(get-value (U2_state_RS0_ROB_dst))
(get-value (U2_state_RS0_vj))
(get-value (U2_state_RS0_vk))
(get-value (U2_state_RS0_qj))
(get-value (U2_state_RS0_qk))
(get-value (U2_state_RS0_imm))
(get-value (U2_state_RS0_dis))
(get-value (U2_state_RS0_busy))

(get-value (U2_state_RS1_op_type))
(get-value (U2_state_RS1_op))
(get-value (U2_state_RS1_ROB_dst))
(get-value (U2_state_RS1_vj))
(get-value (U2_state_RS1_vk))
(get-value (U2_state_RS1_qj))
(get-value (U2_state_RS1_qk))
(get-value (U2_state_RS1_imm))
(get-value (U2_state_RS1_dis))
(get-value (U2_state_RS1_busy))

(get-value (U2_state_RS2_op_type))
(get-value (U2_state_RS2_op))
(get-value (U2_state_RS2_ROB_dst))
(get-value (U2_state_RS2_vj))
(get-value (U2_state_RS2_vk))
(get-value (U2_state_RS2_qj))
(get-value (U2_state_RS2_qk))
(get-value (U2_state_RS2_imm))
(get-value (U2_state_RS2_dis))
(get-value (U2_state_RS2_busy))

(get-value (U2_state_RS3_op_type))
(get-value (U2_state_RS3_op))
(get-value (U2_state_RS3_ROB_dst))
(get-value (U2_state_RS3_vj))
(get-value (U2_state_RS3_vk))
(get-value (U2_state_RS3_qj))
(get-value (U2_state_RS3_qk))
(get-value (U2_state_RS3_imm))
(get-value (U2_state_RS3_dis))
(get-value (U2_state_RS3_busy))

(get-value (U2_state_LSQ0_op_type))
(get-value (U2_state_LSQ0_op))
(get-value (U2_state_LSQ0_ROB_dst))
(get-value (U2_state_LSQ0_vj))
(get-value (U2_state_LSQ0_vk))
(get-value (U2_state_LSQ0_qj))
(get-value (U2_state_LSQ0_qk))
(get-value (U2_state_LSQ0_imm))
(get-value (U2_state_LSQ0_dis))
(get-value (U2_state_LSQ0_busy))

(get-value (U2_state_LSQ1_op_type))
(get-value (U2_state_LSQ1_op))
(get-value (U2_state_LSQ1_ROB_dst))
(get-value (U2_state_LSQ1_vj))
(get-value (U2_state_LSQ1_vk))
(get-value (U2_state_LSQ1_qj))
(get-value (U2_state_LSQ1_qk))
(get-value (U2_state_LSQ1_imm))
(get-value (U2_state_LSQ1_dis))
(get-value (U2_state_LSQ1_busy))

(get-value (U2_state_LSQ2_op_type))
(get-value (U2_state_LSQ2_op))
(get-value (U2_state_LSQ2_ROB_dst))
(get-value (U2_state_LSQ2_vj))
(get-value (U2_state_LSQ2_vk))
(get-value (U2_state_LSQ2_qj))
(get-value (U2_state_LSQ2_qk))
(get-value (U2_state_LSQ2_imm))
(get-value (U2_state_LSQ2_dis))
(get-value (U2_state_LSQ2_busy))

(get-value (U2_state_LSQ3_op_type))
(get-value (U2_state_LSQ3_op))
(get-value (U2_state_LSQ3_ROB_dst))
(get-value (U2_state_LSQ3_vj))
(get-value (U2_state_LSQ3_vk))
(get-value (U2_state_LSQ3_qj))
(get-value (U2_state_LSQ3_qk))
(get-value (U2_state_LSQ3_imm))
(get-value (U2_state_LSQ3_dis))
(get-value (U2_state_LSQ3_busy))

(get-value (U3_state_Cache0_Tag))
(get-value (U3_state_Cache0_Data))
(get-value (U3_state_Cache0_Valid))
(get-value (U3_state_Cache1_Tag))
(get-value (U3_state_Cache1_Data))
(get-value (U3_state_Cache1_Valid))
(get-value (U3_state_Cache2_Tag))
(get-value (U3_state_Cache2_Data))
(get-value (U3_state_Cache2_Valid))
(get-value (U3_state_Cache3_Tag))
(get-value (U3_state_Cache3_Data))
(get-value (U3_state_Cache3_Valid))

(get-value (U3_state_IP))
(get-value (U3_state_CP))
(get-value (U3_state_PC))

(get-value (U3_state_ROB0_busy))
(get-value (U3_state_ROB0_op_type))
(get-value (U3_state_ROB0_destination))
(get-value (U3_state_ROB0_result))
(get-value (U3_state_ROB0_exception))
(get-value (U3_state_ROB0_done))

(get-value (U3_state_ROB1_busy))
(get-value (U3_state_ROB1_op_type))
(get-value (U3_state_ROB1_destination))
(get-value (U3_state_ROB1_result))
(get-value (U3_state_ROB1_exception))
(get-value (U3_state_ROB1_done))

(get-value (U3_state_ROB2_busy))
(get-value (U3_state_ROB2_op_type))
(get-value (U3_state_ROB2_destination))
(get-value (U3_state_ROB2_result))
(get-value (U3_state_ROB2_exception))
(get-value (U3_state_ROB2_done))

(get-value (U3_state_ROB3_busy))
(get-value (U3_state_ROB3_op_type))
(get-value (U3_state_ROB3_destination))
(get-value (U3_state_ROB3_result))
(get-value (U3_state_ROB3_exception))
(get-value (U3_state_ROB3_done))

(get-value (U3_state_ROB4_busy))
(get-value (U3_state_ROB4_op_type))
(get-value (U3_state_ROB4_destination))
(get-value (U3_state_ROB4_result))
(get-value (U3_state_ROB4_exception))
(get-value (U3_state_ROB4_done))

(get-value (U3_state_ROB5_busy))
(get-value (U3_state_ROB5_op_type))
(get-value (U3_state_ROB5_destination))
(get-value (U3_state_ROB5_result))
(get-value (U3_state_ROB5_exception))
(get-value (U3_state_ROB5_done))

(get-value (U3_state_ROB6_busy))
(get-value (U3_state_ROB6_op_type))
(get-value (U3_state_ROB6_destination))
(get-value (U3_state_ROB6_result))
(get-value (U3_state_ROB6_exception))
(get-value (U3_state_ROB6_done))

(get-value (U3_state_ROB7_busy))
(get-value (U3_state_ROB7_op_type))
(get-value (U3_state_ROB7_destination))
(get-value (U3_state_ROB7_result))
(get-value (U3_state_ROB7_exception))
(get-value (U3_state_ROB7_done))

(get-value (U3_state_RS0_op_type))
(get-value (U3_state_RS0_op))
(get-value (U3_state_RS0_ROB_dst))
(get-value (U3_state_RS0_vj))
(get-value (U3_state_RS0_vk))
(get-value (U3_state_RS0_qj))
(get-value (U3_state_RS0_qk))
(get-value (U3_state_RS0_imm))
(get-value (U3_state_RS0_dis))
(get-value (U3_state_RS0_busy))

(get-value (U3_state_RS1_op_type))
(get-value (U3_state_RS1_op))
(get-value (U3_state_RS1_ROB_dst))
(get-value (U3_state_RS1_vj))
(get-value (U3_state_RS1_vk))
(get-value (U3_state_RS1_qj))
(get-value (U3_state_RS1_qk))
(get-value (U3_state_RS1_imm))
(get-value (U3_state_RS1_dis))
(get-value (U3_state_RS1_busy))

(get-value (U3_state_RS2_op_type))
(get-value (U3_state_RS2_op))
(get-value (U3_state_RS2_ROB_dst))
(get-value (U3_state_RS2_vj))
(get-value (U3_state_RS2_vk))
(get-value (U3_state_RS2_qj))
(get-value (U3_state_RS2_qk))
(get-value (U3_state_RS2_imm))
(get-value (U3_state_RS2_dis))
(get-value (U3_state_RS2_busy))

(get-value (U3_state_RS3_op_type))
(get-value (U3_state_RS3_op))
(get-value (U3_state_RS3_ROB_dst))
(get-value (U3_state_RS3_vj))
(get-value (U3_state_RS3_vk))
(get-value (U3_state_RS3_qj))
(get-value (U3_state_RS3_qk))
(get-value (U3_state_RS3_imm))
(get-value (U3_state_RS3_dis))
(get-value (U3_state_RS3_busy))

(get-value (U3_state_LSQ0_op_type))
(get-value (U3_state_LSQ0_op))
(get-value (U3_state_LSQ0_ROB_dst))
(get-value (U3_state_LSQ0_vj))
(get-value (U3_state_LSQ0_vk))
(get-value (U3_state_LSQ0_qj))
(get-value (U3_state_LSQ0_qk))
(get-value (U3_state_LSQ0_imm))
(get-value (U3_state_LSQ0_dis))
(get-value (U3_state_LSQ0_busy))

(get-value (U3_state_LSQ1_op_type))
(get-value (U3_state_LSQ1_op))
(get-value (U3_state_LSQ1_ROB_dst))
(get-value (U3_state_LSQ1_vj))
(get-value (U3_state_LSQ1_vk))
(get-value (U3_state_LSQ1_qj))
(get-value (U3_state_LSQ1_qk))
(get-value (U3_state_LSQ1_imm))
(get-value (U3_state_LSQ1_dis))
(get-value (U3_state_LSQ1_busy))

(get-value (U3_state_LSQ2_op_type))
(get-value (U3_state_LSQ2_op))
(get-value (U3_state_LSQ2_ROB_dst))
(get-value (U3_state_LSQ2_vj))
(get-value (U3_state_LSQ2_vk))
(get-value (U3_state_LSQ2_qj))
(get-value (U3_state_LSQ2_qk))
(get-value (U3_state_LSQ2_imm))
(get-value (U3_state_LSQ2_dis))
(get-value (U3_state_LSQ2_busy))

(get-value (U3_state_LSQ3_op_type))
(get-value (U3_state_LSQ3_op))
(get-value (U3_state_LSQ3_ROB_dst))
(get-value (U3_state_LSQ3_vj))
(get-value (U3_state_LSQ3_vk))
(get-value (U3_state_LSQ3_qj))
(get-value (U3_state_LSQ3_qk))
(get-value (U3_state_LSQ3_imm))
(get-value (U3_state_LSQ3_dis))
(get-value (U3_state_LSQ3_busy))

(get-value (U4_state_Cache0_Tag))
(get-value (U4_state_Cache0_Data))
(get-value (U4_state_Cache0_Valid))
(get-value (U4_state_Cache1_Tag))
(get-value (U4_state_Cache1_Data))
(get-value (U4_state_Cache1_Valid))
(get-value (U4_state_Cache2_Tag))
(get-value (U4_state_Cache2_Data))
(get-value (U4_state_Cache2_Valid))
(get-value (U4_state_Cache3_Tag))
(get-value (U4_state_Cache3_Data))
(get-value (U4_state_Cache3_Valid))

(get-value (U4_state_IP))
(get-value (U4_state_CP))
(get-value (U4_state_PC))

(get-value (U4_state_ROB0_busy))
(get-value (U4_state_ROB0_op_type))
(get-value (U4_state_ROB0_destination))
(get-value (U4_state_ROB0_result))
(get-value (U4_state_ROB0_exception))
(get-value (U4_state_ROB0_done))

(get-value (U4_state_ROB1_busy))
(get-value (U4_state_ROB1_op_type))
(get-value (U4_state_ROB1_destination))
(get-value (U4_state_ROB1_result))
(get-value (U4_state_ROB1_exception))
(get-value (U4_state_ROB1_done))

(get-value (U4_state_ROB2_busy))
(get-value (U4_state_ROB2_op_type))
(get-value (U4_state_ROB2_destination))
(get-value (U4_state_ROB2_result))
(get-value (U4_state_ROB2_exception))
(get-value (U4_state_ROB2_done))

(get-value (U4_state_ROB3_busy))
(get-value (U4_state_ROB3_op_type))
(get-value (U4_state_ROB3_destination))
(get-value (U4_state_ROB3_result))
(get-value (U4_state_ROB3_exception))
(get-value (U4_state_ROB3_done))

(get-value (U4_state_ROB4_busy))
(get-value (U4_state_ROB4_op_type))
(get-value (U4_state_ROB4_destination))
(get-value (U4_state_ROB4_result))
(get-value (U4_state_ROB4_exception))
(get-value (U4_state_ROB4_done))

(get-value (U4_state_ROB5_busy))
(get-value (U4_state_ROB5_op_type))
(get-value (U4_state_ROB5_destination))
(get-value (U4_state_ROB5_result))
(get-value (U4_state_ROB5_exception))
(get-value (U4_state_ROB5_done))

(get-value (U4_state_ROB6_busy))
(get-value (U4_state_ROB6_op_type))
(get-value (U4_state_ROB6_destination))
(get-value (U4_state_ROB6_result))
(get-value (U4_state_ROB6_exception))
(get-value (U4_state_ROB6_done))

(get-value (U4_state_ROB7_busy))
(get-value (U4_state_ROB7_op_type))
(get-value (U4_state_ROB7_destination))
(get-value (U4_state_ROB7_result))
(get-value (U4_state_ROB7_exception))
(get-value (U4_state_ROB7_done))

(get-value (U4_state_RS0_op_type))
(get-value (U4_state_RS0_op))
(get-value (U4_state_RS0_ROB_dst))
(get-value (U4_state_RS0_vj))
(get-value (U4_state_RS0_vk))
(get-value (U4_state_RS0_qj))
(get-value (U4_state_RS0_qk))
(get-value (U4_state_RS0_imm))
(get-value (U4_state_RS0_dis))
(get-value (U4_state_RS0_busy))

(get-value (U4_state_RS1_op_type))
(get-value (U4_state_RS1_op))
(get-value (U4_state_RS1_ROB_dst))
(get-value (U4_state_RS1_vj))
(get-value (U4_state_RS1_vk))
(get-value (U4_state_RS1_qj))
(get-value (U4_state_RS1_qk))
(get-value (U4_state_RS1_imm))
(get-value (U4_state_RS1_dis))
(get-value (U4_state_RS1_busy))

(get-value (U4_state_RS2_op_type))
(get-value (U4_state_RS2_op))
(get-value (U4_state_RS2_ROB_dst))
(get-value (U4_state_RS2_vj))
(get-value (U4_state_RS2_vk))
(get-value (U4_state_RS2_qj))
(get-value (U4_state_RS2_qk))
(get-value (U4_state_RS2_imm))
(get-value (U4_state_RS2_dis))
(get-value (U4_state_RS2_busy))

(get-value (U4_state_RS3_op_type))
(get-value (U4_state_RS3_op))
(get-value (U4_state_RS3_ROB_dst))
(get-value (U4_state_RS3_vj))
(get-value (U4_state_RS3_vk))
(get-value (U4_state_RS3_qj))
(get-value (U4_state_RS3_qk))
(get-value (U4_state_RS3_imm))
(get-value (U4_state_RS3_dis))
(get-value (U4_state_RS3_busy))

(get-value (U4_state_LSQ0_op_type))
(get-value (U4_state_LSQ0_op))
(get-value (U4_state_LSQ0_ROB_dst))
(get-value (U4_state_LSQ0_vj))
(get-value (U4_state_LSQ0_vk))
(get-value (U4_state_LSQ0_qj))
(get-value (U4_state_LSQ0_qk))
(get-value (U4_state_LSQ0_imm))
(get-value (U4_state_LSQ0_dis))
(get-value (U4_state_LSQ0_busy))

(get-value (U4_state_LSQ1_op_type))
(get-value (U4_state_LSQ1_op))
(get-value (U4_state_LSQ1_ROB_dst))
(get-value (U4_state_LSQ1_vj))
(get-value (U4_state_LSQ1_vk))
(get-value (U4_state_LSQ1_qj))
(get-value (U4_state_LSQ1_qk))
(get-value (U4_state_LSQ1_imm))
(get-value (U4_state_LSQ1_dis))
(get-value (U4_state_LSQ1_busy))

(get-value (U4_state_LSQ2_op_type))
(get-value (U4_state_LSQ2_op))
(get-value (U4_state_LSQ2_ROB_dst))
(get-value (U4_state_LSQ2_vj))
(get-value (U4_state_LSQ2_vk))
(get-value (U4_state_LSQ2_qj))
(get-value (U4_state_LSQ2_qk))
(get-value (U4_state_LSQ2_imm))
(get-value (U4_state_LSQ2_dis))
(get-value (U4_state_LSQ2_busy))

(get-value (U4_state_LSQ3_op_type))
(get-value (U4_state_LSQ3_op))
(get-value (U4_state_LSQ3_ROB_dst))
(get-value (U4_state_LSQ3_vj))
(get-value (U4_state_LSQ3_vk))
(get-value (U4_state_LSQ3_qj))
(get-value (U4_state_LSQ3_qk))
(get-value (U4_state_LSQ3_imm))
(get-value (U4_state_LSQ3_dis))
(get-value (U4_state_LSQ3_busy))			
			
(get-value (W1_state_Cache0_Tag))
(get-value (W1_state_Cache0_Data))
(get-value (W1_state_Cache0_Valid))
(get-value (W1_state_Cache1_Tag))
(get-value (W1_state_Cache1_Data))
(get-value (W1_state_Cache1_Valid))
(get-value (W1_state_Cache2_Tag))
(get-value (W1_state_Cache2_Data))
(get-value (W1_state_Cache2_Valid))
(get-value (W1_state_Cache3_Tag))
(get-value (W1_state_Cache3_Data))
(get-value (W1_state_Cache3_Valid))

(get-value (W1_state_IP))
(get-value (W1_state_CP))
(get-value (W1_state_PC))

(get-value (W1_state_ROB0_busy))
(get-value (W1_state_ROB0_op_type))
(get-value (W1_state_ROB0_destination))
(get-value (W1_state_ROB0_result))
(get-value (W1_state_ROB0_exception))
(get-value (W1_state_ROB0_done))

(get-value (W1_state_ROB1_busy))
(get-value (W1_state_ROB1_op_type))
(get-value (W1_state_ROB1_destination))
(get-value (W1_state_ROB1_result))
(get-value (W1_state_ROB1_exception))
(get-value (W1_state_ROB1_done))

(get-value (W1_state_ROB2_busy))
(get-value (W1_state_ROB2_op_type))
(get-value (W1_state_ROB2_destination))
(get-value (W1_state_ROB2_result))
(get-value (W1_state_ROB2_exception))
(get-value (W1_state_ROB2_done))

(get-value (W1_state_ROB3_busy))
(get-value (W1_state_ROB3_op_type))
(get-value (W1_state_ROB3_destination))
(get-value (W1_state_ROB3_result))
(get-value (W1_state_ROB3_exception))
(get-value (W1_state_ROB3_done))

(get-value (W1_state_ROB4_busy))
(get-value (W1_state_ROB4_op_type))
(get-value (W1_state_ROB4_destination))
(get-value (W1_state_ROB4_result))
(get-value (W1_state_ROB4_exception))
(get-value (W1_state_ROB4_done))

(get-value (W1_state_ROB5_busy))
(get-value (W1_state_ROB5_op_type))
(get-value (W1_state_ROB5_destination))
(get-value (W1_state_ROB5_result))
(get-value (W1_state_ROB5_exception))
(get-value (W1_state_ROB5_done))

(get-value (W1_state_ROB6_busy))
(get-value (W1_state_ROB6_op_type))
(get-value (W1_state_ROB6_destination))
(get-value (W1_state_ROB6_result))
(get-value (W1_state_ROB6_exception))
(get-value (W1_state_ROB6_done))

(get-value (W1_state_ROB7_busy))
(get-value (W1_state_ROB7_op_type))
(get-value (W1_state_ROB7_destination))
(get-value (W1_state_ROB7_result))
(get-value (W1_state_ROB7_exception))
(get-value (W1_state_ROB7_done))

(get-value (W1_state_RS0_op_type))
(get-value (W1_state_RS0_op))
(get-value (W1_state_RS0_ROB_dst))
(get-value (W1_state_RS0_vj))
(get-value (W1_state_RS0_vk))
(get-value (W1_state_RS0_qj))
(get-value (W1_state_RS0_qk))
(get-value (W1_state_RS0_imm))
(get-value (W1_state_RS0_dis))
(get-value (W1_state_RS0_busy))

(get-value (W1_state_RS1_op_type))
(get-value (W1_state_RS1_op))
(get-value (W1_state_RS1_ROB_dst))
(get-value (W1_state_RS1_vj))
(get-value (W1_state_RS1_vk))
(get-value (W1_state_RS1_qj))
(get-value (W1_state_RS1_qk))
(get-value (W1_state_RS1_imm))
(get-value (W1_state_RS1_dis))
(get-value (W1_state_RS1_busy))

(get-value (W1_state_RS2_op_type))
(get-value (W1_state_RS2_op))
(get-value (W1_state_RS2_ROB_dst))
(get-value (W1_state_RS2_vj))
(get-value (W1_state_RS2_vk))
(get-value (W1_state_RS2_qj))
(get-value (W1_state_RS2_qk))
(get-value (W1_state_RS2_imm))
(get-value (W1_state_RS2_dis))
(get-value (W1_state_RS2_busy))

(get-value (W1_state_RS3_op_type))
(get-value (W1_state_RS3_op))
(get-value (W1_state_RS3_ROB_dst))
(get-value (W1_state_RS3_vj))
(get-value (W1_state_RS3_vk))
(get-value (W1_state_RS3_qj))
(get-value (W1_state_RS3_qk))
(get-value (W1_state_RS3_imm))
(get-value (W1_state_RS3_dis))
(get-value (W1_state_RS3_busy))

(get-value (W1_state_LSQ0_op_type))
(get-value (W1_state_LSQ0_op))
(get-value (W1_state_LSQ0_ROB_dst))
(get-value (W1_state_LSQ0_vj))
(get-value (W1_state_LSQ0_vk))
(get-value (W1_state_LSQ0_qj))
(get-value (W1_state_LSQ0_qk))
(get-value (W1_state_LSQ0_imm))
(get-value (W1_state_LSQ0_dis))
(get-value (W1_state_LSQ0_busy))

(get-value (W1_state_LSQ1_op_type))
(get-value (W1_state_LSQ1_op))
(get-value (W1_state_LSQ1_ROB_dst))
(get-value (W1_state_LSQ1_vj))
(get-value (W1_state_LSQ1_vk))
(get-value (W1_state_LSQ1_qj))
(get-value (W1_state_LSQ1_qk))
(get-value (W1_state_LSQ1_imm))
(get-value (W1_state_LSQ1_dis))
(get-value (W1_state_LSQ1_busy))

(get-value (W1_state_LSQ2_op_type))
(get-value (W1_state_LSQ2_op))
(get-value (W1_state_LSQ2_ROB_dst))
(get-value (W1_state_LSQ2_vj))
(get-value (W1_state_LSQ2_vk))
(get-value (W1_state_LSQ2_qj))
(get-value (W1_state_LSQ2_qk))
(get-value (W1_state_LSQ2_imm))
(get-value (W1_state_LSQ2_dis))
(get-value (W1_state_LSQ2_busy))

(get-value (W1_state_LSQ3_op_type))
(get-value (W1_state_LSQ3_op))
(get-value (W1_state_LSQ3_ROB_dst))
(get-value (W1_state_LSQ3_vj))
(get-value (W1_state_LSQ3_vk))
(get-value (W1_state_LSQ3_qj))
(get-value (W1_state_LSQ3_qk))
(get-value (W1_state_LSQ3_imm))
(get-value (W1_state_LSQ3_dis))
(get-value (W1_state_LSQ3_busy))

(get-value (W2_state_Cache0_Tag))
(get-value (W2_state_Cache0_Data))
(get-value (W2_state_Cache0_Valid))
(get-value (W2_state_Cache1_Tag))
(get-value (W2_state_Cache1_Data))
(get-value (W2_state_Cache1_Valid))
(get-value (W2_state_Cache2_Tag))
(get-value (W2_state_Cache2_Data))
(get-value (W2_state_Cache2_Valid))
(get-value (W2_state_Cache3_Tag))
(get-value (W2_state_Cache3_Data))
(get-value (W2_state_Cache3_Valid))

(get-value (W2_state_IP))
(get-value (W2_state_CP))
(get-value (W2_state_PC))

(get-value (W2_state_ROB0_busy))
(get-value (W2_state_ROB0_op_type))
(get-value (W2_state_ROB0_destination))
(get-value (W2_state_ROB0_result))
(get-value (W2_state_ROB0_exception))
(get-value (W2_state_ROB0_done))

(get-value (W2_state_ROB1_busy))
(get-value (W2_state_ROB1_op_type))
(get-value (W2_state_ROB1_destination))
(get-value (W2_state_ROB1_result))
(get-value (W2_state_ROB1_exception))
(get-value (W2_state_ROB1_done))

(get-value (W2_state_ROB2_busy))
(get-value (W2_state_ROB2_op_type))
(get-value (W2_state_ROB2_destination))
(get-value (W2_state_ROB2_result))
(get-value (W2_state_ROB2_exception))
(get-value (W2_state_ROB2_done))

(get-value (W2_state_ROB3_busy))
(get-value (W2_state_ROB3_op_type))
(get-value (W2_state_ROB3_destination))
(get-value (W2_state_ROB3_result))
(get-value (W2_state_ROB3_exception))
(get-value (W2_state_ROB3_done))

(get-value (W2_state_ROB4_busy))
(get-value (W2_state_ROB4_op_type))
(get-value (W2_state_ROB4_destination))
(get-value (W2_state_ROB4_result))
(get-value (W2_state_ROB4_exception))
(get-value (W2_state_ROB4_done))

(get-value (W2_state_ROB5_busy))
(get-value (W2_state_ROB5_op_type))
(get-value (W2_state_ROB5_destination))
(get-value (W2_state_ROB5_result))
(get-value (W2_state_ROB5_exception))
(get-value (W2_state_ROB5_done))

(get-value (W2_state_ROB6_busy))
(get-value (W2_state_ROB6_op_type))
(get-value (W2_state_ROB6_destination))
(get-value (W2_state_ROB6_result))
(get-value (W2_state_ROB6_exception))
(get-value (W2_state_ROB6_done))

(get-value (W2_state_ROB7_busy))
(get-value (W2_state_ROB7_op_type))
(get-value (W2_state_ROB7_destination))
(get-value (W2_state_ROB7_result))
(get-value (W2_state_ROB7_exception))
(get-value (W2_state_ROB7_done))

(get-value (W2_state_RS0_op_type))
(get-value (W2_state_RS0_op))
(get-value (W2_state_RS0_ROB_dst))
(get-value (W2_state_RS0_vj))
(get-value (W2_state_RS0_vk))
(get-value (W2_state_RS0_qj))
(get-value (W2_state_RS0_qk))
(get-value (W2_state_RS0_imm))
(get-value (W2_state_RS0_dis))
(get-value (W2_state_RS0_busy))

(get-value (W2_state_RS1_op_type))
(get-value (W2_state_RS1_op))
(get-value (W2_state_RS1_ROB_dst))
(get-value (W2_state_RS1_vj))
(get-value (W2_state_RS1_vk))
(get-value (W2_state_RS1_qj))
(get-value (W2_state_RS1_qk))
(get-value (W2_state_RS1_imm))
(get-value (W2_state_RS1_dis))
(get-value (W2_state_RS1_busy))

(get-value (W2_state_RS2_op_type))
(get-value (W2_state_RS2_op))
(get-value (W2_state_RS2_ROB_dst))
(get-value (W2_state_RS2_vj))
(get-value (W2_state_RS2_vk))
(get-value (W2_state_RS2_qj))
(get-value (W2_state_RS2_qk))
(get-value (W2_state_RS2_imm))
(get-value (W2_state_RS2_dis))
(get-value (W2_state_RS2_busy))

(get-value (W2_state_RS3_op_type))
(get-value (W2_state_RS3_op))
(get-value (W2_state_RS3_ROB_dst))
(get-value (W2_state_RS3_vj))
(get-value (W2_state_RS3_vk))
(get-value (W2_state_RS3_qj))
(get-value (W2_state_RS3_qk))
(get-value (W2_state_RS3_imm))
(get-value (W2_state_RS3_dis))
(get-value (W2_state_RS3_busy))

(get-value (W2_state_LSQ0_op_type))
(get-value (W2_state_LSQ0_op))
(get-value (W2_state_LSQ0_ROB_dst))
(get-value (W2_state_LSQ0_vj))
(get-value (W2_state_LSQ0_vk))
(get-value (W2_state_LSQ0_qj))
(get-value (W2_state_LSQ0_qk))
(get-value (W2_state_LSQ0_imm))
(get-value (W2_state_LSQ0_dis))
(get-value (W2_state_LSQ0_busy))

(get-value (W2_state_LSQ1_op_type))
(get-value (W2_state_LSQ1_op))
(get-value (W2_state_LSQ1_ROB_dst))
(get-value (W2_state_LSQ1_vj))
(get-value (W2_state_LSQ1_vk))
(get-value (W2_state_LSQ1_qj))
(get-value (W2_state_LSQ1_qk))
(get-value (W2_state_LSQ1_imm))
(get-value (W2_state_LSQ1_dis))
(get-value (W2_state_LSQ1_busy))

(get-value (W2_state_LSQ2_op_type))
(get-value (W2_state_LSQ2_op))
(get-value (W2_state_LSQ2_ROB_dst))
(get-value (W2_state_LSQ2_vj))
(get-value (W2_state_LSQ2_vk))
(get-value (W2_state_LSQ2_qj))
(get-value (W2_state_LSQ2_qk))
(get-value (W2_state_LSQ2_imm))
(get-value (W2_state_LSQ2_dis))
(get-value (W2_state_LSQ2_busy))

(get-value (W2_state_LSQ3_op_type))
(get-value (W2_state_LSQ3_op))
(get-value (W2_state_LSQ3_ROB_dst))
(get-value (W2_state_LSQ3_vj))
(get-value (W2_state_LSQ3_vk))
(get-value (W2_state_LSQ3_qj))
(get-value (W2_state_LSQ3_qk))
(get-value (W2_state_LSQ3_imm))
(get-value (W2_state_LSQ3_dis))
(get-value (W2_state_LSQ3_busy))

(get-value (W3_state_Cache0_Tag))
(get-value (W3_state_Cache0_Data))
(get-value (W3_state_Cache0_Valid))
(get-value (W3_state_Cache1_Tag))
(get-value (W3_state_Cache1_Data))
(get-value (W3_state_Cache1_Valid))
(get-value (W3_state_Cache2_Tag))
(get-value (W3_state_Cache2_Data))
(get-value (W3_state_Cache2_Valid))
(get-value (W3_state_Cache3_Tag))
(get-value (W3_state_Cache3_Data))
(get-value (W3_state_Cache3_Valid))

(get-value (W3_state_IP))
(get-value (W3_state_CP))
(get-value (W3_state_PC))

(get-value (W3_state_ROB0_busy))
(get-value (W3_state_ROB0_op_type))
(get-value (W3_state_ROB0_destination))
(get-value (W3_state_ROB0_result))
(get-value (W3_state_ROB0_exception))
(get-value (W3_state_ROB0_done))

(get-value (W3_state_ROB1_busy))
(get-value (W3_state_ROB1_op_type))
(get-value (W3_state_ROB1_destination))
(get-value (W3_state_ROB1_result))
(get-value (W3_state_ROB1_exception))
(get-value (W3_state_ROB1_done))

(get-value (W3_state_ROB2_busy))
(get-value (W3_state_ROB2_op_type))
(get-value (W3_state_ROB2_destination))
(get-value (W3_state_ROB2_result))
(get-value (W3_state_ROB2_exception))
(get-value (W3_state_ROB2_done))

(get-value (W3_state_ROB3_busy))
(get-value (W3_state_ROB3_op_type))
(get-value (W3_state_ROB3_destination))
(get-value (W3_state_ROB3_result))
(get-value (W3_state_ROB3_exception))
(get-value (W3_state_ROB3_done))

(get-value (W3_state_ROB4_busy))
(get-value (W3_state_ROB4_op_type))
(get-value (W3_state_ROB4_destination))
(get-value (W3_state_ROB4_result))
(get-value (W3_state_ROB4_exception))
(get-value (W3_state_ROB4_done))

(get-value (W3_state_ROB5_busy))
(get-value (W3_state_ROB5_op_type))
(get-value (W3_state_ROB5_destination))
(get-value (W3_state_ROB5_result))
(get-value (W3_state_ROB5_exception))
(get-value (W3_state_ROB5_done))

(get-value (W3_state_ROB6_busy))
(get-value (W3_state_ROB6_op_type))
(get-value (W3_state_ROB6_destination))
(get-value (W3_state_ROB6_result))
(get-value (W3_state_ROB6_exception))
(get-value (W3_state_ROB6_done))

(get-value (W3_state_ROB7_busy))
(get-value (W3_state_ROB7_op_type))
(get-value (W3_state_ROB7_destination))
(get-value (W3_state_ROB7_result))
(get-value (W3_state_ROB7_exception))
(get-value (W3_state_ROB7_done))

(get-value (W3_state_RS0_op_type))
(get-value (W3_state_RS0_op))
(get-value (W3_state_RS0_ROB_dst))
(get-value (W3_state_RS0_vj))
(get-value (W3_state_RS0_vk))
(get-value (W3_state_RS0_qj))
(get-value (W3_state_RS0_qk))
(get-value (W3_state_RS0_imm))
(get-value (W3_state_RS0_dis))
(get-value (W3_state_RS0_busy))

(get-value (W3_state_RS1_op_type))
(get-value (W3_state_RS1_op))
(get-value (W3_state_RS1_ROB_dst))
(get-value (W3_state_RS1_vj))
(get-value (W3_state_RS1_vk))
(get-value (W3_state_RS1_qj))
(get-value (W3_state_RS1_qk))
(get-value (W3_state_RS1_imm))
(get-value (W3_state_RS1_dis))
(get-value (W3_state_RS1_busy))

(get-value (W3_state_RS2_op_type))
(get-value (W3_state_RS2_op))
(get-value (W3_state_RS2_ROB_dst))
(get-value (W3_state_RS2_vj))
(get-value (W3_state_RS2_vk))
(get-value (W3_state_RS2_qj))
(get-value (W3_state_RS2_qk))
(get-value (W3_state_RS2_imm))
(get-value (W3_state_RS2_dis))
(get-value (W3_state_RS2_busy))

(get-value (W3_state_RS3_op_type))
(get-value (W3_state_RS3_op))
(get-value (W3_state_RS3_ROB_dst))
(get-value (W3_state_RS3_vj))
(get-value (W3_state_RS3_vk))
(get-value (W3_state_RS3_qj))
(get-value (W3_state_RS3_qk))
(get-value (W3_state_RS3_imm))
(get-value (W3_state_RS3_dis))
(get-value (W3_state_RS3_busy))

(get-value (W3_state_LSQ0_op_type))
(get-value (W3_state_LSQ0_op))
(get-value (W3_state_LSQ0_ROB_dst))
(get-value (W3_state_LSQ0_vj))
(get-value (W3_state_LSQ0_vk))
(get-value (W3_state_LSQ0_qj))
(get-value (W3_state_LSQ0_qk))
(get-value (W3_state_LSQ0_imm))
(get-value (W3_state_LSQ0_dis))
(get-value (W3_state_LSQ0_busy))

(get-value (W3_state_LSQ1_op_type))
(get-value (W3_state_LSQ1_op))
(get-value (W3_state_LSQ1_ROB_dst))
(get-value (W3_state_LSQ1_vj))
(get-value (W3_state_LSQ1_vk))
(get-value (W3_state_LSQ1_qj))
(get-value (W3_state_LSQ1_qk))
(get-value (W3_state_LSQ1_imm))
(get-value (W3_state_LSQ1_dis))
(get-value (W3_state_LSQ1_busy))

(get-value (W3_state_LSQ2_op_type))
(get-value (W3_state_LSQ2_op))
(get-value (W3_state_LSQ2_ROB_dst))
(get-value (W3_state_LSQ2_vj))
(get-value (W3_state_LSQ2_vk))
(get-value (W3_state_LSQ2_qj))
(get-value (W3_state_LSQ2_qk))
(get-value (W3_state_LSQ2_imm))
(get-value (W3_state_LSQ2_dis))
(get-value (W3_state_LSQ2_busy))

(get-value (W3_state_LSQ3_op_type))
(get-value (W3_state_LSQ3_op))
(get-value (W3_state_LSQ3_ROB_dst))
(get-value (W3_state_LSQ3_vj))
(get-value (W3_state_LSQ3_vk))
(get-value (W3_state_LSQ3_qj))
(get-value (W3_state_LSQ3_qk))
(get-value (W3_state_LSQ3_imm))
(get-value (W3_state_LSQ3_dis))
(get-value (W3_state_LSQ3_busy))

(get-value (W4_state_Cache0_Tag))
(get-value (W4_state_Cache0_Data))
(get-value (W4_state_Cache0_Valid))
(get-value (W4_state_Cache1_Tag))
(get-value (W4_state_Cache1_Data))
(get-value (W4_state_Cache1_Valid))
(get-value (W4_state_Cache2_Tag))
(get-value (W4_state_Cache2_Data))
(get-value (W4_state_Cache2_Valid))
(get-value (W4_state_Cache3_Tag))
(get-value (W4_state_Cache3_Data))
(get-value (W4_state_Cache3_Valid))

(get-value (W4_state_IP))
(get-value (W4_state_CP))
(get-value (W4_state_PC))

(get-value (W4_state_ROB0_busy))
(get-value (W4_state_ROB0_op_type))
(get-value (W4_state_ROB0_destination))
(get-value (W4_state_ROB0_result))
(get-value (W4_state_ROB0_exception))
(get-value (W4_state_ROB0_done))

(get-value (W4_state_ROB1_busy))
(get-value (W4_state_ROB1_op_type))
(get-value (W4_state_ROB1_destination))
(get-value (W4_state_ROB1_result))
(get-value (W4_state_ROB1_exception))
(get-value (W4_state_ROB1_done))

(get-value (W4_state_ROB2_busy))
(get-value (W4_state_ROB2_op_type))
(get-value (W4_state_ROB2_destination))
(get-value (W4_state_ROB2_result))
(get-value (W4_state_ROB2_exception))
(get-value (W4_state_ROB2_done))

(get-value (W4_state_ROB3_busy))
(get-value (W4_state_ROB3_op_type))
(get-value (W4_state_ROB3_destination))
(get-value (W4_state_ROB3_result))
(get-value (W4_state_ROB3_exception))
(get-value (W4_state_ROB3_done))

(get-value (W4_state_ROB4_busy))
(get-value (W4_state_ROB4_op_type))
(get-value (W4_state_ROB4_destination))
(get-value (W4_state_ROB4_result))
(get-value (W4_state_ROB4_exception))
(get-value (W4_state_ROB4_done))

(get-value (W4_state_ROB5_busy))
(get-value (W4_state_ROB5_op_type))
(get-value (W4_state_ROB5_destination))
(get-value (W4_state_ROB5_result))
(get-value (W4_state_ROB5_exception))
(get-value (W4_state_ROB5_done))

(get-value (W4_state_ROB6_busy))
(get-value (W4_state_ROB6_op_type))
(get-value (W4_state_ROB6_destination))
(get-value (W4_state_ROB6_result))
(get-value (W4_state_ROB6_exception))
(get-value (W4_state_ROB6_done))

(get-value (W4_state_ROB7_busy))
(get-value (W4_state_ROB7_op_type))
(get-value (W4_state_ROB7_destination))
(get-value (W4_state_ROB7_result))
(get-value (W4_state_ROB7_exception))
(get-value (W4_state_ROB7_done))

(get-value (W4_state_RS0_op_type))
(get-value (W4_state_RS0_op))
(get-value (W4_state_RS0_ROB_dst))
(get-value (W4_state_RS0_vj))
(get-value (W4_state_RS0_vk))
(get-value (W4_state_RS0_qj))
(get-value (W4_state_RS0_qk))
(get-value (W4_state_RS0_imm))
(get-value (W4_state_RS0_dis))
(get-value (W4_state_RS0_busy))

(get-value (W4_state_RS1_op_type))
(get-value (W4_state_RS1_op))
(get-value (W4_state_RS1_ROB_dst))
(get-value (W4_state_RS1_vj))
(get-value (W4_state_RS1_vk))
(get-value (W4_state_RS1_qj))
(get-value (W4_state_RS1_qk))
(get-value (W4_state_RS1_imm))
(get-value (W4_state_RS1_dis))
(get-value (W4_state_RS1_busy))

(get-value (W4_state_RS2_op_type))
(get-value (W4_state_RS2_op))
(get-value (W4_state_RS2_ROB_dst))
(get-value (W4_state_RS2_vj))
(get-value (W4_state_RS2_vk))
(get-value (W4_state_RS2_qj))
(get-value (W4_state_RS2_qk))
(get-value (W4_state_RS2_imm))
(get-value (W4_state_RS2_dis))
(get-value (W4_state_RS2_busy))

(get-value (W4_state_RS3_op_type))
(get-value (W4_state_RS3_op))
(get-value (W4_state_RS3_ROB_dst))
(get-value (W4_state_RS3_vj))
(get-value (W4_state_RS3_vk))
(get-value (W4_state_RS3_qj))
(get-value (W4_state_RS3_qk))
(get-value (W4_state_RS3_imm))
(get-value (W4_state_RS3_dis))
(get-value (W4_state_RS3_busy))

(get-value (W4_state_LSQ0_op_type))
(get-value (W4_state_LSQ0_op))
(get-value (W4_state_LSQ0_ROB_dst))
(get-value (W4_state_LSQ0_vj))
(get-value (W4_state_LSQ0_vk))
(get-value (W4_state_LSQ0_qj))
(get-value (W4_state_LSQ0_qk))
(get-value (W4_state_LSQ0_imm))
(get-value (W4_state_LSQ0_dis))
(get-value (W4_state_LSQ0_busy))

(get-value (W4_state_LSQ1_op_type))
(get-value (W4_state_LSQ1_op))
(get-value (W4_state_LSQ1_ROB_dst))
(get-value (W4_state_LSQ1_vj))
(get-value (W4_state_LSQ1_vk))
(get-value (W4_state_LSQ1_qj))
(get-value (W4_state_LSQ1_qk))
(get-value (W4_state_LSQ1_imm))
(get-value (W4_state_LSQ1_dis))
(get-value (W4_state_LSQ1_busy))

(get-value (W4_state_LSQ2_op_type))
(get-value (W4_state_LSQ2_op))
(get-value (W4_state_LSQ2_ROB_dst))
(get-value (W4_state_LSQ2_vj))
(get-value (W4_state_LSQ2_vk))
(get-value (W4_state_LSQ2_qj))
(get-value (W4_state_LSQ2_qk))
(get-value (W4_state_LSQ2_imm))
(get-value (W4_state_LSQ2_dis))
(get-value (W4_state_LSQ2_busy))

(get-value (W4_state_LSQ3_op_type))
(get-value (W4_state_LSQ3_op))
(get-value (W4_state_LSQ3_ROB_dst))
(get-value (W4_state_LSQ3_vj))
(get-value (W4_state_LSQ3_vk))
(get-value (W4_state_LSQ3_qj))
(get-value (W4_state_LSQ3_qk))
(get-value (W4_state_LSQ3_imm))
(get-value (W4_state_LSQ3_dis))
(get-value (W4_state_LSQ3_busy))				
			
(get-value (I_state_Cache0_Tag))
(get-value (I_state_Cache0_Data))
(get-value (I_state_Cache0_Valid))
(get-value (I_state_Cache1_Tag))
(get-value (I_state_Cache1_Data))
(get-value (I_state_Cache1_Valid))
(get-value (I_state_Cache2_Tag))
(get-value (I_state_Cache2_Data))
(get-value (I_state_Cache2_Valid))
(get-value (I_state_Cache3_Tag))
(get-value (I_state_Cache3_Data))
(get-value (I_state_Cache3_Valid))

(get-value (T_state_Evict0_Valid))
(get-value (T_state_Evict1_Valid))
(get-value (T_state_Evict2_Valid))
(get-value (T_state_Evict3_Valid))
(get-value (T_state_Evict4_Valid))
(get-value (T_state_Evict5_Valid))
(get-value (T_state_Evict6_Valid))
(get-value (T_state_Evict7_Valid))

(get-value (T_state_Evict0_Tag))
(get-value (T_state_Evict1_Tag))
(get-value (T_state_Evict2_Tag))
(get-value (T_state_Evict3_Tag))
(get-value (T_state_Evict4_Tag))
(get-value (T_state_Evict5_Tag))
(get-value (T_state_Evict6_Tag))
(get-value (T_state_Evict7_Tag))			
			

(get-value (U1_state_Evict0_Valid))
(get-value (U1_state_Evict1_Valid))
(get-value (U1_state_Evict2_Valid))
(get-value (U1_state_Evict3_Valid))
(get-value (U1_state_Evict4_Valid))
(get-value (U1_state_Evict5_Valid))
(get-value (U1_state_Evict6_Valid))
(get-value (U1_state_Evict7_Valid))

(get-value (U2_state_Evict0_Tag))
(get-value (U2_state_Evict1_Tag))
(get-value (U2_state_Evict2_Tag))
(get-value (U2_state_Evict3_Tag))
(get-value (U2_state_Evict4_Tag))
(get-value (U2_state_Evict5_Tag))
(get-value (U2_state_Evict6_Tag))
(get-value (U2_state_Evict7_Tag))

(get-value (U2_state_Evict0_Valid))
(get-value (U2_state_Evict1_Valid))
(get-value (U2_state_Evict2_Valid))
(get-value (U2_state_Evict3_Valid))
(get-value (U2_state_Evict4_Valid))
(get-value (U2_state_Evict5_Valid))
(get-value (U2_state_Evict6_Valid))
(get-value (U2_state_Evict7_Valid))

(get-value (U2_state_Evict0_Tag))
(get-value (U2_state_Evict1_Tag))
(get-value (U2_state_Evict2_Tag))
(get-value (U2_state_Evict3_Tag))
(get-value (U2_state_Evict4_Tag))
(get-value (U2_state_Evict5_Tag))
(get-value (U2_state_Evict6_Tag))
(get-value (U2_state_Evict7_Tag))
			
(get-value (U3_state_Evict0_Valid))
(get-value (U3_state_Evict1_Valid))
(get-value (U3_state_Evict2_Valid))
(get-value (U3_state_Evict3_Valid))
(get-value (U3_state_Evict4_Valid))
(get-value (U3_state_Evict5_Valid))
(get-value (U3_state_Evict6_Valid))
(get-value (U3_state_Evict7_Valid))

(get-value (U3_state_Evict0_Tag))
(get-value (U3_state_Evict1_Tag))
(get-value (U3_state_Evict2_Tag))
(get-value (U3_state_Evict3_Tag))
(get-value (U3_state_Evict4_Tag))
(get-value (U3_state_Evict5_Tag))
(get-value (U3_state_Evict6_Tag))
(get-value (U3_state_Evict7_Tag))
			
(get-value (U4_state_Evict0_Valid))
(get-value (U4_state_Evict1_Valid))
(get-value (U4_state_Evict2_Valid))
(get-value (U4_state_Evict3_Valid))
(get-value (U4_state_Evict4_Valid))
(get-value (U4_state_Evict5_Valid))
(get-value (U4_state_Evict6_Valid))
(get-value (U4_state_Evict7_Valid))

(get-value (U4_state_Evict0_Tag))
(get-value (U4_state_Evict1_Tag))
(get-value (U4_state_Evict2_Tag))
(get-value (U4_state_Evict3_Tag))
(get-value (U4_state_Evict4_Tag))
(get-value (U4_state_Evict5_Tag))
(get-value (U4_state_Evict6_Tag))
(get-value (U4_state_Evict7_Tag))				
			
			

(get-value (W1_state_Evict0_Valid))
(get-value (W1_state_Evict1_Valid))
(get-value (W1_state_Evict2_Valid))
(get-value (W1_state_Evict3_Valid))
(get-value (W1_state_Evict4_Valid))
(get-value (W1_state_Evict5_Valid))
(get-value (W1_state_Evict6_Valid))
(get-value (W1_state_Evict7_Valid))

(get-value (W2_state_Evict0_Tag))
(get-value (W2_state_Evict1_Tag))
(get-value (W2_state_Evict2_Tag))
(get-value (W2_state_Evict3_Tag))
(get-value (W2_state_Evict4_Tag))
(get-value (W2_state_Evict5_Tag))
(get-value (W2_state_Evict6_Tag))
(get-value (W2_state_Evict7_Tag))

(get-value (W2_state_Evict0_Valid))
(get-value (W2_state_Evict1_Valid))
(get-value (W2_state_Evict2_Valid))
(get-value (W2_state_Evict3_Valid))
(get-value (W2_state_Evict4_Valid))
(get-value (W2_state_Evict5_Valid))
(get-value (W2_state_Evict6_Valid))
(get-value (W2_state_Evict7_Valid))

(get-value (W2_state_Evict0_Tag))
(get-value (W2_state_Evict1_Tag))
(get-value (W2_state_Evict2_Tag))
(get-value (W2_state_Evict3_Tag))
(get-value (W2_state_Evict4_Tag))
(get-value (W2_state_Evict5_Tag))
(get-value (W2_state_Evict6_Tag))
(get-value (W2_state_Evict7_Tag))
			
(get-value (W3_state_Evict0_Valid))
(get-value (W3_state_Evict1_Valid))
(get-value (W3_state_Evict2_Valid))
(get-value (W3_state_Evict3_Valid))
(get-value (W3_state_Evict4_Valid))
(get-value (W3_state_Evict5_Valid))
(get-value (W3_state_Evict6_Valid))
(get-value (W3_state_Evict7_Valid))

(get-value (W3_state_Evict0_Tag))
(get-value (W3_state_Evict1_Tag))
(get-value (W3_state_Evict2_Tag))
(get-value (W3_state_Evict3_Tag))
(get-value (W3_state_Evict4_Tag))
(get-value (W3_state_Evict5_Tag))
(get-value (W3_state_Evict6_Tag))
(get-value (W3_state_Evict7_Tag))
			
(get-value (W4_state_Evict0_Valid))
(get-value (W4_state_Evict1_Valid))
(get-value (W4_state_Evict2_Valid))
(get-value (W4_state_Evict3_Valid))
(get-value (W4_state_Evict4_Valid))
(get-value (W4_state_Evict5_Valid))
(get-value (W4_state_Evict6_Valid))
(get-value (W4_state_Evict7_Valid))

(get-value (W4_state_Evict0_Tag))
(get-value (W4_state_Evict1_Tag))
(get-value (W4_state_Evict2_Tag))
(get-value (W4_state_Evict3_Tag))
(get-value (W4_state_Evict4_Tag))
(get-value (W4_state_Evict5_Tag))
(get-value (W4_state_Evict6_Tag))
(get-value (W4_state_Evict7_Tag))

(get-value (I_state_Evict0_Valid))
(get-value (I_state_Evict1_Valid))
(get-value (I_state_Evict2_Valid))
(get-value (I_state_Evict3_Valid))
(get-value (I_state_Evict4_Valid))
(get-value (I_state_Evict5_Valid))
(get-value (I_state_Evict6_Valid))
(get-value (I_state_Evict7_Valid))

(get-value (I_state_Evict0_Tag))
(get-value (I_state_Evict1_Tag))
(get-value (I_state_Evict2_Tag))
(get-value (I_state_Evict3_Tag))
(get-value (I_state_Evict4_Tag))
(get-value (I_state_Evict5_Tag))
(get-value (I_state_Evict6_Tag))
(get-value (I_state_Evict7_Tag))	


(get-value (U4_state_ROB1_RF_dst_value))	
(get-value (U4_state_ROB2_RF_dst_value))
(get-value (U4_state_ROB3_RF_dst_value))
(get-value (U4_state_ROB4_RF_dst_value))

(get-value (U4_state_ROB1_DM_dst_value))
(get-value (U4_state_ROB2_DM_dst_value))
(get-value (U4_state_ROB3_DM_dst_value))
(get-value (U4_state_ROB4_DM_dst_value))

(get-value (W4_state_ROB1_RF_dst_value))	
(get-value (W4_state_ROB2_RF_dst_value))
(get-value (W4_state_ROB3_RF_dst_value))
(get-value (W4_state_ROB4_RF_dst_value))

(get-value (W4_state_ROB1_DM_dst_value))
(get-value (W4_state_ROB2_DM_dst_value))
(get-value (W4_state_ROB3_DM_dst_value))
(get-value (W4_state_ROB4_DM_dst_value))

(get-value (I_state_ROB1_RF_dst_value))	
(get-value (I_state_ROB2_RF_dst_value))
(get-value (I_state_ROB3_RF_dst_value))
(get-value (I_state_ROB4_RF_dst_value))

(get-value (I_state_ROB1_DM_dst_value))
(get-value (I_state_ROB2_DM_dst_value))
(get-value (I_state_ROB3_DM_dst_value))
(get-value (I_state_ROB4_DM_dst_value))		
			